function getName() {
	return "aws_s3";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "aws_s3",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "The S3 access log usually is placed in a 'logs' directory within the bucket if the logging is enabled. The files name structure: <DATE>-<UNIQUE_ID> - in XpoLog it should be represented as {date,yyyy-MM-dd-HH-mm-ss}-{string}",
					"typetag": "aws,s3,access",
					"name": "Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{text:Bucket Owner} {text:Bucket,ftype=bucket;,} [{date:Time,dd/MMM/yyyy:HH:mm:ss z}] {geoip:Remote IP,ftype=remoteip;type=;,} {text:Requester} {text:Request ID} {text:Operation} {text:Key} \"{choice:Request-Method,ftype=reqmethod;,GET;POST} {text:Request-URI-FULL}{regexp:Request-URI-Subject,ftype=requrl;refName=Request-URI-FULL,[XPLG_PARAM((.*\\?[^=]+)|(/[^/]+/[^/]+))].*$} {string:Request-Protocol,ftype=reqprotocol;,}\" {number:HTTP status,ftype=respstatus;,} {text:Error Code,ftype=errorcode;,} {number:Bytes Sent,ftype=bytesent;,} {text:Object Size,ftype=objectsize;,} {text:Total Time,ftype=totaltime;,} {text:Turn-Around Time,ftype=turnaroundtime;,} \"{string:Referer,ftype=referer;,}\" \"{string:User Agent,ftype=useragent;,}\"{text:Version Id}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+S3",
					"type_uid": "s3_access",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{text:Bucket Owner} {text:Bucket,ftype=bucket;,} [{date:Time,dd/MMM/yyyy:HH:mm:ss z}] {geoip:Remote IP,ftype=remoteip;type=;,} {text:Requester} {text:Request ID} {text:Operation} {text:Key} \"{choice:Request-Method,ftype=reqmethod;,GET;POST} {text:Request-URI-FULL}{regexp:Request-URI-Subject,ftype=requrl;refName=Request-URI-FULL,[XPLG_PARAM((.*\\?[^=]+)|(/[^/]+/[^/]+))].*$} {string:Request-Protocol,ftype=reqprotocol;,}\" {number:HTTP status,ftype=respstatus;,} {text:Error Code,ftype=errorcode;,} {number:Bytes Sent,ftype=bytesent;,} {text:Object Size,ftype=objectsize;,} {text:Total Time,ftype=totaltime;,} {text:Turn-Around Time,ftype=turnaroundtime;,} \"{string:Referer,ftype=referer;,}\" \"{string:User Agent,ftype=useragent;,}\"{text:Version Id}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "AWS S3",
		"typetag": "aws,s3",
		"name": "aws_s3",
		"description": "",
		"type": "cloud",
		"doclink": "http://docs.aws.amazon.com/AmazonS3/latest/dev/LogFormat.html",
		"version": "current",
		"supportedDataSources": "localFolder,ssh,s3",
		"xwikilink": "",
		"example": ""
	}
});
