function getName() {
	return "cyberark";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "cyberark",
		"apptags": "",
		"displayName": "CyberArk",
		"typetag": "syslog,cyberark,audit",
		"name": "cyberark",
		"description": "",
		"type": "security",
		"doclink": "https://www.cyberark.com/solutions/by-project/session-monitoring-and-recording/",
		"version": "current",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
			"log": {
				"xdoclink": "",
				"defaultPattern": "NONE",
				"howto": "Direct your CyberArk to send audit log via TCP or UDP through XPLG listners.",
				"typetag": "syslog,cyberark,audit",
				"name": "CyberArk",
				"custom_parser_location": "<LINK to JS>",
				"defaultXpoLogPattern": "{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|Vault|{text:Version}|{text:Message Code,ftype=messagecode}|{text:Description,ftype=description}|{text:Number}|act={text:Action,ftype=action} suser={text:Source User,ftype=sourceuser} fname={text:Fname,ftype=fname} dvc={text:DVC,ftype=dvc} shost={text:Source Host,ftype=sourcehost} dhost={text:Destination Host,ftype=targethost} duser={text:Destination User,ftype=targetuser} externalId={text:External ID,ftype=externalid} app={text:App,ftype=app} reason={text:Reason,ftype=reason} cs1Label=\"{text:Cs1Label,ftype=csllabel}\" cs1={text:Cs1,ftype=cs1} cs2Label=\"{text:Cs2Label,ftype=cs2label}\" cs2={text:Cs2,ftype=cs2} cs3Label=\"{text:Cs3Label,ftype=cs3label}\" cs3={text:Cs3,ftype=cs3} cs4Label=\"{text:Cs4Label,ftype=cs4label}\" cs4={text:Cs4,ftype=cs4} cs5Label=\"{text:Cs5Label,ftype=cs5label}\" cs5={text:Cs5,ftype=cs5} cn1Label=\"{text:Cn1Label,ftype=cnllabel}\" cn1={text:Cn1,ftype=cn1} cn2Label=\"{text:Cn2Label,ftype=cn2label}\" cn2={text:Cn2,ftype=cn2}{regexp:Value,ftype=value;refName=Cn2,^Value=\\u005B([^\\u005D]+).*}{regexp:Old Value,ftype=oldvalue;refName=Cn2,Old Value=\\u005B([^\\u005D]+).*} {block,start,emptiness=true}Failure Description: {text:Failure Description,ftype=failure}{regexp:Safe,ftype=safe;refName=Failure Description,Safe:\\s([^,]+).*}{regexp:Folder,ftype=folder;refName=Failure Description,Folder:\\s([^,]+).*}{regexp:Object,ftype=object;refName=Failure Description,Object:\\s([^\\.]+).*}{regexp:Code,ftype=code;refName=Failure Description,Code:\\s([^,]+).*}{eol} {block,end,emptiness=true} msg={string:Message,ftype=message}\n{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|Vault|{text:Version}|{text:Message Code,ftype=messagecode}|{text:Description,ftype=description}|{text:Number}|act={text:Action,ftype=action} suser={text:Source User,ftype=sourceuser} fname={text:Fname,ftype=fname} dvc={text:DVC,ftype=dvc} shost={text:Source Host,ftype=sourcehost} dhost={text:Destination Host,ftype=targethost} duser={text:Destination User,ftype=targetuser} externalId={text:External ID,ftype=externalid} app={text:App,ftype=app} reason={text:Reason,ftype=reason} cs1Label=\"{text:Cs1Label,ftype=csllabel}\" cs1={text:Cs1,ftype=cs1} cs2Label=\"{text:Cs2Label,ftype=cs2label}\" cs2={text:Cs2,ftype=cs2} cs3Label=\"{text:Cs3Label,ftype=cs3label}\" cs3={text:Cs3,ftype=cs3} cs4Label=\"{text:Cs4Label,ftype=cs4label}\" cs4={text:Cs4,ftype=cs4} cs5Label=\"{text:Cs5Label,ftype=cs5label}\" cs5={text:Cs5,ftype=cs5} cn1Label=\"{text:Cn1Label,ftype=cnllabel}\" cn1={text:Cn1,ftype=cn1} cn2Label=\"{text:Cn2Label,ftype=cn2label}\" cn2={text:Cn2,ftype=cn2}{regexp:Value,ftype=value;refName=Cn2,^Value=\\u005B([^\\u005D]+).*}{regexp:Old Value,ftype=oldvalue;refName=Cn2,Old Value=\\u005B([^\\u005D]+).*} msg={string:Message,ftype=message}\n{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|VaultMonitor|{text:Version}|{text:Code1,ftype=code1}|{text:Code2,ftype=code2}|{text:Code3,ftype=code3}|{text:Code4,ftype=code4}|{text:Code5,ftype=code5}|{text:Code6,ftype=code6}|{text:Code7,ftype=code7}|{text:Code8,ftype=code8}|{text:Code9,ftype=code9}|{text:Code10,ftype=code10}|{text:Code11,ftype=code11}|{text:Code12,ftype=code12}",
				"parser_type": "default",
				"xwikilink": "http://wiki.xpolog.com/display/XPOL/CyberArk",
				"type_uid": "cyberark_audit",
				"parser_uid": "uid",
				"parser_specification": {
					"defaultPattern": "NONE",
					"parserparam": "",
					"defaultXpoLogPattern": "{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|Vault|{text:Version}|{text:Message Code,ftype=messagecode}|{text:Description,ftype=description}|{text:Number}|act={text:Action,ftype=action} suser={text:Source User,ftype=sourceuser} fname={text:Fname,ftype=fname} dvc={text:DVC,ftype=dvc} shost={text:Source Host,ftype=sourcehost} dhost={text:Destination Host,ftype=targethost} duser={text:Destination User,ftype=targetuser} externalId={text:External ID,ftype=externalid} app={text:App,ftype=app} reason={text:Reason,ftype=reason} cs1Label=\"{text:Cs1Label,ftype=csllabel}\" cs1={text:Cs1,ftype=cs1} cs2Label=\"{text:Cs2Label,ftype=cs2label}\" cs2={text:Cs2,ftype=cs2} cs3Label=\"{text:Cs3Label,ftype=cs3label}\" cs3={text:Cs3,ftype=cs3} cs4Label=\"{text:Cs4Label,ftype=cs4label}\" cs4={text:Cs4,ftype=cs4} cs5Label=\"{text:Cs5Label,ftype=cs5label}\" cs5={text:Cs5,ftype=cs5} cn1Label=\"{text:Cn1Label,ftype=cnllabel}\" cn1={text:Cn1,ftype=cn1} cn2Label=\"{text:Cn2Label,ftype=cn2label}\" cn2={text:Cn2,ftype=cn2}{regexp:Value,ftype=value;refName=Cn2,^Value=\\u005B([^\\u005D]+).*}{regexp:Old Value,ftype=oldvalue;refName=Cn2,Old Value=\\u005B([^\\u005D]+).*} {block,start,emptiness=true}Failure Description: {text:Failure Description,ftype=failure}{regexp:Safe,ftype=safe;refName=Failure Description,Safe:\\s([^,]+).*}{regexp:Folder,ftype=folder;refName=Failure Description,Folder:\\s([^,]+).*}{regexp:Object,ftype=object;refName=Failure Description,Object:\\s([^\\.]+).*}{regexp:Code,ftype=code;refName=Failure Description,Code:\\s([^,]+).*}{eol} {block,end,emptiness=true} msg={string:Message,ftype=message}\n{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|Vault|{text:Version}|{text:Message Code,ftype=messagecode}|{text:Description,ftype=description}|{text:Number}|act={text:Action,ftype=action} suser={text:Source User,ftype=sourceuser} fname={text:Fname,ftype=fname} dvc={text:DVC,ftype=dvc} shost={text:Source Host,ftype=sourcehost} dhost={text:Destination Host,ftype=targethost} duser={text:Destination User,ftype=targetuser} externalId={text:External ID,ftype=externalid} app={text:App,ftype=app} reason={text:Reason,ftype=reason} cs1Label=\"{text:Cs1Label,ftype=csllabel}\" cs1={text:Cs1,ftype=cs1} cs2Label=\"{text:Cs2Label,ftype=cs2label}\" cs2={text:Cs2,ftype=cs2} cs3Label=\"{text:Cs3Label,ftype=cs3label}\" cs3={text:Cs3,ftype=cs3} cs4Label=\"{text:Cs4Label,ftype=cs4label}\" cs4={text:Cs4,ftype=cs4} cs5Label=\"{text:Cs5Label,ftype=cs5label}\" cs5={text:Cs5,ftype=cs5} cn1Label=\"{text:Cn1Label,ftype=cnllabel}\" cn1={text:Cn1,ftype=cn1} cn2Label=\"{text:Cn2Label,ftype=cn2label}\" cn2={text:Cn2,ftype=cn2}{regexp:Value,ftype=value;refName=Cn2,^Value=\\u005B([^\\u005D]+).*}{regexp:Old Value,ftype=oldvalue;refName=Cn2,Old Value=\\u005B([^\\u005D]+).*} msg={string:Message,ftype=message}\n{text:Date,charsLength=15;,} {text:Server Name,ftype=devicename} {text:CEF,ftype=cef}|Cyber-Ark|VaultMonitor|{text:Version}|{text:Code1,ftype=code1}|{text:Code2,ftype=code2}|{text:Code3,ftype=code3}|{text:Code4,ftype=code4}|{text:Code5,ftype=code5}|{text:Code6,ftype=code6}|{text:Code7,ftype=code7}|{text:Code8,ftype=code8}|{text:Code9,ftype=code9}|{text:Code10,ftype=code10}|{text:Code11,ftype=code11}|{text:Code12,ftype=code12}",
					"externalJS": "link or code"
				}
			}
		}
	]		
}
});
