function getName() {
	return "iis_6";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "iis_6",
		"apptags": "",
		"displayName": "IIS",
		"typetag": "iis,w3c,webserver",
		"name": "iis",
		"description": "",
		"type": "web servers",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_iis6",
		"version": "6",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Files usually located at C:\\Windows\\System32\\LogFiles. In the header of IIS access logs , or on the IIS configuration file locate the format specification string that describes the logged fields, starts with: #Fields:",
					"typetag": "iis,w3c,webserver,access",
					"name": "Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"parser_uid": "uid",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_iis6",
					"type_uid": "iis_access",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							result = result.replace(/#Fields: /g, "");
							result = result.replace(/\)/g, "");
							result = result.replace(/\(/g, "-");
							result = result.replace(/date time/g, "date-time");
							return result;
						},
						"postBuild": function (result) {
							if (result != "") {
								result = result + "{eoe}"
							}
							return result;
						},
						"patternMatch": "\\S+",
						"filters":
						[{
								"filter": [{
										"match": "date-time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "yyyy-MM-dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "date"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "yyyy-MM-dd"
								}
							}, {
								"filter": [{
										"match": "time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "c-ip"
									}
								],
								"type": "GeoIp",
								"function": {
									"filedName": "Client IP",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "cs-username"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Remote User",
									"ftype": "remoteuser"
								}
							}, {
								"filter": [{
										"match": "s-sitename"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Site Name",
									"ftype": "sitename"
								}
							}, {
								"filter": [{
										"match": "s-computername"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Server Name",
									"ftype": "servername"
								}
							}, {
								"filter": [{
										"match": "s-ip"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Server IP",
									"ftype": "localip"
								}
							}, {
								"filter": [{
										"match": "s-port"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Server Port",
									"ftype": "serverport"
								}
							}, {
								"filter": [{
										"match": "cs-method"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "cs-uri-stem"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request URL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "cs-uri-query"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "queryString",
									"ftype": "querystring"
								}
							}, {
								"filter": [{
										"match": "sc-status"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseStatus",
									"ftype": "respstatus"
								}
							}, {
								"filter": [{
										"match": "sc-win32-status"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Win32 Status",
									"ftype": "win32status"
								}
							}, {
								"filter": [{
										"match": "sc-bytes"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "cs-bytes"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Received",
									"ftype": "bytesreceived"
								}
							}, {
								"filter": [{
										"match": "time-taken"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Time Taken",
									"ftype": "processrequestmilli"
								}
							}, {
								"filter": [{
										"match": "cs-version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Protocol Version",
									"ftype": "protocolversion"
								}
							}, {
								"filter": [{
										"match": "cs-host"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Host",
									"ftype": "hostname"
								}
							}, {
								"filter": [{
										"match": "cs-User-Agent"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User Agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "cs(User-Agent)"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User Agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "cs-Cookie"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Cookie",
									"ftype": "cookie"
								}
							}, {
								"filter": [{
										"match": "cs(Cookie)"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Cookie",
									"ftype": "cookie"
								}
							}, {
								"filter": [{
										"match": "cs-Referrer"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
								}
							}, {
								"filter": [{
										"match": "cs(Referrer)"
									}
								],
								 "type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "cs-Referer"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
								}
							}, {
								"filter": [{
										"match": "cs(Referer)"
									}
								],
								 "type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "sc-substatus"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Protocol Substatus",
									"ftype": "ressubstatus"
								}
							}
						]
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "The application log of your IIS server",
					"typetag": "iis,w3c,webserver,error",
					"name": "Error",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{priority:Type,ftype=severity,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=username}*;*{text:Computer,ftype=computer}*;*{string:Description}",
					"parser_type": "default",
					"parser_uid": "uid",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_iis6",
					"type_uid": "iis_error",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{priority:Type,ftype=severity,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=username}*;*{text:Computer,ftype=computer}*;*{string:Description}",
						"externalJS": "link or code",	
					}
				}
			}
		],		
	}
});
