function getName() {
	return "log4j_2";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "log4j_2",
		"apptags": "",
		"displayName": "Log4J",
		"typetag": "java,log4j",
		"name": "log4j",
		"description": "",
		"type": "logging",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_log4j2",
		"version": "2",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "In the Apache Log4J configuration file, can be either properties files, XML file, or in some case the log format was created programmatically for which you can manually create the pattern for the data.",
					"typetag": "java,log4j",
					"name": "Log4J",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_log4j2",
					"type_uid": "log4j_java",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							var reg = new RegExp("%%", "g");
							result = result.replace(reg, "%");
							reg = new RegExp("%enc{([^\\{]+)}", "g");
							result = result.replace(reg, "$1");
							reg = new RegExp("%-?\\d+(\\.\\d+)?", "g");

							return result.replace(reg, "%");
						},
						"filters": [{
								"filter": [{
										match: "%c"
									}, {
										match: "%logger"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Logger",
									"ftype": "logger"
								}
							}, {
								"filter": [{
										match: "%c{\\d+}",
										"isRegExp": true
									}, {
										match: "%logger{\\d+}",
										"isRegExp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:Logger,ftype=logger}";
									}
								}
							}, {
								"filter" : [ {
									match : "%X{([^\\}]+)}",
									"isRegExp" : true
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(
											regexp_params) {
										var param = regexp_params[1];										
										return "{text:" + param + "}";
									}
								}
							},{
								"filter": [{
										match: "%C"
									}, {
										match: "%class"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Class",
									"ftype": "class"
								}
							}, {
								"filter": [{
										match: "%C{\\d+}",
										"isRegExp": true
									}, {
										match: "%class{\\d+}",
										"isRegExp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:Class,ftype=class}";
									}
								}
							}, {
								"filter": [{
										match: "%date"
									}, {
										match: "%d"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "yyyy-MM-dd HH:mm:ss,SSS"
								}
							}, {
								"filter": [{
										"match": "%date{([^\\}]+)}",
										"isRegExp": true
									}, {
										"match": "%d{([^\\}]+)}",
										"isRegExp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										var param = regexp_params[1];
										if (param == "ISO8601") {
											param = "yyyy-MM-dd HH:mm:ss,SSS";
										} else if (param == "ABSOLUTE") {
											param = "HH:mm:ss,SSS";
										}
										return "{date:Date,;," + param + "}";
									}
								}
							}, {
								"filter": [{
										match: "%file"
									}, {
										match: "%F"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "File",
									"ftype": "file"
								}
							}, {
								"filter": [{
										match: "%location"
									}, {
										match: "%l"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (params) {
										return "{text:Method,ftype=method}({text:Class,ftype=sourcecode}:{number:LineNumberr,ftype=linenumber})";
									}
								}
							}, {
								"filter": [{
										match: "%line"
									}, {
										match: "%L"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "LineNumber",
									"ftype": "linenumber"
								}
							}, {
								"filter": [{
										match: "%message"
									}, {
										match: "%msg"
									}, {
										match: "%m"
									}
								],
								"type": "String",
								"function": {
									"filedName": "Message",
									"ftype": "message"
								}
							}, {
								"filter": [{
										match: "%ex"
									}, {
										match: "%exception"
									}, {
										match: "%throwable"
									}
								],
								"type": "String",
								"function": {
									"filedName": "Throwable",
									"ftype": "throwable"
								}
							}, {
								"filter": [{
										match: "%ex{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%exception{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%throwable{([^\\}]+)}",
										"isCustom": true
									}
								],
								"type": "String",
								"function": {
									"filedName": "Throwable",
									"ftype": "throwable"
								}
							}, {
								"filter": [{
										match: "%rEx"
									}, {
										match: "%rException"
									}, {
										match: "%rThrowable"
									}
								],
								"type": "String",
								"function": {
									"filedName": "NestedException",
									"ftype": "nestedexception"
								}
							}, {
								"filter": [{
										match: "%rEx{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%rException{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%rThrowable{([^\\}]+)}",
										"isCustom": true
									}
								],
								"type": "String",
								"function": {
									"filedName": "NestedException",
									"ftype": "nestedexception"
								}
							}, {
								"filter": [{
										match: "%xEx"
									}, {
										match: "%xException"
									}, {
										match: "%xThrowable"
									}
								],
								"type": "String",
								"function": {
									"filedName": "NestedException",
									"ftype": "nestedexception"
								}
							}, {
								"filter": [{
										match: "%xEx{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%xException{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%xThrowable{([^\\}]+)}",
										"isCustom": true
									}
								],
								"type": "String",
								"function": {
									"filedName": "NestedException",
									"ftype": "nestedexception"
								}
							}, {
								"filter": [{
										match: "%K{([^\\}]+)}",
										"isRegexp": true
									}, {
										match: "%map{([^\\}]+)}",
										"isRegexp": true
									}, {
										match: "%Map{([^\\}]+)}",
										"isRegexp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										match: "%method"
									}, {
										match: "%M"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Method",
									"ftype": "method"
								}
							}, {
								"filter": [{
										match: "%n"
									}
								],
								"type": "eol",
								"function": {
									"filedName": "EOL"
								}
							}, {
								"filter": [{
										match: "%level"
									}, {
										match: "%p"
									}
								],
								"type": "Priority",
								"function": {
									"filedName": "Priority",
									"levels": "ALL;TRACE;DEBUG;INFO;WARN;ERROR;FATAL",
									"ftype": "severity"
								}
							}, {
								"filter": [{
										match: "%level{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%p{([^\\}]+)}",
										"isCustom": true
									}
								],
								"type": "Priority",
								"function": {
									"filedName": "Priority",
									"levels": "ALL;TRACE;DEBUG;INFO;WARN;ERROR;FATAL",
									"ftype": "severity"
								}
							}, {
								"filter": [{
										match: "%relative"
									}, {
										match: "%r"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "LogSpeed",
									"ftype": "logprocesstimemilli"
								}
							}, {
								"filter": [{
										match: "%thread"
									}, {
										match: "%t"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Thread",
									"ftype": "thread"
								}
							}, {
								"filter": [{
										match: "%sequenceNumber"
									}, {
										match: "%sn"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SequenceNumber",
									"ftype": "sequencenumber"
								}
							}, {
								"filter": [{
										match: "%NDC"
									}, {
										match: "%x"
									}
								],
								"type": "String",
								"function": {
									"filedName": "NDC"
								}
							}, {
								"filter": [{
										match: "%X{([^\\}]+)}",
										"isRegexp": true
									}, {
										match: "%mdc{([^\\}]+)}",
										"isRegexp": true
									}, {
										match: "%MDC{([^\\}]+)}",
										"isRegexp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:MDC_" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										match: "%marker"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Marker",
									"ftype": "marker"
								}
							}, {
								"filter": [{
										match: "%u"
									}, {
										match: "%uuid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "UUID",
									"ftype": "uniqueid"
								}
							}, {
								"filter": [{
										match: "%u{([^\\}]+)}",
										"isCustom": true
									}, {
										match: "%uuid{([^\\}]+)}",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "UUID",
									"ftype": "uniqueid"
								}
							}
						]
					}
				}
			}
		]
	}
});
