function getName() {
	return "nginx";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "nginx",
		"apptags": "",
		"displayName": "NGINX",
		"typetag": "nginx,w3c,webserver",
		"name": "nginx",
		"description": "",
		"type": "web servers",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_nginx",
		"version": "1.10+",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "$remote_addr - $remote_user [$time_local] \"$request\" $status $body_bytes_sent \"$http_referer\" \"$http_user_agent\" \"$http_x_forwarded_for\"",
					"howto": "In the NGINX configuration file, usually nginx.conf, by default located under \"NGINX_ROOT_DIR/conf/nginx.conf\"). Search for the log_format directive.",
					"typetag": "nginx,w3c,webserver,access",
					"name": "Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_nginx",
					"type_uid": "nginx_access",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "$remote_addr - $remote_user [$time_local] \"$request\" $status $body_bytes_sent \"$http_referer\" \"$http_user_agent\" \"$http_x_forwarded_for\"",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							result = result.replace(/combined/g, "$remote_addr - $remote_user [$time_local] \"$request\" $status $body_bytes_sent \"$http_referer\" \"$http_user_agent\"");
							return result;
						},
						"postBuild": function (result) {
							if (result != "") {
								var reg = new RegExp("\\$(\\w+)", "g");
								result = result.replace(reg, "{text:$1, ftype=$1}");
								result = result + "{eoe}"
							}
							return result;
						},
						"patternMatch": "\\$[\\w_]+",
						"filters":
						[{
								"filter": [{
										"match": "$time_local"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "dd/MMM/yyyy:HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$time_iso8601"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "yyyy-MM-dd'T'HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$arg_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Argument Name"
								}
							}, {
								"filter": [{
										"match": "$args"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Query String",
									"ftype": "querystring"
								}
							}, {
								"filter": [{
										"match": "$body_bytes_sent"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "$binary_remote_addr"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Binary Remote IP",
									"ftype": "binaryremoteip"
								}
							}, {
								"filter": [{
										"match": "$bytes_sent"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "$connection"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Connection Serial Number",
									"ftype": "connserial"
								}
							}, {
								"filter": [{
										"match": "$connection_requests"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Connection Requests",
								    "ftype": "numofrequests"
								}
							}, {
								"filter": [{
										"match": "$content_length"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Content Length",
									"ftype": "contentlength"
								}
							}, {
								"filter": [{
										"match": "$content_type"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Content Type",
									"ftype": "contenttype"
								}
							}, {
								"filter": [{
										"match": "$cookie_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Cookie",
									"ftype": "cookie"
								}
							}, {
								"filter": [{
										"match": "$document_root"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Document Root",
									"ftype": "documentroot"
								}
							}, {
								"filter": [{
										"match": "$document_uri"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request URL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "$geoip_country_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Country Name",
									"ftype": "countryname"
								}
							}, {
								"filter": [{
										"match": "$geoip_country_code"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Country Code",
									"ftype": "countrycode"
								}
							}, {
								"filter": [{
										"match": "$geoip_region_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Region",
									"ftype": "region"
								}
							}, {
								"filter": [{
										"match": "$geoip_city"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "City",
									"ftype": "city"
								}
							}, {
								"filter": [{
										"match": "$http_x_forwarded_for"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "X-Forwarded-For",
									"ftype": "forwardforip"
								}
							}, {
								"filter": [{
										"match": "$host"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Server Name",
									"ftype": "servername"
								}
							}, {
								"filter": [{
										"match": "$hostname"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "RemoteHost",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "$http_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "HTTP Name",
									"ftype": "httpname"
								}
							}, {
								"filter": [{
										"match": "$https"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SSL",
									"ftype": "https"
								}
							}, {
								"filter": [{
										"match": "$is_args"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Has Query Arguments"
								}
							}, {
								"filter": [{
										"match": "$limit_rate"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Rate Limiting"
								}
							}, {
								"filter": [{
										"match": "$msec"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{timestamp:Date,yyyy-MM-dd HH:mm:ss.SSS}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$nginx_version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "NGINX Version"
								}
							}, {
								"filter": [{
										"match": "$pid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Process ID",
									"ftype": "processid"
								}
							}, {
								"filter": [{
										"match": "$pipe"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "PIPE"
								}
							}, {
								"filter": [{
										"match": "$proxy_protocol_addr"
									}
								],
								"type": "IP",
								"function": {
									"filedName": " X-Forwarded-For",
									"ftype": "forwardforip"
								}
							}, {
								"filter": [{
										"match": "$proxy_protocol_port"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Client Port",
									"ftype": "clientport"
								}
							}, {
								"filter": [{
										"match": "$query_string"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Query String",
									"ftype": "querystring"
								}
							}, {
								"filter": [{
										"match": "$realpath_root"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Real Path"
								}
							}, {
								"filter": [{
										"match": "$remote_addr"
									}
								],
								"type": "GeoIp",
								"function": {
									"filedName": "Remote IP",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "$remote_port"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Remote Port",
									"ftype": "remoteport"
								}
							}, {
								"filter": [{
										"match": "$remote_user"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Remote User",
									"ftype": "remoteuser"
								}
							}, {
								"filter": [{
										"match": "$request"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD} {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,} {text:Request Protocol,ftype=reqprotocol;,}";
									}
								}
							}, {
								"filter": [{
										"match": "$request_body"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Body"
								}
							}, {
								"filter": [{
										"match": "$request_body_file"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Body File"
								}
							}, {
								"filter": [{
										"match": "$request_completion"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Completion"
								}
							}, {
								"filter": [{
										"match": "$request_filename"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request File Name"
								}
							}, {
								"filter": [{
										"match": "$request_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Identifier"
								}
							}, {
								"filter": [{
										"match": "$request_length"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Request Length"
								}
							}, {
								"filter": [{
										"match": "$request_method"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$request_time"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Request Time",
									"ftype": "reqtime"
								}
							}, {
								"filter": [{
										"match": "$request_uri"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request URL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "$scheme"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Protocol",
									"ftype": "reqprotocol"
								}
							}, {
								"filter": [{
										"match": "$sent_http_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sent Http Name",
									"ftype": "senthttp"
								}
							}, {
								"filter": [{
										"match": "$sent_trailer_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sent Trailer Name",
									"ftype": "trailername"
								}
							}, {
								"filter": [{
										"match": "$server_addr"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Local IP",
									"ftype": "localip"
								}
							}, {
								"filter": [{
										"match": "$server_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Server Name",
									"ftype": "servername"
								}
							}, {
								"filter": [{
										"match": "$server_port"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Server Port",
									"ftype": "serverport"
								}
							}, {
								"filter": [{
										"match": "$server_protocol"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Protocol",
									"ftype": "reqprotocol"
								}
							}, {
								"filter": [{
										"match": "$status"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Response Status",
									"ftype": "respstatus"
								}
							}, {
								"filter": [{
										"match": "$tcpinfo_rtt"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "TCP Info RTT"
								}
							}, {
								"filter": [{
										"match": "$tcpinfo_rttvar"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "TCP Info RTTVAR"
								}
							}, {
								"filter": [{
										"match": "$tcpinfo_snd_cwnd"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "TCP Info SND CWND"
								}
							}, {
								"filter": [{
										"match": "$tcpinfo_rcv_space"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "TCP Info RCV SPACE"
								}
							}, {
								"filter": [{
										"match": "$uri"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request URL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "$http_user_agent"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User Agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "$upstream_addr"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Upstream Address",
									"ftype": "upstreamaddr"
								}
							}, {
								"filter": [{
										"match": "$upstream_status"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Upstream Status",
									"ftype": "upstreamstatus"
								}
							}, {
								"filter": [{
										"match": "$upstream_response_time"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Upstream Response Time",
									"ftype": "upstreamresponsetime"
								}
							}, {
								"filter": [{
										"match": "$http_referer"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "\\$http_([\\w_]+)",
										"isLast": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{string:HTTP_" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "\\$sent_http_([\\w_]+)",
										"isLast": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{string:SENT_HTTP_" + regexp_params[1] + "}";
									}
								}
							}
						]
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "In the NGINX configuration file, usually nginx.conf, by default located under \"NGINX_ROOT_DIR/conf/nginx.conf\"). Search for the log_format directive.",
					"typetag": "nginx,w3c,webserver,error",
					"name": "Error",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,yyyy/MM/dd HH:mm:ss} [{priority:Level,ftype=severity,debug;info;notice;warn;error;crit;alert;emerg}] {text:PID,ftype=processid}#{text:TID,ftype=threadid}: {text:CID,ftype=connectionid} {string:Message,ftype=message}, client: {geoip:Remote IP,ftype=remoteip}, server: {geoip:LocalIP,ftype=localip}, request: \"{choice:Method,ftype=reqmethod;,GET;POST} {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,} {string:reqprotocol,ftype=reqprotocol;,}\", host: \"{text:Remotehost,ftype=host}\"{block,start,emptiness=true}, referrer: \"{text:RefererQuery,ftype=refererquery;,}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\w-]+://[^?]+|/[^?]+)}\"{block,end,emptiness=true}\n{date:Date,yyyy/MM/dd HH:mm:ss} [{priority:Level,ftype=severity,debug;info;notice;warn;error;crit;alert;emerg}] {text:PID,ftype=processid}#{text:TID,ftype=threadid}: {text:CID,ftype=connectionid} {string:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_nginx",
					"type_uid": "nginx_error",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,yyyy/MM/dd HH:mm:ss} [{priority:Level,ftype=level,debug;info;notice;warn;error;crit;alert;emerg}] {text:PID,ftype=processid}#{text:TID,ftype=threadid}: {text:CID,ftype=connectionid} {string:Message,ftype=message}, client: {geoip:Remote IP,ftype=remoteip}, server: {geoip:LocalIP,ftype=localip}, request: \"{choice:Method,ftype=reqmethod;,GET;POST} {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,} {string:reqprotocol,ftype=reqprotocol;,}\", host: \"{text:Remotehost,ftype=host}\"{block,start,emptiness=true}, referrer: \"{text:RefererQuery,ftype=refererquery;,}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\w-]+://[^?]+|/[^?]+)}\"{block,end,emptiness=true}\n{date:Date,yyyy/MM/dd HH:mm:ss} [{priority:Level,ftype=level,debug;info;notice;warn;error;crit;alert;emerg}] {text:PID,ftype=processid}#{text:TID,ftype=threadid}: {text:CID,ftype=connectionid} {string:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}
		]
	}
});
