function getName() {
	return "paloalto";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "paloalto",
		"apptags": "",
		"displayName": "Palo Alto",
		"typetag": "paloalto",
		"name": "paloalto",
		"description": "",
		"type": "firewalls",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_paloalto",
		"version": "current",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$vsys,$eventid,$object,$fmt,$id,$module,$severity,$opaque,$seqno,$actionflags,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name$message",
					"howto": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_paloalto",
					"typetag": "syslog,paloalto,system,audit",
					"name": "System",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_paloalto",
					"type_uid": "paloalto_system",
					"parser_specification": {
						"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$vsys,$eventid,$object,$fmt,$id,$module,$severity,$opaque,$seqno,$actionflags,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name$message",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"patternMatch": "\\$[\\w_-]+",
						"filters":
						[{
								"filter": [{
										"match": "$actionflags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action Flags",
									"ftype": "actionflags"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Receive-Time",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-number-of-severity"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "CEF-Number-Of-Severity",
									"ftype": "cefnumberofseverity"
								}
							}, {
								"filter": [{
										"match": "$configversion"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Config Version",
									"ftype": "configversion"
								}
							}, {
								"filter": [{
										"match": "$dev"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device",
									"ftype": "device"
								}
							}, {
								"filter": [{
										"match": "$domain"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Domain",
									"ftype": "domain"
								}
							}, {
								"filter": [{
										"match": "$device_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device Name",
									"ftype": "devicename"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_1"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_1",
									"ftype": "dghierlevel1"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_2"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_2",
									"ftype": "dghierlevel2"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_3"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_3",
									"ftype": "dghierlevel3"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_4"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_4",
									"ftype": "dghierlevel4"
								}
							}, {
								"filter": [{
										"match": "$eventid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Event ID",
									"ftype": "eventName"
								}
							}, {
								"filter": [{
										"match": "$fmt"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "fmt",
									"ftype": "fmt"
								}
							}, {
								"filter": [{
										"match": "$id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ID",
									"ftype": "id"
								}
							}, {
								"filter": [{
										"match": "$module"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Module",
									"ftype": "module"
								}
							}, {
								"filter": [{
										"match": "$number-of-severity"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Number-Of-Severity",
									"ftype": "numberofseverity"
								}
							}, {
								"filter": [{
										"match": "$object"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Object,ftype=object}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$message"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true},{string:Message}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$opaque"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "\"{text:Description,ftype=message;,}\"{regexp:Username,ftype=username;refName=Description,(Failed password for |User |for user \\u0027|Password changed for user |failed authentication for user \\u0027 |authenticated for user \\u0027)[XPLG_PARAM([^\\u0027\\s]+)].*}{regexp:Source,ftype=sourceip;refName=Description,(From: |from )[XPLG_PARAM([^\\s]\\d+\\.\\d+\\.\\d+\.\\d+)].*}{regexp:logout,ftype=logout;refName=Description,logged out}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Receive Time",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$sender_sw_version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender_Sw_Version",
									"ftype": "senderswversion"
								}
							}, {
								"filter": [{
										"match": "$seqno"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sequence Number",
									"ftype": "sequencenumber"
								}
							}, {
								"filter": [{
										"match": "$serial"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Serial#",
									"ftype": "serial"
								}
							}, {
								"filter": [{
										"match": "$severity"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{priority:Severity,ftype=status;High;Medium;Low;Informational}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$subtype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Subtype",
									"ftype": "subtype"
								}
							}, {
								"filter": [{
										"match": "$time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$type"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Type",
									"ftype": "eventSource"
								}
							}, {
								"filter": [{
										"match": "$vsys"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System,ftype=virtualsystem}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_id"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System ID,ftype=virtualsystemid}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Virtual System Name",
									"ftype": "vsysname"
								}
							}
                          ]					   
                        }  					   
					} 
				}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$host,$vsys,$cmd,$admin,$client,$result,$path,$seqno,$actionflags,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name$message",
					"howto": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_paloalto",
					"typetag": "syslog,paloalto,configuration,audit",
					"name": "Configuration",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_paloalto",
					"type_uid": "paloalto_configuration",
					"parser_specification": {
						"defaultPattern": "$dev $domain,$type,$subtype,$configversion,$time_generated,$host,$vsys,$cmd,$admin,$client,$result,$path,$seqno,$actionflags,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name$message",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"patternMatch": "\\$[\\w_-]+",
						"filters":
						[{
								"filter": [{
										"match": "$actionflags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action Flags",
									"ftype": "actionflags"
								}
							}, {
								"filter": [{
										"match": "$admin"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Admin",
									"ftype": "username"
								}
							}, {
								"filter": [{
										"match": "$after-change-detail"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "After-Change-Detail",
									"ftype": "afterchangedetail"
								}
							}, {
								"filter": [{
										"match": "$before-change-detail"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Before-Change-Detail",
									"ftype": "beforechangedetail"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Receive-Time",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$configversion"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Config Version",
									"ftype": "configversion"
								}
							}, {
								"filter": [{
										"match": "$client"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Client,ftype=client,Web,CLI}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$cmd"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:CMD,ftype=command,add,clone.commit,delete,edit,move,rename,set}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$dev"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device",
									"ftype": "device"
								}
							}, {
								"filter": [{
										"match": "$domain"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Domain",
									"ftype": "domain"
								}
							}, {
								"filter": [{
										"match": "$device_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device Name",
									"ftype": "devicename"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_1"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_1",
									"ftype": "dghierlevel1"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_2"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_2",
									"ftype": "dghierlevel2"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_3"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_3",
									"ftype": "dghierlevel3"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_4"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_4",
									"ftype": "dghierlevel4"
								}
							}, {
								"filter": [{
										"match": "$message"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true},{string:Message}{block,end,emptiness=true}";
                                    }
                                }
							},{
								"filter": [{
										"match": "$host"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{geoip:Host,ftype=sourceip;type=country:region:city;,}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$path"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:Configuration-path,ftype=path}{regexp:Event Name,ftype=eventName;refName=configuration-path,config mgt-config users|config shared local-user-database user |config shared local-user-database user-group|config shared admin-role|config shared authentication-profile|config mgt-config password-profile}{regexp:Audited_Object,ftype=auditedobject;refName=configuration-path,(config mgt-config users|config shared local-user-database user |config shared local-user-database user-group |config shared admin-role |config shared authentication-profile |config mgt-config password-profile )[XPLG_PARAM([^,]+)]}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Receive Time",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$result"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Result,ftype=status,Submitted,Succeeded,Failed,Unauthorized}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$sender_sw_version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender_Sw_Version",
									"ftype": "senderswversion"
								}
							}, {
								"filter": [{
										"match": "$seqno"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sequence Number",
									"ftype": "sequencenumber"
								}
							}, {
								"filter": [{
										"match": "$serial"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Serial#",
									"ftype": "serial"
								}
							}, {
								"filter": [{
										"match": "$subtype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Subtype",
									"ftype": "subtype"
								}
							}, {
								"filter": [{
										"match": "$time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$type"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Type",
									"ftype": "eventSource"
								}
							}, {
								"filter": [{
										"match": "$vsys"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System,ftype=virtualsystem}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_id"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System ID,ftype=virtualsystemid}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Virtual System Name",
									"ftype": "vsysname"
								}
							}
					    ]
					}
				}
		    } , {
				"log": {
					"xdoclink": "",
					"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$src,$dst,$natsrc,$natdst,$rule,$srcuser,$dstuser,$app,$vsys,$srczone,$dstzone,$inbound_if,$outbound_if,$logset,$time_logged,$sessionid,$repeatcnt,$sport,$dport,$natsport,$natdport,$flags,$proto,$action,$file_url,$contentname,$category,$severity,$direction,$seqno,$actionflags,$srcloc,$dstloc,$padding,$contenttype,$pcap_id,$filedigest,$cloud,$url_idx,$user_agent,$filetype,$xff,$referer,$sender,$subject,$recipient,$reportid,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name,$file_url1,$src_uuid,$dst_uuid,$http_method,$imsi,$imei,$parent_session_id,$parent_start_time,$tunnel,$thr_category,$contentver,$sig_flags,$assoc_id,$ppid,$http_headers$message",
					"howto": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_paloalto",
					"typetag": "syslog,paloalto,threat",
					"name": "Threat",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_paloalto",
					"type_uid": "paloalto_threat",
					"parser_specification": {
						"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$src,$dst,$natsrc,$natdst,$rule,$srcuser,$dstuser,$app,$vsys,$srczone,$dstzone,$inbound_if,$outbound_if,$logset,$time_logged,$sessionid,$repeatcnt,$sport,$dport,$natsport,$natdport,$flags,$proto,$action,$file_url,$contentname,$category,$severity,$direction,$seqno,$actionflags,$srcloc,$dstloc,$padding,$contenttype,$pcap_id,$filedigest,$cloud,$url_idx,$user_agent,$filetype,$xff,$referer,$sender,$subject,$recipient,$reportid,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name,$file_url1,$src_uuid,$dst_uuid,$http_method,$imsi,$imei,$parent_session_id,$parent_start_time,$tunnel,$thr_category,$contentver,$sig_flags,$assoc_id,$ppid,$http_headers$message",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"patternMatch": "\\$[\\w_-]+",
						"filters":
						[{
								"filter": [{
										"match": "$action"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action",
									"ftype": "eventName"
								}
							}, {
								"filter": [{
										"match": "$actionflags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action Flags",
									"ftype": "actionflags"
								}
							}, {
								"filter": [{
										"match": "$app"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Application",
									"ftype": "application"
								}
							}, {
								"filter": [{
										"match": "$assoc_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SCTP Assoication ID",
									"ftype": "sctpassociationid"
								}
							}, {
								"filter": [{
										"match": "$category"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Category",
									"ftype": "category"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Receive-Time",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-number-of-severity"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "CEF-Number-Of-Severity",
									"ftype": "cefnumberofseverity"
								}
							}, {
								"filter": [{
										"match": "$cloud"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Cloud",
									"ftype": "cloud"
								}
							}, {
								"filter": [{
										"match": "$configversion"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Config Version",
									"ftype": "configversion"
								}
							}, {
								"filter": [{
										"match": "$contentname"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Threat/Content Name",
									"ftype": "threatcontentname"
								}
							}, {
								"filter": [{
										"match": "$contenttype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Content Type",
									"ftype": "contenttype"
								}
							}, {
								"filter": [{
										"match": "$contentver"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Content Version",
									"ftype": "contentversion"
								}
							}, {
								"filter": [{
										"match": "$dev"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device",
									"ftype": "device"
								}
							}, {
								"filter": [{
										"match": "$domain"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Domain",
									"ftype": "domain"
								}
							}, {
								"filter": [{
										"match": "$device_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device Name",
									"ftype": "devicename"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_1"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_1",
									"ftype": "dghierlevel1"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_2"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_2",
									"ftype": "dghierlevel2"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_3"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_3",
									"ftype": "dghierlevel3"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_4"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_4",
									"ftype": "dghierlevel4"
								}
							}, {
								"filter": [{
										"match": "$direction"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Direction",
									"ftype": "direction"
								}
							}, {
								"filter": [{
										"match": "$dport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Destination Port",
									"ftype": "dstport"
								}
							}, {
								"filter": [{
										"match": "$dst"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Destination IP",
									"ftype": "targetip"
								}
							}, {
								"filter": [{
										"match": "$dst_uuid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination VM UUID",
									"ftype": "targetvmuuid"
								}
							}, {
								"filter": [{
										"match": "$dstloc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination Country",
									"ftype": "dstcountry"
								}
							}, {
								"filter": [{
										"match": "$dstuser"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination User",
									"ftype": "dstusername"
								}
							}, {
								"filter": [{
										"match": "$dstzone"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination Zone",
								 	"ftype": "dstzone"
								}
							},{
								"filter": [{
										"match": "$file_url"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$file_url1"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{url:URL1,paramsFtype=querystring1;ftype=requrl1;paramsName=Query1;,}";
                                    }
                                }
							},{
								"filter": [{
										"match": "$filedigest"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "File Digest",
									"ftype": "filedigest"
								}
							}, {
								"filter": [{
										"match": "$filetype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "File Type",
									"ftype": "filetype"
								}
							}, {
								"filter": [{
										"match": "$flags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Flags",
									"ftype": "flags"
								}
							}, {
								"filter": [{
										"match": "$from"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "From",
									"ftype": "from"
								}
							}, {
								"filter": [{
										"match": "$http_headers"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "HTTP Headers",
									"ftype": "httpheaders"
								}
							}, {
								"filter": [{
										"match": "$http_method"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,Connect;Delete;Get;Head;Options;Post;Put}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$imei"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Monitor Tag/IMEI",
									"ftype": "monitortag"
								}
							}, {
								"filter": [{
										"match": "$imsi"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel ID/IMSI",
									"ftype": "tunnelid"
								}
							}, {
								"filter": [{
										"match": "$inbound_if"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Inbound Interface",
									"ftype": "srcintf"
								}
							}, {
								"filter": [{
										"match": "$logset"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Log Action",
									"ftype": "logaction"
								}
							}, {
								"filter": [{
										"match": "$message"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true},{string:Message}{block,end,emptiness=true}";
                                    }
                                }
							},{
								"filter": [{
										"match": "$misc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "MISC",
									"ftype": "misc"
								}
							}, {
								"filter": [{
										"match": "$monitortag"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Monitor Tag",
									"ftype": "monitortag"
								}
							}, {
								"filter": [{
										"match": "$natdport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Nat Destination Port",
									"ftype": "natdstport"
								}
							}, {
								"filter": [{
										"match": "$natdst"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Nat Destination IP",
									"ftype": "nattargetip"
								}
							}, {
								"filter": [{
										"match": "$natsport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Nat Source Port",
									"ftype": "natsrcport"
								}
							}, {
								"filter": [{
										"match": "$natsrc"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Nat SourceIP",
									"ftype": "natsourceip"
								}
							}, {
								"filter": [{
										"match": "$number-of-severity"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Number-Of-Severity",
									"ftype": "numberofseverity"
								}
							}, {
								"filter": [{
										"match": "$outbound_if"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Outbound Interface",
									"ftype": "dstintf"
								}
							}, {
								"filter": [{
										"match": "$padding"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "cpadding",
									"ftype": "cpadding"
								}
							}, {
								"filter": [{
										"match": "$parent_session_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Parent Session ID",
									"ftype": "parentsessionid"
								}
							}, {
								"filter": [{
										"match": "$parent_start_time"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Parent Start Time",
									"ftype": "parentstarttime"
								}
							}, {
								"filter": [{
										"match": "$pcap_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "PCAP ID",
									"ftype": "pcapap"
								}
							}, {
								"filter": [{
										"match": "$ppid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Payload Protocol ID",
									"ftype": "payloadprotocolid"
								}
							}, {
								"filter": [{
										"match": "$proto"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "IP Protocol",
									"ftype": "ipprotocol"
								}
							}, {
								"filter": [{
										"match": "$receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Receive Time",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$recipient"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Recipient",
									"ftype": "recipient"
								}
							}, {
								"filter": [{
										"match": "$referer"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery;,}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\w-]+://[^?]+|/[^?]+)}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$repeatcnt"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Repeat Count",
									"ftype": "repeatcount"
								}
							}, {
								"filter": [{
										"match": "$reportid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Report ID",
									"ftype": "reportid"
								}
							}, {
								"filter": [{
										"match": "$rule"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Rule Name",
									"ftype": "rulename"
								}
							}, {
								"filter": [{
										"match": "$sender"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender",
									"ftype": "sender"
								}
							}, {
								"filter": [{
										"match": "$sender_sw_version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender_Sw_Version",
									"ftype": "senderswversion"
								}
							}, {
								"filter": [{
										"match": "$seqno"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sequence Number",
									"ftype": "sequencenumber"
								}
							}, {
								"filter": [{
										"match": "$serial"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Serial#",
									"ftype": "serial"
								}
							}, {
								"filter": [{
										"match": "$sessionid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SessionID",
									"ftype": "sessionid"
								}
							}, {
								"filter": [{
										"match": "$severity"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{priority:Severity,ftype=status;Critical;High;Medium;Low;Informational}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$sig_flags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SIG_Flags",
									"ftype": "sigflafs"
								}
							}, {
								"filter": [{
										"match": "$sport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Source Port",
									"ftype": "sourceport"
								}
							}, {
								"filter": [{
										"match": "$src"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "SourceIP",
									"ftype": "sourceip"
								}
							}, {
								"filter": [{
										"match": "$src_uuid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source VM UUID",
									"ftype": "sourcevmuuid"
								}
							}, {
								"filter": [{
										"match": "$srcloc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source Country",
									"ftype": "srccountry"
								}
							}, {
								"filter": [{
										"match": "$srcuser"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source User",
									"ftype": "username"
								}
							}, {
								"filter": [{
										"match": "$srczone"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source Zone",
								 	"ftype": "srczone"
								}
							}, {
								"filter": [{
										"match": "$subject"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Subject",
									"ftype": "subject"
								}
							}, {
								"filter": [{
										"match": "$subtype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Subtype",
									"ftype": "subtype"
								}
							}, {
								"filter": [{
										"match": "$thr_category"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Threat Category",
									"ftype": "threatcategory"
								}
							}, {
								"filter": [{
										"match": "$threatid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ThreadID",
									"ftype": "threatid"
								}
							}, {
								"filter": [{
										"match": "$time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$time_logged"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Time Logged",
									"ftype": "timelogged"
								}
							}, {
								"filter": [{
										"match": "$time_received"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Time Received",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$to"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "To",
									"ftype": "to"
								}
							}, {
								"filter": [{
										"match": "$tunnel"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel Type",
									"ftype": "tunneltype"
								}
							}, {
								"filter": [{
										"match": "$tunnelid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel ID",
									"ftype": "tunnelid"
								}
							}, {
								"filter": [{
										"match": "$type"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Type",
									"ftype": "eventSource"
								}
							}, {
								"filter": [{
										"match": "$url_idx"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "URL Index",
									"ftype": "urlindex"
								}
							}, {
								"filter": [{
										"match": "$user_agent"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User Agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "$vsys"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System,ftype=virtualsystem}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_id"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System ID,ftype=virtualsystemid}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Virtual System Name",
									"ftype": "vsysname"
								}
							} , {
								"filter": [{
										"match": "$xff"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "X-Forwarded-For",
									"ftype": "forwardedforip"
								}
							}								
		                 ]		
					}
                }					
	        } , {
				"log": {
					"xdoclink": "",
					"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$src,$dst,$natsrc,$natdst,$rule,$srcuser,$dstuser,$app,$vsys,$srczone,$dstzone,$inbound_if,$outbound_if,$logset,$time_logged,$sessionid,$repeatcnt,$sport,$dport,$natsport,$natdport,$flags,$proto,$action,$bytes,$bytes_sent,$bytes_received,$packets,$start,$elapsed,$category,$tpadding,$seqno,$actionflags,$srcloc,$dstloc,$cpadding,$pkts_sent,$pkts_received,$session_end_reason,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name,$action_source,$src_uuid,$dst_uuid,$tunnelid,$monitortag,$parent_session_id,$parent_start_time,$tunnel,$assoc_id,$chunks,$chunks_sent,$chunks_received$message",
					"howto": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_paloalto",
					"typetag": "syslog,paloalto,traffic",
					"name": "Traffic",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_paloalto",
					"type_uid": "paloalto_traffic",
					"parser_specification": {
						"defaultPattern": "$dev $domain,$receive_time,$serial,$type,$subtype,$configversion,$time_generated,$src,$dst,$natsrc,$natdst,$rule,$srcuser,$dstuser,$app,$vsys,$srczone,$dstzone,$inbound_if,$outbound_if,$logset,$time_logged,$sessionid,$repeatcnt,$sport,$dport,$natsport,$natdport,$flags,$proto,$action,$bytes,$bytes_sent,$bytes_received,$packets,$start,$elapsed,$category,$tpadding,$seqno,$actionflags,$srcloc,$dstloc,$cpadding,$pkts_sent,$pkts_received,$session_end_reason,$dg_hier_level_1,$dg_hier_level_2,$dg_hier_level_3,$dg_hier_level_4,$vsys_name,$device_name,$action_source,$src_uuid,$dst_uuid,$tunnelid,$monitortag,$parent_session_id,$parent_start_time,$tunnel,$assoc_id,$chunks,$chunks_sent,$chunks_received$message",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"patternMatch": "\\$[\\w_-]+",
						"filters":
						[{
								"filter": [{
										"match": "$action"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action",
									"ftype": "eventName"
								}
							}, {
								"filter": [{
										"match": "$action_source"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action Source",
									"ftype": "actionsource"
								}
							}, {
								"filter": [{
										"match": "$actionflags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Action Flags",
									"ftype": "actionflags"
								}
							}, {
								"filter": [{
										"match": "$app"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Application",
									"ftype": "application"
								}
							}, {
								"filter": [{
										"match": "$assoc_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SCTP Assoication ID",
									"ftype": "sctpassociationid"
								}
							}, {
								"filter": [{
										"match": "$bytes"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes",
									"ftype": "bytes"
								}
							}, {
								"filter": [{
										"match": "$bytes_received"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Bytes Received",
									"ftype": "bytesreceived"
								}
							}, {
								"filter": [{
										"match": "$bytes_sent"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "$category"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Category",
									"ftype": "category"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Receive-Time",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-formatted-time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "MMM dd yyyy HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "$cef-number-of-severity"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "CEF-Number-Of-Severity",
									"ftype": "cefnumberofseverity"
								}
							}, {
								"filter": [{
										"match": "$chunks"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "SCTP Chunks",
									"ftype": "chunks"
								}
							}, {
								"filter": [{
										"match": "$chunks_sent"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "SCTP Chunks Sent",
									"ftype": "chunkssent"
								}
							},{
								"filter": [{
										"match": "$chunks_received"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "SCTP Chunks Received",
									"ftype": "chunksreceived"
								}
							}, {
								"filter": [{
										"match": "$configversion"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Config Version",
									"ftype": "configversion"
								}
							}, {
								"filter": [{
										"match": "$cpadding"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "cpadding",
									"ftype": "cpadding"
								}
							}, {
								"filter": [{
										"match": "$dev"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device",
									"ftype": "device"
								}
							}, {
								"filter": [{
										"match": "$message"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true},{string:Message}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$domain"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Domain",
									"ftype": "domain"
								}
							}, {
								"filter": [{
										"match": "$device_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Device Name",
									"ftype": "devicename"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_1"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_1",
									"ftype": "dghierlevel1"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_2"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_2",
									"ftype": "dghierlevel2"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_3"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_3",
									"ftype": "dghierlevel3"
								}
							}, {
								"filter": [{
										"match": "$dg_hier_level_4"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "dg_hier_level_4",
									"ftype": "dghierlevel4"
								}
							}, {
								"filter": [{
										"match": "$dport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Destination Port",
									"ftype": "dstport"
								}
							}, {
								"filter": [{
										"match": "$dst"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Destination IP",
									"ftype": "targetip"
								}
							}, {
								"filter": [{
										"match": "$dst_uuid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination VM UUID",
									"ftype": "targetvmuuid"
								}
							}, {
								"filter": [{
										"match": "$dstloc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination Country",
									"ftype": "dstcountry"
								}
							}, {
								"filter": [{
										"match": "$dstuser"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination User",
									"ftype": "dstusername"
								}
							}, {
								"filter": [{
										"match": "$dstzone"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Destination Zone",
								 	"ftype": "dstzone"
								}
							}, {
								"filter": [{
										"match": "$elapsed"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Elapsed Time(sec)",
								 	"ftype": "elapsedtime"
								}
							}, {
								"filter": [{
										"match": "$flags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Flags",
									"ftype": "flags"
								}
							}, {
								"filter": [{
										"match": "$from"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "From",
									"ftype": "from"
								}
							}, {
								"filter": [{
										"match": "$imei"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Monitor Tag/IMEI",
									"ftype": "monitortag"
								}
							}, {
								"filter": [{
										"match": "$imsi"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel ID/IMSI",
									"ftype": "tunnelid"
								}
							}, {
								"filter": [{
										"match": "$inbound_if"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Inbound Interface",
									"ftype": "srcintf"
								}
							}, {
								"filter": [{
										"match": "$logset"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Log Action",
									"ftype": "logaction"
								}
							}, {
								"filter": [{
										"match": "$misc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "MISC",
									"ftype": "misc"
								}
							}, {
								"filter": [{
										"match": "$monitortag"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Monitor Tag",
									"ftype": "monitortag"
								}
							}, {
								"filter": [{
										"match": "$natdport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Nat Destination Port",
									"ftype": "natdstport"
								}
							}, {
								"filter": [{
										"match": "$natdst"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Nat Destination IP",
									"ftype": "nattargetip"
								}
							}, {
								"filter": [{
										"match": "$natsport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Nat Source Port",
									"ftype": "natsourceport"
								}
							}, {
								"filter": [{
										"match": "$natsrc"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Nat SourceIP",
									"ftype": "natsourceip"
								}
							}, {
								"filter": [{
										"match": "$ndpmatches"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "NDP Matches",
									"ftype": "ndpmatches"
								}
							},{
								"filter": [{
										"match": "$nftrans"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "NF Trans",
									"ftype": "nftrans"
								}
							},{
								"filter": [{
										"match": "$nthreats"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "N Threats",
									"ftype": "ntrheats"
								}
							},{
								"filter": [{
										"match": "$nurlcount"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "URL Count",
									"ftype": "nurlcount"
								}
							}, {
								"filter": [{
										"match": "$outbound_if"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Outbound Interface",
									"ftype": "dstintf"
								}
							}, {
								"filter": [{
										"match": "$packets"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Packets",
									"ftype": "packets"
								}
							}, {
								"filter": [{
										"match": "$parent_session_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Parent Session ID",
									"ftype": "parentsessionid"
								}
							}, {
								"filter": [{
										"match": "$parent_start_time"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Parent Start Time",
									"ftype": "parentstarttime"
								}
							}, {
								"filter": [{
										"match": "$pkts_received"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Received Packets",
									"ftype": "rcvdpkt"
								}
							}, {
								"filter": [{
										"match": "$pkts_sent"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Sent Packets",
									"ftype": "sentpkt"
								}
							}, {
								"filter": [{
										"match": "$pcap_id"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "PCAP ID",
									"ftype": "pcapap"
								}
							}, {
								"filter": [{
										"match": "$proto"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "IP Protocol",
									"ftype": "ipprotocol"
								}
							}, {
								"filter": [{
										"match": "$receive_time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Receive Time",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$repeatcnt"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Repeat Count",
									"ftype": "repeatcount"
								}
							}, {
								"filter": [{
										"match": "$rule"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Rule Name",
									"ftype": "rulename"
								}
							}, {
								"filter": [{
										"match": "$sender"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender",
									"ftype": "sender"
								}
							}, {
								"filter": [{
										"match": "$sender_sw_version"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sender_Sw_Version",
									"ftype": "senderswversion"
								}
							}, {
								"filter": [{
										"match": "$seqno"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Sequence Number",
									"ftype": "sequencenumber"
								}
							}, {
								"filter": [{
										"match": "$serial"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Serial#",
									"ftype": "serial"
								}
							}, {
								"filter": [{
										"match": "$session_end_reason"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Session End Reason",
									"ftype": "sessionendreason"
								}
							}, {
								"filter": [{
										"match": "$sessionid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "SessionID",
									"ftype": "sessionid"
								}
							}, {
								"filter": [{
										"match": "$severity"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{priority:Severity,ftype=status;Critical;High;Medium;Low;Informational}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$sport"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Source Port",
									"ftype": "sourceport"
								}
							}, {
								"filter": [{
										"match": "$src"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "SourceIP",
									"ftype": "sourceip"
								}
							}, {
								"filter": [{
										"match": "$src_uuid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source VM UUID",
									"ftype": "sourcevmuuid"
								}
							}, {
								"filter": [{
										"match": "$srcloc"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source Country",
									"ftype": "srccountry"
								}
							}, {
								"filter": [{
										"match": "$srcuser"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source User",
									"ftype": "username"
								}
							}, {
								"filter": [{
										"match": "$srczone"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Source Zone",
								 	"ftype": "srczone"
								}
							}, {
								"filter": [{
										"match": "$start"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Start",
									"ftype": "start"
								}
							}, {
								"filter": [{
										"match": "$subtype"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Subtype",
									"ftype": "subtype"
								}
							}, {
								"filter": [{
										"match": "$time_generated"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "CEF-Formatted-Time-Generated",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$time_logged"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Time Logged",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$time_received"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Time Received",
									"datePattern": "yyyy/MM/dd HH:mm:ss"
								}
							}, {
								"filter": [{
										"match": "$tpadding"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "tpadding",
									"ftype": "tpadding"
								}
							}, {
								"filter": [{
										"match": "$to"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "To",
									"ftype": "to"
								}
							}, {
								"filter": [{
										"match": "$traffic_flags"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Traffic Flags",
									"ftype": "trafficflags"
								}
							}, {
								"filter": [{
										"match": "$tunnel"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel Type",
									"ftype": "tunneltype"
								}
							}, {
								"filter": [{
										"match": "$tunnelid"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Tunnel ID",
									"ftype": "tunnelid"
								}
							}, {
								"filter": [{
										"match": "$type"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Type",
									"ftype": "eventSource"
								}
							}, {
								"filter": [{
										"match": "$vsys"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System,ftype=virtualsystem}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_id"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{block,start,emptiness=true}{text:Virtual System ID,ftype=virtualsystemid}{block,end,emptiness=true}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "$vsys_name"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Virtual System Name",
									"ftype": "vsysname"
								}
							} , {
								"filter": [{
										"match": "$xff"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "X-Forwarded-For",
									"ftype": "forwardedforip"
								}
							}								
		                 ]		
					}
                }   
           	}				
      ] 
   }	 
});
