function getName() {
	return "sap";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "sap",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,sm21,audit",
					"name": "SM21",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,SLGTTYP;SUBID;xpologName;CENTDATA;SENDER_ID;MONBEW;POS_CREATT#_#date::dateFormat=yyyyMMddHHmmss.SSS,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS;SLGFTYP;T100MSGNR;MONKAT;FILE_NO;DEVCLASS;AREA;CLASID;ERRNO;POS;xpologType;RECEVIVE_T;user#_#ftype=user#_#name=ZUSER;xpologLabels;xpologEnvironment#_#ftype=environment;T100ARBGB}{map:User Type,ftype=usertype;refIndex=18,file:knowledge/repository/system/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=18,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_sm21",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,SLGTTYP;SUBID;xpologName;CENTDATA;SENDER_ID;MONBEW;POS_CREATT#_#date::dateFormat=yyyyMMddHHmmss.SSS,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS;SLGFTYP;T100MSGNR;MONKAT;FILE_NO;DEVCLASS;AREA;CLASID;ERRNO;POS;xpologType;RECEVIVE_T;user#_#ftype=user#_#name=ZUSER;xpologLabels;xpologEnvironment#_#ftype=environment;T100ARBGB}{map:User Type,ftype=usertype;refIndex=18,file:knowledge/repository/system/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=18,file:knowledge/repository/system/useridentity.prop}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,sm20,audit",
					"name": "SM20",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-dd HH:mm:ss.SSSZ;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ALGFILEPOS;ALGFILENO;PARAM2#_#ftype=param2;PARAM1#_#ftype=param1;PARAM3#_#ftype=param3;ALGTEXT;PARAMREST;ZCLIENT#_#ftype=client;ZUSER#_#ftype=user;ZTERMINALNAME#_#ftype=terminal;ZTRANSACTIONCODE#_#ftype=transactioncode;ZPROGRAM#_#ftype=program;ZAUDITCLASS#_#ftype=auditclass;ZEVENTCLASS#_#ftype=eventclass;ZSUBNAME#_#ftype=subname;ZAUDITLOGMESSAGE#_#ftype=algtext}{regexp:Status,ftype=status;refName=ZAUDITLOGMESSAGE,Successful|successful|Failed|failed|Started|Status|Logoff|Locked in|Changed|changed|Created|Unlocked|created|passed}{regexp:Context Type,ftype=contexttype;refName=ZAUDITLOGMESSAGE,(\\w+).*}{regexp:Context,ftype=context;refName=ZAUDITLOGMESSAGE,(Field content changed:\\s|User Master Record\\s|Transaction\\s|transaction\\s|Report\\s|Type=|Type = |User\\s|by\\s\\w+\\sto\\s)[XPLG_PARAM([^\\s\\u0029]+)].*}{regexp:Type,ftype=type;refName=ZAUDITLOGMESSAGE,(Type = |type=|R=Type=|Type=)[XPLG_PARAM([^\\s\\,\\u0029]+)].*}{map:Login Type,ftype=logintype;refIndex=25,file:knowledge/repository/system/sap/map/login_type.prop}{regexp:Reason,ftype=reason;refName=ZAUDITLOGMESSAGE,(Reason = |reason=|Reason=)[XPLG_PARAM([^\\s\\,\\u0029]+)].*}{map:Login Reason,ftype=loginreason;refIndex=27,file:knowledge/repository/system/sap/map/login_reason.prop}{map:User Type,ftype=usertype;refIndex=13,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=13,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_sm20",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-dd HH:mm:ss.SSSZ;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ALGFILEPOS;ALGFILENO;PARAM2#_#ftype=param2;PARAM1#_#ftype=param1;PARAM3#_#ftype=param3;ALGTEXT;PARAMREST;ZCLIENT#_#ftype=client;ZUSER#_#ftype=user;ZTERMINALNAME#_#ftype=terminal;ZTRANSACTIONCODE#_#ftype=transactioncode;ZPROGRAM#_#ftype=program;ZAUDITCLASS#_#ftype=auditclass;ZEVENTCLASS#_#ftype=eventclass;ZSUBNAME#_#ftype=subname;ZAUDITLOGMESSAGE#_#ftype=algtext}{regexp:Status,ftype=status;refName=ZAUDITLOGMESSAGE,Successful|successful|Failed|failed|Started|Status|Logoff|Locked in|Changed|changed|Created|Unlocked|created|passed}{regexp:Context Type,ftype=contexttype;refName=ZAUDITLOGMESSAGE,(\\w+).*}{regexp:Context,ftype=context;refName=ZAUDITLOGMESSAGE,(Field content changed:\\s|User Master Record\\s|Transaction\\s|transaction\\s|Report\\s|Type=|Type = |User\\s|by\\s\\w+\\sto\\s)[XPLG_PARAM([^\\s\\u0029]+)].*}{regexp:Type,ftype=type;refName=ZAUDITLOGMESSAGE,(Type = |type=|R=Type=|Type=)[XPLG_PARAM([^\\s\\,\\u0029]+)].*}{map:Login Type,ftype=logintype;refIndex=25,file:knowledge/repository/system/sap/map/login_type.prop}{regexp:Reason,ftype=reason;refName=ZAUDITLOGMESSAGE,(Reason = |reason=|Reason=)[XPLG_PARAM([^\\s\\,\\u0029]+)].*}{map:Login Reason,ftype=loginreason;refIndex=27,file:knowledge/repository/system/sap/map/login_reason.prop}{map:User Type,ftype=usertype;refIndex=13,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=13,file:knowledge/repository/system/useridentity.prop}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,sm04",
					"name": "SM04",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,EXT_TIME;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;TRACE#_#ftype=trace;EXT_TRACE#_#ftype=exttrace;RFC_TYPE_LONG#_#ftype=rfctype;PAGING_BLOCKS;LINE_COL;APPLICATION#_#ftype=application;OPEN_TASKS;STATE#_#ftype=state;EXT_STATE;PRIORITY#_#ftype=priority;REQUEST_TIME;IPADDR;LOGON_PRIVILEGE;TOTAL_MEM_HYPER_KB;SESSION_HDL;SESSION_TYPE#_#ftype=sessiontype;SERVER_NAME#_#ftype=servername;LOGON_ID#_#ftype=logonid;LOCATION_INFO#_#ftype=location;SECURITY_CONTEXT;VERSION;SESSION_KEY#_#ftype=sessionid;TOTAL_MEM_KB;WEBSOCKET_HANDLE;TOTAL_MEM_BRUTTO_KB;TOTAL_MEM_ABAP_KB;SAP_GUI_VERSION;USER_NAME#_#ftype=user#_#name=ZUSER;TENANT;ZTIMESTAMP#_#date::dateFormat=yyyy-MM-dd HH:mm:ss.SSSZ;RFC_HDL;SELECTED;TOTAL_MEM_HEAP_KB;IP_ADDR;EXT_STYPE;SESSIONS;CLIENT_IP_ADDR#_#ftype=clientip;LOGON_HDL#_#ftype=logonhdl;APPL_INFO#_#ftype=appinfo;ACT_PROGRAM#_#ftype=program}{map:User Type,ftype=usertype;refIndex=32,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=32,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_sm04",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,EXT_TIME;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;TRACE#_#ftype=trace;EXT_TRACE#_#ftype=exttrace;RFC_TYPE_LONG#_#ftype=rfctype;PAGING_BLOCKS;LINE_COL;APPLICATION#_#ftype=application;OPEN_TASKS;STATE#_#ftype=state;EXT_STATE;PRIORITY#_#ftype=priority;REQUEST_TIME;IPADDR;LOGON_PRIVILEGE;TOTAL_MEM_HYPER_KB;SESSION_HDL;SESSION_TYPE#_#ftype=sessiontype;SERVER_NAME#_#ftype=servername;LOGON_ID#_#ftype=logonid;LOCATION_INFO#_#ftype=location;SECURITY_CONTEXT;VERSION;SESSION_KEY#_#ftype=sessionid;TOTAL_MEM_KB;WEBSOCKET_HANDLE;TOTAL_MEM_BRUTTO_KB;TOTAL_MEM_ABAP_KB;SAP_GUI_VERSION;USER_NAME#_#ftype=user#_#name=ZUSER;TENANT;ZTIMESTAMP#_#date::dateFormat=yyyy-MM-dd HH:mm:ss.SSSZ;RFC_HDL;SELECTED;TOTAL_MEM_HEAP_KB;IP_ADDR;EXT_STYPE;SESSIONS;CLIENT_IP_ADDR#_#ftype=clientip;LOGON_HDL#_#ftype=logonhdl;APPL_INFO#_#ftype=appinfo;ACT_PROGRAM#_#ftype=program}{map:User Type,ftype=usertype;refIndex=32,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=32,file:knowledge/repository/system/useridentity.prop}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,sm50",
					"name": "SM50",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;WP_TYPE_DISP;FAILURES;LINE_COL;CPU#_#ftype=cputime;PRIORITY#_#ftype=priority;ELAPSED_TYPE_DISP;AIN_PROGRAM;CPU_RAW#_#ftype=cpuraw;TRACE_LEVEL;RECONNECT_STATE;SESSION_HDL;RESTART;SESSION_TYPE#_#ftype=sessiontype;SERVER_NAME#_#ftype=servername;ELAPSED_TIME_DISP#_#ftype=elapsedtime;SEM_LOCKED;LOGON_ID#_#ftype=logonid;LAPSED_TIME;RESTART_DISP;STATE_INFO_DISP;ACTION_INFO;SEM_LOCKING;TENANT_DISP;STATE_DISP#_#ftype=state;CURRENT_ACTION_DISP#_#ftype=action;SESSION_KEY;PID#_#ftype=PID;USER_NAME#_#ftype=user#_#name=ZUSER;CPU_USER#_#ftype=cpuuser;FAILURES_DISP;FIELD_COL;SELECTED;WP_INDEX;CPU_SYSTEM#_#ftype=cpusystem;LOGON_HDL#_#ftype=logonhdl;WP_PROGRAM#_#ftype=program;PRIORITY_DISP}{regexp:Hour_User,ftype=houruser;refName=CPU_USER,([^\\:]+).*}{regexp:Minute_User,ftype=minuteuser;refName=CPU_USER,\\d+\\:([^\\:]+).*}{regexp:Second_User,ftype=seconduser;refName=CPU_USER,\\d+\\:\\d+\\:([^\\n]+).*}{regexp:Hour_System,ftype=hoursystem;refName=CPU_SYSTEM,([^\\:]+).*}{regexp:Minute_System,ftype=minutesystem;refName=CPU_SYSTEM,\\d+\\:([^\\:]+).*}{regexp:Second_System,ftype=secondsystem;refName=CPU_SYSTEM,\\d+\\:\\d+\\:([^\\n]+).*}{map:User Type,ftype=usertype;refIndex=32,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=32,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_sm50",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;WP_TYPE_DISP;FAILURES;LINE_COL;CPU#_#ftype=cputime;PRIORITY#_#ftype=priority;ELAPSED_TYPE_DISP;AIN_PROGRAM;CPU_RAW#_#ftype=cpuraw;TRACE_LEVEL;RECONNECT_STATE;SESSION_HDL;RESTART;SESSION_TYPE#_#ftype=sessiontype;SERVER_NAME#_#ftype=servername;ELAPSED_TIME_DISP#_#ftype=elapsedtime;SEM_LOCKED;LOGON_ID#_#ftype=logonid;LAPSED_TIME;RESTART_DISP;STATE_INFO_DISP;ACTION_INFO;SEM_LOCKING;TENANT_DISP;STATE_DISP#_#ftype=state;CURRENT_ACTION_DISP#_#ftype=action;SESSION_KEY;PID#_#ftype=PID;USER_NAME#_#ftype=user#_#name=ZUSER;CPU_USER#_#ftype=cpuuser;FAILURES_DISP;FIELD_COL;SELECTED;WP_INDEX;CPU_SYSTEM#_#ftype=cpusystem;LOGON_HDL#_#ftype=logonhdl;WP_PROGRAM#_#ftype=program;PRIORITY_DISP}{regexp:Hour_User,ftype=houruser;refName=CPU_USER,([^\\:]+).*}{regexp:Minute_User,ftype=minuteuser;refName=CPU_USER,\\d+\\:([^\\:]+).*}{regexp:Second_User,ftype=seconduser;refName=CPU_USER,\\d+\\:\\d+\\:([^\\n]+).*}{regexp:Hour_System,ftype=hoursystem;refName=CPU_SYSTEM,([^\\:]+).*}{regexp:Minute_System,ftype=minutesystem;refName=CPU_SYSTEM,\\d+\\:([^\\:]+).*}{regexp:Second_System,ftype=secondsystem;refName=CPU_SYSTEM,\\d+\\:\\d+\\:([^\\n]+).*}{map:User Type,ftype=usertype;refIndex=32,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=32,file:knowledge/repository/system/useridentity.prop}",
						"externalJS": "link or code"
					}
				}
			},{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,changedocument,audit",
					"name": "Change Document",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ZUSERNAME#_#ftype=user;ZNAME_LAST;ZKEYGUID;ZEXT_KEYLEN;ZSCRTEXT_S;ZDDTEXT#_#ftype=message;ZOBTEXT;ZOBJECT#_#ftype=context#_#;ZVALUE_NEW#_#ftype=value;ZFNAME#_#ftype=fname;ZTEXT_CASE;ZVALUE_OLD;ZKEYGUID_STR;ZOBJECTID#_#ftype=objectid;ZCHANGENR;ZSCRTEXT_L;ZSCRTEXT_M;ZDEPARTMENT;ZCHNGIND;ZTCODE#_#ftype=tcode;ZF_NEW;ZNAME_FIRST;ZF_OLD}{map:User Type,ftype=usertype;refIndex=5,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=5,file:knowledge/repository/system/useridentity.prop}{regexp:ZTableName,ftype=tablename;refName=Json,\\u0022ZT\\wBNAME\\u0022:\\u0022([^\\u0022]+).*}{regexp:ZTableKey254,ftype=tablekey254;refName=Json,\\u0022ZT\\wBKEY254\\u0022:\\u0022([^\\u0022]+).*}{regexp:ZTableKey,ftype=tablekey;refName=Json,\\u0022ZT\\wBKEY\\u0022:\\u0022([^\\u0022]+).*}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_changedocument",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ZUSERNAME#_#ftype=user;ZNAME_LAST;ZKEYGUID;ZEXT_KEYLEN;ZSCRTEXT_S;ZDDTEXT#_#ftype=message;ZOBTEXT;ZOBJECT#_#ftype=context#_#;ZVALUE_NEW#_#ftype=value;ZFNAME#_#ftype=fname;ZTEXT_CASE;ZVALUE_OLD;ZKEYGUID_STR;ZOBJECTID#_#ftype=objectid;ZCHANGENR;ZSCRTEXT_L;ZSCRTEXT_M;ZDEPARTMENT;ZCHNGIND;ZTCODE#_#ftype=tcode;ZF_NEW;ZNAME_FIRST;ZF_OLD}{map:User Type,ftype=usertype;refIndex=5,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=5,file:knowledge/repository/system/useridentity.prop}{regexp:ZTableName,ftype=tablename;refName=Json,\\u0022ZT\\wBNAME\\u0022:\\u0022([^\\u0022]+).*}{regexp:ZTableKey254,ftype=tablekey254;refName=Json,\\u0022ZT\\wBKEY254\\u0022:\\u0022([^\\u0022]+).*}{regexp:ZTableKey,ftype=tablekey;refName=Json,\\u0022ZT\\wBKEY\\u0022:\\u0022([^\\u0022]+).*}",
						"externalJS": "link or code"
					}
				}
			},{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "",
					"typetag": "sap,stad",
					"name": "STAD",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ZTRANSACTION#_#ftype=context;ZPROGRAM#_#ftype=program;CPUTIME#_#ftype=cputime;TRANSFEREDKBYTES#_#ftype=transferedkbytes;SCREEN#_#ftype=screen;MEMORYUSED#_#ftype=memory;SERVER#_#ftype=server;WAITTIME#_#ftype=waittime;STARTED#_#ftype=started;RESPONSETIME#_#ftype=processrequestmicrosecs;DBREQTIME#_#ftype=dbreqtime;WP#_#ftype=wp;ZUSER#_#ftype=user;TYPE#_#ftype=type;VMCELAPSEDTIME#_#ftype=elapsedtime}{map:User Type,ftype=usertype;refIndex=17,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=17,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "",
					"type_uid": "sap_stad",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{json:Json,ZTIMESTAMP#_#date::dateFormat=yyyy-MM-ddHH:mm:ss.SSSZ,dateUIFormat=yyyy-MM-dd HH:mm:ss.SSS Z;xpologName#_#ftype=xpologname;xpologType#_#ftype=xpologtype;xpologLabels#_#ftype=label;xpologEnvironment#_#ftype=environment;ZTRANSACTION#_#ftype=context;ZPROGRAM#_#ftype=program;CPUTIME#_#ftype=cputime;TRANSFEREDKBYTES#_#ftype=transferedkbytes;SCREEN#_#ftype=screen;MEMORYUSED#_#ftype=memory;SERVER#_#ftype=server;WAITTIME#_#ftype=waittime;STARTED#_#ftype=started;RESPONSETIME#_#ftype=processrequestmicrosecs;DBREQTIME#_#ftype=dbreqtime;WP#_#ftype=wp;ZUSER#_#ftype=user;TYPE#_#ftype=type;VMCELAPSEDTIME#_#ftype=elapsedtime}{map:User Type,ftype=usertype;refIndex=17,file:knowledge/repository/user/SAP/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=17,file:knowledge/repository/system/useridentity.prop}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "SAP",
		"typetag": "sap",
		"name": "sap",
		"description": "",
		"type": "operating systems",
		"doclink": "",
		"version": "current",
		"xwikilink": "",
		"example": ""
	}
});
