function getName() {
	return "weblogic";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "weblogic",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WebLogic_ROOT_DIR/user_projects/domains/DOMAIN_NAME/servers/SERVER_NAME/logs/\"",
					"typetag": "weblogic,basedomain",
					"name": "Base Domain",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "####<{date:Date,MMM dd, yyyy hh:mm:ss a z}> <{priority:Priority,ftype=status;,TRACE;DEBUG;INFO;NOTICE;WARNING;ERROR;CRITICAL;ALERT;EMERGENCY}> <{text:Type,ftype=subsystem}> <{text:Machine_Name,ftype=machinename}> <{text:Server_Name,ftype=servername}> <{text:ThreadID,ftype=thread}> <{block,start,emptiness=true}<{block,end,emptiness=true}{text:UserID,ftype=username;,}>{block,start,emptiness=true}>{block,end,emptiness=true} <{text:Transaction_ID,ftype=transaction}> <{text:Diagnostic_Context_ID,ftype=diagcontext}> <{text:Raw_Time_Value,ftype=rawtime}> {block,start,emptiness=true}{regexp:Severity-Value,ftype=severityvalue;refName=Error Details,severity-value:\\s([^\\u005D]+).*}{regexp:RID,ftype=rid;refName=Error Details,rid:\\s([^\\u005D]+).*}{regexp:Partition-ID,ftype=partitionid;refName=Error Details,partition-id:\\s([^\\u005D]+).*}{regexp:Partition-Name,ftype=partitionname;refName=Error Details,partition-name:\\s([^\\u005D]+).*}<{text:Error Details,ftype=errordetails}> {block,end,emptiness=true}<BEA-{number:BEA,ftype=messageid}> <{string:Message,ftype=message}>{text}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_weblogic",
					"type_uid": "wls_domain",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "####<{date:Date,MMM dd, yyyy hh:mm:ss a z}> <{priority:Priority,ftype=status;,TRACE;DEBUG;INFO;NOTICE;WARNING;ERROR;CRITICAL;ALERT;EMERGENCY}> <{text:Type,ftype=subsystem}> <{text:Machine_Name,ftype=machinename}> <{text:Server_Name,ftype=servername}> <{text:ThreadID,ftype=thread}> <{block,start,emptiness=true}<{block,end,emptiness=true}{text:UserID,ftype=username;,}>{block,start,emptiness=true}>{block,end,emptiness=true} <{text:Transaction_ID,ftype=transaction}> <{text:Diagnostic_Context_ID,ftype=diagcontext}> <{text:Raw_Time_Value,ftype=rawtime}> {block,start,emptiness=true}{regexp:Severity-Value,ftype=severityvalue;refName=Error Details,severity-value:\\s([^\\u005D]+).*}{regexp:RID,ftype=rid;refName=Error Details,rid:\\s([^\\u005D]+).*}{regexp:Partition-ID,ftype=partitionid;refName=Error Details,partition-id:\\s([^\\u005D]+).*}{regexp:Partition-Name,ftype=partitionname;refName=Error Details,partition-name:\\s([^\\u005D]+).*}<{text:Error Details,ftype=errordetails}> {block,end,emptiness=true}<BEA-{number:BEA,ftype=messageid}> <{string:Message,ftype=message}>{text}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WebLogic_ROOT_DIR/user_projects/domains/DOMAIN_NAME/servers/SERVER_NAME/logs/\"",
					"typetag": "weblogic,adminserver",
					"name": "AdminServer",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "####<{date:Date,MMM dd, yyyy hh:mm:ss a z}> <{priority:Priority,ftype=status;,TRACE;DEBUG;INFO;NOTICE;WARNING;ERROR;CRITICAL;ALERT;EMERGENCY}> <{text:Type,ftype=subsystem}> <{text:Machine_Name,ftype=machinename}> <{text:Server_Name,ftype=servername}> <{text:ThreadID,ftype=thread}> <{block,start,emptiness=true}<{block,end,emptiness=true}{text:UserID,ftype=username;,}>{block,start,emptiness=true}>{block,end,emptiness=true} <{text:Transaction_ID,ftype=transaction}> <{text:Diagnostic_Context_ID,ftype=diagcontext}> <{text:Raw_Time_Value,ftype=rawtime}> {block,start,emptiness=true}{regexp:Severity-Value,ftype=severityvalue;refName=Error Details,severity-value:\\s([^\\u005D]+).*}{regexp:RID,ftype=rid;refName=Error Details,rid:\\s([^\\u005D]+).*}{regexp:Partition-ID,ftype=partitionid;refName=Error Details,partition-id:\\s([^\\u005D]+).*}{regexp:Partition-Name,ftype=partitionname;refName=Error Details,partition-name:\\s([^\\u005D]+).*}<{text:Error Details,ftype=errordetails}> {block,end,emptiness=true}<BEA-{number:BEA,ftype=messageid}> <{string:Message,ftype=message}>{text}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_weblogic",
					"type_uid": "wls_admin",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "####<{date:Date,MMM dd, yyyy hh:mm:ss a z}> <{priority:Priority,ftype=status;,TRACE;DEBUG;INFO;NOTICE;WARNING;ERROR;CRITICAL;ALERT;EMERGENCY}> <{text:Type,ftype=subsystem}> <{text:Machine_Name,ftype=machinename}> <{text:Server_Name,ftype=servername}> <{text:ThreadID,ftype=thread}> <{block,start,emptiness=true}<{block,end,emptiness=true}{text:UserID,ftype=username;,}>{block,start,emptiness=true}>{block,end,emptiness=true} <{text:Transaction_ID,ftype=transaction}> <{text:Diagnostic_Context_ID,ftype=diagcontext}> <{text:Raw_Time_Value,ftype=rawtime}> {block,start,emptiness=true}{regexp:Severity-Value,ftype=severityvalue;refName=Error Details,severity-value:\\s([^\\u005D]+).*}{regexp:RID,ftype=rid;refName=Error Details,rid:\\s([^\\u005D]+).*}{regexp:Partition-ID,ftype=partitionid;refName=Error Details,partition-id:\\s([^\\u005D]+).*}{regexp:Partition-Name,ftype=partitionname;refName=Error Details,partition-name:\\s([^\\u005D]+).*}<{text:Error Details,ftype=errordetails}> {block,end,emptiness=true}<BEA-{number:BEA,ftype=messageid}> <{string:Message,ftype=message}>{text}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "c-ip - cs-username date-time cs-uri sc-status bytes",
					"howto": "Logs are usually located under \"WebLogic_ROOT_DIR/user_projects/domains/DOMAIN_NAME/servers/SERVER_NAME/logs/\"",
					"typetag": "weblogic,access,w3",
					"name": "Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_weblogic",
					"type_uid": "wls_access",
					"parser_specification": {
						"defaultPattern": "c-ip - cs-username date-time cs-uri sc-status bytes",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							result = result.replace(/#Fields: /g, "");
							result = result.replace(/\)/g, "");
							result = result.replace(/\(/g, "-");
							result = result.replace(/date time/g, "date-time");
							return result;
						},
						"postBuild": function (result) {
							if (result != "") {
								result = result + "{eoe}"
							}
							return result;
						},
						"patternMatch": "\\S+",
						"filters":
						[{ "filter": [{
										"match": "date-time"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "[{date:Date,locale=en,dd/MMM/yyyy:HH:mm:ss z}]";
                                    }
                                }
						 } , {
								"filter": [{
										"match": "date"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "dd/MMM/yyyy"
								}
							}, {
								"filter": [{
										"match": "time"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "HH:mm:ss z"
								}
							}, {
								"filter": [{
										"match": "c-ip"
									}
								],
								"type": "GeoIp",
								"function": {
									"filedName": "Client IP",
									"ftype": "remoteip"
								}
						} , {
								"filter": [{
										"match": "s-ip"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Server IP",
									"ftype": "localip"
								}
						} , {
								"filter": [{
										"match": "cs-username"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Remote User",
									"ftype": "remoteuser"
								}
						} , {
								"filter": [{
										"match": "time-taken"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Time Taken",
									"ftype": "processrequestsecs"
								}
						} , {
								"filter": [{
										"match": "bytes"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
						}, {
								"filter": [{
										"match": "c-dns"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Client Domain",
									"ftype": "clientdomain"
								}
						}, {
								"filter": [{
										"match": "s-dns"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Server Domain",
									"ftype": "serverdomain"
								}
						}, {
								"filter": [{
										"match": "sc-status"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseStatus",
									"ftype": "respstatus"
								}
						}, {
								"filter": [{
										"match": "sc-comment"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Comment",
									"ftype": "comment"
								}
						}, {
								"filter": [{
										"match": "cs-method"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD}";
                                    }
                                }
						}, {
								"filter": [{
										"match": "cs-uri"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function" : function (params){
										return "\"{choice:Method,ftype=reqmethod;,GET;POST;HEAD} {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,} {text:Request Protocol,ftype=reqprotocol;,}\"";
									}
								}
						}, {
								"filter": [{
										"match": "cs-uri-stem"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request URL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "cs-uri-query"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "queryString",
									"ftype": "querystring"
								}
						}
                      ]					
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "c-ip s-ip cs-username date time cs-method cs-uri sc-status",
					"howto": "Logs are usually located under \"WebLogic_ROOT_DIR/user_projects/domains/DOMAIN_NAME/servers/SERVER_NAME/logs/\"",
					"typetag": "weblogic,access,w3",
					"name": "WFCA_Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_weblogic",
					"type_uid": "wfca_access",
					"parser_specification": {
						"defaultPattern": "c-ip s-ip cs-username date time cs-method cs-uri sc-status",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							result = result.replace(/#Fields: /g, "");
							result = result.replace(/\)/g, "");
							result = result.replace(/\(/g, "-");
							result = result.replace(/date time/g, "date-time");
							return result;
						},
						"postBuild": function (result) {
							if (result != "") {
								result = result + "{eoe}"
							}
							return result;
						},
						"patternMatch": "\\S+",
						"filters":
						[{ "filter": [{
										"match": "date-time"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{date:Date,yyyy-MM-ddHH:mm:ss;yyyy-MM-dd HH:mm:ss}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "date"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{date:Date,yyyy-MM-dd}{tab}";
                                    }
                                }
						 }, { "filter": [{
										"match": "time"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{date:Date,HH:mm:ss}{tab}";
                                    }
                                }
						 }, { "filter": [{
										"match": "c-ip"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{geoip:ClientIP,ftype=remoteip}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "s-ip"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{ip:ServerIP,ftype= localip}{block,start,emptiness=true}:{number:ServerPort,ftype=serverport}{block,end,emptiness=true}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "cs-username"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:Remote User,ftype=remoteuser;,}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "time-taken"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{number:Time Taken,ftype=processrequestsecs;,}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "bytes"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{number:Bytes Sent,ftype=bytesent;,}{block,start,emptiness=true}{tab}{block,end,emptiness=true}";
                                    }
                                }
						 } , { "filter": [{
										"match": "c-dns"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:Client Domain,ftype=clientdomain;,}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "s-dns"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:Server Domain,ftype=serverdomain;,}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "sc-status"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:ResponseStatus,ftype=respstatus;,}{block,start,emptiness=true}{tab}{block,end,emptiness=true}";
                                    }
                                }
						 } , { "filter": [{
										"match": "sc-comment"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:Comment,ftype=comment;,}{tab}";
                                    }
                                }
						 } , { "filter": [{
										"match": "cs-method"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD}{tab}";
                                    }
                                }
						 } , {
								"filter": [{
										"match": "cs-uri"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function" : function (params){
										return " {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,}{tab}";
									}
								}
						},  {
								"filter": [{
										"match": "cs-uri-stem"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function" : function (params){
										return "{text:Request URL,ftype=requrl}{tab}";
									}
								}
						}, {
								"filter": [{
										"match": "cs-uri-query"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function" : function (params){
										return "{text:QueryString,ftype=querystring}{tab}";
									}								
								}
						    }
                          ]						
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "WLLogs are usually located under \"WebLogic_ROOT_DIR/user_projects/domains/DOMAIN_NAME/servers/SERVER_NAME/logs/\"_HOME/yourdomain/yourserver/logs/DefaultAuditRecorder.log",
					"typetag": "weblogic,audit",
					"name": "Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "#### Audit Record Begin <{date:Date,MMM dd, yyyy hh:mm:ss a}>  <Severity ={text:Severity,ftype=status}>  <<<Event Type = {text:Event Type,ftype=eventtype} ><Subject: {text:Subject,ftype=subject}{eol}>{regexp:ONCE,\\u003CONCE\\u003E}<<jndi>><type=<{text:jndi,ftype=type}>, application={text:Application,ftype=application}, path={text:Path,ftype=path}, action={text:Action,ftype=action}>{string:End Of Record} Audit Record End ####\n#### Audit Record Begin <{date:Date,MMM dd, yyyy hh:mm:ss a}>  <Severity ={text:Severity,ftype=status}> <<<Event Type = {text:Event Type,ftype=eventtype}><Subject = Subject: {text:Subject,ftype=subject}{eol}{string:Principal,ftype=principal}>{string} type=<{text:jndi,ftype=type}>, {string:Message,ftype=message} Audit Record End ####",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_weblogic",
					"type_uid": "wls_audit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "#### Audit Record Begin <{date:Date,MMM dd, yyyy hh:mm:ss a}>  <Severity ={text:Severity,ftype=status}>  <<<Event Type = {text:Event Type,ftype=eventtype} ><Subject: {text:Subject,ftype=subject}{eol}>{regexp:ONCE,\\u003CONCE\\u003E}<<jndi>><type=<{text:jndi,ftype=type}>, application={text:Application,ftype=application}, path={text:Path,ftype=path}, action={text:Action,ftype=action}>{string:End Of Record} Audit Record End ####\n#### Audit Record Begin <{date:Date,MMM dd, yyyy hh:mm:ss a}>  <Severity ={text:Severity,ftype=status}> <<<Event Type = {text:Event Type,ftype=eventtype}><Subject = Subject: {text:Subject,ftype=subject}{eol}{string:Principal,ftype=principal}>{string} type=<{text:jndi,ftype=type}>, {string:Message,ftype=message} Audit Record End ####",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "Weblogic",
		"typetag": "weblogic",
		"name": "weblogic",
		"description": "",
		"type": "application servers",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_weblogic",
		"version": "current",
		"xwikilink": "",
		"example": ""
	}
});
