{
	"id": "opening-message",
	"displayName": "Opening Message",
	"position": {
		"side": "top",
		"align": "start",
		"hideArrow": false
	},
	"buttons": [{
			"id": "btn-got-it",
			"action": "(d) => d.next()"
		}, {
			"id": "do-not-show-again",
			"action": "(d) => { d.setDoNotShowAgain(true); d.next();}"
		}
	],
	"progress": {
		"enabled": false,
		"content": ""
	},
	"style": "theme-handler xplg-default-theme xplg-opening-message",
	"header": "\n<div class=\"title\">{{title}}</div>\n<div class=\"sub-title\">{{subtitle}}</div>",
	"description": "\n<div class=\"content\">{{content}}</div>\n<div class=\"footer\">\n  <div class=\"btn-container\">\n    <button type=\"button\" id=\"btn-got-it\">Got it</button>\n  </div>\n  <div id=\"do-not-show-again\">Skip all guides</div>\n</div>",
	"onHighlightEnd": "(element, step, opts) => {\n    const wrapperEl = opts?.state?.popover?.wrapper;\n    if (wrapperEl) {\n        const adminPanelEl = document.getElementById('guide_me_admin_panel');\n        if (!element) {\n            const insetStyle = wrapperEl.style.inset;\n            if (insetStyle) {\n                let [top, right, bottom, left] = insetStyle.split(' ');\n                if (top) {\n                    top = parseInt(parseInt(top) / 3) + 'px';\n                }\n                if (adminPanelEl) {\n                    const pageWidth = document.body.offsetWidth;\n                    const adminPanelWidth = adminPanelEl.offsetWidth || 0;\n                    if (adminPanelWidth && left) {\n                        left = parseInt(adminPanelWidth + ((pageWidth - adminPanelWidth - wrapperEl.offsetWidth) / 2)) + 'px';\n                    }\n                }\n                wrapperEl.style.inset = [top, right, bottom, left].join(' ');\n            }\n        }\n    }\n    if (wrapperEl) {\n        wrapperEl.classList.add('xplg-opening-message__visible');\n    }\n}",
	"variables": {
		"title": "Title mandatory",
		"subtitle": "Subtitle optional",
		"content": "Content"
	}
}
