//mf_kpicpualerts

var writeResultsToFile = false;

with(new JavaImporter(java.lang, java.io,java.net,java.util,java.util,java.nio.file.Files,java.util.concurrent, java.io)){
	 
    disableHttpsVerification();
		
	var user = convertToString(System.getenv("user"));
	var pass = convertToString(System.getenv("pass"));
	var baseUrl = convertToString(System.getenv("baseurl"));
	
	
	
	var prop = new Properties();
	
	var propFile = System.getenv("propfile");
	if (propFile == null || propFile.length == 0){
		propFile = "task.properties";
	}
	prop.load(new FileInputStream(propFile));

	var userpropfile = System.getenv("userpropfile");
    if (userpropfile != null && userpropfile.length() > 0){
        prop.load(new FileInputStream(userpropfile));
    }

    writeResultsToFile = prop.get("writeResultsToFile");
    writeResultsToFile = writeResultsToFile == null || writeResultsToFile == "true";		
	
	//logger
	var logger = initLogger(prop.get("loggingLevel"));
	
	var propBaseUrl = prop.get("baseurl");
	if (propBaseUrl != null && propBaseUrl != ""){
		baseUrl = propBaseUrl;
	}
	
	var propUser = prop.get("user");
	if (propUser != null && propUser != ""){
		user = propUser;
	}
	
	var propPass = prop.get("pass");
	if (propPass != null && propPass != ""){
		pass = propPass;
	}
	
	
	var xpologHttpService = new Packages.impl.httpServiceForAnt.XpologHttpService(baseUrl, user, pass);
	xpologHttpService.login();
	
	
	var info = {};
	info.xpologHttpService = xpologHttpService;
	info.prop = prop;
	info.logger = logger;
	
	var timezone = prop.get("timezone");
	if (timezone != null) {
		info.timezone = TimeZone.getTimeZone(timezone);
	}
	
	updateContext(info,prop);
	
	var sharedData = {};

    sharedData.hasData = true;
	getHosts(info,sharedData);
	if (sharedData.hasData){
		getHostsInformation(info,sharedData);
	}
	
}

function getHosts(info,sharedData){
    var xpologHttpService = info.xpologHttpService;
    var logger = info.logger;
    var prop = info.prop;
	
	

    //logger.info("count1="+count1);
    logger.info("step 0 - pre changes for anomalies");

    

    var hostsResponse = xpologHttpService.createBuilder()
                                        .setUrl("/admin/hosts")
                                        .setCallType("GET")                                        
                                        .execute();

    logger.info("step 0 getHosts");
    logger.info("code = " + hostsResponse.getStatusCode());
    logger.debug("text = " + hostsResponse.getContent());
    var hostsContent = JSON.parse(hostsResponse.getContent());
	
	if (writeResultsToFile){
	    writeToFile("hosts.json", JSON.stringify(hostsContent), info);
	}
	
	if (hostsContent != null && hostsContent.response != null && hostsContent.response.items != null){
		updateHostsList(info,sharedData,hostsContent.response.items);
	}else {
		sharedData.hasData = false;
	}
}

function updateHostsList(info,sharedData,items){
	logger.info("items length = " + items.length);
	var hostsList = [];
	var map = {};
	if (items.length > 0){
		for (var i = 0; i < items.length;i++){
			var item = items[i];
			if (item.name != null){				
				var name = item.name;				
				var list = name.split(",");
				for (var j = 0; j < list.length;j++){
					var host = list[j];
					if (!map[host]){
						map[host] = true;
						hostsList.push(list[j]);
					}
					
				}
			}
			
		}
		logger.info("hostsList length = " + hostsList.length);
		sharedData.hostsList = hostsList;
	}else {
		sharedData.asData = false;
	}
}

function getHostsInformation(info,sharedData){
	if (sharedData.hostsList != null && sharedData.hostsList.length > 0){
        var prop = info.prop;
        var numOfThreads = parseInt(prop.getProperty("hostInfo.numOfThreads"));
        var threadPool = java.util.concurrent.Executors.newFixedThreadPool(numOfThreads);

		var dateFormat = new java.text.SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
		sharedData.dateFormat = dateFormat;

		var outputPathPrefix = prop.getProperty("hostInfo.outputPathPrefix");
		var fw = null;
		with(new JavaImporter(java.lang, java.io,java.net,java.util)){
		    var time = convertToString(new java.text.SimpleDateFormat("dd-MM-yyyy-HH-mm").format(new java.util.Date()));
		    fw = FileWriter(outputPathPrefix +time + ".log", true);
		}
		sharedData.fileWriter = fw;
		var hostsList = sharedData.hostsList;
		var hostsCounter = java.util.concurrent.atomic.AtomicLong(hostsList.length);
//		var hostsCounter = java.util.concurrent.atomic.AtomicLong(50);
		logger.info("step 1 - getHostsInformation " + hostsList.length);
		for (var i = 0; i < hostsList.length ;i++){
		    var host = hostsList[i];
		    var index = i;
//		    logger.info(i + ": " + host);
            var runnable = new java.lang.Runnable() {
                host: host,
                i: i,
                run: function() {
                    try{
                        logger.debug(this.i + ": " + this.host);
                        executeHostInformation(info,sharedData,this.host, this.i);
                        
                    }
                    catch(e){}
                    var c = hostsCounter.getAndDecrement();
					if (c % 10 == 1){
                            logger.debug("flushing " + this.i);
                            fw.flush();
                        }
                    logger.debug(c);
                    if (c <= 1){
                        logger.info("shutdown");
                        threadPool.shutdown();
                    }
                }
            };
            threadPool.submit(runnable);
		}

		try{
		    var maxTimeToRunInHours = parseInt(prop.getProperty("hostInfo.maxTimeToRunInHours"));
		    threadPool.awaitTermination(maxTimeToRunInHours, java.util.concurrent.TimeUnit.HOURS);
        }
        catch(e){};
        try{
            fw.flush();
            fw.close();
        }
        catch(e){}
	}
}

function executeHostInformation(info,sharedData,host,index){
	 var xpologHttpService = info.xpologHttpService;
    var logger = info.logger;
    var prop = info.prop;
	
	var query = convertToString(prop.getProperty("hostInfo.query"));
	var fixedInterval = convertToString(prop.getProperty("hostInfo.fixedInterval"));
	

	query = replaceAll(query,"\[HOST\]",host);
	
	//logger.info(query);
	var executeQuery = {
		"searchQuery" : query,
		"fixedInterval" : fixedInterval,
		"maxNumOfRecords" : 1,
		"params" : {
		    "listOfExts":"ext.time,ext.log,ext.logtypes"
		}
	}

	
	//logger.info(JSON.stringify(executeQuery));
	
	//logger.info("step 2 - hosts info " + host);
	var hostResponse = xpologHttpService.createBuilder()
										.setUrl("/search/execute")
										.setCallType("POST")
										.addBodyParam(JSON.stringify(executeQuery))
										.execute();
											
	//logger.info("step 2 - anomalies alerts results");
	//logger.info("code = " + hostResponse.getStatusCode());
	logger.debug("text = " + hostResponse.getContent());
	
	var jsonContent = JSON.parse(hostResponse.getContent());
	//logger.debug(JSON.stringify(jsonContent));
	if (writeResultsToFile){
	 // writeToFile("hosts/" + host+".json", JSON.stringify(jsonContent), info);
	}
	updateHostInformation(info,sharedData,host,jsonContent,index);
	
}

function updateHostInformation(info,sharedData,host,jsonContent,index){
	 var logger = info.logger;
	 
	 var event = {}
	 event.host = host;
	 event.time = "";
	 
	 if (jsonContent.response != null && jsonContent.response.events != null && jsonContent.response.events.length > 0){
		 var item = jsonContent.response.events[0];
		 if (item.event != null){
			 event = item.event;
		 }
	 }
	 
	 var time = convertToString(sharedData.dateFormat.format(new java.util.Date()));

	 var msg = index + " " + time + " " + JSON.stringify(event);
	 logger.debug(msg);
	 var fw = sharedData.fileWriter;
	 fw.write(msg + "\n");
}

// COMMON

function writeToFile(path, data, info){
	with(new JavaImporter(java.lang, java.io,java.net,java.util)){
	    var filePathPrefix = info.filePathPrefix;
		var fw = (filePathPrefix == null || filePathPrefix.length() == 0) ? new FileWriter(new File(path)) : new FileWriter(new File(filePathPrefix, path));
		fw.write(data);
		fw.close();
	}
}

function convertToString(obj){
	return "" + obj;
}

function initLogger(level) {
    var ret = {};
	if (level == "info") {
        ret.info = function (content) {
            reallyLog(content);
        };
        ret.error = function (content) {
            reallyLog(content);
        };
        ret.debug = function (content) {
            doNothing(content);
        };
    } else if (level == "error") {
		ret.info = function (content) {
            doNothing(content);
        };
        ret.error = function (content) {
            reallyLog(content);
        };
        ret.debug = function (content) {
            doNothing(content);
        };
    } else if (level == "debug") {
        ret.info = function (content) {
              reallyLog(content);
        };
        ret.error = function (content) {
            reallyLog(content);
        };
        ret.debug = function (content) {
            reallyLog(content);
        };
    }
	return ret;
}

function reallyLog(content) {
    with (new JavaImporter(java.lang, java.io, java.net, java.util)) {
        System.out.println(content);
    }
}
function doNothing(content) {}

function replaceAll(string, search, replace) {
  return string.split(search).join(replace);
}

function updateContext(info,prop){
	with(new JavaImporter(java.lang, java.io,java.net,java.util)){
		var context = System.getenv("context");
		if (context == null || context.length == 0){
			context = prop.get("context");
		}
		if (context == null){
			context = "";
		}else if (context.length() > 0){
			context = context + " ";
		}

		var origContextId = "";
		var contextId = System.getenv("contextId");
		if (contextId == null || contextId.length == 0){
			contextId = prop.get("contextId");
		}
		if (contextId == null){
			contextId = "";
		}else if (contextId.length() > 0){
		    origContextId = "" + contextId;
			contextId = "_" + contextId;
		}
		
		var filePathPrefix = System.getenv("filePathPrefix");
        if (filePathPrefix == null || filePathPrefix.length == 0){
            filePathPrefix = prop.get("filePathPrefix");
        }

        if (filePathPrefix == null){
            filePathPrefix = "";
        }else {
			filePathPrefix = "" + filePathPrefix;
		}

        var filePathPrefixFile = new File(filePathPrefix);
        if (origContextId != null && origContextId.length > 0){
            filePathPrefixFile = filePathPrefix.length > 0 ? new File(filePathPrefixFile, origContextId) : new File(origContextId);
        }
		
        var fullPath = "";
        try{
            fullPath = filePathPrefixFile.getAbsolutePath();
            if (fullPath != null && fullPath.length() > 0){
                filePathPrefixFile.mkdirs();
            }
        }
        catch(eee){
        }

		info.context = context;
		info.origContextId = origContextId;
		info.contextId = contextId;
        info.filePathPrefix = filePathPrefixFile.getAbsolutePath();
	}
}

function disableHttpsVerification(){
	with(new JavaImporter(javax.net.ssl,java.security.cert)){
		var trust = new javax.net.ssl.X509TrustManager() {
					getAcceptedIssuers : function() {
						return null;
					},
					checkClientTrusted : function(certs, authType) {
					},
					checkServerTrusted: function(certs, authType) {
					}
			};
			
			
			var trustAllCerts = [];
			trustAllCerts.push(trust);
	 
		 
			var sc = javax.net.ssl.SSLContext.getInstance("SSL");
			sc.init(null, trustAllCerts, new java.security.SecureRandom());
		   javax.net.ssl.HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
		   
			var allHostsValid = new javax.net.ssl.HostnameVerifier() {
				verify : function(hostname, session) {
					return true;
				}
			};
			
			javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(allHostsValid);
	}
}


