function getName(){
	return "InnerJoin";
}

function getOperationType(){
	return "function";
}

function createOperation(){
	return {
		
		inputCols: [{"name":"ext.log"},{"name":"ext.logType"}],
		outputCols: [],
		source :  {
			names: {},
			keysIndexes : [],
			keysOutputIndexes : [],
			columnsIndexes : [],
			columnsOutputIndexes : []
		},
		target :  {
			names: {},
			keysIndexes : [],
			keysOutputIndexes : [],
			columnsIndexes : [],
			columnsOutputIndexes : []
		},
		
		
		getInputColumns: function(){
			return this.inputCols;
		},
		getOuputColumns: function(){
			return this.outputCols;
		},
		updateParameters: function(parameters){
			 
			if (parameters != "undefined" && parameters != null){				
				var arr = parameters.split(";");
				this.outputCols = [];
				var inputs = "";	
				var map = {};
				if (arr.length > 0){
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						var index = str.indexOf("=");
						if (index > 0){
							var key = str.substring(0,index).trim().toLowerCase();
							var value = str.substring(index + 1).trim();
							map[key] = value;
						}
					}
				}
				var columnsMap = {};
				if (map.sources != null){
					arr = map.sources.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						this.source.names[str] = "";
					}
				}
				if (map.sourcekeys != null){
					arr = map.sourcekeys.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						var col = {"name" : str};
						this.inputCols.push(col);
						this.outputCols.push(col);
						columnsMap[str] = this.inputCols.length - 1; 
						this.source.keysIndexes.push(this.inputCols.length - 1);
						this.source.keysOutputIndexes.push(i);
					}
				}
				
				if (map.sourcecolumns != null){
					arr = map.sourcecolumns.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						var col = {"name" : str};
						this.inputCols.push(col);
						this.outputCols.push(col);
						columnsMap[str] = this.inputCols.length - 1; 
						this.source.columnsIndexes.push(this.inputCols.length - 1);
						this.source.columnsOutputIndexes.push(this.outputCols.length - 1);
					}
					print(columnsMap[str]);
				}
				if (map.targets != null){
					arr = map.targets.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						this.target.names[str] = "";
					}
				}
				if (map.targetkeys != null){
					arr = map.targetkeys.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						var index = columnsMap[str] == null ? -1 : columnsMap[str];
						if (index == -1){
							var col = {"name" : str};
							this.inputCols.push(col);
							index = this.inputCols.length - 1;
						}
						 
						this.target.keysIndexes.push(index);
						this.target.keysOutputIndexes.push(i);
					}
				}
				if (map.targetcolumns != null){
					arr = map.targetcolumns.split(",");
					for (var i = 0; i < arr.length;i++){
						var str = arr[i];
						var index = columnsMap[str] == null ? -1 : columnsMap[str];
						if (index >= 0){
							str = "Target " + str;
							index = -1;
						}
						if (index == -1){
							var col = {"name" : str};
							this.inputCols.push(col);
							this.outputCols.push(col);
							index = this.inputCols.length - 1;
						}
						 
						this.target.columnsIndexes.push(index);
						this.target.columnsOutputIndexes.push(this.outputCols.length - 1);
					}
				}
//				print("map = " + JSONtoString(map));
//				print("columnsMap" + JSONtoString(columnsMap));
//				print("source = " + JSONtoString(this.source));
//				print("target = " + JSONtoString(this.target));
//				print("inputCols = " + JSONtoString(this.inputCols));
//				print("outputCols = " + JSONtoString(this.outputCols));
							
			}
		},
		createFunction: function(){
			return createFunction(this.source,this.target,this.outputCols.length);
		}
	}
}

function createFunction(source,target,outputLength){
	
	return {
		sourceData: {},
		sourceKeys: {},
		targetData: {},
		targetKeys: {},
				
		processEventData: function(){			
			if (arguments.length > 2){				
				var data = null;
				var keys = null;
				var obj = null;
				var s = arguments[0] == null ? null : arguments[0].trim();
				if (s != null && s != "" && source.names[s] != null){
					data = this.sourceData;
					obj = source;
					keys = this.sourceKeys;
				}
				if (data == null){
					s = arguments[1] == null ? null : arguments[1].trim();
					if (s != null && s != "" && source.names[s] != null){
						data = this.sourceData;
						obj = source;
						keys = this.sourceKeys;
					}
				}
				if (data == null){
					s = arguments[0] == null ? null : arguments[0].trim();
					if (s != null && s != "" && target.names[s] != null){
						data = this.targetData;
						obj = target;
						keys = this.targetKeys;
					}
				}
				if (data == null){
					s = arguments[1] == null ? null : arguments[1].trim();
					if (s != null && s != "" && target.names[s] != null){
						data = this.targetData;
						obj = target;
						keys = this.targetKeys;
					}
				}
				if (data == null){
					return;
				}
				var d = [];
				for (var i = 0; i < outputLength;i++){
					d[i] = "";
				}
				var key = "";
				for (var i = 0; i < obj.keysIndexes.length;i++){
					var index = obj.keysIndexes[i];
					if (index >= arguments.length){
						continue;
					}
					var str = arguments[index];
					if (i > 0){
						key += "#;#"
					}
					if (str != null){						
						key += str;
						d[obj.keysOutputIndexes[i]] = str;
					}
				}
				var fullKey = key;
				for (var i = 0; i < obj.columnsIndexes.length;i++){
					var index = obj.columnsIndexes[i];
					if (index >= arguments.length){
						continue;
					}					
					var str = arguments[index];
					if (i >= 0){
						fullKey += "#;#"
					}
					if (str != null){						
						d[obj.columnsOutputIndexes[i]] = str;
						fullKey += str;
					}
				}
				if (keys[fullKey] != null){
					return;
				}
				keys[fullKey] = 0;
				var list = data[key];
				if (list == null){
					list = [];
					data[key] = list;
				}
				list.push(d);
//				print("obj = " + JSONtoString(data));
//				print("arguments = " + JSONtoString(arguments));
			}
			
		},
		doFinal: function(){
			
		},
		getFinalData: function(){
			var result = [];
			for (var key in this.targetData) {				
				  if (this.sourceData.hasOwnProperty(key)) {					  
					  var s = this.sourceData[key];
					  var t = this.targetData[key];
					  for (var i = 0; i < s.length;i++){
						  for (var j = 0; j < t.length;j++){
							  var arr = [];
							  for (var k = 0; k < s[i].length;k++){
								  arr[k] = s[i][k];
							  }
							  for (var k = 0; k < target.columnsOutputIndexes.length;k++){
								  arr[target.columnsOutputIndexes[k]] = t[j][target.columnsOutputIndexes[k]];
							  }
							  result.push(arr);
						  }
					  }				    
				  }
			}
			return result;
		},
		merge: function(obj) {
			for (var key in obj.targetData) {	
				var arr = obj.targetData[key];
				var list = this.targetData[key];
				if (list == null){
					list = [];
					this.targetData[key] = list;
				}
				for (var i = 0;i < arr.length;i++){
					var buffer = key;
					
					for (var k = 0; k < target.columnsOutputIndexes.length;k++){
						  var str = arr[i][target.columnsOutputIndexes[k]];
						  if (key != ""){
								buffer += "#;#";
							}
						  buffer += str;
					  }
					if (this.targetKeys[buffer] == null){
						list.push(arr[i]);
						this.targetKeys[buffer] = 0;
					}
				}
			}
			
			for (var key in obj.sourceData) {	
				var arr = obj.sourceData[key];
				var list = this.sourceData[key];
				if (list == null){
					list = [];
					this.sourceData[key] = list;
				}
				for (var i = 0;i < arr.length;i++){
					var buffer = key;
					
					for (var k = 0; k < source.columnsOutputIndexes.length;k++){
						  var str = arr[i][source.columnsOutputIndexes[k]];
						  if (key != ""){
								buffer += "#;#";
							}
						  buffer += str;
					  }
					if (this.sourceKeys[buffer] == null){
						list.push(arr[i]);
						this.sourceKeys[buffer] = 0;
					}
				}
			}
		}
	};
}
