function getName() {
	return "validateSla";
}

function createFormat(col1,col2,zone){
	return {
		getInputColumns : function () {
			return col1 + "," + col2;
		},
			formatData : function(createdate,eventsla){
				if (isNaN(createdate)) {
					return "Invalid epoch time";
				}
				var MS_PER_DAY = 1000 * 60 * 60 * 24;
				var today = new Date();
				var dateObject = new Date(Number(createdate));
				var totalDays = Math.floor((today - dateObject) / MS_PER_DAY);
				// Calculate the number of business days
				var businessDaysCount = 0;
				var currentDate = new Date(dateObject);
				var dayOfWeek_1, dayOfWeek_2;
				if (zone == 'ISR')
				{
					dayOfWeek_1 = 5;
					dayOfWeek_2 = 6;
				}
				else
				{
					dayOfWeek_1 = 6;
					dayOfWeek_2 = 0;
				}
				while (currentDate <= today)
				{
					var dayOfWeek = currentDate.getDay();
					//print ("Current Date is: " + currentDate + ", day of week is: " + dayOfWeek)
					if (dayOfWeek !== dayOfWeek_1 && dayOfWeek !== dayOfWeek_2) {
						businessDaysCount++;
					}
					currentDate.setDate(currentDate.getDate() + 1);
				}
				// Calculate the difference between the SLA and the business days count
				var diff = eventsla - businessDaysCount;
				return diff;
			}
	}
}