function getBaseLog(x, y) {
  return Math.log(y) / Math.log(x);
}

function cepHistogramMergedData0(chartJson,drilldown){



	var series = chartJson.series;
	var minX = 0;
	var maxX = 0;
	var len = series.length / 2;
	var minTime = 0;
	var maxTime = 0;

	if (series){
		var startTime = 0;
		var splitStep = 1;
		var info = chartJson.info;

		if (info && info.dataInfo){
			var dataInfo = info.dataInfo;
			startTime = dataInfo.startTime;
			splitStep = dataInfo.splitStep;
		}
		var newSeries = [];
		var maxY = (series.length / 2) + 1;
		var weight = 1;
		for (var i = 0; i < series.length;i++){
			var color = "var(--diagram-legend" + ((i / 2) + 1) + ")";
			if (series[i].name.startsWith("index_")){
				series[i].name = series[i].name.substring(6);
			}
			if (series[i].name == "Other"){
				color = "var(--diagram-legend-other)";
			}
			series[i].type = "scatter";
			series[i].opacity = drilldown ? 0.85 : 0.75;
			series[i].color = color;
			series[i].jitter = {
				"x" : 0.25,
				"y" : 0
			};


			if (maxX == 0){
				maxX = series[i].data.length;
				//print ("maxX = " + maxX);
				if (maxX < 90){
					if (maxX > 1){
						weight = 100.0 / (maxX - 1);
					}
					maxX = 100 + 2;
				}
			}
			var countSeries = series[i + 1];

			if (true){
				var data = series[i].data;
				var countData = countSeries.data;
				var tmp = [];
				for (var k = 0; k < data.length;k++){
					if (startTime > 0){
						data[k].x = startTime + (splitStep * data[k].x);
					}
					var max = countData[k].y;
					var amount = max;
					var y = data[k].y;
					y = maxY - y;
					if (i == 0 && k == data.length - 1 && max < 1){
						max = 1;
						y = null;
					}
					if (max > 1){
						max = getBaseLog(2, max);
					}

					var dateFormat = "";
					if (y != null && y > 0){
						if (minTime == 0 || data[k].x < minTime){
							if (data[k].x > 1000){
								minTime = data[k].x;
							}
						}
						if (maxTime == 0 || data[k].x > minTime){
							if (data[k].x > 1000){
								maxTime = data[k].x;
							}
						}
					}
					if (true || drilldown){
                        dateFormat = getUTCTimeString(data[k].x);
					}
					var x = (k*weight);
					//print("k = " + k + " , " + x + " , " + weight);
					if (x >  maxX){
						maxX = x;
					}
					for (var j = 0; j < max && j < 10;j++){
					    var index =(data.length*j + k);

						var amountStr = amount + ' event' + (amount > 1 ? 's' : '');
					    var event = {
							"marker": data[k].marker,
							"x": x,
							"y": y,
							"amount" : amountStr,
							"timestamp" : dateFormat,
							"id": (data[k].id + "-" +  index)
						}
					   tmp.push(event);
					}
				}
				series[i].data = tmp;
			}
			newSeries.push(series[i]);
			i++;

		}
		series = newSeries;
		chartJson.series = newSeries;
	}
	var seriesMax = series ? 1 * (len + 1) : 1;
	if (drilldown && series){
		seriesMax = len + 1;
	}
	var weight = 6;
	var redius = 3.5;
	if (drilldown) {
		redius = 4;
		if (len > 4){
			redius = 3.5;
			weight = 5;
		}
		if (len > 6){
			redius = 3.5;
		}
	}else {
		if (len > 2){
			redius = 3;
		}
		if (len > 4){
			redius = 2.5;
			weight = 5;
		}
	}
	chartJson.chart.height = 18;
	if (drilldown){

		//chartJson.chart.height = (weight*(len + 1) + 1*((len + 2) - 1));
		chartJson.chart.height = (redius*2*(len) + 2*(len - 1));
		//print("chartJson.chart.height = " + chartJson.chart.height);
	}
	//chartJson.chart.width = 800;
	chartJson.chart.animation = false;
	chartJson.chart.type = "scatter";
	// remove all spaces
	chartJson.chart.margin = [0, 0, 0, 0];
	chartJson.chart.spacingTop = 0;
	chartJson.chart.spacingBottom = 0;
	chartJson.chart.spacingLeft = 0;
	chartJson.chart.spacingRight = 0;
	chartJson.chart.backgroundColor = "var(--histogram-background)";

	// disable legend
	chartJson.legend = {enabled: false};
	// enable tooltip
	chartJson.tooltip = {
        enabled: true,
        animation: false,
        outside: true,
        padding: 12,
        borderRadius: 3,
        backgroundColor: "var(--secondary)",
        borderWidth: 2,
        shadow: false,
        hideDelay: 0
    };
	//chartJson.tooltip = {enabled: false};
	// hide export options button with dropdown
	chartJson.exporting = {enabled: false};
	// hide xAxis
	var xAxis = chartJson.xAxis;
	xAxis.visible = false;
    xAxis.labels = {enabled: false};
	xAxis.startOnTick = false;
	xAxis.endOnTick = false;
	xAxis.min = minX;
	xAxis.max = maxX;

	if (minTime > 0 && xAxis.tickPositions && xAxis.tickPositions.length > 0){
		xAxis.tickPositions = [minTime,maxTime];
	}

	// hide yAxis

	var yAxis = chartJson.yAxis;
	yAxis.visible = false;
    yAxis.labels = {enabled: false};
	yAxis.max = seriesMax;
	yAxis.startOnTick = false;
	yAxis.endOnTick = false;

	if (true){
		var positions = [];
		for (var i = 1;i <= len;i++){
			var tick = i;
			positions.push(tick);
		}
		yAxis.gridLineColor = "var(--histogram-lines)";
		yAxis.tickPositions = positions;
		yAxis.visible = true;
	}


	// remove border from bars in chart
	chartJson.plotOptions = {
		"series": {
			"turboThreshold": 1000,
			"lineWidth": 0
		},
		"scatter": {
              "borderRadius": 0,
              "pointPadding": 0,
              "groupPadding": 0,
              "jitter": {
                "y" : 0
              },
              "allowOverlap" : true,
               "marker": {
               "symbol": "circle",
               "radius" : redius
              },
			  "tooltip": {
                "headerFormat": "",
                "pointFormat": "<span style=\"color: var(--surface);" +
                    "font-family: var(--ff-roboto);" +
                    "font-size: var(--fs-13);" +
                    "line-height: var(--lh-16);" +
                    "font-weight: var(--fw-normal);\">" +
                        "{point.timestamp}<br/>{series.name}<br/>{point.amount}" +
                    "</span>",
                "clusterFormat": ""
			  }
            }
	};
	//print("after - " + JSONtoString(chartJson));

	return chartJson;
}

function getUTCTimeString(timestamp) {
    if (timestamp) {
        var date = new Date(timestamp);
        var h = ('0' + date.getUTCHours()).slice(-2);
        var m = ('0' + date.getUTCMinutes()).slice(-2);
        var s = ('0' + date.getUTCSeconds()).slice(-2);
        return h + ':' + m + ':' + s;
    }
    return '';
}

function cepHistogramMergedData(str){
	if (str == null) return str;
	var chartJson = stringToJSON(str);
	//print("before - " + str);
	chartJson = cepHistogramMergedData0(chartJson,false);
	//print("after - " + JSONtoString(chartJson));
	return JSONtoString(chartJson);
}

function cepDrillDownHistogramMergedData(str){
	if (str == null) return str;
	var chartJson = stringToJSON(str);
	//print("before - " + str);
	chartJson = cepHistogramMergedData0(chartJson,true);
	//print("after - " + JSONtoString(chartJson));
	return JSONtoString(chartJson);
}