function getName() {
	return "active_directory";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "active_directory",
		"apptags": "",
		"displayName": "Active Directory",
		"typetag": "windows,activedirectory",
		"name": "active_directory",
		"description": "",
		"type": "security",
		"doclink": "https://msdn.microsoft.com/en-us/library/bb726966.aspx",
		"version": "current",
		"supportedDataSources": "winEvent",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "C:\\Windows\\System32\\winevt\\Logs\\Application.evtx",
					"typetag": "windows,activedirectory,application",
					"name": "Application",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=user}*;*{text:Computer,ftype=computer}*;*{string:Description,ftype=description}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Active+Directory",
					"type_uid": "activedirectory_application",
					"defaultLogLocation" : "Application",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=user}*;*{text:Computer,ftype=computer}*;*{string:Description,ftype=description}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "C:\\Windows\\System32\\winevt\\Logs\\Security.evtx",
					"typetag": "windows,activedirectory,security",
					"name": "Security",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}{map:Event Description,ftype=event description;refIndex=6,file:knowledge/repository/system/win/map/winEventsMap.prop}{map:Category Description,ftype=category description;refIndex=6,file:knowledge/repository/system/win/map/winEventsCategoryMap.prop}{map:Sub Category,ftype=sub category;refIndex=6,file:knowledge/repository/system/win/map/winEventsSubCategoryMap.prop}*;*{text:User,ftype=user}{regexp:Logon ID,refName=description;ftype=logon id,Logon ID:\\s+(\\S+).*}*;*{text:Computer,ftype=computer}*;*{regexp:Group Name,ftype=usergroup;refName=Description,Group Name:\\s([^\\n]+).*}{regexp:Object Name,ftype=object;refName=Description,(New Account:.*Account Name:\\s+|Target Account:.*\\tAccount Name:\\s+|New Computer Account:.*Account Name:\\s+|Target Computer:.*Account Name:\\s+|Computer Account That Was Changed:.*\\tAccount Name:\\s+|Member:.*Account Name:\\s+CN=|Member:.*Account Name:\\s+cn=|New Logon:.*\\tAccount Name:\\s|Member:.*Account Name:\\s|Account That Was Locked Out:.*\\tAccount Name:\\s|Account Whose Credentials Were Used:.*\\tAccount Name:\\s|Object Name:\\s+)[XPLG_PARAM([^\\n,]+)]}{regexp:Object Type,ftype=objecttype;refName=Description,Object Type:\\s+([^\\n]+).*}{regexp:Handle ID,ftype=handleid;refName=Description,Handle ID:\\s+([^\\n]+).*}{regexp:Source Address,ftype=sourceip;refName=Description,\\tSource Address:\\s([^\\n]+)}{regexp:Destination Address,ftype=targetip;refName=Description,\\tDestination Address:\\s([^\\n]+)}{string:Description,ftype=description}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Active+Directory",
					"type_uid": "activedirectory_security",
					"defaultLogLocation" : "Security",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}{map:Event Description,ftype=event description;refIndex=6,file:knowledge/repository/system/win/map/winEventsMap.prop}{map:Category Description,ftype=category description;refIndex=6,file:knowledge/repository/system/win/map/winEventsCategoryMap.prop}{map:Sub Category,ftype=sub category;refIndex=6,file:knowledge/repository/system/win/map/winEventsSubCategoryMap.prop}*;*{text:User,ftype=user}{regexp:Logon ID,refName=description;ftype=logon id,Logon ID:\\s+(\\S+).*}*;*{text:Computer,ftype=computer}*;*{regexp:Group Name,ftype=usergroup;refName=Description,Group Name:\\s([^\\n]+).*}{regexp:Object Name,ftype=object;refName=Description,(New Account:.*Account Name:\\s+|Target Account:.*\\tAccount Name:\\s+|New Computer Account:.*Account Name:\\s+|Target Computer:.*Account Name:\\s+|Computer Account That Was Changed:.*\\tAccount Name:\\s+|Member:.*Account Name:\\s+CN=|Member:.*Account Name:\\s+cn=|New Logon:.*\\tAccount Name:\\s|Member:.*Account Name:\\s|Account That Was Locked Out:.*\\tAccount Name:\\s|Account Whose Credentials Were Used:.*\\tAccount Name:\\s|Object Name:\\s+)[XPLG_PARAM([^\\n,]+)]}{regexp:Object Type,ftype=objecttype;refName=Description,Object Type:\\s+([^\\n]+).*}{regexp:Handle ID,ftype=handleid;refName=Description,Handle ID:\\s+([^\\n]+).*}{regexp:Source Address,ftype=sourceip;refName=Description,\\tSource Address:\\s([^\\n]+)}{regexp:Destination Address,ftype=targetip;refName=Description,\\tDestination Address:\\s([^\\n]+)}{string:Description,ftype=description}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "C:\\Windows\\System32\\winevt\\Logs\\System.evtx",
					"typetag": "windows,activedirectory,system",
					"name": "System",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=user}*;*{text:Computer,ftype=computer}*;*{string:Description,ftype=description}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Active+Directory",
					"type_uid": "activedirectory_system",
					"defaultLogLocation" : "System",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{priority:Type,ftype=type,Error;Warning;Information;Success;Audit Failure;Audit Success}*;*{timestamp:Date,MM/dd/yyyy HH:mm:ss}{regexp:Account Name,refName=Description;ftype=accountname,Account Name:\\s+(\\S+).*}{regexp:Account Domain,refName=Description;ftype=domain,Account Domain:\\s+(\\S+).*}*;*{text:Source,ftype=source}*;*{text:Category,ftype=category}*;*{number:Event,ftype=event}*;*{text:User,ftype=user}*;*{text:Computer,ftype=computer}*;*{string:Description,ftype=description}",
						"externalJS": "link or code"
					}
				}
			}
		]		
	}
});
