function getName() {
	return "etrust";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "etrust",
		"apptags": "",
		"displayName": "eTrust",
		"typetag": "syslog,etrust,audit",
		"name": "etrust",
		"description": "",
		"type": "Security",
		"doclink": "https://casupport.broadcom.com/cadocs/0/g014501e.pdf?intcmp=searchresultclick&resultnum=1",
		"version": "current",
		"xwikilink": "http://wiki.xpolog.com/display/XPOL/eTrust",
		"example": "",
		"logtypes": [{
			"log": {
				"xdoclink": "",
				"defaultPattern": "NONE",
				"howto": "",
				"typetag": "syslog,etrust,audit",
				"name": "eTrust",
				"custom_parser_location": "<LINK to JS>",
				"defaultXpoLogPattern": "{text} {text:Server Name,ftype=servername} {text:CEF} {text:Version}| {text:CA,ftype=ca}|{text:PIM,ftype=pim}|{text:SP,ftype=sp}|{text:Header,ftype=header}|{text:Event Description,ftype=eventdescription}|{text:EventCode,ftype=eventcode}| {properties:Properties,keysSep==;propSep=space;,event_header#_#ftype=eventheader#_#name=Event Header;shost#_#ftype=sourcehost#_#name=Source Host;dhost#_#ftype=targethost#_#name=Destination Host;event_type#_#ftype=eventtype#_#name=Event Type;status#_#ftype=status#_#name=Status;susr#_#ftype=username#_#name=Source User;dst#_#ftype=dst#_#name=DST;program#_#ftype=program#_#name=Program;start;time#_#date::dateFormat=HH:mm:ss#_#dateUIFormat=dd/MM/yyyy HH:mm:ss;message#_#ftype=message#_#name=Message;User_Logon_Session_ID#_#ftype=sessionid#_#name=User Logon Session ID;Audit_flags#_#ftype=auditflags#_#name=Audit Flags;nStatus#_#ftype=nstatus#_#name=Nstatus;rt#_#ftype=rt#_#name=RT;nReason#_#ftype=nreason#_#name=Nreason;nStage#_#ftype=nstage#_#name=Nstage;act#_#ftype=action#_#name=Action;administrator#_#ftype=administrator#_#name=Administrator;class#_#ftype=class#_#name=Class;object#_#ftype=object#_#name=Object;command#_#ftype=command#_#name=Command;on_behalf#_#ftype=onbehalf#_#name=On Behalf;resource#_#ftype=resource#_#name=Resource;access#_#ftype=access#_#name-Access;on_behalf_of#_#ftype=onbehalfof#_#name=On Behalf Of;daemon#_#ftype=daemon#_#name=Daemon;service#_#ftype=service#_#name=Service;file#_#ftype=file#_#name=File;deployment_task#_#ftype=deploymenttask#_#name=Deployment Task;engine_service#_#ftype=engineservice#_#name=Engine Service;event_name#_#ftype=eventname#_#name=Event Name;server_name#_#name=Server;event_date#_#name=Event Date;host#_#ftype=host#_#name=Host;account_type#_#ftype=accounttype#_#name=Account Type;is_disconnected#_#ftype=isdisconnected#_#name=Is Disconnected;suid#_#ftype=suid#_#name=SUID;suser#_#name=Suser;user_last_name#_#ftype=lastname#_#name=User Lastname;nimbus#_#ftype=nimbus#_#name=Nimbus;opt_nimbus#_#name=Opt Nimbus;attributes#_#ftype=attributes#_#name=Attributes;mac_address#_#ftype=macaddress#_#name=Mac Address}",
				"parser_type": "default",
				"xwikilink": "",
				"type_uid": "etrust",
				"parser_uid": "uid",
				"parser_specification": {
					"defaultPattern": "NONE",
					"parserparam": "",
					"defaultXpoLogPattern": "{text} {text:Server Name,ftype=servername} {text:CEF} {text:Version}| {text:CA,ftype=ca}|{text:PIM,ftype=pim}|{text:SP,ftype=sp}|{text:Header,ftype=header}|{text:Event Description,ftype=eventdescription}|{text:EventCode,ftype=eventcode}| {properties:Properties,keysSep==;propSep=space;,event_header#_#ftype=eventheader#_#name=Event Header;shost#_#ftype=sourcehost#_#name=Source Host;dhost#_#ftype=targethost#_#name=Destination Host;event_type#_#ftype=eventtype#_#name=Event Type;status#_#ftype=status#_#name=Status;susr#_#ftype=username#_#name=Source User;dst#_#ftype=dst#_#name=DST;program#_#ftype=program#_#name=Program;start;time#_#date::dateFormat=HH:mm:ss#_#dateUIFormat=dd/MM/yyyy HH:mm:ss;message#_#ftype=message#_#name=Message;User_Logon_Session_ID#_#ftype=sessionid#_#name=User Logon Session ID;Audit_flags#_#ftype=auditflags#_#name=Audit Flags;nStatus#_#ftype=nstatus#_#name=Nstatus;rt#_#ftype=rt#_#name=RT;nReason#_#ftype=nreason#_#name=Nreason;nStage#_#ftype=nstage#_#name=Nstage;act#_#ftype=action#_#name=Action;administrator#_#ftype=administrator#_#name=Administrator;class#_#ftype=class#_#name=Class;object#_#ftype=object#_#name=Object;command#_#ftype=command#_#name=Command;on_behalf#_#ftype=onbehalf#_#name=On Behalf;resource#_#ftype=resource#_#name=Resource;access#_#ftype=access#_#name-Access;on_behalf_of#_#ftype=onbehalfof#_#name=On Behalf Of;daemon#_#ftype=daemon#_#name=Daemon;service#_#ftype=service#_#name=Service;file#_#ftype=file#_#name=File;deployment_task#_#ftype=deploymenttask#_#name=Deployment Task;engine_service#_#ftype=engineservice#_#name=Engine Service;event_name#_#ftype=eventname#_#name=Event Name;server_name#_#name=Server;event_date#_#name=Event Date;host#_#ftype=host#_#name=Host;account_type#_#ftype=accounttype#_#name=Account Type;is_disconnected#_#ftype=isdisconnected#_#name=Is Disconnected;suid#_#ftype=suid#_#name=SUID;suser#_#name=Suser;user_last_name#_#ftype=lastname#_#name=User Lastname;nimbus#_#ftype=nimbus#_#name=Nimbus;opt_nimbus#_#name=Opt Nimbus;attributes#_#ftype=attributes#_#name=Attributes;mac_address#_#ftype=macaddress#_#name=Mac Address}",
					"externalJS": "link or code"
				}
			}
		}
	]		
}
});
