function getName() {
	return "fedora";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "fedora",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/messages",
					"typetag": "fedora,linux,messages",
					"name": "Messages",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}: [{text:time-taken,ftype=time-taken;,}] {text:Message,ftype=message}\n{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}:{regexp:User,ftype=accountid;refName=message,([passed|failed|closed|opened] for user |password for invalid user |password for |USER=| user \\u0027| user )[XPLG_PARAM([^\\s\\.\\u005D\\u0027]+)].*}{regexp:Sourceip,ftype=sourceip;refName=Message,(\\d+\\.\\d+\\.\\d+\\.\\d+).*} {text:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_messages",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}: [{text:time-taken,ftype=time-taken;,}] {text:Message,ftype=message}\n{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}:{regexp:User,ftype=accountid;refName=message,([passed|failed|closed|opened] for user |password for invalid user |password for |USER=| user \\u0027| user )[XPLG_PARAM([^\\s\\.\\u005D\\u0027]+)].*}{regexp:Sourceip,ftype=sourceip;refName=Message,(\\d+\\.\\d+\\.\\d+\\.\\d+).*} {text:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/secure",
					"typetag": "fedora,linux,auth",
					"name": "Secure",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}:{regexp:User,ftype=accountid;refName=message,([passed|failed|closed|opened] for user |changed password expiry for\\s|password for invalid user |password for |password changed for\\s|USER=|User unknown:\\s|unknown user:\\s|user \\u0027|user=|user | user:\\sname=)[XPLG_PARAM([^\\s\\.\\u005D\\u0027\\,\\u003A\\u0028]+)].*}{regexp:Sourceip,ftype=sourceip;refName=Message,(\\d+\\.\\d+\\.\\d+\\.\\d+).*}{regexp:Group,ftype=group;refName=Message,(group\\s'|group:\\sname=|group added.*name=)[XPLG_PARAM([^'\\s,]+)].*} {regexp:uid,ftype=uid;refName=Message,uid=([^\\s\\u0029]+).*}{regexp:rhost,ftype=rhost;refName=Message,rhost=([^\\s]+),*}{text:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_secure",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}:{regexp:User,ftype=accountid;refName=message,([passed|failed|closed|opened] for user |changed password expiry for\\s|password for invalid user |password for |password changed for\\s|USER=|User unknown:\\s|unknown user:\\s|user \\u0027|user=|user | user:\\sname=)[XPLG_PARAM([^\\s\\.\\u005D\\u0027\\,\\u003A\\u0028]+)].*}{regexp:Sourceip,ftype=sourceip;refName=Message,(\\d+\\.\\d+\\.\\d+\\.\\d+).*}{regexp:Group,ftype=group;refName=Message,(group\\s'|group:\\sname=|group added.*name=)[XPLG_PARAM([^'\\s,]+)].*} {regexp:uid,ftype=uid;refName=Message,uid=([^\\s\\u0029]+).*}{regexp:rhost,ftype=rhost;refName=Message,rhost=([^\\s]+),*}{text:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/cron",
					"typetag": "fedora,linux,cron",
					"name": "Cron",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Server,ftype=server} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_cron",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Server,ftype=server} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/mailog",
					"typetag": "fedora,linux,mail",
					"name": "Maillog",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{number:process id}]{block,end,emptiness=true}: {regexp:session,refName=Message;ftype=session,^(\\w+):}{regexp:From,refName=Message;ftype=from,\\s+from=\\u003C?([^\\u003E,]+)}{regexp:To,refName=Message;ftype=to,\\s+to=\\u003C?([^\\u003E,]+)}{regexp:Size,refName=Message;ftype=size,size=([^\\s,]+).*}{regexp:Class,refName=Message;ftype=class,class=([^\\s,]+).*}{regexp:nrcpts,refName=Message;ftype=nrcpts,nrcpts=([^\\s,]+).*}{regexp:msgID,refName=Message;ftype=msgid,msgid=<([^>]+).*}{regexp:Proto,refName=Message;ftype=protocol,proto=([^\\s,]+).*}{regexp:Stat,refName=Message;ftype=status,stat=([^\\s,]+).*}{regexp:Relay,refName=Message;ftype=relay,relay=([^\\s,]+).*}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_maillog",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{number:process id}]{block,end,emptiness=true}: {regexp:session,refName=Message;ftype=session,^(\\w+):}{regexp:From,refName=Message;ftype=from,\\s+from=\\u003C?([^\\u003E,]+)}{regexp:To,refName=Message;ftype=to,\\s+to=\\u003C?([^\\u003E,]+)}{regexp:Size,refName=Message;ftype=size,size=([^\\s,]+).*}{regexp:Class,refName=Message;ftype=class,class=([^\\s,]+).*}{regexp:nrcpts,refName=Message;ftype=nrcpts,nrcpts=([^\\s,]+).*}{regexp:msgID,refName=Message;ftype=msgid,msgid=<([^>]+).*}{regexp:Proto,refName=Message;ftype=protocol,proto=([^\\s,]+).*}{regexp:Stat,refName=Message;ftype=status,stat=([^\\s,]+).*}{regexp:Relay,refName=Message;ftype=relay,relay=([^\\s,]+).*}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Directed by default to /dev/console, possible file names: /var/log/kernel or /var/log/kern.log",
					"typetag": "fedora,linux,kernel",
					"name": "Kernel",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}:{block,start,emptiness=true} [{text:time-taken,ftype=time-taken;,}]{block,end,emptiness=true} {text:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_kernel",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}:{block,start,emptiness=true} [{text:time-taken,ftype=time-taken;,}]{block,end,emptiness=true} {text:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/dnf.log",
					"typetag": "fedora,linux,dnf",
					"name": "Dnf",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd'T'HH:mm:ssZ} {priority:Priority,ftype=priority,INFO;NOTICE;WARN;WARNING;DEBUG;DDEBUG;SUBDEBUG;CRITICAL} {string:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_dnf",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd'T'HH:mm:ssZ} {priority:Priority,ftype=priority,INFO;NOTICE;WARN;WARNING;DEBUG;DDEBUG;SUBDEBUG;CRITICAL} {string:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/ufw.log",
					"typetag": "fedora,linux,ufw",
					"name": "Ufw",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Hostname.ftype=hostname} {text:Process,ftype=process}: [{text:Kernel Time,ftype=kerneltime}] [{text:LogPrefix}] {properties:Message,keysSep==;propSep=space;,IN#_#ftype=interfacein;OUT#_#ftype=interfaceout;MAC#_#ftype-mac;SRC#_#ftype=sourceip;DST#_#ftype=targetip;LEN#_#ftype=length#_#name=Payload Length;TOS#_#ftype=servicetype#_#name=Type Of Service;PREC#_#ftype=precedence#_#name=Precedence;TTL#_#ftype=ttl;ID#_#ftype=id#_#name=Identification;PROTO#_#ftype=protocol;SPT#_#ftype=sourceport#_#name=SourcePort;DPT#_#ftype=targetport#_#name=TargetPort;WINDOW#_#name=windowssize;RES#_#ftype=flags#_#name=TCP Flags;URGP}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_ufw",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Hostname.ftype=hostname} {text:Process,ftype=process}: [{text:Kernel Time,ftype=kerneltime}] [{text:LogPrefix}] {properties:Message,keysSep==;propSep=space;,IN#_#ftype=interfacein;OUT#_#ftype=interfaceout;MAC#_#ftype-mac;SRC#_#ftype=sourceip;DST#_#ftype=targetip;LEN#_#ftype=length#_#name=Payload Length;TOS#_#ftype=servicetype#_#name=Type Of Service;PREC#_#ftype=precedence#_#name=Precedence;TTL#_#ftype=ttl;ID#_#ftype=id#_#name=Identification;PROTO#_#ftype=protocol;SPT#_#ftype=sourceport#_#name=SourcePort;DPT#_#ftype=targetport#_#name=TargetPort;WINDOW#_#name=windowssize;RES#_#ftype=flags#_#name=TCP Flags;URGP}",
						"externalJS": "link or code"
					}
				}
			},{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/audit/audit.log",
					"typetag": "fedora,linux,audit",
					"name": "Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "type={text:Type,ftype=eventid}{map:Event Description,ftype=eventdescription;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit.prop}{map:Category,ftype=category;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit-categories.prop} msg=audit({timestamp:Date,yyyy-MM-dd HH:mm:ss.SSS}:{text:Message ID}): {properties:values,keysSep==;propSep=space;,pid#_#ftype=pid#_#name=PID;uid#_#name=UID;auid#_#ftype=auid;old-auid#_#ftype=oldauid#_#name=Old auid;ses#_#ftype=sessionid#_#name=Sessionid;sub;tty;old-ses;res;proctitle;arch;syscall;success;exit;items}msg=''{properties:msg,keysSep==;propSep=space;,op#_#ftype=op#_#name=OP;exe#_#ftype=exe;hostname#_#ftype=machine#_#name=Hostname;addr#_#ftype=sourceip;terminal#_#ftype=terminal#_#name=Terminal;res#_#ftype=status#_#name=Status;acct#_#ftype=accountid;fp#_#ftype=fp;kind#_#ftype=kind;direction#_#ftype=direction;spid#_#ftype=spid;suid#_#ftype=suid;rport#_#ftype=rport#_#name=Rport;port#_#ftyperport#_#name=Port;comm#_#ftype=comm;unit#_#ftype=unit;id#_#ftype=uid#_#name=ID}''{regexp:New Name,ftype=newname;refName=OP,new name:\\s+([^\\s]+).*}{regexp:New GID,ftype=newgid;refName=OP,new gid:\\s+(\\d+)}{regexp:Operation,ftype=operation;refName=OP,([^\\u003B]+).*}\ntype={text:Type,ftype=eventid}{map:Event Description,ftype=eventdescription;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit.prop}{map:Category,ftype=category;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit-categories.prop} msg=audit({timestamp:Date,yyyy-MM-dd HH:mm:ss.SSS}:{text:Message ID}): {properties:values,keysSep==;propSep=space;,pid#_#ftype=pid#_#name=PID;uid#_#name=UID;auid#_#ftype=auid;old-auid#_#ftype=oldauid#_#name=Old auid;ses#_#ftype=sessionid#_#name=Sessionid;sub;tty;old-ses;res;proctitle;arch;syscall;success;exit;items;acct#_#ftype=accountid;exe#_#ftype=exe;hostname#_#ftype=machine#_#name=Hostname;addr#_#ftype=sourceip;terminal#_#ftype=terminal#_#name=Terminal;subj;msg;grantors;op#_#ftype=op#_#name=OP;fp#_#ftype=fp;kind#_#ftype=kind;direction#_#ftype=direction;spid#_#ftype=spid;suid#_#ftype=suid;rport#_#ftype=rport#_#name=Rport;port#_#ftyperport#_#name=Port;comm#_#ftype=comm;unit#_#ftype=unit}{regexp:New Name,ftype=newname;refName=OP,new name:\\s+([^\\s]+).*}{regexp:New GID,ftype=newgid;refName=OP,new gid:\\s+(\\d+)}{regexp:Operation,ftype=operation;refName=OP,([^\\u003B]+).*}{regexp:Status,ftype=status;refName=res,(\\w+).*}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Fedora",
					"type_uid": "fedora_audit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "type={text:Type,ftype=eventid}{map:Event Description,ftype=eventdescription;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit.prop}{map:Category,ftype=category;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit-categories.prop} msg=audit({timestamp:Date,yyyy-MM-dd HH:mm:ss.SSS}:{text:Message ID}): {properties:values,keysSep==;propSep=space;,pid#_#ftype=pid#_#name=PID;uid#_#name=UID;auid#_#ftype=auid;old-auid#_#ftype=oldauid#_#name=Old auid;ses#_#ftype=sessionid#_#name=Sessionid;sub;tty;old-ses;res;proctitle;arch;syscall;success;exit;items}msg=''{properties:msg,keysSep==;propSep=space;,op#_#ftype=op#_#name=OP;exe#_#ftype=exe;hostname#_#ftype=machine#_#name=Hostname;addr#_#ftype=sourceip;terminal#_#ftype=terminal#_#name=Terminal;res#_#ftype=status#_#name=Status;acct#_#ftype=accountid;fp#_#ftype=fp;kind#_#ftype=kind;direction#_#ftype=direction;spid#_#ftype=spid;suid#_#ftype=suid;rport#_#ftype=rport#_#name=Rport;port#_#ftyperport#_#name=Port;comm#_#ftype=comm;unit#_#ftype=unit;id#_#ftype=uid#_#name=ID}''{regexp:New Name,ftype=newname;refName=OP,new name:\\s+([^\\s]+).*}{regexp:New GID,ftype=newgid;refName=OP,new gid:\\s+(\\d+)}{regexp:Operation,ftype=operation;refName=OP,([^\\u003B]+).*}\ntype={text:Type,ftype=eventid}{map:Event Description,ftype=eventdescription;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit.prop}{map:Category,ftype=category;refIndex=0,file:knowledge/repository/system/linux/map/linux-audit-categories.prop} msg=audit({timestamp:Date,yyyy-MM-dd HH:mm:ss.SSS}:{text:Message ID}): {properties:values,keysSep==;propSep=space;,pid#_#ftype=pid#_#name=PID;uid#_#name=UID;auid#_#ftype=auid;old-auid#_#ftype=oldauid#_#name=Old auid;ses#_#ftype=sessionid#_#name=Sessionid;sub;tty;old-ses;res;proctitle;arch;syscall;success;exit;items;acct#_#ftype=accountid;exe#_#ftype=exe;hostname#_#ftype=machine#_#name=Hostname;addr#_#ftype=sourceip;terminal#_#ftype=terminal#_#name=Terminal;subj;msg;grantors;op#_#ftype=op#_#name=OP;fp#_#ftype=fp;kind#_#ftype=kind;direction#_#ftype=direction;spid#_#ftype=spid;suid#_#ftype=suid;rport#_#ftype=rport#_#name=Rport;port#_#ftyperport#_#name=Port;comm#_#ftype=comm;unit#_#ftype=unit}{regexp:New Name,ftype=newname;refName=OP,new name:\\s+([^\\s]+).*}{regexp:New GID,ftype=newgid;refName=OP,new gid:\\s+(\\d+)}{regexp:Operation,ftype=operation;refName=OP,([^\\u003B]+).*}{regexp:Status,ftype=status;refName=res,(\\w+).*}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "Fedora",
		"typetag": "fedora,linux",
		"name": "fedora",
		"description": "",
		"type": "operating systems",
		"doclink": "https://docs.fedoraproject.org/f26/system-administrators-guide/monitoring-and-automation/Viewing_and_Managing_Log_Files.html",
		"version": "current",
		"xwikilink": "",
		"example": ""
	}
});
