function getName() {
	return "freebsd";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "freebsd",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/messages",
					"typetag": "freebsd,linux,messages",
					"name": "Messages",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message;,}{regexp:User,ftype=user;refName=message,[passed|failed] for (.*) from}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_messages",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message;,}{regexp:User,ftype=user;refName=message,[passed|failed] for (.*) from}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/auth.log",
					"typetag": "freebsd,linux,auth",
					"name": "Auth",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:SourceIP,ftype=source} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_auth",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:SourceIP,ftype=source} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/cron",
					"typetag": "freebsd,linux,cron",
					"name": "Cron",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Server,ftype=server} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_cron",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:Server,ftype=server} {text:Process,ftype=process}{block,start,emptiness=true}[{text:pid,ftype=pid}]{block,end,emptiness=true}: {text:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/mailog",
					"typetag": "freebsd,linux,mail",
					"name": "Maillog",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{number:process id}]{block,end,emptiness=true}: {regexp:session,refName=Message;ftype=session,^(\\w+):}{regexp:From,refName=Message;ftype=from,\\s+from=<?([^,<>]+)}{regexp:To,refName=Message;ftype=to,\\s+to=<?([^,<>]+)}{text:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_maillog",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}{block,start,emptiness=true}[{number:process id}]{block,end,emptiness=true}: {regexp:session,refName=Message;ftype=session,^(\\w+):}{regexp:From,refName=Message;ftype=from,\\s+from=<?([^,<>]+)}{regexp:To,refName=Message;ftype=to,\\s+to=<?([^,<>]+)}{text:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "should be allowed manually in /etc/syslog.conf",
					"typetag": "freebsd,linux,kernel",
					"name": "Kernel",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}: [{text:time-taken,ftype=time-taken;,}] {text:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_kernel",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,MMM dd HH:mm:ss} {text:source,ftype=source} {text:process name,ftype=process;,}: [{text:time-taken,ftype=time-taken;,}] {text:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "praudit /var/audit/current >> external_file",
					"typetag": "freebsd,linux,audit",
					"name": "Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "header,{number:BytesInRecord},{number:Version_Number},{text:eventName,ftype=eventName},{number:Number3},{date:Date,EEE MMM dd HH:mm:ss yyyy}, +{string:Process_Time}{eol}{regexp:status,ftype=status;refName=Record,return,(\\w+)}{regexp:Failure_Message,refName=Record,failure : ([^,]*)}{regexp:Message,ftype=message;refName=Record,text,([^\\n]*)}{regexp:AuditUserId,ftype=username;refName=Record,subject.*?,([^,]*)}{regexp:EffectiveUserID,refName=Record,subject.*?,.*?,([^,]*)}{regexp:EffectiveGroupID,refName=Record,subject.*?,.*?,.*?,([^,]*)}{regexp:RealUserID,refName=Record,subject.*?,.*?,.*?,.*?,([^,]*)}{regexp:RealGroupID,refName=Record,subject.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:ProcessID,refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:SessionID,ftype=sessionid;refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:Port,refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:TerminalIp,ftype=sourceip;refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^\\n]*)}{string:Record}trailer,{number:trailer_number}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_audit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "header,{number:BytesInRecord},{number:Version_Number},{text:eventName,ftype=eventName},{number:Number3},{date:Date,EEE MMM dd HH:mm:ss yyyy}, +{string:Process_Time}{eol}{regexp:status,ftype=status;refName=Record,return,(\\w+)}{regexp:Failure_Message,refName=Record,failure : ([^,]*)}{regexp:Message,ftype=message;refName=Record,text,([^\\n]*)}{regexp:AuditUserId,ftype=username;refName=Record,subject.*?,([^,]*)}{regexp:EffectiveUserID,refName=Record,subject.*?,.*?,([^,]*)}{regexp:EffectiveGroupID,refName=Record,subject.*?,.*?,.*?,([^,]*)}{regexp:RealUserID,refName=Record,subject.*?,.*?,.*?,.*?,([^,]*)}{regexp:RealGroupID,refName=Record,subject.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:ProcessID,refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:SessionID,ftype=sessionid;refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:Port,refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^,]*)}{regexp:TerminalIp,ftype=sourceip;refName=Record,subject.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,.*?,([^\\n]*)}{string:Record}trailer,{number:trailer_number}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "/var/log/userlog",
					"typetag": "freebsd,linux,audit,userlog",
					"name": "Userlog",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd HH:mm:ss} [{text:UserActor,ftype=username}:{text:Action,ftype=eventName}] {text:ObjectName,ftype=object}({number:ID,ftype=id}){regexp:Home_Directory,ftype=homedir;refName=Message,( home\s|&\u003A)[XPLG_PARAM([^\s\u003A]*)]}{regexp:Shell,ftype=shell;refName=Message,:(/bin[^\s].*)}{string:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
					"type_uid": "freebsd_userlog",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd HH:mm:ss} [{text:UserActor,ftype=username}:{text:Action,ftype=eventName}] {text:ObjectName,ftype=object}({number:ID,ftype=id}){regexp:Home_Directory,ftype=homedir;refName=Message,( home\s|&\u003A)[XPLG_PARAM([^\s\u003A]*)]}{regexp:Shell,ftype=shell;refName=Message,:(/bin[^\s].*)}{string:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "FreeBSD",
		"typetag": "freebsd,linux",
		"name": "freebsd",
		"description": "",
		"type": "operating systems",
		"doclink": "http://wiki.xpolog.com/display/XPOL/Free+BSD",
		"version": "current",
		"xwikilink": "",
		"example": ""
	}
});
