function getName() {
	return "log4j_1_2";
}
xplgRegisterSystemDef({
	"xplg_system_def" : {
		"uid" : "log4j_1_2",
		"apptags" : "",
		"displayName" : "Log4J",
		"typetag" : "java,log4j",
		"name" : "log4j",
		"description" : "",
		"type" : "logging",
		"doclink" : "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_log4j1",
		"version" : "1.2",
		"xwikilink" : "",
		"example" : "",
		"logtypes" : [ {
			"log" : {
				"xdoclink" : "",
				"defaultPattern" : "NONE",
				"howto" : "In the Apache Log4J configuration file, can be either properties files, XML file, or in some case the log format was created programmatically for which you can manually create the pattern for the data.",
				"typetag" : "java,log4j",
				"name" : "Log4J",
				"custom_parser_location" : "<LINK to JS>",
				"defaultXpoLogPattern" : "NONE",
				"parser_type" : "default",
				"xwikilink" : "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_log4j1",
				"type_uid" : "log4j",
				"parser_uid" : "uid",
				"parser_specification" : {
					"defaultPattern" : "NONE",
					"parserparam" : "",
					"defaultXpoLogPattern" : "NONE",
					"externalJS" : "link or code",
					"preBuild" : function(pattern) {
						var result = pattern;
						var reg = new RegExp("%%", "g");
						var result = result.replace(reg, "%");
						reg = new RegExp("%-?\\d+(\\.\\d+)?", "g");
						return pattern.replace(reg, "%");
					},
					"filters" : [
							{
								"filter" : [ {
									match : "%c"
								} ],
								"type" : "Text",
								"function" : {
									"filedName" : "Category",
									"ftype" : "category"
								}
							},
							{
								"filter" : [ {
									match : "%c{\\d+}",
									"isRegExp" : true
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(
											regexp_params) {
										return "{text:Category,ftype=logger}";
									}
								}
							},
							{
								"filter" : [ {
									match : "%X{([^\\}]+)}",
									"isRegExp" : true
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(
											regexp_params) {
										var param = regexp_params[1];										
										return "{text:" + param + "}";
									}
								}
							},
							{
								"filter" : [ {
									match : "%C"
								} ],
								"type" : "Text",
								"function" : {
									"filedName" : "Class",
									"ftype" : "class"
								}
							},
							{
								"filter" : [ {
									match : "%C{\\d+}",
									"isRegExp" : true
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(
											regexp_params) {
										return "{text:Class,ftype=class}";
									}
								}
							},
							{
								"filter" : [ {
									match : "%d"
								} ],
								"type" : "Date",
								"function" : {
									"filedName" : "Date",
									"datePattern" : "yyyy-MM-dd HH:mm:ss,SSS"
								}
							},
							{
								"filter" : [ {
									"match" : "%d{([^\\}]+)}",
									"isRegExp" : true
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(
											regexp_params) {
										var param = regexp_params[1];
										if (param == "ISO8601") {
											param = "yyyy-MM-dd HH:mm:ss,SSS";
										} else if (param == "ABSOLUTE") {
											param = "HH:mm:ss,SSS";
										}
										return "{date:Date," + param + "}";
									}
								}
							},
							{
								"filter" : [ {
									match : "%file"
								}, {
									match : "%F"
								} ],
								"type" : "Text",
								"function" : {
									"filedName" : "File",
									"ftype" : "file"
								}
							},
							{
								"filter" : [ {
									match : "%l"
								} ],
								"type" : "CustomParse",
								"function" : {
									"custom_parse_function" : function(params) {
										return "{text:Method,ftype=method}({text:Class,ftype=sourcecode}:{number:LineNumberr,ftype=linenumber}";
									}
								}
							},
							{
								"filter" : [ {
									match : "%L"
								} ],
								"type" : "Number",
								"function" : {
									"filedName" : "LineNumber",
									"ftype" : "linenumber"
								}
							},
							{
								"filter" : [ {
									match : "%m"
								} ],
								"type" : "String",
								"function" : {
									"filedName" : "Message",
									"ftype" : "message"
								}
							},
							{
								"filter" : [ {
									match : "%M"
								} ],
								"type" : "Text",
								"function" : {
									"filedName" : "Method",
									"ftype" : "method"
								}
							},
							{
								"filter" : [ {
									match : "%n"
								} ],
								"type" : "eol",
								"function" : {
									"filedName" : "EOL"
								}
							},
							{
								"filter" : [ {
									match : "%p"
								} ],
								"type" : "Priority",
								"function" : {
									"filedName" : "Priority",
									"levels" : "ALL;TRACE;DEBUG;INFO;WARN;ERROR;FATAL",
									"ftype" : "severity"
								}
							}, {
								"filter" : [ {
									match : "%r"
								} ],
								"type" : "Number",
								"function" : {
									"filedName" : "LogSpeed",
									"ftype" : "logprocesstimemilli"
								}
							}, {
								"filter" : [ {
									match : "%t"
								} ],
								"type" : "Text",
								"function" : {
									"filedName" : "Thread",
									"ftype" : "thread"
								}
							} ]
				}
			}
		} ]
	}
});
