function getName() {
	return "mssql_2016";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "mssql_2016",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "By default, the error log is located at:\" MSSQL_ROOT_DIR\\Microsoft SQL Server\\MSSQL.n\\MSSQL\\LOG\\ERRORLOG\" - In XpoLog set name path: MSSQL{string}.{string}\\MSSQL\\Log\\ERRORLOG{string} , Encoding: ERRORLOG encoding is UCS-2 LE BOM which may not be parsed properly using the default character set. Enter Advanced  Settings - Regional Settings and choose the character set UTF-16LE",
					"typetag": "database,mssql,error",
					"name": "Error",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd HH:mm:ss.SS} {text:event,ftype=eventName} {regexp:Errorcode,refName=Message;ftype=errorCode,Error: (\\d+).*}{regexp:Severity,refName=Message,Severity: (\\d+).*}{regexp:State,refName=Message,State: (\\d+).*}{regexp:User,refName=Message,(login \\u0022|user \\u0027)[XPLG_PARAM([^\\u0027\\u0022]+)].*}{regexp:DB,ftype=database;refName=Message,database \\u0027([^\\u0027]+).*}{regexp:Failure_Message,refName=Message,Reason: ([^\\u005B]*).*}{regexp:Client,ftype=source;refName=Message,\\u005BCLIENT:\\s([^\\u005D]*).*} {string:Message}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_mssql",
					"type_uid": "mssql_error",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,yyyy-MM-dd HH:mm:ss.SS} {text:event,ftype=eventName} {regexp:Errorcode,refName=Message;ftype=errorCode,Error: (\\d+).*}{regexp:Severity,refName=Message,Severity: (\\d+).*}{regexp:State,refName=Message,State: (\\d+).*}{regexp:User,refName=Message,(login \\u0022|user \\u0027)[XPLG_PARAM([^\\u0027\\u0022]+)].*}{regexp:DB,ftype=database;refName=Message,database \\u0027([^\\u0027]+).*}{regexp:Failure_Message,refName=Message,Reason: ([^\\u005B]*).*}{regexp:Client,ftype=source;refName=Message,\\u005BCLIENT:\\s([^\\u005D]*).*} {string:Message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "To create Audit follow the instructions in the following article: https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_mssql_audit",
					"typetag": "database,mssql,audit",
					"name": "Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "@XPLG@{date:Date,yyyy-MM-dd HH:mm:ss.SSSSSSS}*;*{number:Sequence Number}*;*{text:Action ID,ftype=event}{map:Action Description,ftype=classdescription;refIndex=2,file:knowledge/repository/system/sql/map/action-id-description.prop}*;*{text:Action Status,ftype=status}*;*{text:Permission Bitmask,ftype=permissionbitmask}*;*{text:Column Permission}*;*{number:Session ID,ftype=sessionid}*;*{number:Server Principal ID}*;*{number:Database Principal ID}*;*{number:Target Server Principal ID}*;*{number:Target Database Principal ID}*;*{number:Object ID}*;*{text:Class Type,ftype=classtype}{map:Class Type Description,ftype=classtypedesc;refIndex=13,file:knowledge/repository/system/sql/map/class-type-description.prop}{map:Class Type Group Description,ftype=classgroupdesc;refIndex=13,file:knowledge/repository/system/sql/map/class-type-group-description.prop}*;*{text:Session Server Principal Name}*;*{text:Server Principal Name,ftype=accountuser}*;*{text:Server Principal SID,ftype=serverprincipalsid}*;*{text:Database Principal Name,ftype=dbprinsiplename}*;*{text:Target Server Principal Name}*;*{text:Target Server Principal SID,ftype=targetprincipalsid}*;*{text:Target Database Principal Name,ftype=targetdbprinsiplename}*;*{text:Server Instance Name,ftype=accounthost}*;*{text:Database Name,ftype=sqlqdb}*;*{text:Schema Name,ftype=sqlqschema}*;*{text:Object Name,ftype=sqlqtable}*;*{string:Statement,ftype=sqlquery}*;*{string:Additional information,ftype=additionalinfo}*;*{string:File Name,ftype=ftype}*;*{number:Audit File Offset,ftype=auditoffset}*;*{number:User Defined Event ID,ftype=userdefinedid}*;*{string:User Defined Information,ftype=userdefinedinformation}*;*{number:Audit Schema Version,ftype=auditversion}*;*{string:Sequence Group ID,ftype=sequencegroupid}*;*{number:Transaction ID,ftype=transactionid}@XPLG@",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_mssql",
					"type_uid": "mssql_audit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "@XPLG@{date:Date,yyyy-MM-dd HH:mm:ss.SSSSSSS}*;*{number:Sequence Number}*;*{text:Action ID,ftype=event}{map:Action Description,ftype=classdescription;refIndex=2,file:knowledge/repository/system/sql/map/action-id-description.prop}*;*{text:Action Status,ftype=status}*;*{text:Permission Bitmask,ftype=permissionbitmask}*;*{text:Column Permission}*;*{number:Session ID,ftype=sessionid}*;*{number:Server Principal ID}*;*{number:Database Principal ID}*;*{number:Target Server Principal ID}*;*{number:Target Database Principal ID}*;*{number:Object ID}*;*{text:Class Type,ftype=classtype}{map:Class Type Description,ftype=classtypedesc;refIndex=13,file:knowledge/repository/system/sql/map/class-type-description.prop}{map:Class Type Group Description,ftype=classgroupdesc;refIndex=13,file:knowledge/repository/system/sql/map/class-type-group-description.prop}*;*{text:Session Server Principal Name}*;*{text:Server Principal Name,ftype=accountuser}*;*{text:Server Principal SID,ftype=serverprincipalsid}*;*{text:Database Principal Name,ftype=dbprinsiplename}*;*{text:Target Server Principal Name}*;*{text:Target Server Principal SID,ftype=targetprincipalsid}*;*{text:Target Database Principal Name,ftype=targetdbprinsiplename}*;*{text:Server Instance Name,ftype=accounthost}*;*{text:Database Name,ftype=sqlqdb}*;*{text:Schema Name,ftype=sqlqschema}*;*{text:Object Name,ftype=sqlqtable}*;*{string:Statement,ftype=sqlquery}*;*{string:Additional information,ftype=additionalinfo}*;*{string:File Name,ftype=ftype}*;*{number:Audit File Offset,ftype=auditoffset}*;*{number:User Defined Event ID,ftype=userdefinedid}*;*{string:User Defined Information,ftype=userdefinedinformation}*;*{number:Audit Schema Version,ftype=auditversion}*;*{string:Sequence Group ID,ftype=sequencegroupid}*;*{number:Transaction ID,ftype=transactionid}@XPLG@",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "MSSQL",
		"typetag": "database,mssql",
		"name": "mssql",
		"description": "",
		"type": "databases",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_mssql",
		"version": "2016",
		"xwikilink": "",
		"example": ""
	}
});
