function getName() {
	return "tomcat_7";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "tomcat_7",
		"apptags": "",
		"displayName": "Apache Tomcat",
		"typetag": "tomcat",
		"name": "tomcat",
		"description": "",
		"type": "application servers",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_tomcat7",
		"version": "7",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"TOMCAT_ROOT_DIR/logs/\". The server has default logging configuration and can be configured to use log4j.",
					"typetag": "tomcat,out",
					"name": "Catalina out",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,dd-MMM-yyyy HH:mm:ss.SSS} {priority:Priority,ftype=severity,ALL;FINEST;FINER;FINE;INFO;CONFIG;WARNING;SEVERE} [{text:Thread,ftype=thread}] {text:Source,ftype=source} {string:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_tomcat8",
					"type_uid": "tomcat_catalina_out",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,dd-MMM-yyyy HH:mm:ss.SSS} {priority:Priority,ftype=severity,ALL;FINEST;FINER;FINE;INFO;CONFIG;WARNING;SEVERE} [{text:Thread,ftype=thread}] {text:Source,ftype=source} {string:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"TOMCAT_ROOT_DIR/logs/\". The server has default logging configuration and can be configured to use log4j.",
					"typetag": "tomcat,servlet",
					"name": "Catalina Servlet",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{date:Date,dd-MMM-yyyy HH:mm:ss.SSS} {priority:Priority,ftype=severity,ALL;FINEST;FINER;FINE;INFO;CONFIG;WARNING;SEVERE} [{text:Thread,ftype=thread}] {text:Source,ftype=source} {string:Message,ftype=message}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_tomcat8",
					"type_uid": "tomcat_catalina_servlet",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{date:Date,dd-MMM-yyyy HH:mm:ss.SSS} {priority:Priorirty,ftype=severity,ALL;FINEST;FINER;FINE;INFO;CONFIG;WARNING;SEVERE} [{text:Thread,ftype=thread}] {text:Source,ftype=source} {string:Message,ftype=message}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"parser_uid": "uid",
					"xdoclink": "",
					"defaultPattern": "%h %l %u %t \\\"%r\\\" %>s %b",
					"howto": "Logs are usually located under \"TOMCAT_ROOT_DIR/logs/\". The server has default logging configuration and can be configured to use log4j.",
					"typetag": "tomcat,access",
					"name": "Access",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "NONE",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_tomcat8",
					"type_uid": "tomcat_access",
					"parser_specification": {
						"defaultPattern": "%h %l %u %t \\\"%r\\\" %>s %b",
						"parserparam": "",
						"defaultXpoLogPattern": "NONE",
						"externalJS": "link or code",
						"preBuild": function (pattern) {
							var result = pattern;
							var reg = new RegExp("%t", "g");
							result = result.replace(reg, "[%t]");
							var reg = new RegExp("%S", "g");
							result = result.replace(reg, "%I %O");
							var reg = new RegExp("%%", "g");
							result = result.replace(reg, "%");
							reg = new RegExp("%>s", "g");
							result = result.replace(reg, "%s");
							reg = new RegExp("\\\\\"", "g");
							result = result.replace(reg, "\"");
							return result;
						},
						"postBuild": function (result) {
							if (result != "") {
								result = result + "{eoe}"
							}
							
							return result;
						},
						"filters":
						[{
								"filter": [{
										"match": "%a"
									}
								],
								"type": "GeoIp",
								"function": {
									"filedName": "Remote IP",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "%{c}a",
										"isCustom" : true
									}
								],
								"type": "GeoIp",
								"function": {
									"filedName": "Remote IP",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "%A"
									}
								],
								"type": "IP",
								"function": {
									"filedName": "Local IP",
									"ftype": "localip"
								}
							}, {
								"filter": [{
										"match": "%B"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "%b"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "Bytes Sent",
									"ftype": "bytesent"
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}C"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:Cookie_" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%D"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseTimeMicroSecs",
									"ftype": "processrequestmicrosecs"
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}e"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{string:EnvVariable_" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%f"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "FileName"
								}
							}, {
								"filter": [{
										"match": "%h"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "RemoteHost",
									"ftype": "remoteip"
								}
							}, {
								"filter": [{
										"match": "%H"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Request Protocol",
									"ftype": "reqprotocol"
								}
							}, {
								"filter": [{
										"match": "%{Referer}i",
										"isCustom": true
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{text:RefererQuery,ftype=refererquery}{regexp:Referer,ftype=referer;refName=RefererQuery,^([\\w-]+://[^?]+|/[^?]+)}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}i"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:HEADER " + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%{User-Agent}i",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User-agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "%{User-agent}i",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "User-agent",
									"ftype": "useragent"
								}
							}, {
								"filter": [{
										"match": "%{X-Forwarded-For}i",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "X-Forwarded-For",
									"ftype": "forwardforip"
								}
							}, {
								"filter": [{
										"match": "%k"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "KeepAlive"
								}
							}, {
								"filter": [{
										"match": "%l"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "logname",
									"ftype": "remotelog"
								}
							}, {
								"filter": [{
										"match": "%m"
									}
								],
								"type": "CustomParse",
                                "function": {
                                    "custom_parse_function" : function (params){
                                        return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD}";
                                    }
                                }
							}, {
								"filter": [{
										"match": "%L"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "LogID",
									"ftype": "logid"
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}n"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{Text:NOTE " + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}o"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{Text:HEADER Line " + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%p"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ServerPort",
									"ftype": "serverport"
								}
							}, {
								"filter": [{
										"match": "%P"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ProcessID",
									"ftype": "processid"
								}
							}, {
								"filter": [{
										"match": "%{canonical}p",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ServerPort",
									"ftype": "serverport"
								}
							}, {
								"filter": [{
										"match": "%{local}p",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "LocalServerPort",
									"ftype": "localserverport"
								}
							}, {
								"filter": [{
										"match": "%{remote}p",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "RemotePort",
									"ftype": "remoteport"
								}
							}, {
								"filter": [{
										"match": "%{pid}P",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ProcessID",
									"ftype": "processid"
								}
							}, {
								"filter": [{
										"match": "%{tid}P",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ThreadID",
									"ftype": "threadid"
								}
							}, {
								"filter": [{
										"match": "%{hextid}P",
										"isCustom": true
									}
								],
								"type": "Text",
								"function": {
									"filedName": "HexThreadID",
									"ftype": "hexthreadid"
								}
							}, {
								"filter": [{
										"match": "%q"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "QueryString",
									"ftype": "querystring"
								}
							}, {
								"filter": [{
										"match": "%r"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function" : function (params){
										return "{choice:Method,ftype=reqmethod;,GET;POST;HEAD} {url:URL,paramsFtype=querystring;ftype=requrl;paramsName=Query;,} {text:Request Protocol,ftype=reqprotocol;,}";
									}
								}
							}, {
								"filter": [{
										"match": "%R"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ResponseHandler"
								}
							}, {
								"filter": [{
										"match": "%s"
									}, {
										"match": "%>s"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseStatus",
									"ftype": "respstatus"
								}
							}, {
								"filter": [{
										"match": "%t"
									}
								],
								"type": "Date",
								"function": {
									"filedName": "Date",
									"datePattern": "dd/MMM/yyyy:HH:mm:ss z",
									"dateLocale": "en"
								}
							}, {
								"filter": [{
										"match": "%{([^\\}]+)}t",
										"isRegExp": true
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										var param = regexp_params[1];
										if (param == "sec") {
											return "{timestamp:timestamp,product=0.0001;,dd/MMM/yyyy:HH:mm:ss z}";
										} else if (param == "msec") {
											return "{timestamp:timestamp,dd/MMM/yyyy:HH:mm:ss z}";
										} else if (param == "usec") {
											return "{timestamp:timestamp,product=1000;,dd/MMM/yyyy:HH:mm:ss z}";
										} else if (param == "msec_frac") {
											return "{timestamp:timestamp,dd/MMM/yyyy:HH:mm:ss z}";
										} else if (param == "usec_frac") {
											return "{timestamp:timestamp,product=1000;,dd/MMM/yyyy:HH:mm:ss z}";
										} else {
											param = param.replace(/%(\w)/g, function test(p) {
													var part = p[1];
													if (part == "z" || part == "Z") {
														return part;
													}
													switch (part) {
													case "a":
														return "EEE";
													case "A":
														return "EEEEE";
													case "b":
														return "MMM";
													case "B":
														return "MMMMM";
													case "Y":
														return "YYYY";
													case "y":
														return "YY";
													case "T":
														return "HH:mm:ss";
													case "m":
														return "MM";
													case "M":
														return "mm";
													case "l":
														return "hh";
													case "I":
														return "hh";
													case "p":
														return "a";
													case "P":
														return "a";
													case "R":
														return "HH:mm";
													case "S":
														return "ss";
													case "d":
														return "dd";
													case "H":
														return "HH";
													case "W":
														return "w";
													}
													return part;
												});
											return "{date:Date,;," + param + "}";
										}
									}
								}
							}, {
								"filter": [{
										"match": "%T"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseTimeSecs",
									"ftype": "processrequestsecs"
								}
							}, {
								"filter": [{
										"match": "%{s}T",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseTimeSecs",
									"ftype": "processrequestsecs"
								}
							}, {
								"filter": [{
										"match": "%{ms}T",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseTimeMilliSecs",
									"ftype": "processrequestmilli"
								}
							}, {
								"filter": [{
										"match": "%{us}T",
										"isCustom": true
									}
								],
								"type": "Number",
								"function": {
									"filedName": "ResponseTimeMicroSecs",
									"ftype": "processrequestmicrosecs"
								}
							}, {
								"filter": [{
										"match": "%u"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "Remote User",
									"ftype": "remoteuser"
								}
							}, {
								"filter": [{
										"match": "%U"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "RequestURL",
									"ftype": "requrl"
								}
							}, {
								"filter": [{
										"match": "%v"
									}, {
										"match": "%V"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ServerName",
									"ftype": "servername"
								}
							}, {
								"filter": [{
										"match": "%X"
									}
								],
								"type": "Text",
								"function": {
									"filedName": "ConnectionStatus"
								}
							}, {
								"filter": [{
										"match": "%I"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "TotalBytesWHeadersReceived",
									"ftype": "reqbyteswheaders"
								}
							}, {
								"filter": [{
										"match": "%O"
									}
								],
								"type": "Number",
								"function": {
									"filedName": "TotalBytesWHeadersSent",
									"ftype": "reqbyteswheaders"
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}^ti"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:Req_" + regexp_params[1] + "}";
									}
								}
							}, {
								"filter": [{
										"match": "%{([\\w_]+)}^to"
									}
								],
								"type": "CustomParse",
								"function": {
									"custom_parse_function": function (regexp_params) {
										return "{text:Resp_" + regexp_params[1] + "}";
									}
								}
							}
						]
					}
				}
			}
		],
	}
});
