function getName() {
	return "websphere_6";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "websphere_6",
		"apptags": "",
		"displayName": "Websphere",
		"typetag": "was,server",
		"name": "websphere",
		"description": "",
		"type": "application servers",
		"doclink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=ext_websphere",
		"version": "6",
		"xwikilink": "",
		"example": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,systemout",
					"name": "System out Basic",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_system_out_basic",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,systemout",
					"name": "System out Advanced",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN} UOW={text:UOW,ftype=uow;,} source={text:Source,ftype=source;,}{block,start,emptiness=true} class={text:Class,ftype=class;,} method={text:Method,ftype=method;,}{block,end,emptiness=true} org={text:Organization,ftype=organization;,} prod={text:Product,ftype=product;,} component={text:Component,ftype=component;,} thread=[{text:Thread Name,ftype=thread;,}]{regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_system_out_advanced",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN} UOW={text:UOW,ftype=uow;,} source={text:Source,ftype=source;,}{block,start,emptiness=true} class={text:Class,ftype=class;,} method={text:Method,ftype=method;,}{block,end,emptiness=true} org={text:Organization,ftype=organization;,} prod={text:Product,ftype=product;,} component={text:Component,ftype=component;,} thread=[{text:Thread Name,ftype=thread;,}]{regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,systemerr",
					"name": "System err",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN} {string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_system_error",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN} {string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,server-start",
					"name": "Server start",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_server_start",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,server-stop",
					"name": "Server stop",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_server_stop",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,nativeout",
					"name": "Native out",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_native_out",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,MM/dd/yy HH:mm:ss:SSS z}] {text:Thread ID,charsLength=8;ftype=threadid;,} {text:Short Name,charsLength=13;ftype=shortname;,} {map:Event Type,ftype=severity;,F=FATAL;E=ERROR;W=WARNING;A=AUDIT;I=INFO;C=CONFIGURATION;D=DETAIL;O=SYSTEM OUTPUT;R=SYSTEM ERROR;Z=UNKNOWN}{block,start,emptiness=true} {text:Class,ftype=class;stopPattern=^com\\\\.ibm\\\\.[\\\\w\\\\.]+(\\\\s);,} {text:Method,ftype=method;,}{block,end,emptiness=true} {regexp:messagecode,refName=Message;ftype=messagecode,^\\\\s*([A-Z][A-Z][A-Z][A-Z]\\\\d\\\\d\\\\d\\\\d[EWI]):}{string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,http-error",
					"name": "Http error",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "[{date:Date,locale=en,EEE, dd MMM yyyy HH:mm:ss z}] [{priority:Severity,ftype=severity;,DEBUG;INFO;WARN;ERROR;CRITICAL}] [{geoip:Client IP,stopPattern=^[\\d+:\\.]+(:\\d+/);ftype=remoteip;type=country:region:city}:{text:Remote Port,ftype=remoteport;,}/{text:Server Host,stopPattern=^[\\d+:\\.]+(:\\d+\\]);ftype=localip;,}:{text:Server Port,ftype=localport;,}] {string:Message,ftype=message;,}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_http_error",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "[{date:Date,locale=en,EEE, dd MMM yyyy HH:mm:ss z}] [{priority:Severity,ftype=severity;,DEBUG;INFO;WARN;ERROR;CRITICAL}] [{geoip:Client IP,stopPattern=^[\\d+:\\.]+(:\\d+/);ftype=remoteip;type=country:region:city}:{text:Remote Port,ftype=remoteport;,}/{text:Server Host,stopPattern=^[\\d+:\\.]+(:\\d+\\]);ftype=localip;,}:{text:Server Port,ftype=localport;,}] {string:Message,ftype=message;,}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,access,w3c",
					"name": "Http access Basic",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{geoip:Client IP,ftype=remoteip;type=;,} {string:Remote Logical Username,ftype=remoteuser;,} {string:Remote User,ftype=remoteuser;,} [{date:Date,locale=en,dd/MMM/yyyy:HH:mm:ss z}] \\\"{choice:Method,ftype=reqmethod;,GET;POST} {string:URL,ftype=requrl;,}{block,start,emptiness=true}?{string:Query,ftype=querystring;,}{block,end,emptiness=true} {string:reqprotocol,ftype=reqprotocol;,}\\\" {number:Status,ftype=respstatus;,} {number:Bytes Sent,ftype=bytesent;,}{eoe}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_http_access_basic",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{geoip:Client IP,ftype=remoteip;type=;,} {string:Remote Logical Username,ftype=remoteuser;,} {string:Remote User,ftype=remoteuser;,} [{date:Date,locale=en,dd/MMM/yyyy:HH:mm:ss z}] \\\"{choice:Method,ftype=reqmethod;,GET;POST} {string:URL,ftype=requrl;,}{block,start,emptiness=true}?{string:Query,ftype=querystring;,}{block,end,emptiness=true} {string:reqprotocol,ftype=reqprotocol;,}\\\" {number:Status,ftype=respstatus;,} {number:Bytes Sent,ftype=bytesent;,}{eoe}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,access,w3c",
					"name": "Http access Combined",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{geoip:Client IP,ftype=remoteip;type=;,} {string:Remote Logical Username,ftype=remoteuser;,} {string:Remote User,ftype=remoteuser;,} [{date:Date,locale=en,dd/MMM/yyyy:HH:mm:ss z}] \\\"{choice:Method,ftype=reqmethod;,GET;POST} {string:URL,ftype=requrl;,}{block,start,emptiness=true}?{string:Query,ftype=querystring;,}{block,end,emptiness=true} {string:reqprotocol,ftype=reqprotocol;,}\\\" {number:Status,ftype=respstatus;,} {number:Bytes Sent,ftype=bytesent;,} \\\"{string:Referer,ftype=referer;,}\\\" \\\"{string:User Agent,ftype=useragent;,}\\\" \\\"{string:Cookie,ftype=cookie;,}\\\"{eoe}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_http_access_combined",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{geoip:Client IP,ftype=remoteip;type=;,} {string:Remote Logical Username,ftype=remoteuser;,} {string:Remote User,ftype=remoteuser;,} [{date:Date,locale=en,dd/MMM/yyyy:HH:mm:ss z}] \\\"{choice:Method,ftype=reqmethod;,GET;POST} {string:URL,ftype=requrl;,}{block,start,emptiness=true}?{string:Query,ftype=querystring;,}{block,end,emptiness=true} {string:reqprotocol,ftype=reqprotocol;,}\\\" {number:Status,ftype=respstatus;,} {number:Bytes Sent,ftype=bytesent;,} \\\"{string:Referer,ftype=referer;,}\\\" \\\"{string:User Agent,ftype=useragent;,}\\\" \\\"{string:Cookie,ftype=cookie;,}\\\"{eoe}",
						"externalJS": "link or code"
					}
				}
			}, {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Logs are usually located under \"WAS_ROOT_DIR/VERSION/AppServer/profiles/PROFILE_NAME/logs/\"",
					"typetag": "was,server,audit",
					"name": "Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "<date>{date:Date,yyyy-MM-dd'T'HH:mm:ss}</date>{regexp:Millis,refName=Record,<millis>([^<]*)}{regexp:Sequence,refName=Record,<sequence>([^<]\\d+)}{regexp:logger,refName=Record,<logger>([^<]*)}{regexp:level,ftype=status;refName=Record,<level>([^<]*)}{regexp:thread,refName=Record,<thread>([^<]*)}{regexp:Message,refName=Record,<message>([^<]*)}{regexp:key,refName=Record,<key>([^<]*)}{regexp:catalog,refName=Record,<catalog>([^<]*)}{regexp:Event_name,ftype=eventName;refName=Record,<message>([^(]*)}{regexp:Username,ftype=username;refName=Message,\\u0028([^\\u0029]*)}{regexp:UserID,ftype=object;refName=Record,UserID[s]?+=\"([^\"]*)}{regexp:RoleID,refName=Message,RoleID[s]?+=\"([^\"]*)}{regexp:Client,ftype=eventSource;refName=Record,Client=\"([^\"]*)}{regexp:Origin,ftype=host;refName=Record,Origin=\"([^\"]*)}{regexp:SessionID,ftype=sessionid;refName=Record,SessionID=\"([^\"]*)}{string:Record}\\n{date:Date,yyyy-MM-dd HH:mm:ss.SSS z} {priority:status,ftype=status}: {text:Event_name,ftype=eventName} ({text:Username,ftype=username}): {regexp:UserID,ftype=object;refName=Record,(UserID=\"|UserIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:LastName,refName=Record,LastName=\"([^\"]+)*}{regexp:FirstName,refName=Record,FirstName=\"([^\"]+)*}{regexp:GroupID,ftype=object;refName=Record,(GroupID=\"|GroupIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:RoleID,ftype=object;refName=Record,(RoleID=\"|RoleIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:Client,ftype=object;refName=Record,Client=\"([^\"]+)*}{regexp:Project,refName=Record,Project=\"([^\"]+)*}{regexp:Origin,refName=Record,Origin=\"([^\"]+)*}{regexp:SessionID,ftype=sessionid;refName=Record,SessionID=\"([^\"]+)*}{string:Record}",
					"parser_type": "default",
					"xwikilink": "https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=xplg_websphere",
					"type_uid": "was_audit",
					"parser_uid": "uid",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "<date>{date:Date,yyyy-MM-dd'T'HH:mm:ss}</date>{regexp:Millis,refName=Record,<millis>([^<]*)}{regexp:Sequence,refName=Record,<sequence>([^<]\\d+)}{regexp:logger,refName=Record,<logger>([^<]*)}{regexp:level,ftype=status;refName=Record,<level>([^<]*)}{regexp:thread,refName=Record,<thread>([^<]*)}{regexp:Message,refName=Record,<message>([^<]*)}{regexp:key,refName=Record,<key>([^<]*)}{regexp:catalog,refName=Record,<catalog>([^<]*)}{regexp:Event_name,ftype=eventName;refName=Record,<message>([^(]*)}{regexp:Username,ftype=username;refName=Message,\\u0028([^\\u0029]*)}{regexp:UserID,ftype=object;refName=Record,UserID[s]?+=\"([^\"]*)}{regexp:RoleID,refName=Message,RoleID[s]?+=\"([^\"]*)}{regexp:Client,ftype=eventSource;refName=Record,Client=\"([^\"]*)}{regexp:Origin,ftype=host;refName=Record,Origin=\"([^\"]*)}{regexp:SessionID,ftype=sessionid;refName=Record,SessionID=\"([^\"]*)}{string:Record}\\n{date:Date,yyyy-MM-dd HH:mm:ss.SSS z} {priority:status,ftype=status}: {text:Event_name,ftype=eventName} ({text:Username,ftype=username}): {regexp:UserID,ftype=object;refName=Record,(UserID=\"|UserIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:LastName,refName=Record,LastName=\"([^\"]+)*}{regexp:FirstName,refName=Record,FirstName=\"([^\"]+)*}{regexp:GroupID,ftype=object;refName=Record,(GroupID=\"|GroupIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:RoleID,ftype=object;refName=Record,(RoleID=\"|RoleIDs=\")[XPLG_PARAM([^\"]+)]*}{regexp:Client,ftype=object;refName=Record,Client=\"([^\"]+)*}{regexp:Project,refName=Record,Project=\"([^\"]+)*}{regexp:Origin,refName=Record,Origin=\"([^\"]+)*}{regexp:SessionID,ftype=sessionid;refName=Record,SessionID=\"([^\"]+)*}{string:Record}",
						"externalJS": "link or code"
					}
				}
			}
		]		
	}
});
