{
	"id": "ui-marker",
	"displayName": "UI Marker",
	"position": {
		"side": "top",
		"align": "start",
		"hideArrow": true
	},
	"buttons": [],
	"progress": {
		"enabled": false,
		"content": ""
	},
	"style": "theme-handler xplg-default-theme xplg-ui-marker",
	"description": "\n<div class=\"inner\">\n<div class=\"outer\"></div></div>",
	"onRenderEnd": "arg => {\n    const popoverElement = arg.elem;\n    const targetElem = arg.targetElem;\n    if (!targetElem || !popoverElement) return;\n\n    const descriptionElem = popoverElement.querySelector('#driver-popover-description');\n    if (!descriptionElem) return;\n\n    const {\n      top: targetTop,\n      left: targetLeft,\n      height: targetHeight,\n    } = targetElem.getBoundingClientRect();\n\n    const top = targetTop + targetHeight / 2 - 32 / 2 - 3;\n\n    descriptionElem.style.position = 'fixed';\n    descriptionElem.style.top = top + 'px';\n    descriptionElem.style.left = targetLeft + 2 + 'px';\n  }",
	"onHighlightEnd": "(element, step, opts) => {\n  const targetEl = element;\n  const wrapperEl = opts?.state?.popover?.wrapper;\n  const stepIndex = opts?.state?.activeIndex;\n  let wrapperElCopy;\n  if (targetEl && wrapperEl && stepIndex === 0) {\n    wrapperElCopy = wrapperEl.cloneNode(true);\n    const wrapperElCopyDescription = wrapperElCopy.querySelector('#driver-popover-description');\n    if (wrapperElCopyDescription) {\n      document.body.classList.add('driver-active__ui-marker');\n      targetEl.appendChild(wrapperElCopy);\n      const wrapperElListener = () => {\n        if (step?.popover?.onNextClick) {\n          wrapperElCopy.remove();\n          document.body.classList.remove('driver-active__ui-marker');\n          step.popover.onNextClick(element, step, opts);\n        }\n      };\n      wrapperElCopy.addEventListener('mouseover', wrapperElListener, { once: true });\n    }\n  }\n}",
	"onDestroyEnd": "(element, step, opts) => {\n  document.body.classList.remove('driver-active__ui-marker');\n  document.querySelector('.driver-popover.xplg-ui-marker')?.remove();\n}"
}
