import {IEmbeddedConf} from './models/embedded-conf';
import {SafeResourceUrl} from '@angular/platform-browser';

export abstract class XplgContainerAbstract {

    private _embeddedConf: IEmbeddedConf = {src: ('' as SafeResourceUrl)};

    set embeddedConf(conf: IEmbeddedConf) {
        this._embeddedConf = conf;
    }

    get embeddedConf(): IEmbeddedConf {
        return this._embeddedConf;
    }

    protected abstract initEmbeddedInstance(): void;
    protected abstract refreshEmbeddedInstance(): void;
    protected abstract destroyEmbeddedInstance(): void;
    protected abstract listenEmbeddedInstance(): void;
    protected abstract getData(): void;
}
