import {Injectable} from '@angular/core';
import {environment} from '../../environments/environment';

@Injectable()
export class MockDataProviderService {

    fetchDiagramData() {
        let diagramData;
        if (!environment.production) {
            try {
                diagramData = this.fetchSyncDiagramData() || this.fetchAsyncDiagramData();
            } catch(error) {
            }
        }
        return diagramData;
    }

    private fetchSyncDiagramData() {
        return require('../../assets/mockData/sync-diagram.json');
    }

    private fetchAsyncDiagramData() {
        return require('../../assets/mockData/async-diagram.json');
    }
}
