export class NodeHelper {

    static addHiddenNodes(diagram: any): any {
        if (diagram?.data?.length) {
            const nodePorts = [{
                id: 'asyncSourcePort',
                offset: {
                    x: 0.5,
                    y: 1
                }
            }];
            const hiddenNode = {
                value: '',
                uiPrefs: {hidden: true},
                ports: [
                    {
                        id: 'asyncTargetPortLeft',
                        offset: {
                            x: 0,
                            y: 0.98
                        }
                    },
                    {
                        id: 'asyncTargetPortRight',
                        offset: {
                            x: 1,
                            y: 0.98
                        }
                    }
                ]
            };
            const asyncDiagramData: any = [];
            for (let i = 0; i <= diagram.data.length - 1; i++) {
                if (i) {
                    asyncDiagramData.push({
                        ...diagram.data[i],
                        ports: nodePorts,
                        parent: asyncDiagramData[asyncDiagramData.length - 1].id
                    });
                } else {
                    asyncDiagramData.push({...diagram.data[i], ports: nodePorts});
                }
                if (diagram.data.length - 1 !== i) {
                    asyncDiagramData.push({
                        ...hiddenNode,
                        id: `${diagram.data[i].id}-hidden`,
                        parent: asyncDiagramData[asyncDiagramData.length - 1].id
                    });
                }
            }
            return {...diagram, data: asyncDiagramData};
        }
        return diagram;
    }
}
