<%@ page language="java"%>

<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.HashSet"%>
<%@ page import="java.util.Iterator"%>
<%@ page import="java.util.Map"%>
<%@ page import="java.util.Map.Entry"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.LogInfo"%>
<%@ page import="xpolog.eye.LogsManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@ page import="xpolog.eye.search.SearchUtil"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>
<%@ page import="xpolog.eye.SiteAdministrator"%>
<%@ page import="xpolog.eye.util.ModuleMembersUtil"%>

<%!
  static final String BASE_DIRECTORY = "../../";
%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION,true)){
	   return;
	}

	UserContext userContext = UserEnvironment.getUserContext(request);

	boolean allowApplyNamePattern = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("allowApplyNamePattern", false);
	
	String message = "";
	ErrorModel errmod = null;
	if(allowApplyNamePattern) {
		HashSet<String> logsIds = new HashSet<String>();
 		String query = request.getParameter("query");
 		String namePattern = request.getParameter("namePattern");
 		String actionType = request.getParameter("actionType");
		if(query == null || query.length() == 0) {
			if(errmod == null) {
				errmod = new ErrorModel();
			}
			errmod.addError("Logs to change were not specified");
		}else {
			SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(userContext, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
			if(parseResponse == null) {
				if(errmod == null) {
					errmod = new ErrorModel();
				}
				errmod.addError("Failed to apply name pattern to logs");
			}else {
				if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
					if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError("The specified logs to change don't exist");
				}else {
					HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
					if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
						if(errmod == null) {
							errmod = new ErrorModel();
						}
						errmod.addError("Failed to apply name pattern to logs");
					}else {
						logsIds.addAll(sourcesToQueries.keySet());
					}
				}
			}
		}
		/*if(namePattern == null || namePattern.length() == 0) {
			if(errmod == null) {
				errmod = new ErrorModel();
			}
			errmod.addError("Name pattern to use was not specified");
		}*/
		if(actionType == null || actionType.length() == 0) {
			if(errmod == null) {
				errmod = new ErrorModel();
			}
			errmod.addError("Action type was not specified");
		}
		
  	if(errmod == null || errmod.getErrorCount() == 0) {
  		if(actionType.equals("preview")) {
  			try {
  				Map<String, String> result = SiteManagment.getAdminInstance().replaceNames(namePattern, logsIds, userContext);
  				int numberOfLogsChanged = result.size();
      		if(numberOfLogsChanged <= 0) {
    	  		if(errmod == null) {
    					errmod = new ErrorModel();
    				}
    	  		errmod.addError("No changes will be made based on the given parameters");
    	  	}else {
    	  		Iterator<Entry<String, String>> it = result.entrySet().iterator();
    	  		String previousNewLogName = null;
    	  		int numberOFExampleLogs = 0;
    	  		Entry<String, String> entry = null;
    	  		LogsManager logsManager = LogsManager.getInstance();
    	  		while(it.hasNext() && numberOFExampleLogs < 3) {
    	  			entry = it.next();
    	  			String logId = entry.getKey();
    	  			String newLogName = entry.getValue();
    	  			if(previousNewLogName == null || !previousNewLogName.equals(newLogName)) {
    	  				LogInfo logInfo = logsManager.getLogInfo(logId);
    	  				if(logInfo != null) {
    	  					previousNewLogName = newLogName;
  	  	  				message += ("*;*" + ModuleMembersUtil.getPathToRoot(logId) + " will be renamed to " + newLogName);
  	  	  				numberOFExampleLogs++;
    	  				}
    	  			}
    	  		}
    	  		message = "Please review the following example changes before continuing (displaying " + numberOFExampleLogs + " out of " + result.size() + "):" + message;
    	  	}
  			}catch(Exception e) {
  				if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError(e.getMessage());
  			}
  		}else {
  			int numberOfLogsChanged = SiteManagment.getAdminInstance().renameLogsNames(namePattern, logsIds, userContext);
  			if(numberOfLogsChanged <= 0) {
  	  		if(errmod == null) {
  					errmod = new ErrorModel();
  				}
  				errmod.addError("Failed to apply name pattern to selected logs");
  	  	}else {
  	  		String logString = "logs";
  	  		if(numberOfLogsChanged == 1) {
  	  			logString = "log";
  	  		}
  	  		String selectedLogString = "logs";
  	  		if(logsIds.size() == 1) {
  	  			selectedLogString = "log";
  	  		}
  	  		message = "Name pattern applied successfully on " + numberOfLogsChanged + " " + logString + " out of " + logsIds.size() + " selected " + selectedLogString;
  	  	}
  		}
  	}
	}else {
		errmod = new ErrorModel();
		errmod.addError("Operation is not allowed");
	}
	
	String xml = "";
	if (errmod != null && errmod.getErrorCount() > 0){
		//errors
		String[] errors = errmod.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		message = sb.toString();
		//params
		String[] params = errmod.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
	}else{
		xml = GridModelActionsHelper.getResultXML(true, message);
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>