<%@ page language="java"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.site.main.*" %>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.Module"%>
<%@ page import="java.util.*"%>

<%
 
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.EDIT_MODULE_PERMISSION,true)){
	  return;
	}
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();
  UserContext userContext = UserEnvironment.getUserContext(request);
  
  String sourceId = request.getParameter("sourceId");
  String targetId = request.getParameter("targetId");
  String childStr = request.getParameter("isChild");
  boolean isChild = childStr != null && childStr.equals("true");
  
  String openStr = request.getParameter("isOpen");
  boolean isOpen = openStr != null && openStr.equals("true");

  Module rootMod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
  Module storageMod = mgmt.getModuleFromId(Module.ROOT_STORAGE_MODULE_ID);
  
  String message = "";
  boolean success = false;  
  if (sourceId != null && sourceId.length() > 0 && targetId != null && targetId.length() > 0){  	  
	  boolean isTargetStorage = (storageMod != null && storageMod.isDescendant(targetId)) || targetId.equals(Module.ROOT_STORAGE_MODULE_ID);
    
	  try {
	    ModuleMember targetMember = mgmt.getModuleMember(targetId);
	    ArrayList sources = new ArrayList();
	    String [] sourceIds = sourceId.split(",");
		  boolean isSourceStorage = isTargetStorage;
		  boolean isTopFolder = false;
	    for(int i = 0 ; i < sourceIds.length;i++){
        if (sourceIds[i].equalsIgnoreCase(Module.ROOT_MODULE_ID) || sourceIds[i].equalsIgnoreCase(Module.ROOT_STORAGE_MODULE_ID)){
        	isTopFolder = true;
          break;
        }
	    	isSourceStorage = storageMod != null && storageMod.isDescendant(sourceIds[i]);
	    	if (isSourceStorage != isTargetStorage){
          break; 
	    	}
	    	ModuleMember source = mgmt.getModuleMember(sourceIds[i]);
	    	if (source != null){
	    		sources.add(source);
	    	}
	    }
      if (isTopFolder){
    	  message = "It is not allowed to move a top folder"; 
      }else if (isSourceStorage != isTargetStorage){
	    	message = "It is not allowed to move a folder member from " + (isSourceStorage ? "Storage" : "Folders and Logs") + " to " + (isTargetStorage ? "Storage" : "Folders and Logs");   
	    }else if (targetMember != null && sources.size() > 0){	    
	    	 Module parent = isChild || isOpen? mgmt.getModuleFromId(targetId) : mgmt.getParentModule(targetId);         
	   		 if (parent != null){
	   			int index = isChild ? parent.getModuleMembers().size() : isOpen ? 0 : parent.indexOf(targetMember) + 1;
	   		//audit
	   		  for (Iterator iterator = sources.iterator(); iterator.hasNext();) {
			      ModuleMember sourceMember = (ModuleMember) iterator.next();
	   		    AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
	   		  			userContext, AuditConstants.CHANGE, "move folder/log", AuditConstants.MODULES, "move the folder/log  " + sourceMember.getId() + " to parent " + parent.getId() + " in position " + index);
	   		  }
	   		 success = admin.updateMemberLocation(sources,parent,index,userContext);	   			
	   		 }	      
	     }
	   } catch (Exception e) {
				ErrorModel.log.error("Failed to move folder/log " + sourceId
						+ " to " + targetId + " , is child = " + isChild + " , is open = " + isOpen, e);
				success = false;
				message = e.getMessage();
		 }   
	  
  }else {
		message = "No source or taget were given, please refresh and try again";
	}
  
  String xml = GridModelActionsHelper.getResultXML(success, message);

	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	
	
	out.write(xml);
	out.flush();
 
%>
