<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.managment.*"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.site.portal.PortalItem"%>
<%@ page import="xpolog.eye.util.Constants"%>
<%@ page import="xpolog.logic.security.LogicPermissionConstants"%>

<%@ page import="java.util.*"%>

<%!
	static final String BASE_DIRECTORY = "";
%>
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request,response,null,true)){
	  return;
	}

	UserSecurity user = securityManager.getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	if (userContext == null){
		userContext = new UserContext();
	}
	
	boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);
	
	long keepAliveInterval = Configuration.getInstance().getKeepAliveInterval();
	
	userContext.setUser(user);
	String applicationId = request.getParameter("applicationId");
	if (applicationId != null){
		if (applicationId.length() > 0){
			HashSet set = new HashSet();
			if (applicationId.indexOf(",") == -1){
				set.add(applicationId);
			}else{
				String[] apps = applicationId.split(",");
				for (int i=0; i<apps.length; i++){
					set.add(apps[i]);
				}
			}
			userContext.setIncludeSet(set);
		}else{
			HashSet set = new HashSet();
			userContext.setIncludeSet(set);
		}
	}
	UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	env.setUserContext(userContext);	
	boolean isDemo = XpologLicenseManager.getInstance().isDemo();
	
	String userMessage = "";
	if (user != null) {		
		userMessage = "User: " + user.getUser().getDisplayName();		
	}
	
	List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
	boolean showComps = comps.size() > 1;
	
	boolean xpologEnabled = false;
	boolean searchEnabled = false;
	boolean dashboardEnabled = false;
	boolean txexpoEnabled = false;
	String xpologLink = "";
	String xpologSearchLink = "";
	String dashboardLink = "";
	String txexpoLink = "";
	for(int i=0;i<comps.size();i++) {
		ApplicationComponent comp = (ApplicationComponent)comps.get(i);		
		if(comp != null && comp.getId().equals(XpologManagment.XPOLOG_COMPONENT) && comp.isVisible()) {
			xpologEnabled = true;
			xpologLink = "componentAction.jsp?selectedCompId=" + comp.getId();
		}
		if(comp != null && comp.getId().equals(XpologManagment.SEARCH_ENGINE_COMPONENT) && comp.isVisible()) {
			searchEnabled = true;
			xpologSearchLink = "componentAction.jsp?selectedCompId=" + comp.getId();
		}
		if(comp != null && comp.getId().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
			dashboardEnabled = true;
			dashboardLink = "componentAction.jsp?selectedCompId=" + comp.getId();
		}
		if(comp != null && comp.getId().equals(XpologManagment.TX_EXPO_COMPONENT) && comp.isVisible()) {
			txexpoEnabled = true;
			txexpoLink = "componentAction.jsp?selectedCompId=" + comp.getId();
		}
		
		
	}
	
	boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
  boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
  boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
  boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;
  
  boolean isPermittedAddVerify = searchEnabled && securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
  boolean isPermittedEditVerify = searchEnabled && securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);
  boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;
  
	boolean isPermittedAddReport = searchEnabled && securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.EDIT_REPORTS_PERMISSION) && ReportsManager.IS_ACTIVE;
  boolean isPermittedViewReport = searchEnabled && securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION) && ReportsManager.IS_ACTIVE;
  boolean isPermittedReports = isPermittedViewReport || isPermittedAddReport;
  boolean isPermittedAddTransaction = securityManager.isHavePermission(userContext,LogicPermissionConstants.AdministrationPermissions.TRANSACTIONS_PERMISSION);
  
	boolean isPermittedViewDashboard = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_VIEW_PERMISSION);

  boolean isPermittedEnvironmentAnalysis = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
  isPermittedEnvironmentAnalysis = false;
  
	boolean presentQuickStart = isPermittedAddLog || isPermittedAddReport || isPermittedAddVerify|| isPermittedAddTransaction;
	boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();
	
	boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();
	boolean isPermittedIssueTrackingSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.IssueTraqckingPermissions.ISSUE_TRACKING_SETTINGS_PERMISSION);
  
	boolean isRegistered = XpologLicenseManager.getInstance().isRegistered();
	
	String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);
	
  ArrayList list = new ArrayList();
  if(valid) {
  	if(isTestingBuid && false) {
	  	list.add(new PortalItem("Testing<br>Environments",xpologLink + "&forward=root.jsp?mainPage=testingPortal.jsp","Testing<br>Environments","images/portal/btns/diagnostics.gif","images/portal/btns/diagnostics-on.gif"));
	  	list.add(PortalItem.SEP_ITEM);
	  }
	  if(isSiteDemo) {
		  list.add(new PortalItem("Log <br>Viewer",xpologLink + "&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=Log4J_Log_1227520538204%2526gotoMain=true%2526timetamp=" + System.currentTimeMillis(),"Log Viewer","images/portal/btns/log-viewer.gif","images/portal/btns/log-viewer-on.gif"));
	  }else {
		  list.add(new PortalItem("Log <br>Viewer",xpologLink + "&forward=root.jsp?mainPage=view/mainView.jsp","Log Viewer","images/portal/btns/log-viewer.gif","images/portal/btns/log-viewer-on.gif"));  
	  }
	  list.add(PortalItem.SEP_ITEM);
	  list.add(new PortalItem("Log <br>Monitor",xpologLink + "&forward=root.jsp?mainPage=monitor/monitorsView.jsp","Log Monitor","images/portal/btns/log-monitor.gif","images/portal/btns/log-monitor-on.gif"));
	  if (isPermittedViewReport){
	    list.add(PortalItem.SEP_ITEM);
	    list.add(new PortalItem("Reports",xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp","Reports","images/portal/btns/reports.gif","images/portal/btns/reports-on.gif"));
	  }
	 	
	  if (dashboardEnabled && isPermittedViewDashboard){
	    list.add(PortalItem.SEP_ITEM);
	    list.add(new PortalItem(analyticsH,dashboardLink,analyticsH,"images/portal/btns/dashboard.gif","images/portal/btns/dashboard-on.gif"));
	  }
	  
	  if (searchEnabled){
	    list.add(PortalItem.SEP_ITEM);
	    list.add(new PortalItem("Search<br>Engine",xpologSearchLink,"Search Engine","images/portal/btns/search-engine.gif","images/portal/btns/search-engine-on.gif"));
	  }
	  if(!isTestingBuid && isPermittedEnvironmentAnalysis) {
	  	list.add(PortalItem.SEP_ITEM);
	  	list.add(new PortalItem("Environment<br>Analysis",xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true","Environment Analysis","images/portal/btns/diagnostics.gif","images/portal/btns/diagnostics-on.gif"));
	  }
	  if (txexpoEnabled){
	    list.add(PortalItem.SEP_ITEM);
	    list.add(new PortalItem("Transactions <br>Analysis",txexpoLink,"Transactions Analysis","images/portal/btns/transactions.gif","images/portal/btns/transactions-on.gif"));
	  }
	  
  }else {
	  list.add(new PortalItem("Save <br>License","settings/settings.jsp","License","images/portal/btns/collection.gif","images/portal/btns/collection-on.gif"));
  }
  request.setAttribute("mainItems",list);
  
  list = new ArrayList();
  if (valid){
  	if(isTestingBuid && false) {
  		list.add(new PortalItem("Add Testing Environment Analysis",xpologLink + "&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Testing","Add Testing Environment Analysis"));
  		if(isPermittedIssueTrackingSettings) {
    		list.add(new PortalItem("Add Bug Tracking System",xpologLink + "&forward=root.jsp?mainPage=tools/issuetracking/issueTrackingView.jsp?openIssueTrackerType=true","Add Bug Tracking System"));
    	}
    }
  	if (isPermittedAddLog){
      list.add(new PortalItem("Add Log Data",xpologLink + "&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp","Add Log Data"));
      if (isPermittedAddModule){
        list.add(new PortalItem("Add Log Data Directory",xpologLink + "&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner","Add Log Data Directory"));
      }
    }
    if (isPermittedAddVerify){
      list.add(new PortalItem("Create Monitor",xpologLink + "&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp","Create Monitor"));
    }
    if (isPermittedAddReport){
      list.add(new PortalItem("Generate Report",xpologLink + "&forward=root.jsp?mainPage=reports/agg/aggReportDefinition.jsp?reportTemplateId=Aggregation","Generate Report"));
    }
    if (searchEnabled){
      list.add(new PortalItem("Search Log Data",xpologSearchLink,"Search Log Data"));
    }
    if (presentQuickStart){
      list.add(new PortalItem("Open Quick Start Wizard","javascript:showStartWizard()","Open Quick Start Wizard"));
    }
    request.setAttribute("linksItems",list);
  } else {
	  list.add(new PortalItem("Save license","settings/settings.jsp","License"));
  }
  request.setAttribute("linksItems",list);
  String openQuickWizard = (String)request.getSession().getAttribute("openQuickWizard");
  
  //license manager parameters
  //check if the param on session - already presented, if there are 30 or less days.
  // set showLicenseDivProperty to false because the license notifications have been moved to the topMenu.jsp
  boolean showLicenseDivProperty = false;//Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("showLicenseDiv",true);
  boolean isLicnesePermanent = XpologLicenseManager.getInstance().isPermanentLicense();
  int daysLeft = XpologLicenseManager.getInstance().getDaysLeft();
  String licenseDivPresnetedString = (String)request.getSession().getAttribute("licenseDivPresneted");
  boolean licenseDivPresneted = false;
  if(licenseDivPresnetedString != null && licenseDivPresnetedString.equalsIgnoreCase("true")) {
	  licenseDivPresneted = true;
  }
  boolean showLicenseDiv = valid && ((showLicenseDivProperty && daysLeft <= 30 && !licenseDivPresneted && !isLicnesePermanent) || (showLicenseDivProperty && daysLeft < 0 && !isLicnesePermanent));
  
%>

<HTML>
<HEAD>
<title>XpoLog Center</title>
<meta http-equiv="Content-Language" content="en-us">
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/portal.css?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>" />
<link rel="stylesheet" type="text/css" href="<%=BASE_DIRECTORY%>css/mainproduct.css?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>" />

<script src="<%=BASE_DIRECTORY%>scripts/UIUtil.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>" type="text/javascript"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/help/help.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>
<script LANGUAGE="JavaScript1.2" src="<%=BASE_DIRECTORY%>scripts/portal.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>
<script type="text/javascript" src="scripts/jquery/jquery.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>

<script>
function init(){
  
  
  <%if(showLicenseDiv){
	  request.getSession().setAttribute("licenseDivPresneted","true");
  %>
  	showLicenseDiv();	
  <%}else {%>
  	firstInitStartWizard();
  <%}%>
}

function firstInitStartWizard(){
  <% if (valid && presentQuickStart && (openQuickWizard == null || !openQuickWizard.equals("false"))){%>
  	initStartWizard();
  <%}%>
}

function showSimpleMessage(title,msg,width,height){
    var msgWriter = new messageWriter("simpleMessage",title,"<%=BASE_DIRECTORY%>");
    msgWriter.setYParent(document.getElementById("mygrid"),50);
    msgWriter.width = width;
    msgWriter.height = height;
    msgWriter.showMessage(msg);
  }

function hideSimpleMessage(){
  hideLayer('simpleMessage');
}

<%
if(keepAliveInterval > 0) {
%>
	setInterval("doKeepAliveBack(<%=isDemo %>, true)",<%=keepAliveInterval%>);
<%
}
%>
</script>

</HEAD>
<BODY style="margin: 0; padding: 0; border-width: 0;overflow:auto" onload="init()">
<jsp:include page="portal/quickStartWizard.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">	
	<tr height="10px">
		<td valign="top" style="padding-top:5">
		<jsp:include page="topMenu.jsp" flush="true">
			<jsp:param name="homePage" value="homePage"/>
			<jsp:param name="showHome" value="false"/>
			<jsp:param name="showHelp" value="false"/>
		</jsp:include>
	</tr>
	<tr>
	<td colspan="3">
	<%
	String licenseMessage = "XpoLog Center Suite";
	if(isTestingBuid) {
		licenseMessage += " for Testing Environments";
	}
	if(!valid) {
		String invalidServerKeyMessage = SiteManagment.getInstance().getXpologManagment().getInvalidServerKeyMessage();
		if(invalidServerKeyMessage != null && invalidServerKeyMessage.length() > 0) {
			licenseMessage += (" - " + invalidServerKeyMessage);
		}else {
			licenseMessage += " - your license has expired";
		}
	}
	if(isSiteDemo) {
		licenseMessage = "Welcome to XpoLog Live Demo &nbsp;&nbsp;<a href=\"https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=download\" class=\"HELP_HEADER_LINK\" target=\"_target\">Download free trial from www.xpolog.com</a>";
	}
	%>
<jsp:include page="portal/portal.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
<jsp:param name="title" value="<%=licenseMessage%>"  />
</jsp:include>

<%if(showLicenseDiv) { %>
<jsp:include page="portal/licenseDiv.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>

<%if(showLicenseDiv && isDemo && !isRegistered) { %>
<jsp:include page="portal/registerDiv.jsp" flush="true">
	<jsp:param name="baseDirectory" value="<%=BASE_DIRECTORY%>" />
</jsp:include>
<%} %>

</td></tr>
</table>
</BODY>
</HTML>
