<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.admin.patterns.PatternAdminHelper"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.AddressBook"%>
<%@ page import="xpolog.eye.media.auth.AuthenticationAccount"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.Module"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request,response,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION,true,true)){
	  return;
	}
  
  String ERROR_OBJ = "ERROR_OBJ";
  String MODULE_ID = "MODULE_ID";
  String LOG_ID = "LOG_ID";
  String BUILDER = "CURRENT_LOG_BUILDER";
  String CURRENT_LOG = "CURRENT_LOG"; 
  String DATA_FILTER_QUERY = "dataFilterQuery";
  String ALLOW_DUPLICATED_RECORDS = "allowDuplicatedRecords";

  UserEnvironment env = UserEnvironment.getUserEnvironment(request);
  UserContext userContext = UserEnvironment.getUserContext(request);
  SiteManagment mgmt = SiteManagment.getInstance();
  SiteAdministrator admin = SiteManagment.getAdminInstance();


  String modid      = request.getParameter("ParentModule");
  String parentApps = request.getParameter("parentApplication");
	HashSet applicationsIds = new HashSet();
  String[] appArr = null;
	if(parentApps != null && parentApps.length() >0){
		appArr = parentApps.split("#");
		for(int i = 0 ;	appArr != null &&  i < appArr.length ; i++){
			applicationsIds.add(appArr[i]);
		}		
	}  
  String logname    = request.getParameter("LogName");
  String logdesc    = request.getParameter("LogDescription");
  String machine    = request.getParameter("machineName");  
  String timeZoneId = request.getParameter("TimeZone");
  String charset    = request.getParameter("charset");
  String sourceGroup = request.getParameter("sourceGroup");
  String sourceTypes = request.getParameter("CustomTypeName");
  
  String eventType = request.getParameter("eventType");
  if (charset != null && charset.equals("default")){
    charset = null;
  }
  if (sourceTypes != null && sourceTypes.trim().length() == 0){
	  sourceTypes = null;
  }
  String authAccId = request.getParameter("accountId");
  String logCollectionPolicyId = request.getParameter("logCollectionPolicyId");
  String dataFilterQuery = request.getParameter(DATA_FILTER_QUERY);
  String allowDuplicatedRecordsStr = request.getParameter(ALLOW_DUPLICATED_RECORDS);
  int allowDuplicatedRecords = LinearBrowsingManager.DUPLICATED_RECORDS_USE_SYSTEM_DEFAULT;
  if (allowDuplicatedRecordsStr != null && allowDuplicatedRecordsStr.length() > 0){
  	allowDuplicatedRecords = Integer.parseInt(allowDuplicatedRecordsStr);
  }
  
  String doSaveStr = request.getParameter("doSave");
  boolean doSave = doSaveStr != null && doSaveStr.length() > 0;

  
  //verify data
  ErrorModel errmodel = new ErrorModel();

  if(logname == null || logname.trim().equals("")){
    errmodel.addError("No name was supplied.");
  }
  if(WebUtil.isContainSpecialCharecter(logname)){
     errmodel.addError("The following characters are prohibited in the name field: "+WebUtil.getSpecialCharectersList());
  }
  String fileType = null;
  String eventLogName = null;
  if(eventType == null || eventType.equals("")){
    errmodel.addError("No event log name supplied.");
  }else {
    int type = Integer.parseInt(eventType);
    switch (type){
      case WinEventAdminHelper.APPLICATION_TYPE:
        eventLogName = "Application";
        break;
      case WinEventAdminHelper.SYSTEM_TYPE:
        eventLogName = "System";
        break;
      case WinEventAdminHelper.SECURITY_TYPE:
        eventLogName = "Security";
        break;
      case WinEventAdminHelper.FILE_TYPE:
        eventLogName    = request.getParameter("fullPath_0WinEvent");
        if(eventLogName == null || eventLogName.equals("")){
    	  	errmodel.addError("No event log name supplied.");
  			}
  		
  			fileType = request.getParameter("fileType");
  			if(fileType == null || fileType.equals("")){
    	  	errmodel.addError("No file type supplied.");
	  		}
        break;
      default :
        eventLogName = "Application";
        break; 
        
    }
  }
  
  
  if(modid == null || modid.trim().equals("")){
    errmodel.addError("No parent folder was selected. If no folder is available please check your permissions");
  }
  
  if (authAccId != null && authAccId.length() > 0 && (machine == null || machine.length() == 0 || machine.equalsIgnoreCase("localhost"))){
  	authAccId = null;
  }
  
  if (logCollectionPolicyId == null || logCollectionPolicyId.length() == 0){
  	errmodel.addError("No collection policy was selected");
  }

  if(errmodel.getErrorCount() != 0){
    request.getSession().setAttribute(ERROR_OBJ,errmodel);
    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
    return;

  }
  
	String op = request.getParameter("OP");
	if(op == null || op.length()==0){
		op = "ADD";
	}
	
	String logAdminScreenWidth = request.getParameter("LogAdminScreenWidth");
	if(logAdminScreenWidth == null || logAdminScreenWidth.length()==0){
		logAdminScreenWidth = "600px";
	}

  LogBrowsingManager lbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
  if(lbm != null && !lbm.getType().equals(WinEventLogBuilder.EVENT_VIEWER_TYPE)){
  	lbm = null;
  	request.getSession().removeAttribute(CURRENT_LOG);
  }

  WinEventLogBuilder builder = (WinEventLogBuilder)LogBrowserBuilderFactory.getLogBroserBuilderByType(LogBrowserBuilderFactory.WIN_EVENT_TYPE);
  builder.setLogName(eventLogName);
  String dataPat = WinEventLogBuilder.createDefaultPatternByLogName(eventLogName);
  String logTypes = WinEventAdminHelper.getLogTypes(eventLogName);
  if(sourceTypes == null && sourceGroup != null && sourceGroup.equals("system")){
	  sourceTypes = request.getParameter("SystemTypePattern");   
	  if (sourceTypes== null){
		  sourceTypes = "windows#" + logTypes;
    }
  }
  
  if (sourceGroup != null && sourceGroup.equals("system")){
     int index = sourceTypes.indexOf("#");
     if (index  >  0){
    	  sourceTypes = sourceTypes.substring(index + 1);
        sourceGroup += "#" + sourceTypes.substring(0,index);
     }
     if (lbm == null){
    	  sourceTypes = logTypes;
    	  sourceGroup = "system#windows";
     }
  }else if (sourceGroup == null || sourceGroup.length() == 0){
	  if (lbm == null){
    	  sourceTypes = logTypes;
    	  sourceGroup = "system#windows";
     }
  }
  
  boolean shouldRemoveIndex = false;
  if(lbm != null){
    builder.setID(lbm.getId());
    String orgDataPat = LogAdminHelper.getXpologPattern(lbm);
    if (orgDataPat != null && orgDataPat.length() > 0){
    	dataPat = orgDataPat;
    }
    String machineName = WinEventAdminHelper.getMachineName(lbm);
    String logName = WinEventAdminHelper.getLogName(lbm);
    if (lbm.isUseIndexing() && ((machineName != null && !machineName.equalsIgnoreCase(machine)) || (logName != null && !logName.equalsIgnoreCase(logname)))){
    	shouldRemoveIndex = true;
    }
    builder.setUseIndexing(lbm.isUseIndexing());
    builder.setUseIndexingForDateSearch(lbm.isUseIndexingForDateSearch());
    builder.setIndexNullValues(lbm.isIndexNullValues());
    builder.setUseWholeWords(lbm.isUseWholeWords());
    builder.setUseProxy(lbm.isUsingProxy());
    builder.setImported(lbm.isImported());
    builder.setComputeStatistics(lbm.isComputeStatistics());
    builder.setUseInDashboard(lbm.isUseInDashboard());
    builder.setUseInDashboardTask(lbm.isUseInDashboardTask());
    builder.setHost(lbm.getHost());
    builder.setScannerRoot(lbm.getScannerRoot());
    builder.setScannerName(lbm.getScannerName());
    builder.setDataVersion(lbm.getDataVersion());
  }

  builder.setName(logname);
  builder.setApplicationsIds(applicationsIds);
  builder.setRecordPattern(dataPat);
  builder.setLogDescription(logdesc);
  builder.setTimeZoneId(timeZoneId);
  builder.setCharset(charset);
  builder.setSourceTypes(sourceTypes);
  builder.setSourceTypesGroup(sourceGroup);
  builder.setMachineName(machine);
  builder.setLogType(fileType);
  if(lbm != null){
	  builder.setIgnoreUnparsedRecords(LogAdminHelper.isIgnoreUnparsedRecords(lbm));
  }
  if (authAccId != null){
  	AuthenticationAccount acc = (AuthenticationAccount)AddressBook.getInstance().getAccountById(authAccId);
  	builder.setAuthenticationAccount(acc);
  }else{
  	builder.setAuthenticationAccount(null);
  }
  builder.setLogCollectionPolicyId(logCollectionPolicyId);
  builder.setDataFilterQuery(dataFilterQuery);
  builder.setAllowDuplicatedRecords(allowDuplicatedRecords);

  boolean isNew = lbm == null || lbm.getId() == null;
  if(isNew) {
  	builder.setUseIndexing(true);
  }
  
  try{
    //for configuration reasons
    builder.updateBuilder();
  }catch(Exception e){
  	if (doSave || !(e instanceof XpologBuilderException) || !((XpologBuilderException)e).isFilterQueryError()){
	    errmodel.addError("Building log problem,please check patterns and path again.");
	    errmodel.addError(e.getMessage());
	    request.getSession().setAttribute(ERROR_OBJ,errmodel);
	    response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
	    return;
  	}
  }
  
  //audit
  AuditManager auditMgr = AuditManager.getInstance();

  if (doSave){
		builder.updateBuilder();
		lbm = builder.getLogBrowserManager();

		LogBrowsingManager oldlbm = (LogBrowsingManager)request.getSession().getAttribute(CURRENT_LOG);
		if(oldlbm != null){ //Not new log
			lbm.setFilterManager(oldlbm.getFilterManager());
			lbm.setRecordMask(oldlbm.getRecordMask());
			LogAdminHelper.getLogRecordBuilder(lbm).setMergeColumns(LogAdminHelper.getMergeIndexing(oldlbm));      
			lbm.setCustomizationManager(oldlbm.getCustomizationManager());
			lbm.setSearchAndFilterDef(oldlbm.getSearchAndFilterDef());
			lbm.setConsolidation(oldlbm.isConsolidation());
  	}
		Module parentmod = mgmt.getModuleFromId(modid);
		if(parentmod == null){
			modid = "rootModule";
			parentmod = mgmt.getModuleFromId(modid);
		}
	  
		String newId = admin.addLogBrowser(lbm,parentmod,userContext);
		if (!isNew || (applicationsIds != null && applicationsIds.size() > 0)){
			LogAdminHelper.updateLogApplicationsMetas(lbm.getId(),applicationsIds);
		}
		 
		request.getSession().setAttribute(CURRENT_LOG,lbm);
		 
		auditMgr.write(AuditConstants.BASIC_AUDIT_LEVEL,
		userContext, AuditConstants.CHANGE, "save/edit log", AuditConstants.LOGS, "change the log " + lbm.getName()); 
		env.setTempAttribute(SiteConstants.FORWARD_URL_ATTRIBUTE,"loggers/admin/logaddopok.jsp?removeLog=" + !builder.isLogCanBeUsed() + "&lbmId=" + lbm.getId());
		response.sendRedirect(BASE_DIRECTORY + "common/actions/nextAction.jsp");
		return;
  }
	request.getSession().setAttribute("IS_NEW", Boolean.valueOf(isNew));
	
	String [] pages = {"loggers/admin/logAdminGate.jsp?isPrevious=true&logType=winEvent&eventType=" + eventType + "&OP=" + op + "&ts=" + System.currentTimeMillis(),
				"loggers/admin/logDataPattern.jsp?OP=" + op + "&LogAdminScreenWidth=" + logAdminScreenWidth,
				"loggers/admin/logFieldAdmin.jsp"};
	AdminUIController controller = new AdminUIController(pages);
	builder.setUiController(controller);

	request.getSession().setAttribute(MODULE_ID,modid);
	request.getSession().setAttribute(BUILDER,builder);
	
	String forwardURL = request.getParameter("forwardURL");
	if (forwardURL != null && forwardURL.length() > 0){
		String nextToken = forwardURL.indexOf("?") == -1 ? "?" : "&";
		forwardURL = forwardURL + nextToken + "forwardURL=loggers/admin/logAdminGate.jsp";
		response.sendRedirect(forwardURL);
		return;
	}
  
	response.sendRedirect(BASE_DIRECTORY + controller.getForwardPage());
%>