<%@ page language="java"%>

<%@ page import="java.util.List"%>
<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.managment.ApplicationComponent"%>
<%@ page import="xpolog.eye.managment.XpologManagment"%>
<%@ page import="xpolog.eye.media.cloud.CloudData"%>
<%@ page import="xpolog.eye.media.cloud.CloudManager"%>
<%@ page import="xpolog.eye.media.cloud.CloudManagerHelper"%>
<%@ page import="xpolog.eye.reports.ReportsManager"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.UserSecurity"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.security.XpologLicenseManager"%>
<%@ page import="xpolog.eye.site.portal.PortalHelpInfo"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.util.Constants"%>

<%!
static final String BASE_DIRECTORY = "../";
%>

<%
String baseDirectory = request.getParameter("baseDirectory");
if(baseDirectory == null) {
	baseDirectory = BASE_DIRECTORY;
}
String isDashboardsValidStr = request.getParameter("isDashboardsValid");
boolean isDashboardsValid = isDashboardsValidStr != null && isDashboardsValidStr.equals("true");

WebSecurityManager securityManager = WebSecurityManager.getInstance();
if (!securityManager.checkForPermission(request,response,null,true)){
  return;
}

UserSecurity user = securityManager.getUserSecurity(request);
UserContext userContext = UserEnvironment.getUserContext(request);

boolean isSiteDemo = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("isSiteDemo",false);

List comps = SiteManagment.getInstance().getApplicationComponentsManager().getVisibleApplicationComponents(user);
boolean showComps = comps.size() > 1;

boolean xpologEnabled = false;
boolean searchEnabled = false;
boolean dashboardEnabled = false;
boolean txexpoEnabled = false;
String xpologLink = "";
String xpologSearchLink = "";
String dashboardLink = "";
String txexpoLink = "";
for(int i=0;i<comps.size();i++) {
	ApplicationComponent comp = (ApplicationComponent)comps.get(i);		
	if(comp != null && comp.getId().equals(XpologManagment.XPOLOG_COMPONENT) && comp.isVisible()) {
		xpologEnabled = true;
		xpologLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getId().equals(XpologManagment.SEARCH_ENGINE_COMPONENT) && comp.isVisible()) {
		searchEnabled = true;
		xpologSearchLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getId().equals(XpologManagment.ANALYTICS_COMPONENT) && comp.isVisible()) {
		dashboardEnabled = true;
		dashboardLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
	if(comp != null && comp.getId().equals(XpologManagment.TX_EXPO_COMPONENT) && comp.isVisible()) {
		txexpoEnabled = true;
		txexpoLink = "componentAction.jsp?selectedCompId=" + comp.getId();
	}
}

boolean isPermittedAddLog = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_LOG_PERMISSION);
boolean isPermittedAddModule = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_MODULE_PERMISSION);
boolean isPermittedSettings = securityManager.isHavePermission(userContext,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION);
boolean haveQuickStart = isPermittedAddLog || isPermittedAddModule;

boolean searchEngineComponentValid = SiteManagment.getInstance().getXpologManagment().isComponentValid("SearchEngine");

boolean isPermittedAddVerify = searchEngineComponentValid && securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.ADD_VERIFY_PERMISSION);
boolean isPermittedEditVerify = searchEngineComponentValid && securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.EDIT_VERIFY_PERMISSION);

boolean isPermittedAddDashboard = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardsPermissions.EDIT_DASHBOARD_PERMISSION);
boolean isPermittedViewReport = searchEngineComponentValid && securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION) && ReportsManager.IS_ACTIVE;
boolean isPermittedVerify = isPermittedAddVerify || isPermittedEditVerify;

boolean isDashboardValid = SiteManagment.getInstance().getXpologManagment().isDashboardValidAndComponentExists();
boolean isPermittedViewDashboard = securityManager.isHavePermission(userContext,ActionsPermissionConstants.DashboardPermissions.DASHBOARD_VIEW_PERMISSION);

boolean isPermittedEnvironmentAnalysis = securityManager.isHavePermission(userContext,ActionsPermissionConstants.ToolsPermissions.VIEW_REPORTS_PERMISSION);
isPermittedEnvironmentAnalysis = false;

boolean isPermittedCloud = securityManager.isHavePermission(userContext,ActionsPermissionConstants.AdministrationPermissions.CLOUD_PERMISSION);

boolean presentQuickStart = isPermittedAddLog || isPermittedAddDashboard || isPermittedAddVerify;
boolean showMoreActions = isPermittedAddLog || isPermittedAddVerify || isPermittedAddDashboard || presentQuickStart || isPermittedSettings; 

boolean valid = SiteManagment.getInstance().getXpologManagment().isValidToBeActive();

boolean isTestingBuid = SiteManagment.getInstance().isTestingBuild();

boolean isDemo = XpologLicenseManager.getInstance().isDemo();

String analyticsH = Configuration.getInstance().getString(Constants.Strings.ANALYTICS_HEADER_DISPLAY_NAME);

PortalHelpInfo portalHelpInfo = PortalHelpInfo.getLeftPanelPortalHelpInfo();
String headerText = portalHelpInfo != null ? portalHelpInfo.getHeaderText() : null;
if (headerText == null || headerText.length() == 0){
	headerText = "Get Help";
}


%>

<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
	<tr valign="top" height="10px">
		<td>
			<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						Quick Actions
					</td>
				</tr>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<%if(valid) { %>
				<%if(isDashboardsValid) { %>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_QUICK_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<%if(isTestingBuid) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=testingPortal.jsp" %>"><img src="<%=baseDirectory %>images/home/environmentAnalysis.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'environmentAnalysisOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'environmentAnalysis.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=testingPortal.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Testing Environments</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(searchEnabled) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologSearchLink %>"><img src="<%=baseDirectory %>images/home/searchEngine.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'searchEngineOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'searchEngine.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologSearchLink %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Search Engine</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%}%>
							<%if(isSiteDemo) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=Log4J_Log_1227520538204%2526gotoMain=true%2526timetamp=" + System.currentTimeMillis() %>"><img src="<%=baseDirectory %>images/home/logViewer.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logViewerOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logViewer.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/logview.jsp%253Flogid=Log4J_Log_1227520538204%2526gotoMain=true%2526timetamp=" + System.currentTimeMillis() %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Viewer</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%}else { %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=view/mainView.jsp" %>"><img src="<%=baseDirectory %>images/home/logViewer.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logViewerOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logViewer.gif')" ></a>
											</td>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=view/mainView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Log Viewer</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isPermittedVerify) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorsView.jsp" %>"><img src="<%=baseDirectory %>images/home/logMonitor.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'logMonitorOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'logMonitor.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorsView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Monitors</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isPermittedViewReport) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp" %>"><img src="<%=baseDirectory %>images/home/reports.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'reportsOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'reports.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Reports</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(isDashboardValid && isPermittedViewDashboard) { %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=dashboardLink %>"><img src="<%=baseDirectory %>images/home/dashboard.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'dashboardOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'dashboard.gif')" ></a>
											</td>
											<td>
												<a href="<%=dashboardLink %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK"><%=analyticsH %></a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if(!isTestingBuid && isPermittedEnvironmentAnalysis) {%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true" %>"><img src="<%=baseDirectory %>images/home/environmentAnalysis.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'environmentAnalysisOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'environmentAnalysis.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=reports/reportsDefinitionView.jsp?isEnvironmentAnalysis=true" %>" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Environment Analysis</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<tr height="100%"><td>&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%} %>
				<%
				if(isPermittedCloud) {
				%>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT_DARK">
						<img src="<%=baseDirectory %>images/home/cloud/cloud.png" border="0" />&nbsp;&nbsp;Cloud Accounts
					</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_CLOUD_ACCOUNTS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
						<%
						List<CloudData> cloudDatas = CloudManagerHelper.getCloudDatas(userContext);
						CloudData cloudData = null;
						int numberOfAccounts;
						for(int i = 0; i < cloudDatas.size(); i++) {
							cloudData = cloudDatas.get(i);
							
							numberOfAccounts = 0;
							if(cloudData.getCloudAccountInfos() != null) {
								numberOfAccounts = cloudData.getCloudAccountInfos().size();
							}
							/*String cloudAccountId = "";
							if(numberOfAccounts == 1) {
								cloudAccountId = cloudData.getCloudAccountInfos().get(0).getCloudAccountId();
							}*/
						%>
						
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_CLOUD_ACCOUNT_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_CLOUD_ACCOUNT_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp%3FhideManagementPage=true%26mainPage=cloud/admin/cloudAdminView.jsp?fullPage=true%2526selectedAccountType=" + cloudData.getType() %>"><img src="<%=baseDirectory %>images/home/cloud/<%=cloudData.getType() %>.png" border="0" onMouseOver="javascript:setHomeImageSource(this, 'cloud/<%=cloudData.getType() %>Over.png')" onMouseOut="javascript:setHomeImageSource(this, 'cloud/<%=cloudData.getType() %>.png')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp%3FhideManagementPage=true%26mainPage=cloud/admin/cloudAdminView.jsp?fullPage=true%2526selectedAccountType=" + cloudData.getType() %>" class="HOME_PAGE_LEFT_PANEL_CLOUD_ACCOUNT_TEXT_LINK"><%=cloudData.getName() %> (<%=numberOfAccounts %>)</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						<%
						}
						%>
							<tr height="100%"><td>&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%
				}
				%>
				<tr height="1px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SEPARATOR">&nbsp;</td>
				</tr>
				<%if (showMoreActions){%>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						More Actions
					</td>
				</tr>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_MORE_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<%if (isPermittedAddLog && isPermittedAddModule){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner" %>"><img src="<%=baseDirectory %>images/home/addLogsDirectory.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'addLogsDirectoryOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'addLogsDirectory.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=wizards/common/wizardStarter.jsp?wizardPath=scanner" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Add Log Data Directory</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedAddLog){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp" %>"><img src="<%=baseDirectory %>images/home/addLog.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'addLogOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'addLog.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=loggers/admin/logAdminGate.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Add Log Data</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<% if (isPermittedAddVerify){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp" %>"><img src="<%=baseDirectory %>images/home/createMonitor.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'createMonitorOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'createMonitor.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=monitor/monitorDefinition.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Create Monitor</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedAddDashboard){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink%>&forward=root.jsp%3FhideManagementPage=true%26mainPage=portal/widgets/view/widgetsPortalView.jsp?fullPage=true%2526addNewDashboard=true"><img src="<%=baseDirectory %>images/home/generateReport.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'generateReportOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'generateReport.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink%>&forward=root.jsp%3FhideManagementPage=true%26mainPage=portal/widgets/view/widgetsPortalView.jsp?fullPage=true%2526addNewDashboard=true" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Create Dashboard</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (presentQuickStart){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="javascript:showStartWizard()"><img src="<%=baseDirectory %>images/home/openQuickStartWizard.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'openQuickStartWizardOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'openQuickStartWizard.gif')" ></a>
											</td>
											<td>
												<a href="javascript:showStartWizard()" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Quick Start Wizard</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<%if (isPermittedSettings){ %>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr>
											<td class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_IMAGE_CELL">
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=settings/mailset.jsp" %>"><img src="<%=baseDirectory %>images/home/settings.gif" border="0" onMouseOver="javascript:setHomeImageSource(this, 'settingsOver.gif')" onMouseOut="javascript:setHomeImageSource(this, 'settings.gif')" ></a>
											</td>
											<td>
												<a href="<%=xpologLink + "&forward=root.jsp?mainPage=settings/mailset.jsp" %>" class="HOME_PAGE_LEFT_PANEL_MORE_ACTION_TEXT_LINK">Settings</a>
											</td>
										</tr>
									</table>
								</td>
							</tr>
							<%} %>
							<tr height="100%"><td>&nbsp;</td></tr>
							<tr><td style="font-size: 1px; height: 1px;">&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%} %>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_TITLE_CELL HOME_PAGE_LEFT_PANEL_SECTION_TITLE_TEXT">
						<%=headerText %>
					</td>
				</tr>
				<%
				String[] helpItems = null;
				if (portalHelpInfo != null){
					helpItems = portalHelpInfo.getHelpItems();
				}%>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_GET_HELP_CELL" valign="top">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
						<%
						if (helpItems != null){
							for (int i=0; i<helpItems.length; i++){%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL"><%=helpItems[i].trim() %></td>
							</tr>		
							<%}	
						}else{
						%>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="mailto:support@xplg.com?subject=Questions regarding XpoLog Center" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK">Contact XpoLog</a>
								</td>
							</tr>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=online_knowledgebase" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK" target="_new">Online knowledge base</a>
								</td>
							</tr>
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_CELL">
									<a href="https://id.xplg.com/xplg/product/redirects.jsp?redirectRequest=user_manual" class="HOME_PAGE_LEFT_PANEL_HELP_ITEM_TEXT_LINK" target="_new">XpoLog Center user manual</a>
								</td>
							</tr>
						<%} %>
							<tr><td style="font-size: 1px; height: 1px;">&nbsp;</td></tr>
						</table>
					</td>
				</tr>
				<%
						if (isDemo){
				%>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_LIVE_SUPPORT_CELL">
					<!-- Begin SupportSuite Javascript Code -->
					
					<!-- BEGIN TAG CODE -->
						<div>
							<div id="proactivechatcontainernc2v4biell">
							</div>
							<table border="0" cellspacing="0" cellpadding="0">
								<tr>
									<td align="center" id="swifttagcontainernc2v4biell">
										<div style="display: inline;" id="swifttagdatacontainer"></div>
									</td>
								</tr>
								<tr>
									<td align="center"></td>
								</tr>
							</table>
						</div>
						<script type="text/javascript">
							var swiftscriptelemnc2v4biell=document.createElement("script");
							swiftscriptelemnc2v4biell.type="text/javascript";
							var swiftrandom = Math.floor(Math.random()*1001);
							var swiftuniqueid = "nc2v4biell";
							var swifttagurlnc2v4biell="http://support.xpolog.com/visitor/index.php?/LiveChat/HTML/HTMLButtonBase";
							setTimeout("swiftscriptelemnc2v4biell.src=swifttagurlnc2v4biell;document.getElementById('swifttagcontainernc2v4biell').appendChild(swiftscriptelemnc2v4biell);",1);
						</script>
					<!-- END TAG CODE -->
					
					<!-- End SupportSuite Javascript Code -->
					</td>
				</tr>
				<%
						}
				%>
				<tr><td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND">&nbsp;</td></tr>
				<%}else { %>
				<tr height="10px">
					<td class="HOME_PAGE_LEFT_PANEL_DARK_BACKGROUND HOME_PAGE_LEFT_PANEL_SECTION_QUICK_ACTIONS_CELL">
						<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
							<tr height="10px">
								<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_CELL">
									<table border="0" width="100%" height="100%" cellspacing="0" cellpadding="0">
										<tr height="10px">
											<td class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_IMAGE_CELL">
												<a href="settings/settings.jsp"><img src="<%=baseDirectory %>images/home/logCollection.gif" border="0" onMouseOver="javascript:setImageSource(this, 'logCollectionOver.gif')" onMouseOut="javascript:setImageSource(this, 'logCollection.gif')" ></a>
											</td>
											<td>
												<a href="settings/settings.jsp" class="HOME_PAGE_LEFT_PANEL_QUICK_ACTION_TEXT_LINK">Save License</a>
											</td>
										</tr>
										<tr><td>&nbsp;</td></tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr><td class="HOME_PAGE_LEFT_PANEL_LIGHT_BACKGROUND HOME_PAGE_LEFT_PANEL_LIVE_SUPPORT_CELL">&nbsp;</td></tr>
				<%} %>
			</table>
		</td>
	</tr>
</table>