<%@ page language="java"%>

<%@ page import="java.util.*"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.helpers.SearchEngineAdminHelper"%>
<%@ page import="xpolog.eye.data.index.*"%>
<%@ page import="xpolog.eye.data.index.adapters.*"%>
<%@ page import="xpolog.eye.data.index.adapters.defaultadapter.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@page import="xpolog.eye.system.health.XpoLogSystemHealth"%>
<%@ page import="xpolog.eye.Module"%>
<%!
static final String BASE_DIRECTORY = "../../";
%>

<%@ include file="moduleTree.jsp"%>

<%//constants

	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION,true)){
	  return;
	}

	String ERROR_OBJ = "ERROR_OBJ";
	
	String baseDirectory = request.getParameter("baseDirectory");
  if (baseDirectory == null){
  	baseDirectory = BASE_DIRECTORY;
  }

	//site management
	final UserEnvironment env = UserEnvironment.getUserEnvironment(request);
	SiteManagment mgmt = SiteManagment.getInstance();
	//UserSecurity user = WebSecurityManager.getInstance().getUserSecurity(request);
	UserContext userContext = UserEnvironment.getUserContext(request);
	Module curmod = mgmt.getModuleFromId(Module.ROOT_MODULE_ID);
	HashMap modulesMap = new HashMap();
	HashMap logsMap = new HashMap();

	LogsIndexerRunner runner = SearchEngineManager.getInstance().getCustomIndexerRunner();
	boolean isRunning = runner.isRunning();

	//appropriate messages
	String runMessage = "<span class=REGULARTEXT>To <b>run indexing</b>, please check the logs you would like to run indexing on, and click run</span>";
	String stopMessage = "<span class=REGULARTEXT>To <b>stop indexing</b>, click stop</span><br><span class=SMALLTEXT>Note: by clicking stop - all the logs which have an 'In Progress' status will be stopped being 	indexed</span>";

%>


<jsp:include page="../../widgets/xtree/jsp/treeIncluder.jsp" flush="true">
<jsp:param name="baseDirectory" value="<%=baseDirectory%>" />
</jsp:include>
<script>

var xhrObject = null;
function abortAjaxCalls() {
	//console.debug("abortAjaxCalls xhrObject=" + xhrObject);
	if(xhrObject != null) {
		xhrObject.abort();
	}
}

function run(){
	//console.debug("run");
	abortAjaxCalls();
	clearTimeoutObjects();
	updateSelected();
	var postParams = "";
	postParams += ("&mods=" + document.getElementById("mods").value);
	postParams += ("&logs=" + document.getElementById("logs").value);
	postParams += ("&op=run");
	xhrObject = sendAjaxRequest("<%=baseDirectory %>support/actions/searchEngineIndexingAction.jsp",function(req){
	    var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
	    	if(responseElement != null && typeof responseElement != " undefined") {
	    		var status = responseElement.getAttribute("status");
	    		//console.debug("run status=" + status);
	    		var message = responseElement.getAttribute("message");
	    		//console.debug("run message=" + message);
	    		if(status == "ok") {
	    			updateUIElements(true);
	    			updateStaus("run");
	    		}else {
	    			if(typeof message == "string") {
	    				updateStatusMessage(message);
	    			}
	    		}
	    	}
	    }
	},"POST",postParams);
}

var isDuringStop = false;
function stop() {
	if(isDuringStop) {
		//console.log("already stopping")
		return;
	}
	isDuringStop = true;
	//console.debug("stop");
	abortAjaxCalls();
	clearTimeoutObjects();
	var postParams = "op=stop";
	xhrObject = sendAjaxRequest("<%=baseDirectory %>support/actions/searchEngineIndexingAction.jsp",function(req){
	    var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
	    	if(responseElement != null && typeof responseElement != " undefined") {
	    		var status = responseElement.getAttribute("status");
	    		var message = responseElement.getAttribute("message");
	    		if(status == "ok") {
	    			if(typeof message == "string") {
	    				updateStatusMessage(message);
	    			}
	    			updateStaus("stop");
	    		}
	    	}
	    }
	},"POST",postParams);
}

function clearTimeoutObjects() {
	//console.debug("clearTimeoutObjects updateStatusTimeoutObject=" + updateStatusTimeoutObject);
	if(updateStatusTimeoutObject != null) {
		clearTimeout(updateStatusTimeoutObject);
	}
}

function onIndexingComplete(op) {
	//console.debug("onIndexingComplete op=" + op);
	clearTimeoutObjects();
	var message = "Indexing complete";
	if(op == "stop") {
		message = "Indexing stopped"
	}
	updateStatusMessage(message);
	updateUIElements(false);
	tree.clearCheckedNodes();
	tree.refreshItem("Module-rootModule");
	if(op == "stop") {
		isDuringStop = false;
	}
}

var updateStatusTimeoutObject = null;
function updateStaus(op) {
	//console.debug("updateStaus op=" + op);
	abortAjaxCalls();
	xhrObject = sendAjaxRequest("<%=baseDirectory %>support/actions/getIndexingStatus.jsp",function(req){
	    var xmldoc = req.responseXML.documentElement;
	    if(xmldoc) {
	    	var responseElement = xmldoc.getElementsByTagName("Response")[0];
	    	if(responseElement != null && typeof responseElement != " undefined") {
	    		var isRunning = responseElement.getAttribute("isRunning");
	    		//console.debug("updateStaus isRunning=" + isRunning);
	    		if(isRunning == "true") {
	    			var status = getXMLElementValue(responseElement);
	    			if(typeof status == "string") {
	    				var message = "Status: " + status;
	    				updateStatusMessage(message);
	    			}
	    			updateStatusTimeoutObject = setTimeout("updateStaus('" + op + "')", 2000);
	    		}else {
	    			onIndexingComplete(op);
	    		}
	    	}
	    }
	});
}

function updateStatusMessage(message) {
	//console.debug("updateStatusMessage " + message);
	var statusMsg = document.getElementById("statusMsg");
	  if(statusMsg) {
		  handleInnerHTML(statusMsg, message, 1);
	  }
}

function updateUIElements(isRunning) {
	//console.debug("updateUIElements isRunning=" + isRunning);
	var runIndexTitle = document.getElementById("runIndexTitle");
	var stopIndexTitle = document.getElementById("stopIndexTitle");
	var runIndexLink = document.getElementById("runIndexLink");
	var stopIndexLink = document.getElementById("stopIndexLink");
	if(isRunning) {
		runIndexTitle.style.display = "none";
		stopIndexTitle.style.display = "";
		runIndexLink.style.display = "none";
		stopIndexLink.style.display = "";
	}else {
		runIndexTitle.style.display = "";
		stopIndexTitle.style.display = "none";
		runIndexLink.style.display = "";
		stopIndexLink.style.display = "none";
	}
}

function updateSelected(){
	list = tree.getAllChecked();
	arr = list.split(",");
  var logsStr = "";
  var modsStr = "";
	for (var i=0; i<arr.length; i++){
		s = arr[i];
		ind = s.indexOf("-");
		if (ind == -1){
			continue;
		}else{
			type = s.substring(0,ind);
			id = s.substring(ind+1,s.length);
			if (type == "<%=XpoLogObjectTypes.MODULE_TYPE%>"){
				if (modsStr != ""){
					modsStr += ",";
				}
				modsStr += id;
				if (tree.hasChildren(s) && tree.hasChildren(s)==true){
 				modsStr += "*";
				}
			}else{
				if (logsStr != ""){
					logsStr += ",";
				}
				logsStr += id;
			}
		}
	}
	document.getElementById("mods").value = modsStr;
	document.getElementById("logs").value = logsStr;
	//console.debug("mods=" + document.getElementById("mods").value);
	//console.debug("logs=" + document.getElementById("logs").value);
}

</script>
<form AUTOCOMPLETE="OFF" id="access" name="access" METHOD="POST" style="padding:0px;margin:0px">
<input type="hidden" id="mods" name="mods">
<input type="hidden" id="logs" name="logs">
<table border="0" cellspacing="0" width="100%" height="100%" cellpadding="0">
  <tr>
    <td height="100%" valign="top">
    <table border="0" cellspacing="0" width="100%" height="90%" cellpadding="0">
      <tr>
        <td valign="top" height="90%">
        <table border="0" cellpadding="0" cellspacing="0" width="100%" id="AutoNumber1">
          <tr>
            <td>
            <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber2" height="100%">
              <tr>
                <td width="3%" height="100%">&nbsp;&nbsp;&nbsp; </td>
                <td width="93%" colspan="2" height="100%">
                <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber3" height="53">
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <tr>
                    <td>
                    <span id="statusMsg" class="INFORMATIONMESSAGE"></span>
                    </td>
                  </tr>
                  <tr>
                    <td width="15%" height="18"></td>
                  </tr>
                  <% 
                  	if (!XpoLogSystemHealth.getInstance().getSystemHealthStatus().isCollectionOK()) {
                  %>
                  <tr>
        						<td valign="bottom" height="10%">
        							<table border="0" width="100%">
                 				<tr>
                  				<td colspan="8" style="font-size:12;color: red;font-weight:bold">
                    				<div>Unable to run indexing - there is not enough disk space.<br> Please go to XpoLog System Health or contact XpoLog System Administrator. </div>
                  				</td>                 
                				</tr>
        							</table>
        						</td>
      						</tr>   
      						<%
      						}else { 
      						%>
                  <tr>
                    <td>
                    	<span id="runIndexTitle" style="display:<%=isRunning ? "none" : "" %>"><%=runMessage%></span>
                    	<span id="stopIndexTitle" style="display:<%=isRunning ? "" : "none" %>"><%=stopMessage%></span>
                    </td>
                  </tr>
                  <tr>
                    <td>
                    <span class="REGULARTEXT">&nbsp;</span>
                    </td>
                  </tr>
									<tr>
										<td valign="top">
											<div id="loadingDiv" style="display:none">
												<span class="REGULARTEXT">Loading...</span>
											</div>
										</td>
									</tr>
                  <tr>
                    <td width="15%">
                    <table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" id="AutoNumber6">
											<tr>
												<td valign="top">
													<div id="treeboxbox_tree"></div>
												</td>
											</tr>
										</table>
                    </td>
                  </tr>
                  <%
      						}
                  %>
                  </table>
                </td>
              </tr>
            </table>
            </td>
          </tr>
          </table>
        </td>
      </tr>
      <% if (XpoLogSystemHealth.getInstance().getSystemHealthStatus().isCollectionOK()) {%>
      <tr>
        <td valign="bottom" height="10%">
        <table border="0" width="100%">
          <tr>
            <td width="30%">&nbsp;</td>
            <td align="center">
              <table border="0" width="100%">
                <tr>
                  <td align="center">
                  	<a href="javascript:run()" id="runIndexLink" class="LINK" style="display:<%=isRunning ? "none" : "" %>">run</a>
                  	<a href="javascript:stop()" id="stopIndexLink" class="LINK" style="display:<%=isRunning ? "" : "none" %>">stop</a>
                  </td>
                </tr>
              </table>
            </td>
            <td width="30%">&nbsp;</td>
          </tr>
        </table>
        </td>
      </tr>
     <%} %>
    </table>
    </td>
  </tr>
</table>

</form>
<script>
	tree=new dhtmlXTreeObject("treeboxbox_tree","100%","100%","0");
	tree.setImagePath("<%=baseDirectory%>dhtmlxSuite/dhtmlxTree/codebase/imgs/");
	tree.setIconSize(13,13);
	tree.enableTreeLines(false);
	tree.setOnLoadingStart(startLoading);
	tree.setOnLoadingEnd(endLoading);
	tree.enableCheckBoxes(1);
	tree.enableThreeStateCheckboxes(true);
	tree.setXMLAutoLoading("<%=env.addUrlCsrfToken("actions/searchEngineModuleTreeXML.jsp?usingIndex=true&showIndexingInfo=true")%>");
	tree.loadXML("<%=env.addUrlCsrfToken("actions/searchEngineModuleTreeXML.jsp?usingIndex=true&showIndexingInfo=true")%>");
	
<%
if(isRunning) {	
%>
	updateStaus();
<%
}
%>
</script>
