<%@ page language="java" %>
<%@page import="java.lang.*"%>
<%@page import="java.net.*"%>

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.util.StringUtil"%>
<%@page import="xpolog.eye.security.*"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.config.*"%>
<%@page import="xpolog.eye.util.*"%>
<%@page import="xpolog.eye.util.DateUtil"%>
<%@page import="xpolog.eye.*"%>
<%@page import="xpolog.eye.reports.health.ui.*"%>
<%@page import="xpolog.eye.data.filters.DateFilter"%>

<%@page import="org.apache.commons.lang3.math.NumberUtils"%>
<%@page import="xpolog.eye.LogInfo"%>
<%@page import="xpolog.eye.LogsManager"%>
<%@page import="xpolog.eye.ModuleMember"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.computation.ComputationResult"%>
<%@page import="xpolog.eye.computation.ComputationResults"%>
<%@page import="xpolog.eye.computation.MultiComputationResult"%>
<%@page import="xpolog.eye.computation.impl.TotalComputationResult"%>
<%@page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@page import="xpolog.eye.search.SearchUtil"%>
<%@page import="java.lang.reflect.Constructor"%>
<%@page import="java.lang.reflect.Field"%>
<%@page import="java.text.DecimalFormat"%>
<%@page import="java.util.*"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.io.File"%>
<%@page import="java.io.FileWriter"%>
<%@page import="java.io.PrintWriter"%>


<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="../../css/mainproduct.css?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>" />
<script type="text/javascript" src="../../scripts/UIUtil.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>
	<script type="text/javascript" src="../../scripts/jquery/jquery.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>

</head>
<body>


<%


WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request, response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION, true)) {
	return;
}
UserContext userContext = UserEnvironment.getUserContext(request);

class CustomDashboardDataConfiguration extends DashboardDataConfiguration {

    CustomDashboardDataConfiguration(String amountOfDays, String amountOfHours, String amountOfMinutes, String loadFutureTimePeriod) {
        this.amountOfDays = NumberUtils.toInt(amountOfDays, -1);
        this.amountOfHours = NumberUtils.toInt(amountOfHours, -1);
        this.amountOfMinutes = NumberUtils.toInt(amountOfMinutes, -1);
        this.loadFutureTimePeriod = NumberUtils.toLong(loadFutureTimePeriod, -1);
    }

    int amountOfDays = -1;
    int amountOfHours = -1;
    int amountOfMinutes = -1;
    long loadFutureTimePeriod = -1;


    public int getAmountOfDays() {
        if (amountOfDays < 0) {
            return super.getAmountOfDays();
        }
        return amountOfDays;
    }

    public int getAmountOfHours() {
        if (amountOfHours < 0) {
            return super.getAmountOfHours();
        }
        return amountOfHours;
    }

    public int getAmountOfMinutes() {
        if (amountOfMinutes < 0) {
            return super.getAmountOfMinutes();
        }
        return amountOfMinutes;
    }

    public long getLoadFutureTimePeriod() {
        if (loadFutureTimePeriod < 0) {
            return super.getLoadFutureTimePeriod();
        }
        return loadFutureTimePeriod;
    }

    public String toString() {
        return new StringJoiner(", ", CustomDashboardDataConfiguration.class.getSimpleName() + "[", "]")
                .add("amountOfDays=" + amountOfDays)
                .add("amountOfHours=" + amountOfHours)
                .add("amountOfMinutes=" + amountOfMinutes)
                .add("loadFutureTimePeriod=" + loadFutureTimePeriod)
                .toString();
    }
}

class AnalyticsInfoPrinter {
    class Info{
        private String logId;
        private String name;
        private String fnlPath;

        Info(String logId, String name, String fnlPath){
            this.logId = logId;
            this.name = name;
            this.fnlPath = fnlPath;
        }


        public String toString() {
            return String.format("logId=%s, name=%s, fnlPath=%s", logId, name, fnlPath);
        }
    }

    class TreeKey{
        long num;
        String logId;

        public TreeKey(long num, String logId) {
            this.num = num;
            this.logId = logId;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            TreeKey treeKey = (TreeKey) o;

            if (num != treeKey.num) return false;
            return Objects.equals(logId, treeKey.logId);
        }

        @Override
        public int hashCode() {
            int result = (int) (num ^ (num >>> 32));
            result = 31 * result + (logId != null ? logId.hashCode() : 0);
            return result;
        }
    }

    StringBuilder sb = new StringBuilder();
    Map<String, Info> logIdVsInfo = new HashMap<>();
    DecimalFormat df = new DecimalFormat("#.##");

    String datePattern = "HH:mm dd/MM/yyyy";
    SimpleDateFormat simpleDateFormat = new SimpleDateFormat(datePattern);
    CustomDashboardDataConfiguration customDashboardDataConfiguration = null;
    DashboardDataManager dashboardDataManager;
    String sourcesQuery = null;
    long minTimeToPrint = -1;
    long minSizeToPrint = -1;
    boolean printNoAnalytics = false;
    boolean printAllData = true;
    String sort = "time";

    long steps = 300_000;
    long startTime;
    long endTime;

    String filename = null;
    PrintWriter writer = null;



    void addLogId(ModuleMember moduleMember){
        LogInfo logInfo = LogsManager.getInstance().getLogInfo(moduleMember.getId());
        logIdVsInfo.put(moduleMember.getId(), new Info(moduleMember.getId(), moduleMember.getName(), logInfo.getPathToRoot().replace(",", "->")));
    }

    void updateLogIdInfos(String query){
        try {
            SiteManagment mgmt = SiteManagment.getInstance();
            if (query == null || query.length() == 0){
                ModuleMember[] allLogs = mgmt.getAllLogBrowsersIds();
                if (allLogs != null){
                    for (int i=0; i<allLogs.length; i++){
                        ModuleMember moduleMember = allLogs[i];
                        addLogId(moduleMember);
                    }
                }

            }else{
                SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(null, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
                if(parseResponse == null) {
                    print("Failed to apply name pattern to logs");
                }else {
                    if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
                        print("The specified logs to change don't exist");
                    }else {
                        HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
                        if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
                            print("Failed to apply name pattern to logs");
                        }
                        else {
                            for (Object key : sourcesToQueries.keySet()) {
                                String lbmId = String.valueOf(key);
                                try{
                                    ModuleMember mm = mgmt.getModuleMember(lbmId);
                                    if (mm != null){
                                        addLogId(mm);
                                    }
                                }catch(Exception e){
                                    print("Could not get ModuleMember for logId = " + lbmId + ", error = " + e.getMessage());
                                }
                            }
                        }
                    }
                }
            }
        }
        catch (Exception e){
            print("Could not get logIds, " + e.getMessage());
        }
    }

    public void runForTimes(long startTime, long endTime, long steps) {
        long totalTime = System.currentTimeMillis();
        try {
            DashboardDataQuery dashboardDataQuery = new DashboardDataQuery();

            dashboardDataQuery.setStartTime(startTime);
            dashboardDataQuery.setEndTime(endTime);
            dashboardDataQuery.setSteps(steps);
            print("startTime = " + simpleDateFormat.format(new Date(startTime)) + ", endTime = " + simpleDateFormat.format(new Date(endTime)) +", step = " + steps + (writer != null ? ", file = " + new File(filename).getAbsolutePath() : ""));
            print("");

            TreeMap<TreeKey, String> treeMap = new TreeMap<>(Comparator.comparingLong((TreeKey k) -> k.num).thenComparing(k -> k.logId).reversed());
            for (Map.Entry<String, Info> entry : logIdVsInfo.entrySet()) {
                String logId = entry.getKey();
                Info info = entry.getValue();
                dashboardDataQuery.setMembers(new HashSet(Arrays.asList(logId)));

                long memoryDelta = memory();
                long time = System.currentTimeMillis();
                DashboardDataResult dashboardData = dashboardDataManager.getDashboardData(dashboardDataQuery);
                if (dashboardData == null){
                    if (printNoAnalytics){
                        print("No analytics for " + info);
                    }
                    continue;
                }
                ArrayList<ComputationResults> logResults = dashboardData.getLogResults();
                ComputationResults logResult = logResults.get(0);

                ComputationResult[] results = logResult.getResults();

                long total = 0;
                int resultsCount = 0;
                for (ComputationResult result : results) {
                    if (result instanceof MultiComputationResult){
                        MultiComputationResult multiComputationResult = (MultiComputationResult) result;
                        int tmpResultsCount = multiComputationResult.getResultsCount();
                        resultsCount += tmpResultsCount;

                        ComputationResult[] innerResults = multiComputationResult.getResults();
                        for (ComputationResult innerResult : innerResults) {
                            if (innerResult instanceof TotalComputationResult){
                                TotalComputationResult totalComputationResult = (TotalComputationResult) innerResult;
                                long innerTotal = totalComputationResult.getTotal();
                                total += innerTotal;
                            }
                            else {
                                print("Not total");
                            }
                        }
                    }
                    else {
                        print("Not multi");
                    }
                }
                int resultsOverTimeCount = logResult.getResultsOverTimeCount();
                long innerOvertimeResultsCount = -1;

                try {
                    innerOvertimeResultsCount = Arrays.stream((logResult).getResultsOverTime()).
                            map(ComputationResults::getResults).
                            flatMap(Arrays::stream).
                            filter(computationResult -> computationResult instanceof MultiComputationResult).
                            mapToLong(computationResult -> ((MultiComputationResult) computationResult).getResultsCount()).
                            sum();
                }
                catch (Exception e){

                }
                if (total <= 0 && resultsCount <= 0){
                    if (printNoAnalytics){
                        print("No total or resultsCount for " + info);
                    }
                    continue;
                }
                time = System.currentTimeMillis() - time;
                if (time > minTimeToPrint) {
                    long totalMemory = memory();
                    memoryDelta = totalMemory - memoryDelta;
                    if (memoryDelta > minSizeToPrint) {
                        String msg = "";
                        if (printAllData) {
                            msg = info + ", timeMS = " + time + ", resultsOverTimeCount = " + resultsOverTimeCount + ", innerOvertimeResultsCount = " + innerOvertimeResultsCount + ", total = " + total + ", resultsCount = " + resultsCount + ", total memory = " + memoryAsString(totalMemory) + ", memory delta = " + memoryAsString(memoryDelta);
                        } else {
                            msg = info.logId + ", timeMS = " + time + ", resultsCount = " + resultsCount;
                        }
                        if (sort != null) {
                            long num = time;
                            if ("time".equals(sort)){
                                // this is the default
                            }
                            else if ("total".equals(sort)){
                                num = total;
                            }
                            else if ("resultsCount".equals(sort)){
                                num = resultsCount;
                            }
                            else if ("resultsOvertime".equals(sort)){
                                num = resultsOverTimeCount;
                            }
                            else if ("innerResultsOvertime".equals(sort)){
                                num = innerOvertimeResultsCount;
                            }
                            treeMap.put(new TreeKey(num, info.logId), msg);
                        }
                        else {
                            print(msg);
                        }
                    }
                }
            }
            if (sort != null){
                print("Sorted by " + sort + ":");
                for (TreeKey treeKey : treeMap.keySet()) {
                    print(treeMap.get(treeKey));
                }
            }
        }
        catch (Throwable t){
            print("General error, " + t.getMessage());
        }
        finally {
            print("");
            print("Total timeMS = " + (System.currentTimeMillis() - totalTime));
        }
    }

    long memory(){
        return Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
    }

    String memoryAsString(long memoryBytes){
        return memoryBytes + " (" + toGB(memoryBytes) + ", " + toMB(memoryBytes) + ")";
    }
    String toGB(long bytes){
        double GB = 1073741824;
        return df.format(bytes/GB) + " GB";
    }

    String toMB(long bytes){
        double MB = 1048576;
        return df.format(bytes/MB) + " MB";
    }

    void init(String startTimeStr, String endTimeStr, String startDateStr, String endDateStr, String stepsStr, String stepsMSStr) {
        try {
            Class<DashboardDataManager> clazz = DashboardDataManager.class;

            Constructor<DashboardDataManager> constructor = clazz.getDeclaredConstructor();
            constructor.setAccessible(true);

            Field configurationField = clazz.getDeclaredField("configuration");
            configurationField.setAccessible(true);

            dashboardDataManager = constructor.newInstance();

            configurationField.set(dashboardDataManager, customDashboardDataConfiguration);

            updateLogIdInfos(sourcesQuery);
            initTimes(startTimeStr, endTimeStr, startDateStr, endDateStr, stepsStr, stepsMSStr);

            if (StringUtil.isNotEmpty(filename)) {
                try {
                    File file = new File(filename);
                    file.getParentFile().mkdirs();
                    writer = new PrintWriter(new FileWriter(file));
                }
                catch (Exception e){
                    print("Could not create writer for path " + filename + ", error = " + e.getMessage());
                }
            }
        }
        catch (Throwable t){
            print("Could not init, error = " + t.getMessage());
        }
    }

    void close(){
        if (writer != null) {
            writer.close();
        }
    }

    void initTimes(String startTimeStr, String endTimeStr, String startDateStr, String endDateStr, String stepsStr, String stepsMSStr) {
        int MINUTE = 60 * 1000;
        int HOUR = 60 * MINUTE;
        int DAY = 24 * HOUR;

        try{
            this.endTime = StringUtil.isNotEmpty(endDateStr) ? simpleDateFormat.parse(endDateStr).getTime() : NumberUtils.toLong(endTimeStr, System.currentTimeMillis());
            this.startTime = StringUtil.isNotEmpty(startDateStr) ? simpleDateFormat.parse(startDateStr).getTime() : NumberUtils.toLong(startTimeStr, this.endTime - 14 * DAY);
        }
        catch (Exception e){
            print("Could not parse start/end dates/times. Date format is " + datePattern);
        }

        if (StringUtil.isNotEmpty(stepsStr)) {
            switch (stepsStr){
                case "1d":
                    this.steps = DAY;
                    break;
                case "1h":
                    this.steps = HOUR;
                    break;
                case "5m":
                default:
                    this.steps = 5 * MINUTE;
            }
        }
        else {
            this.steps = NumberUtils.toLong(stepsMSStr, 5 * MINUTE);
        }
    }

    void print(String msg){
        sb.append(msg).append("</br>\n");
        if (writer != null) {
            writer.println(msg);
        }
//        System.out.println(msg);
    }

    boolean hasAnyAmountsSet(CustomDashboardDataConfiguration customDashboardDataConfiguration){
        return customDashboardDataConfiguration.amountOfDays > -1 || customDashboardDataConfiguration.amountOfHours > -1 || customDashboardDataConfiguration.amountOfMinutes > -1;
    }
    void jsp(AnalyticsInfoPrinter analyticsInfoPrinter){
        analyticsInfoPrinter.minTimeToPrint = 1;
        analyticsInfoPrinter.sourcesQuery = "log.xpologlog";
        CustomDashboardDataConfiguration customDashboardDataConfiguration = new CustomDashboardDataConfiguration(null, null, null, null);
        analyticsInfoPrinter.customDashboardDataConfiguration = customDashboardDataConfiguration;
        analyticsInfoPrinter.init(null, null, null, null, null, null);
        if (analyticsInfoPrinter.hasAnyAmountsSet(customDashboardDataConfiguration)){
            if (customDashboardDataConfiguration.amountOfDays > -1){
                analyticsInfoPrinter.print("Data per day unit:");
                DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last " + customDashboardDataConfiguration.amountOfDays + " days", 0, true, true);
                analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), endTime, DateUtil.DAY_UNIT);
            }
            if (customDashboardDataConfiguration.amountOfHours > -1){
                analyticsInfoPrinter.print("Data per hour unit:");
                DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last " + customDashboardDataConfiguration.amountOfHours + " days", 0, true, true);
                analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), endTime, DateUtil.HOUR_UNIT);
            }
            if (customDashboardDataConfiguration.amountOfMinutes > -1){
                analyticsInfoPrinter.print("Data per minute unit:");
                DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last " + customDashboardDataConfiguration.amountOfMinutes + " days", 0, true, true);
                analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), endTime, 5 * DateUtil.MIN_UNIT);
            }
        }
        else {
            analyticsInfoPrinter.runForTimes(startTime, endTime, steps);
        }
        analyticsInfoPrinter.close();
    }
}



String message = "";
String errorLogs = null;
StringBuilder builder = new StringBuilder();

AnalyticsInfoPrinter analyticsInfoPrinter = null;
try{
    String sourcesQuery = request.getParameter("sourcesQuery");
    String minTimeToPrint = request.getParameter("minTimeToPrint");
    String minSizeToPrint = request.getParameter("minSizeToPrint");
    String sort = request.getParameter("sort");
    String file = request.getParameter("file");

    String amountOfDays = request.getParameter("amountOfDays");
    String amountOfHours = request.getParameter("amountOfHours");
    String amountOfMinutes = request.getParameter("amountOfMinutes");
    String loadFutureTimePeriod = request.getParameter("loadFutureTimePeriod");

    String startTime = request.getParameter("startTime");
    String endTime = request.getParameter("endTime");
    String startDate = request.getParameter("startDate");
    String endDate = request.getParameter("endDate");
    String steps = request.getParameter("steps");
    String stepsMS = request.getParameter("stepsMS");


    analyticsInfoPrinter = new AnalyticsInfoPrinter();
    builder = analyticsInfoPrinter.sb;

    analyticsInfoPrinter.minTimeToPrint = NumberUtils.toLong(minTimeToPrint, -1);
    analyticsInfoPrinter.minSizeToPrint = NumberUtils.toLong(minSizeToPrint, -1);
    if (StringUtil.isNotEmpty(sort)){
        analyticsInfoPrinter.sort = sort;
    }
    analyticsInfoPrinter.filename = file;

    analyticsInfoPrinter.sourcesQuery = sourcesQuery;
    CustomDashboardDataConfiguration customDashboardDataConfiguration = new CustomDashboardDataConfiguration(amountOfDays, amountOfHours, amountOfMinutes, loadFutureTimePeriod);
    analyticsInfoPrinter.customDashboardDataConfiguration = customDashboardDataConfiguration;
    analyticsInfoPrinter.init(startTime, endTime, startDate, endDate, steps, stepsMS);

    if (analyticsInfoPrinter.hasAnyAmountsSet(customDashboardDataConfiguration)){
        if (customDashboardDataConfiguration.amountOfDays > -1){
            analyticsInfoPrinter.print("");
            analyticsInfoPrinter.print("Data per day unit:");
            DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last" + customDashboardDataConfiguration.amountOfDays + "days", 1000, true, true);
            analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), analyticsInfoPrinter.endTime, DateUtil.DAY_UNIT);
            analyticsInfoPrinter.print("---------------------------------------------------------------------------------");
        }
        if (customDashboardDataConfiguration.amountOfHours > -1){
            analyticsInfoPrinter.print("");
            analyticsInfoPrinter.print("Data per hour unit:");
            DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last" + customDashboardDataConfiguration.amountOfDays + "days", 1000, true, true);
            analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), analyticsInfoPrinter.endTime, DateUtil.HOUR_UNIT);
            analyticsInfoPrinter.print("---------------------------------------------------------------------------------");
        }
        if (customDashboardDataConfiguration.amountOfMinutes > -1){
            analyticsInfoPrinter.print("");
            analyticsInfoPrinter.print("Data per minute unit:");
            DateFilter dateFilterFromTimeFrameKeyLast = DateUtil.getDateFilterFromTimeFrameKeyLast("last" + customDashboardDataConfiguration.amountOfDays + "days", 1000, true, true);
            analyticsInfoPrinter.runForTimes(dateFilterFromTimeFrameKeyLast.getMinDate().getTime(), analyticsInfoPrinter.endTime, 5 * DateUtil.MIN_UNIT);
            analyticsInfoPrinter.print("---------------------------------------------------------------------------------");
        }
    }
    else {
        analyticsInfoPrinter.runForTimes(analyticsInfoPrinter.startTime, analyticsInfoPrinter.endTime, analyticsInfoPrinter.steps);
    }
}
catch (Exception e ){
    builder.append(e.getMessage());
}
finally{
    if (analyticsInfoPrinter != null){
        analyticsInfoPrinter.close();
    }
}

%>

<%=builder.toString()%>

</body>
</html>

