<%@ page language="java" %>

<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.util.ModuleMembersUtil"%>
<%@page import="xpolog.eye.search.SearchUtil"%>
<%@page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.security.*"%>
<%@page import="xpolog.eye.data.store.*"%>
<%@page import="xpolog.eye.util.*"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.*"%>
<%@page import="java.io.*"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Collections"%>
<%@page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@page import="com.xpolog.logcollection.LogCollectionManager"%>
<%@page import="com.xpolog.logcollection.locations.files.*"%>
<%@page import="com.xpolog.logcollection.system.LogCollectionPolicy"%>
<%@page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>

<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.LogBrowsingManager"%>


<%!static final String BASE_DIRECTORY = "../../";
	%>
<%
    WebSecurityManager manager = WebSecurityManager.getInstance();
    if (!manager.checkForPermission(request, response, ActionsPermissionConstants.SettingsPermissions.GENERAL_PERMISSION, true)) {
        return;
    }

    UserContext userContext = UserEnvironment.getUserContext(request);
    boolean success = true;
    String message = "";
    List<String> logsIds = new ArrayList<String>();
    String rowIds = "";

    String query = request.getParameter("sourceQuery");
    String collectionPolicyName = request.getParameter("collectionPolicy");
    boolean printOnly = "true".equals(request.getParameter("printOnly"));

    boolean changesOnly = "true".equals(request.getParameter("changesOnly")) || request.getParameter("changesOnly") == null;
    boolean moveData = "true".equals(request.getParameter("moveData"));

    //extract logs names from query supplied
    if (query != null && query.length() > 0){
        SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(userContext, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
        if(parseResponse == null) {
            message = "Query response is empty.";
            success = false;
        }else {
            if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
                message = "Query parsing returned with error: " + parseResponse.getErrorMessage();
                success = false;
            }else {
                HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
                if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
                    message = "No logs were found from the query supplied.";
                    success = false;
                }else {
                    logsIds.addAll(sourcesToQueries.keySet());
                    success = true;
                }
            }
        }
    }
    else {
        message = "Query was not supplied.";
        success = false;
    }

    if (success && logsIds.size() > 0) {

        //find collection policy by name supplied
        LogCollectionSystemManager sysMgr = LogCollectionManager.getInstance().getSystemMgr();
        LogCollectionPolicy policy = sysMgr.getLogCollectionPolicyByName(userContext, collectionPolicyName);


        if (policy != null) {
            Set<String> set = new HashSet();
            Map<String,String> moveMap = new HashMap();
            SiteManagment mgmt = SiteManagment.getInstance();


            if (!printOnly || changesOnly) {
                // attach logs to their collection policy
                for (String logId : logsIds) {
                    try {
                        LogBrowsingManager lbm = mgmt.getLogBrowserManager(logId);
                        if (changesOnly){
                            if (policy.getId().equals(lbm.getLogCollectionPolicyId())){
                                continue;
                            }
                        }
                        set.add(logId);
                        File sourceDir = null;
                        File targetDir = null;
                        if (moveData){
                            sourceDir = XpologDataStoreManager.getInstance().getXpologDataLogsBaseDirectory(logId);

                            FileLocationInfo fileLocationInfo = policy.getDefaultFileLocationInfo();
                            if (fileLocationInfo != null && fileLocationInfo.getPath() != null){
                                String path = fileLocationInfo.getPath();
                                if (path != null){
                                    targetDir = new File(new File(path,XpologDataStoreManager.LOGS_DIRECTORY_NAME),logId);
                                }
                            }
                            String desc = "Move from " + sourceDir + " to " + targetDir;
                            moveMap.put(logId,desc);

                        }
                        if (!printOnly) {
                            if (moveData){
                                if (sourceDir != null && targetDir != null){
                                    if (!targetDir.exists()){
                                        FileUtil.moveDir(sourceDir,targetDir);
                                    }
                                    lbm.setLogCollectionPolicyId(policy.getId());
                                    SiteManagment.getAdminInstance().addLogBrowser(lbm);
                                }
                            }else {
                                lbm.setLogCollectionPolicyId(policy.getId());
                                                            SiteManagment.getAdminInstance().addLogBrowser(lbm);
                            }

                        }
                    }
                    catch (Throwable t) {
                        ErrorModel.log.error("Changing Log: " + logId + " collection policy failed.",t);
                    }
                }
            }

            ArrayList<String> logPaths = new ArrayList<String>();
            Iterator<String> it = logsIds.iterator();

            while (it.hasNext()){
                String key = it.next();
                if (changesOnly && !set.contains(key)){
                    continue;
                }
                String logPath = ModuleMembersUtil.getPathToRoot(key, " -> ");
                if (logPath != null) {
                    if (moveData){
                        String desc = moveMap.get(key);
                        if (desc != null){
                            logPath += " (" + desc + ")";
                        }
                    }
                    logPaths.add(logPath);
                }
            }
            Collections.sort(logPaths);

            message = " Collection Policy : " + policy.getName() + " , was assigned to : " + logPaths.size() + " logs.";
            for (String logPath : logPaths) {
                rowIds += "<LogPath> " + logPath + " </LogPath>";
            }

            success = true;
        }
        else {
            message = "No collection policy was found.";
            success = false;
        }
    }
    else {
        message = "No logs were found.";
        success = false;
    }


    if (success) {
        ErrorModel.log.debug(message);
        if (rowIds.length() > 0) {
            ErrorModel.log.debug(rowIds);
        }
    }
    else {
        ErrorModel.log.error(message);
    }

    String xml = GridModelActionsHelper.getResultXML(success, message, null, rowIds);

    response.setContentType("text/xml");
    response.setHeader("Pragma-Control", "no-cache");
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Expires", "0");

    out.write(xml);
    out.flush();
%>
