<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.hosts.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="org.w3c.dom.*"%>
<%@ page import="xpolog.eye.Module"%>
<%!
static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request, response, null, true)) {
		return;
	}

	String query = request.getParameter("query");

    String msg = "Start clean hosts for ssh logs";
    String result = "";
    %>
    <%=msg%>
    <%
        XpologFileLock xpologFileLock = null;
        SiteAdministrator admin = SiteManagment.getAdminInstance();
        try {
            if (Configuration.getInstance().isCluster()){
                xpologFileLock = admin.lockModules("clean logs host for host");
            }
        SiteManagment mgmt = SiteManagment.getInstance();
        List<String> logsIds = new ArrayList<String>();
            if (query == null || query.length() == 0) {
                ModuleMember[] allLogsModuleMembers = mgmt.getAllLogBrowsersIds();
                if (allLogsModuleMembers != null){
                    for (ModuleMember allLogsModuleMember : allLogsModuleMembers) {
                        logsIds.add(allLogsModuleMember.getId());
                    }
                }
            }else {
                SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(null, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
                ErrorModel errmod = null;
                if(parseResponse == null) {
                    if(errmod == null) {
                        errmod = new ErrorModel();
                    }
                    errmod.addError("Failed to apply name pattern to logs");
                }else {
                    if (parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
                        if (errmod == null) {
                            errmod = new ErrorModel();
                        }
                        errmod.addError("The specified logs to change don't exist");
                    } else {
                        HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
                        if (sourcesToQueries == null || sourcesToQueries.size() == 0) {
                            if (errmod == null) {
                                errmod = new ErrorModel();
                            }
                            errmod.addError("Failed to apply name pattern to logs");
                        } else {
                            logsIds.addAll(sourcesToQueries.keySet());
                        }
                    }
                }
            }

            StringBuilder builder = new StringBuilder();
            List<String> newLogsIds = new ArrayList<String>();

            for (String logId : logsIds) {
                 try {
                    ModuleMember moduleMember = mgmt.getModuleMember(logId);


                    String lbmType = moduleMember.getLogType();
                    if (lbmType == null || (!lbmType.equals(SshSimpleBuilder.SSH_LOG_TYPE))) {
                        continue;
                    }

                    LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager(moduleMember.getId());
                    if (lbm == null) {
                        continue;
                    }

                    File file = null;
                   if ((lbm.getHost() != null && lbm.getHost().length() > 0) || (moduleMember.getHost() != null && moduleMember.getHost().length() > 0)){
                       newLogsIds.add(logId);

                       String filePath = mgmt.getLogBrowserManagerFile(logId);
                        if(filePath != null) {
                            file = new File(filePath);
                            Element lbmElem = mgmt.getBrowserElem(logId, false);
                            if(lbmElem != null) {
                                String hostStr = lbmElem.getAttribute(LogBrowsingManager.HOST_ATT);
                                if(hostStr != null && hostStr.length() > 0) {
                                    lbmElem.removeAttribute(LogBrowsingManager.HOST_ATT);

                                    Document doc = XMLUtil.buildXml();
                                    Element elem = admin.createXpologElement(doc);
                                    Element imported = (Element)doc.importNode(lbmElem, true);
                                    elem.appendChild(imported);
                                    doc.appendChild(elem);
                                    XMLUtil.saveXml(doc, file);
                                }
                            }
                        }


                        if(true) {
                            // update the useInDashboard attribute in the module member
                            Module module = mgmt.getParentModule(logId);
                            ModuleMember mm = mgmt.getModuleMember(logId);
                            if(module != null && mm != null) {
                                mm.setHost(null);

                                module.addMember(mm);

                                SiteManagment.getAdminInstance().updateModule(module, null, null, false,false);
                            }
                        }

                       builder.append("clean host for log " + logId + " - " + lbm.getName() +  " with host " + lbm.getHost() + ";");
                   }
                } catch (Exception e) {
                    ErrorModel.log.error("Failed to update host for log " + logId, e);
                }
            }
            if (newLogsIds.size() > 0){
              //  SiteManagment.getAdminInstance().updateLogsHost(newLogsIds ,"",null,false);
              SiteManagment.getInstance().refreshModules();
            }

            result = builder.toString();
        } catch (Throwable t) {
           	ErrorModel.log.error("Failed to update app tags", t);
        }finally {
            if (Configuration.getInstance().isCluster()){
                admin.releaseLockModules(xpologFileLock);
            }
        }
        String[] outputArr = result.split(";");
        StringBuilder output = new StringBuilder();
        output.append("<br>");
        for (int i = 0; i < outputArr.length; i++){
            output.append(outputArr[i]);
            output.append("<br>");
        }

        output.append("<br>");
        output.append("Finish process");
        result = output.toString();
%>

<%=result%>



