<%@page language="java" %>

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.util.search.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="xpolog.eye.data.store.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>

<%!
        static final String BASE_DIRECTORY = "../../";
%>
<%
        WebSecurityManager manager = WebSecurityManager.getInstance();
        if (!manager.checkForPermission(request,response,null,true)) {
                return;
        }

        UserContext user = UserEnvironment.getUserContext(request);
        if (user != null && user.getUser() != null && !user.getUser().isAdmin()) {
                response.sendRedirect(BASE_DIRECTORY + UserEnvironment.getUserEnvironment(request).addUrlCsrfToken("security/common/accessDenied.jsp"));
                return;
        }

        String lbmId = request.getParameter("lbmId");
        String query = request.getParameter("query");
        String pathsToVerify = request.getParameter("paths");
        String deleteStr = request.getParameter("delete");
        boolean delete = deleteStr != null && deleteStr.equals("true");

        String [] paths = pathsToVerify == null ? new String[0] : pathsToVerify.split(",");
        Set<String> set = new HashSet<>();
        if (paths != null) {
                for (String path : paths) {
                        set.add(path.toLowerCase());
                }
        }

        StringBuilder builder = new StringBuilder();


        try {

                SiteManagment mgmt = SiteManagment.getInstance();
                HashSet<String> logsIds = new HashSet<String>();


                if (query == null || query.length() == 0) {
                        ModuleMember[] allLogs = mgmt.getAllLogBrowsersIds();
                        if (allLogs != null) {
                                for (int i=0; i<allLogs.length; i++) {
                                        logsIds.add(allLogs[i].getId());
                                }
                        }

                }else{
                        SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(user, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
                        if (parseResponse == null) {
                                ErrorModel.log.error("Failed to apply name pattern to logs");
                        }else{
                                if (parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
                                        ErrorModel.log.error("The specified logs to change does not exist");
                                }else{
                                        HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
                                        if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
                                                ErrorModel.log.error("Failed to apply name pattern to logs");
                                        }else{
                                                logsIds.addAll(sourcesToQueries.keySet());
                                        }
                                }

                        }
                }

                if (logsIds != null) {
                        int count = 0;
                        for (String id : logsIds) {
                                count++;
                                LogInfo logInfo = LogsManager.getInstance().getLogInfo(id);
                                String baseDir = XpologDataStoreManager.getInstance().getXpologLogDataDirectory(id);
                                File directory = new File(baseDir).getAbsoluteFile();
                                if (directory.exists()) {
                                        String path = directory.getParentFile().getParentFile().getParentFile().getAbsolutePath();
                                        for (String allPath : paths) {
                                                allPath = allPath.trim();
                                                if (!allPath.equalsIgnoreCase(path)){
                                                        File testDir = new File(allPath,"logs/" + id);
                                                        if (testDir.exists()) {
                                                                if(delete) {
                                                                        builder.append("deleted invalid path = " + testDir).append(" | valid path = " + directory).append("<br>\n");
                                                                        FileUtil.deleteFile(testDir,true);
                                                                }else{
                                                                        builder.append("found invalid path = " + testDir).append(" | valid path = " + directory).append("<br>\n");
                                                                }

                                                        }
                                                }
                                        }
                                }
                        }
                }


        }catch (Throwable e){
                ErrorModel.log.error("Failed to clean unused directories", e);
                builder.append("error - " + e.getMessage());
        }
%>

<html>

<head>
</script>
</head>

<body>
<p>
<%=builder.toString()%>
</p>
</body>

</html>
