class DSPluginClient {
    constructor(conf) {
        this.conf = conf;
        this.endpointUrl = conf.baseUrl;
    }

    init(json) {
        this.authResponse = {};
        const url = this.endpointUrl + "rest/init.jsp";

        this.initJson = json;

        const headers = {"Content-Type": "application/json"};


        const requestData = {
          "accountFormData": json,
          "defaultParams" : {},
          "scripttest" : true

        };
         if (json.accountFormData){
            requestData = json;
         }


        const requestOptions = {
          method: 'POST',
          headers: headers,
          body: JSON.stringify(requestData)
        };


        // Send a GET request
        fetch(url,requestOptions)
          .then(response => {
            if (!response.ok) {
              if (response){
                 writeOutputResult("Error " + response.status + " on " + url);
              }
              if (response.status === 404) {
                  throw new Error('Resource not found');
                } else if (response.status === 500) {
                  throw new Error('Internal server error');
                } else {
                  // For other error status codes, just throw a generic error
                  throw new Error('Request failed with status ' + response.status);
                }
              //throw new Error('Network response was not ok');
            }
            return response.json(); // Parse the response as JSON
          })
          .then(data => {
            // Handle the data from the response
           writeOutputResult(data);
           writeInputResult({});
           this.authResponse = data.authResponse;

          })
          .catch(error => {
            // Handle any errors that occurred during the fetch
            console.error('Fetch error:', error);
          });
    }

    dataTypes() {
        const url = this.endpointUrl + "rest/dataTypes.jsp";

         const headers = this.authResponse && this.authResponse.headers ? this.authResponse.headers : {};
         const parameters = this.authResponse && this.authResponse.parameters ? this.authResponse.parameters : {};

         const requestData = {
             "scripttest" : true
         };


         const requestOptions = {
           method: 'POST',
           headers: headers,
           body: JSON.stringify(requestData)
         };


         // Send a GET request
         fetch(url,requestOptions)
           .then(response => {
             if (!response.ok) {
                if (response){
                    writeOutputResult("Error " + response.status + " on " + url);
                }
               throw new Error('Network response was not ok');
             }
             return response.json(); // Parse the response as JSON
           })
           .then(data => {
             // Handle the data from the response
            writeOutputResult(data);

           })
           .catch(error => {
             // Handle any errors that occurred during the fetch
             console.error('Fetch error:', error);
           });
    }

    nextEvents(json) {
        const url = this.endpointUrl + "rest/nextEvents.jsp";

         const headers = this.authResponse && this.authResponse.headers ? this.authResponse.headers : {};
         const parameters = this.authResponse && this.authResponse.parameters ? this.authResponse.parameters : {};

         const requestData = {
             "scripttest" : true
         };
         if (json && json.metaData){
            requestData.metaData = json.metaData;
         }


         const requestOptions = {
           method: 'POST',
           headers: headers,
           body: JSON.stringify(requestData)
         };


         // Send a GET request
         fetch(url,requestOptions)
           .then(response => {
             if (!response.ok) {
                if (response){
                    writeOutputResult("Error " + response.status + " on " + url);
                }
                if (response.status === 404) {
                    throw new Error('Resource not found');
                  } else if (response.status === 500) {
                    throw new Error('Internal server error');
                  } else {
                    // For other error status codes, just throw a generic error
                    throw new Error('Request failed with status ' + response.status);
                  }
              // throw new Error('Network response was not ok');
             }
             return response.json(); // Parse the response as JSON
           })
           .then(data => {
             // Handle the data from the response
            writeOutputResult(data);
            const inputData = {
                "metaData" : data.metaData
                     };
            writeInputResult(inputData);

           })
           .catch(error => {
             // Handle any errors that occurred during the fetch
             console.error('Fetch error:', error);
           });
    }

    disconnect() {

    }
}







