
class PluginsClient {
    constructor() {

        this.plugins = [];

       this.pluginsList = document.getElementById('pluginsList');
       this.pluginsList.addEventListener('change',(event) => this.loadPlugin());

       document.getElementById('init').addEventListener('click',(event) => this.init());
       document.getElementById('dataTypes').addEventListener('click',(event) => this.dataTypes());
       document.getElementById('nextEvents').addEventListener('click',(event) => this.nextEvents());
       document.getElementById('reset').addEventListener('click',(event) => this.reset());

       this.input = document.getElementById('input');
       this.output = document.getElementById('output');

    }

    async loadPlugins(endpointUrl) {
       const url = endpointUrl;
       const headers = {

       };

       // Define the request configuration including headers
       const requestOptions = {
         method: 'GET',
         headers: headers
       };

        try {
               const response = await fetch(url,requestOptions);
               if (!response.ok) {
                    if (response.status === 404) {
                       throw new Error('Resource not found');
                     } else if (response.status === 500) {
                       throw new Error('Internal server error');
                     } else {
                       // For other error status codes, just throw a generic error
                       throw new Error('Request failed with status ' + response.status);
                     }
               }
               const data = await response.json();
               const selectElement = document.getElementById('pluginsList');

           //this.plugins = data.plugins;

           data.plugins.forEach((plugin) => {
                                const index = this.plugins.length;
                                this.plugins.push(plugin);
                                const option = document.createElement('option');
                                option.id = plugin.id;
                                option.value = index;
                                option.text = plugin.name;
                                selectElement.add(option);
                              });
           } catch (error) {
                console.error('Fetch error:', error);

           }

    }

     loadPlugin() {
          this.plugin = this.plugins[this.pluginsList.value];
          this.initPlugin();
    }

    initPlugin(){
         this.pluginClient = new DSPluginClient(this.plugin);
         var inputText = this.plugin.defaults ? JSON.stringify(this.plugin.defaults, null, 2) : "{}";
         this.input.value = inputText;
    }

    getInputJson(){
        var json = {};
        var text = this.input.value;
        if (text != ""){
            try {
                var parseJson = JSON.parse(text);
                if (parseJson){
                    json = parseJson;
                }
            }catch (e){
                console.error("Error parse input " + e);
            }
        }
        return json;
    }

     init() {
        if (this.pluginClient){
            this.pluginClient.init(this.getInputJson());
        }
    }

    dataTypes() {
        if (this.pluginClient){
            this.pluginClient.dataTypes();
        }
    }

    nextEvents() {
        if (this.pluginClient){
            this.pluginClient.nextEvents(this.getInputJson());
        }
    }



    reset() {
        var conf = this.pluginClient.initJson;
        this.initPlugin();
        writeInputResult(conf);

    }
}






