<%@ page language="java"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.search.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="xpolog.eye.data.filters.query.*"%>
<%@ page import="xpolog.eye.site.*"%>
<%@ page import="xpolog.eye.data.*"%>
<%@ page import="xpolog.eye.data.log.*"%>
<%@ page import="xpolog.eye.util.naming.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.media.listeners.*"%>
<%@ page import="java.util.*"%>
<%@ page import="java.io.*"%>
<%@ page import="java.nio.file.*"%>
<%@ page import="java.util.zip.*"%>
<%@ page import="xpolog.eye.data.store.collection.listeners.*"%>
<%@ page import="xpolog.eye.data.store.collection.listeners.recordhandlers.*"%>
<%@ page import="xpolog.eye.search.computation.store.file.*"%>

<%!
  static final String BASE_DIRECTORY = "../../";



%>
<%
	WebSecurityManager manager = WebSecurityManager.getInstance();
	if (!manager.checkForPermission(request,response,null,true)){
		return;
	}
	
	UserContext user = UserEnvironment.getUserContext(request);
	if (user != null && user.getUser() != null && !user.getUser().isAdmin()){
		response.sendRedirect(BASE_DIRECTORY + UserEnvironment.getUserEnvironment(request).addUrlCsrfToken("security/common/accessDenied.jsp"));
		return;
	}


	String data = request.getParameter("data");
	String path = request.getParameter("path");
	String listenerId = request.getParameter("listenerId");
	String doReloadStr = request.getParameter("doReload");
	boolean doReload = doReloadStr != null && doReloadStr.equals("true");
	String useLocalStr = request.getParameter("useLocal");
	boolean useLocal = useLocalStr == null || !useLocalStr.equals("false");

	String linesNumStr = request.getParameter("linesNum");
	int linesNum = 1;
	if (linesNumStr != null){
        try {
            linesNum = Integer.parseInt(linesNumStr);
        }catch(Exception e){}
    }

    File f = null;

    if (data != null && data.length() > 0){
        f = new File("temp/handlers/test.log");
        if (!f.getParentFile().exists()){
            f.getParentFile().mkdirs();
        }
        Files.writeString(f.toPath(), data);
        path = f.getParentFile().getPath();
    }


    StringBuilder builder = new StringBuilder();
	if (path != null && path.length() > 0){
        try {

                ListenersRecordHandlerFactory factory = null;
                if (useLocal){
                    factory = new ListenersRecordHandlerFactory();
                    factory.init();
                }else {
                    factory = ListenersRecordHandlerFactory.getInstance();
                    if (doReload){
                        factory.reload();
                        factory = ListenersRecordHandlerFactory.getInstance();
                    }
                }


        		if (listenerId == null){
        			listenerId = "3";
        		}

        		GeneralListenerRecordHandler generalHandler = factory.getGeneralListenerRecordHandler("httpListener",listenerId);
        		 builder.append("general handler " + generalHandler +  " , useLocal = " + useLocal).append("\n<br>");;
        		if (generalHandler != null){
        			LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager("httpListenerVer1", LogsManager.getInstance().getLoadOnlineLbmRequest());
        			if (lbm != null){
        				generalHandler.setRecordMask(lbm.getRecordMask());
        				lbm.setAddOrigDataToResult(true);
        			}

        			generalHandler.init();

        			LogAdminHelper.updateLogDirectoryAndPattern(lbm,path,"{0}","{string}");
        			RecordsMaskTableModel model = lbm.getFirstEntries(linesNum);

        			String internalId =  ListenersManager.getInstance().getInternalListenerLbmId(listenerId);
        			LogNameExtractor logNameExtractor = LbmUtil.getLogNameExtractor(internalId);

        			builder.append("model = " + model.getRowCount()).append("\n<br>");
        			for (int i = 0; i < model.getRowCount();i++){
        				LogRecord rec = (LogRecord)model.getRecordAt(i);
        				builder.append("wrapper original data = " + rec.getOriginalData()).append("\n<br>");
        				ListenerLogRecordWrapper wrapper = generalHandler.transformRecord(rec,logNameExtractor);
        				if (wrapper != null){
        					builder.append("wrapper record data = " + rec).append("\n<br>");
        					builder.append("warpper  log name = " + wrapper.getLogName() +  " , host name = " + wrapper.getHost() +  " , appTags = " + wrapper.getAppTags()).append("\n<br>");
        					builder.append("warpper message = " + wrapper.getData()).append("\n<br>");
        					if (wrapper.getBuilderCreatorInfo() != null){
        						builder.append("wrapper path " + wrapper.getBuilderCreatorInfo().getXpologPath()).append("\n<br>");
        						builder.append("wrapper template  " + wrapper.getBuilderCreatorInfo().getTemplateId()).append("\n<br>");
        					}
        				}
        			}
        		}
        }catch (Exception e){
            //e.printStackTrace();
            builder.append("error:" + e.getMessage()).append("\n<br>");
        }

    }
%>

<html>

<head>
</script>
</head>

<body>
<p>
<%=builder.toString()%>
</p>
</body>

</html>
