<%@ page language="java" %>

<%@page import="xpolog.config.Configuration"%>
<%@page import="xpolog.eye.site.UserEnvironment"%>
<%@page import="xpolog.eye.util.ModuleMembersUtil"%>
<%@page import="xpolog.eye.LogsManager"%>
<%@page import="xpolog.eye.LbmRequest"%>
<%@page import="xpolog.eye.search.SearchUtil"%>
<%@page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@page import="xpolog.eye.ModuleMember"%>
<%@page import="xpolog.eye.SiteManagment"%>
<%@page import="xpolog.eye.error.ErrorModel"%>
<%@page import="xpolog.eye.site.UserContext"%>
<%@page import="xpolog.eye.security.WebSecurityManager"%>
<%@page import="xpolog.eye.data.store.log.LogDataStoreHelper"%>
<%@page import="xpolog.eye.data.store.log.LogDataStoreHelper.LogDataStatus"%>
<%@page import="xpolog.eye.data.store.XpologDataStoreManager"%>
<%@page import="xpolog.eye.data.store.file.DataManager"%>
<%@page import="xpolog.eye.data.store.file.DataManager.DataCommitsRequest"%>
<%@page import="xpolog.eye.XpoLogObjectTypes"%>
<%@page import="xpolog.eye.jobs.executers.XpoLogDataStoreMaintenanceJobExecuter"%>
<%@page import="xpolog.eye.common.JobStatus"%>
<%@page import="xpolog.eye.LogInfo"%>
<%@page import="com.xpolog.logcollection.system.LogCollectionPolicy"%>
<%@page import="com.xpolog.logcollection.storage.StoragePolicy"%>
<%@page import="com.xpolog.logcollection.system.LogCollectionSystemManager"%>
<%@page import="xpolog.eye.system.XpoLogSystemProcessInfo"%>
<%@page import="xpolog.eye.site.SystemUserConext"%>
<%@page import="xpolog.eye.system.XpoLogSystemMnager"%>
<%@page import="xpolog.eye.util.DateUtil"%>
<%@page import="xpolog.eye.audit.AuditConstants"%>
<%@page import="java.io.File"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Comparator"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.HashSet"%>
<%@page import="java.util.Collections"%>


<%!
SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss.SSS");

JobStatus status = null;
XpoLogSystemProcessInfo processInfo = null;

void addProcessInfo(UserContext context, JobStatus jobStatus, boolean writeAudit){
    if (context == null){
        context = SystemUserConext.getSystemUserContext();
    }
    String name = "Xpolog Data Store Maintenance";
    String id = XpoLogSystemMnager.getInstance().getNextId();
    String desc = "Xpolog Data Store Maintenance";
    processInfo = XpoLogSystemProcessInfo.createProcessInfo(AuditConstants.DATA_STORE,id,name,desc,null,context,jobStatus,null,null,null,null,null);
    if (processInfo != null){
        XpoLogSystemMnager.getInstance().addSystemProcess(processInfo,writeAudit);
    }
}

void removeProcessInfo(boolean writeAudit){
    if (processInfo != null){
        XpoLogSystemMnager.getInstance().removedSystemProcess(processInfo,writeAudit);
    }
    processInfo = null;
}

void deleteUnusableDataCommits(String lbmId){
    //new XpoLogDataStoreMaintenanceJobExecuter().jacob(lbmId);
    String dataDir = XpologDataStoreManager.getInstance().getXpologLogDataDirectory(lbmId);
    File directory = new File(dataDir);
    if (directory.exists()){
        DataManager dataManager = new DataManager(directory, lbmId, XpoLogObjectTypes.LOG_TYPE);
        DataCommitsRequest dataCommitsRequest = new DataCommitsRequest();
        dataCommitsRequest.setLoadLastCommitExtraData(false);
        dataCommitsRequest.setMaintenanceMode(true);
        try {
            dataManager.loadDataCommits(dataCommitsRequest);
            XpoLogDataStoreMaintenanceJobExecuter xpoLogDataStoreMaintenanceJobExecuter = new XpoLogDataStoreMaintenanceJobExecuter();
            LogInfo logInfo = LogsManager.getInstance().getLogInfo(lbmId);
            String logCollectionPolicyId = logInfo.getLogCollectionPolicyId();
            LogCollectionPolicy logCollectionPolicy = LogCollectionSystemManager.getInstance().getLogCollectionPolicy(logCollectionPolicyId);

            StoragePolicy storagePolicy = logCollectionPolicy.getStoragePolicy();
            if (storagePolicy != null) {
                int deleteFilesTimeUnitType = storagePolicy.getDeleteFilesTimeUnitType();
                long deleteFilesAge = storagePolicy.getDeleteFilesAge();
                if (deleteFilesTimeUnitType > 0 && deleteFilesAge > 0){
                    long minDataAge = DateUtil.getTimestampFromNow(String.valueOf(deleteFilesAge), deleteFilesTimeUnitType);
                    xpoLogDataStoreMaintenanceJobExecuter.deleteStaleData(logInfo, minDataAge, true, status);
                }
            }
        } catch (Exception e) {
            //log.error("Failed to load data commits for log " + " (" + lbmId + ")",e);
        }
    }
}

void updateStatusMsg(int i, int size, String msgPrefix, String logName, String lbmId, JobStatus status){
    try{
        double percent = (i * 100d)/(double)size;
        status.setCurrentPercent(percent);
        String msg = msgPrefix + " " + logName + " (" + lbmId + ") - ("+(int)percent+"%)";
        status.setCurrentStatus(msg);
    }
    catch(Exception e){
    }
}

Comparator logNameComp = new Comparator(){
	public int compare(Object o1, Object o2){
    if (o1 == o2) return 0;
    if (o2 == null) return 1;
    if (o1 == null) return -1;
		String logName1 = (String)o1;
		String logName2 = (String)o2;
		int index1 = logName1.indexOf("^");
		if (index1 != -1){
			logName1 = logName1.substring(0,index1);
		}
		int index2 = logName2.indexOf("^");
		if (index2 != -1){
			logName2 = logName2.substring(0,index2);
		}
		return logName1.toLowerCase().compareTo(logName2.toLowerCase());
  }
};
%>

<html>
<head>
<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">
<META HTTP-EQUIV="PRAGMA" CONTENT="NO-CACHE">
<META HTTP-EQUIV="EXPIRES" CONTENT="0">
<link rel="stylesheet" type="text/css" href="../../css/mainproduct.css?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>" />
<script type="text/javascript" src="../../scripts/UIUtil.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>
<script type="text/javascript" src="../../scripts/jquery/jquery.js?buildNumber=<%=Configuration.getInstance().getBuildNumber() %>"></script>

</head>
<body>
<table class="REGULARTEXT" style="border: 0; width: 100%; margin: 0; padding: 0">
<%

WebSecurityManager manager = WebSecurityManager.getInstance();
if (!manager.checkForPermission(request, response, null, true)) {
	return;
}
UserContext userContext = UserEnvironment.getUserContext(request);
String message = "";
ErrorModel errmod = null;
SiteManagment mgmt = SiteManagment.getInstance();
String errorLogs = null;

String query = request.getParameter("query");


HashSet<String> logsIds = new HashSet<String>();
ArrayList<String> logNames = new ArrayList<String>();


if (query == null || query.length() == 0){
	ModuleMember[] allLogs = mgmt.getAllLogBrowsersIds();
	if (allLogs != null){
		for (int i=0; i<allLogs.length; i++){
			String logNameId = allLogs[i].getName() + "^" + allLogs[i].getId();
			logNames.add(logNameId);
		}
		Collections.sort(logNames,logNameComp);
	}

}else{
	SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(userContext, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
	if(parseResponse == null) {
		if(errmod == null) {
			errmod = new ErrorModel();
		}
		errmod.addError("Failed to apply name pattern to logs");
	}else {
		if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
			if(errmod == null) {
				errmod = new ErrorModel();
			}
			errmod.addError("The specified logs to change don't exist");
		}else {
			HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
			if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
				if(errmod == null) {
					errmod = new ErrorModel();
				}
				errmod.addError("Failed to apply name pattern to logs");
			}else {
				logsIds.addAll(sourcesToQueries.keySet());
			}
		}
		if (logsIds != null && logsIds.size() > 0){
			Iterator<String> it = logsIds.iterator();
			while (it.hasNext()){
				String lbmId = it.next();
				try{
					ModuleMember mm = mgmt.getModuleMember(lbmId);
					if (mm != null){
						String logNameId = mm.getName() + "^" + mm.getId();
						logNames.add(logNameId);
					}
				}catch(Exception e){
					e.printStackTrace();
				}
			}
			Collections.sort(logNames,logNameComp);
		}
	}
}

if (logNames != null){
	String logNameAndId = null, lbmId = null, logName = null, logPath = null, dataStatusDesc = null, logErrorMessage = null;
	int n=0;
	try{
        status = new JobStatus();
        addProcessInfo(null, status, true);
        int size = logNames.size();
        for (int i=0; i<size; i++){
            logNameAndId = logNames.get(i);
            int index = logNameAndId.indexOf("^");
            if (index == -1){
                continue;
            }
            logName = logNameAndId.substring(0,index);
            lbmId = logNameAndId.substring(index+1);

            try{
                updateStatusMsg(i, size, "Starting step 1 of deleting stale data of", logName, lbmId, status);
                deleteUnusableDataCommits(lbmId);
            }
            catch(Exception e){
            }

            try{
                updateStatusMsg(i, size, "Starting step 2 of deleting stale data of", logName, lbmId, status);
                deleteUnusableDataCommits(lbmId);
            }
            catch(Exception e){
            }

            updateStatusMsg(i, size, "Deleted stale data of", logName, lbmId, status);

            n++;
            if (errorLogs == null){
                errorLogs = lbmId;
            }else{
                errorLogs += "," + lbmId;
            }
        }
    }
    finally{
        removeProcessInfo(true);
    }
}

%>
</table>
</body>
</html>