<%@ page language="java"%>
<%@ page import="xpolog.eye.*"%>
<%@ page import="xpolog.eye.admin.*"%>
<%@ page import="xpolog.eye.admin.builders.*"%>
<%@ page import="xpolog.eye.search.*"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.io.*"%>
<%@ page import="java.util.*"%>
<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.admin.builders.MergedLogBrowserBuilder"%>
<%@ page import="xpolog.eye.error.ErrorModel"%>
<%@ page import="xpolog.eye.security.*"%>
<%@ page import="xpolog.eye.util.hosts.*"%>
<%@ page import="xpolog.eye.util.*"%>
<%@ page import="xpolog.eye.media.remote.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.meta.*"%>
<%@ page import="xpolog.eye.remote.*"%>
<%@ page import="xpolog.eye.admin.helpers.*"%>
<%@ page import="org.w3c.dom.*"%>

<%!
static final String BASE_DIRECTORY = "../../";
%>
<%
	WebSecurityManager securityManager = WebSecurityManager.getInstance();
	if (!securityManager.checkForPermission(request, response, null, true)) {
		return;
	}

	String query = request.getParameter("query");
	boolean updateAppTags = request.getParameter("updateAppTags") != null && request.getParameter("updateAppTags").equalsIgnoreCase("true") ;
	boolean updateHost = request.getParameter("updateHost") != null && request.getParameter("updateHost").equalsIgnoreCase("true") ;
	boolean updateLogTypes = request.getParameter("updateLogTypes") != null && request.getParameter("updateLogTypes").equalsIgnoreCase("true") ;

    String msg = "Starting update remote logs meta";
    String result = "";
    %>
    <%=msg%>
    <%
        XpologFileLock xpologFileLock = null;
        SiteAdministrator admin = SiteManagment.getAdminInstance();
        try {
            if (Configuration.getInstance().isCluster()){
                xpologFileLock = admin.lockModules("update remote logs meta");
            }
        SiteManagment mgmt = SiteManagment.getInstance();
        List<String> logsIds = new ArrayList<String>();
            if (query == null || query.length() == 0) {
                ModuleMember[] allLogsModuleMembers = mgmt.getAllLogBrowsersIds();
                if (allLogsModuleMembers != null){
                    for (ModuleMember allLogsModuleMember : allLogsModuleMembers) {
                        logsIds.add(allLogsModuleMember.getId());
                    }
                }
            }else {
                SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(null, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
                ErrorModel errmod = null;
                if(parseResponse == null) {
                    if(errmod == null) {
                        errmod = new ErrorModel();
                    }
                    errmod.addError("Failed to apply name pattern to logs");
                }else {
                    if (parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
                        if (errmod == null) {
                            errmod = new ErrorModel();
                        }
                        errmod.addError("The specified logs to change don't exist");
                    } else {
                        HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
                        if (sourcesToQueries == null || sourcesToQueries.size() == 0) {
                            if (errmod == null) {
                                errmod = new ErrorModel();
                            }
                            errmod.addError("Failed to apply name pattern to logs");
                        } else {
                            logsIds.addAll(sourcesToQueries.keySet());
                        }
                    }
                }
            }

            StringBuilder outputBuilder = new StringBuilder();

            for (String logId : logsIds) {
                 try {
                    ModuleMember moduleMember = mgmt.getModuleMember(logId);


                    String lbmType = moduleMember.getLogType();
                    if (lbmType == null || (!lbmType.equals(RemoteLogBuilder.PROXY_LOG_TYPE) && !lbmType.equals(RemoteLogBuilder.REMOTE_LOG_TYPE))) {
                        continue;
                    }

                    LogBrowsingManager lbm = SiteManagment.getInstance().getLogBrowserManager(moduleMember.getId());
                    if (lbm == null) {
                        continue;
                    }

                     RemoteLogBuilder builder = (RemoteLogBuilder) LogBrowserBuilderFactory.getLogBroserBuilderByType("PROXY_LOG_TYPE");
                    if (builder == null) {
                        continue;
                    }

                     builder.setID(lbm.getId());
                    builder.setRemoteLogId(RemoteAdminHelper.getRemoteLogId(lbm));
                    String remoteAccountId = RemoteAdminHelper.getRemoteAccountId(lbm);
                    if (remoteAccountId == null || remoteAccountId.length() == 0) {
                        continue;
                    }



                    builder.setRemoteAccountId(remoteAccountId);
                    builder.setLogBrowserManager(lbm);


                    ProxyLogBrowser logBrowser = new ProxyLogBrowser();
                    logBrowser.setID(builder.getLogBrowserID());
                    logBrowser.setType(RemoteLogBuilder.PROXY_LOG_TYPE);
                    RemoteXplgAccount acc = (RemoteXplgAccount) AddressBook.getInstance().getAccountById(remoteAccountId);
                    boolean compressTraffic = true;
                    if (acc != null) {
                        compressTraffic = acc.isCompressTraffic();
                    }

                    LogBrowsingManager lbmFromRemote = null;
                    try {
                        String remoteXpoLogId = builder.getRemoteXpoLogId();
                        if (remoteAccountId != null && remoteAccountId.length() > 0) {
                            lbmFromRemote = logBrowser.getLbmFromRemote(remoteAccountId, builder.getRemoteLogId(), false);
                        } else if (remoteXpoLogId == null || remoteXpoLogId.length() == 0) {
                            lbmFromRemote = logBrowser.getLbmFromRemote(builder.getProtocol(), builder.getHostAddr(), builder.getPort(),
                                    builder.getRemoteContext(), builder.getRemoteLogId(), null, false, compressTraffic);
                        } else {
                            lbmFromRemote = logBrowser.getLbmFromRemote(remoteXpoLogId, builder.getRemoteLogId());
                        }
                    } catch (Exception e) {
                        ErrorModel.log.error("Failed to get remote log for " + logId, e);
                        lbmFromRemote = null;
                    }
                    if (lbmFromRemote == null){
                        continue;
                    }

                    outputBuilder.append(";update log " + lbmFromRemote.getName() + " - ");
                    String appTagsNames = null;
                    if (lbmFromRemote != null && lbmFromRemote.getAppTags() != null && lbmFromRemote.getAppTags().length() > 0) {
                        appTagsNames = lbmFromRemote.getAppTags();
                    }
                    if (updateAppTags && appTagsNames != null && appTagsNames.length() > 0) {
                        MetaData appTag = null;
                        String appTagId = null;
                        MetaDataManager metaMgr = SiteManagment.getInstance().getMetaDataMgr();
                        String[] apptagsArr = appTagsNames.split(",");
                        for (String appTagName : apptagsArr) {
                            appTag = metaMgr.getMetaDataByName(appTagName);
                            if (appTag == null) {
                                appTagId = XpologUtil.generateID(appTagName);
                                appTag = new MetaData();
                                appTag.setName(appTagName);
                                appTag.setId(appTagId);
                                metaMgr.saveMetaData(appTag);
                            } else {
                                appTagId = appTag.getId();
                            }

                            metaMgr.addXplgObjMetaData(XpoLogObjectTypes.LOG_TYPE, moduleMember.getId(), appTagId, true);
                          //  AuditManager.getInstance().write(new LogSystemAuditEvent(AuditConstants.BASIC_AUDIT_LEVEL, SystemUserConext.getSystemUserContext(), AuditConstants.CHANGE,"Logs", AuditConstants.LOGS, "Adding apptag to log from remote log, apptag: " + appTagId + " log: " + moduleMember.getId()));
                            outputBuilder.append(appTagId);
                            outputBuilder.append(" | ");
                            outputBuilder.append(moduleMember.getId());
                            outputBuilder.append("&");
                        }
                    }



                    if (updateLogTypes) {
                        String sourceTypes = lbmFromRemote.getSourceTypes();
                        lbm.setSourceTypes(sourceTypes);
                        lbm.setSourceTypesIds(lbmFromRemote.getSourceTypesIds());
                        lbm.setSourceTypesGroup(lbmFromRemote.getSourceTypesGroup());
                        outputBuilder.append("   ,   sourceTypes = " + sourceTypes +  " and " + lbmFromRemote.getSourceTypesIds());
                    }

                    if (updateHost) {
                        String remoteHost = HostsManager.getInstance().getHostFromRemoteAccount(lbmFromRemote, acc);
                        String oldHost = lbm.getHost();

                        lbm.setHost(remoteHost);
                        lbm.setCustomHost(true);
                        outputBuilder.append("   ,   from host = " + oldHost +  " to " + remoteHost);
                    }

                    SiteManagment.getAdminInstance().addLogBrowser(lbm);


                } catch (Throwable t) {
                    ErrorModel.log.error("Failed to update remote logs meta for log " + logId, t);
                }
            }

            result = outputBuilder.toString();
            //System.out.println("result before = " + result);
        } catch (Throwable t) {
           	ErrorModel.log.error("Failed to update remote logs meta", t);
        }finally {
            if (Configuration.getInstance().isCluster()){
                //admin.releaseLockModules(xpologFileLock);
            }
        }
        String[] outputArr = result.split(";");
        StringBuilder output = new StringBuilder();
        output.append("<br>");
        for (int i = 0; i < outputArr.length; i++){
            output.append(outputArr[i]);
            output.append("<br>");
        }

        output.append("<br>");
        output.append("Finish process");
        result = output.toString();
       // System.out.println("result = " + result);
%>

<%=result%>



