<%@ page language="java"%>

<%@ page import="java.util.HashMap"%>
<%@ page import="java.util.HashSet"%>

<%@ page import="xpolog.config.Configuration"%>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.SiteManagment"%>
<%@ page import="xpolog.eye.search.SearchQueryParseResponse"%>
<%@ page import="xpolog.eye.search.SearchUtil"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.UserEnvironment"%>
<%@ page import="xpolog.eye.site.UserContext"%>
<%@ page import="xpolog.eye.site.ui.grid.models.GridModelActionsHelper"%>
<%@ page import="xpolog.eye.site.ui.tree.ModuleMemberRenderer"%>

<%!
  static final String BASE_DIRECTORY = "../";
%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request, response, ActionsPermissionConstants.AdministrationPermissions.EDIT_LOG_PERMISSION, true,true)) {
		return;
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);

	boolean allowApplyTemplatePattern = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("allowApplyTemplatePattern", false);

	String message = "";
	ErrorModel errmod = null;
	if(allowApplyTemplatePattern) {
		String templateId = request.getParameter("templateId");
		String logsSelectionOption = request.getParameter("logsSelectionOption");
		if(logsSelectionOption != null) {
			HashSet<String> logsIds = new HashSet<String>();
	  	if(logsSelectionOption.equals("query")) {
				String query = request.getParameter("query");
				if(query == null || query.length() == 0) {
					if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError("Log name was not specified");
				}else {
					SearchQueryParseResponse parseResponse = SearchUtil.getSearchQueryParseResponse(userContext, xpolog.eye.search.SearchUtil.appendSourcesQueryPrefix(query,false));
					if(parseResponse == null) {
						if(errmod == null) {
							errmod = new ErrorModel();
						}
						errmod.addError("Failed to apply template to logs");
					}else {
						if(parseResponse.getErrorMessage() != null && parseResponse.getErrorMessage().length() > 0) {
							if(errmod == null) {
								errmod = new ErrorModel();
							}
							errmod.addError("The specified log name doesn't exist");
						}else {
							HashMap sourcesToQueries = parseResponse.getSourcesToQueries();
							if(sourcesToQueries == null || sourcesToQueries.size() == 0) {
								if(errmod == null) {
									errmod = new ErrorModel();
								}
								errmod.addError("Failed to apply template to logs");
							}else {
								logsIds.addAll(sourcesToQueries.keySet());
							}
						}
					}
				}
			}else {
				String modsStr = request.getParameter("mods");
				String logsStr = request.getParameter("logs");
			
				if(templateId == null || templateId.length() == 0) {
					if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError("No template was selected");
				}
				if((modsStr == null || modsStr.length() == 0) && (logsStr == null || logsStr.length() == 0)) {
					if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError("No logs were selected");
				}
				if(errmod == null || errmod.getErrorCount() == 0) {
					HashMap logs = new HashMap();
				  HashMap mods = new HashMap();
					String [] modsArr = null;
				  String modsList = request.getParameter("mods");
				  if (modsList != null && modsList.length() > 0){
				  	modsArr = modsList.split(",");
				  }
				  if (modsArr != null){
				    for (int i = 0;i< modsArr.length;i++){
				    	if (!modsArr[i].endsWith("*")){
				      	mods.put(modsArr[i],modsArr[i]);
				    	}
				    }
				  }
				  if (modsArr != null){
				    for (int i = 0;i< modsArr.length;i++){
				    	String id = modsArr[i];
				    	if (modsArr[i].endsWith("*")){
				     		id = id.substring(0,id.length()-1);
				     		ModuleMemberRenderer.addAllModuleChildren(id,mods,logs);
				     	}
				      mods.put(id,id);
				    }
				  }
				  String [] logsArr = null;
					if (logsStr != null && logsStr.length() > 0){
						logsArr = logsStr.split(",");
					}
					if(logsArr != null && logsArr.length > 0) {
						for(int i = 0; i < logsArr.length; i++) {
							logs.put(logsArr[i], logsArr[i]);
						}
					}
				  if(logs.size() == 0) {
				  	if(errmod == null) {
							errmod = new ErrorModel();
						}
						errmod.addError("No logs were selected");
				  }else {
				  	logsIds.addAll(logs.keySet());
				  }
				}
			}
	  	if(errmod == null || errmod.getErrorCount() == 0) {
	  		int numberOfLogsChanged = SiteManagment.getAdminInstance().applyTemplateToLogs(templateId, logsIds, userContext);
		  	if(numberOfLogsChanged <= 0) {
		  		if(errmod == null) {
						errmod = new ErrorModel();
					}
					errmod.addError("Failed to apply template to selected logs");
		  	}else {
		  		String logString = "logs";
		  		if(numberOfLogsChanged == 1) {
		  			logString = "log";
		  		}
		  		String selectedLogString = "logs";
		  		if(logsIds.size() == 1) {
		  			selectedLogString = "log";
		  		}
		  		message = "Template was applied successfully on " + numberOfLogsChanged + " " + logString + " out of " + logsIds.size() + " selected " + selectedLogString;
		  	}
	  	}
		}
	}else {
		errmod = new ErrorModel();
		errmod.addError("Operation is not allowed");
	}
	
	String xml = "";
	if (errmod != null && errmod.getErrorCount() > 0){
		//errors
		String[] errors = errmod.getErrors();
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<errors.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(errors[i]);
		}
		message = sb.toString();
		//params
		String[] params = errmod.getErrorParams();
		sb = new StringBuffer();
		for (int i=0; i<params.length; i++){
			if (sb.length() > 0){
				sb.append("*;*");
			}
			sb.append(params[i]);
		}
		String paramsList = sb.toString();
		xml = GridModelActionsHelper.getResultXML(false, message, paramsList);
  	//request.getSession().setAttribute(ERROR_OBJ,errmod);
  	//response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?okURL=monitor/monitorDefinition.jsp%3FuseSessionBuilder=true");
	}else{
		//response.sendRedirect("addopok.jsp?refreshMenu=true");
		xml = GridModelActionsHelper.getResultXML(true, message);
	}
	response.setContentType("text/xml");
	response.setHeader("Pragma-Control", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setHeader("Expires", "0");
	out.write(xml);
	out.flush();
%>