<%@page import="org.json.simple.JSONObject"%>
<%@page import="xpolog.eye.media.ext.ExternalMediasManager"%>
<%@ page language="java"%>

<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.ext.ExternalAccount"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.util.XpologUtil"%>

<%@ page import="java.util.Properties"%>
<%!
	static final String BASE_DIRECTORY = "../../../";
%>
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request, response, ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION, true,true)) {
		return;
	}
	
	UserContext userContext = UserEnvironment.getUserContext(request);
	String ERROR_OBJ = "ERROR_OBJ";
	
	String Name,Description,AccessKey,SecretKey,Id,AdditionalParams;
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	AccessKey = request.getParameter("ema_custom_accessKey");
	SecretKey = request.getParameter("ema_custom_secretKey");
	Id = request.getParameter("Id");
	AdditionalParams = request.getParameter("AdditionalParams");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
   	errmodel.addError("Name was not supplied");
   	if(isEmbeded){
   		errorMsg += "Name was not supplied<br>";
   	}
 	}
 	if(AccessKey == null || AccessKey.equals("")){
   	errmodel.addError("Access Key was not supplied");
   	if(isEmbeded){
   		errorMsg += "Access Key was not supplied<br>";
   	}
 	}
 	if(SecretKey == null || SecretKey.equals("")){
   	errmodel.addError("Secret Key was not supplied");
   	if(isEmbeded){
   		errorMsg += "Secret Key was not supplied<br>";
   	}
 	}
  	
	AddressBook adbok = AddressBook.getInstance();
	if (Id == null || Id.length() == 0){
		Account acc = adbok.getAccountByName(Name);
		if (acc instanceof ExternalAccount){
			errmodel.addError("Account name " + Name + " already exists. Please enter a different account name");
			if(isEmbeded){
	    	errorMsg += "Account name " + Name + " already exists. Please enter a different account name<br>";
	    }
		}
	}

	if(errmodel.getErrorCount() != 0){
		if(!isEmbeded){
	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
 	 		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
	 	}else{
			result += "error@#" + errorMsg;
			out.write(result);
			out.flush();
		}
  	return;
	}
	
	ExternalMediasManager externalMediasMgr = ExternalMediasManager.getInstance(); 
	ExternalAccount s3Acc = null;
	if(Id != null){
		s3Acc = (ExternalAccount)adbok.getAccountById(Id);
		
	}
	if(s3Acc == null){
		s3Acc = externalMediasMgr.createExternalAccount("s3");
	}
	
	s3Acc.setAccountName(Name);
	s3Acc.setDescription(Description);
	JSONObject configuration = new JSONObject();
	configuration.put("accessKey", AccessKey);
	configuration.put("secretKey", SecretKey);
	s3Acc.setConfiguration(configuration);
	Properties paramsProp = XpologUtil.getPropertiesFromString(AdditionalParams);
	s3Acc.setParameters(paramsProp);
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errorMsg.length() == 0){
			Media med = MediaManager.newInstance().getMediaByAccount(s3Acc);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  try {
				verified = med.verify(s3Acc);
			  if (!verified){
			  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
			  }else{
			  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occurred during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		adbok.addAccount(s3Acc,userContext);
		adbok.saveAddressBook();
		
		if(!isEmbeded) {
			request.getSession().setAttribute("lastSelectedAccount",s3Acc.getId());
		}
		
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit hdfs account " + Name);
	}
	
	if (!adbok.validateMaxHosts()){
		errmodel.addError(AddressBook.MAX_DATA_SOURCES_WARN_MSG);
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
  	return;
	}
	
	if(isEmbeded){
		response.setContentType("text/html");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "hdfs@#";
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			result += s3Acc.getAccountName() + "@#";
			result += s3Acc.getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
		String forwardURL = request.getParameter("forwardURL");
		if (forwardURL != null && forwardURL.length() > 0){
			response.sendRedirect(BASE_DIRECTORY + forwardURL);
		}else{
			response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=hdfs");
		}
	}
%>

