<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.gae.*"%>
<%@ page import="xpolog.eye.scheduler.AccountJob"%>
<%@ page import="xpolog.eye.scheduler.XpoScheduledOperation"%>
<%@ page import="xpolog.eye.scheduler.XpoJobDetails"%>
<%@ page import="xpolog.eye.scheduler.ui.SchedulerHelper"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.util.DateUtil"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%> 
<%
	if (!WebSecurityManager.getInstance().checkForPermission(request, response, ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION, true,true)) {
		return;
	}
	
	String ERROR_OBJ = "ERROR_OBJ";
	UserContext userContext = UserEnvironment.getUserContext(request);

	String Name,Description,Email,Pwd,Id;
	String forwardURL = request.getParameter("forwardURL");
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Email = request.getParameter("Email");
	Pwd = request.getParameter("Pwd");
	Id = request.getParameter("Id");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
  	errmodel.addError("Name was not supplied");
    if(isEmbeded){
    	errorMsg += "Name was not supplied<br>";
    }
  }
  if(Email == null || Email.equals("")){
   	errmodel.addError("Email was not supplied");
   	errorMsg += "Email was not supplied<br>";
	}
  if(Pwd == null || Pwd.equals("")){
   	errmodel.addError("Password was not supplied");
   	errorMsg += "Password was not supplied<br>";
	}
  
  GAEAccount ftac = null;
	AddressBook adbok = AddressBook.getInstance();
	if(Id != null){
		ftac = (GAEAccount)adbok.getAccountById(Id);
	}
	if(ftac == null){
		ftac = new GAEAccount();
	}
	
  
  /*XpoScheduledOperation schedOp = SchedulerHelper.getAccountScheduledOperation(request,"AccountScheduler",errmodel);
	if(errmodel.getErrorCount() == 0) {
		if (schedOp != null){
			if (schedOp.getDetails() != null){
				XpoJobDetails det = schedOp.getDetails();
				AccountJob job = (AccountJob)det.getXpoJob();
				job.setAccountId(ftac.getId());
				job.setTaskClassKey("xpolog.eye.automation.tasks.cloud.GAEAccountTask");
	  	}
			ftac.setSchedOp(schedOp);
		}else{
			ftac.setSchedOp(null);
		}
	}*/
	
	if (Id == null || Id.length() == 0){
		Account acc = adbok.getAccountByName(Name);
		if (acc instanceof GAEAccount){
			errmodel.addError("Account name " + Name + " already exists. Please enter a different account name");
			if(isEmbeded){
	    	errorMsg += "Account name " + Name + " already exists. Please enter a different account name<br>";
	    }
		}
	}

 	if(errmodel.getErrorCount() != 0){
		if(!isEmbeded){
	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
	 		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
	 	}else{
			result += "error@#" + errorMsg;
			out.write(result);
			out.flush();
		}
  	return;
	}
	
	ftac.setAccountName(Name);
	if (Pwd != null && Pwd.length()>0) {
		ftac.setPassword(Pwd);
	}else {
		ftac.setPassword("");
	}
	
	ftac.setEmail(Email);
	ftac.setDescription(Description);
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errorMsg.length() == 0){
			Media med = MediaManager.newInstance().getMediaByAccount(ftac);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  try {
			  verified = med.verify(ftac);
			  if (!verified){
			  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
			  }else{
			  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occurred during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		adbok.addAccount(ftac,userContext);
		
		if(!isEmbeded) {
			request.getSession().setAttribute("lastSelectedAccount",ftac.getId());
		}
		
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit gae account " + Name);
	}
	
	if (!adbok.validateMaxHosts()){
		errmodel.addError(AddressBook.MAX_DATA_SOURCES_WARN_MSG);
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
  	return;
	}
	
	if(isEmbeded){
		response.setContentType("text/html");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "gae@#";
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			String name = ftac.getAccountName();
			if(!ftac.isEnabled()) {
				name += " (disabled)";
			}
			result += name + "@#";
			result += ftac.getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
			forwardURL = request.getParameter("forwardURL");
			if (forwardURL != null && !forwardURL.startsWith("http")){
				forwardURL = BASE_DIRECTORY + forwardURL;
			}
			if (forwardURL != null){
				forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&") + "accountId=" + ftac.getId();
				response.sendRedirect(forwardURL);
			}else{
				response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=gae");
			}
	}
%>

