<%@ page language="java"%>

<%@ page import="xpolog.config.*"%>
<%@ page import="xpolog.eye.audit.*" %>
<%@ page import="xpolog.eye.error.*"%>
<%@ page import="xpolog.eye.media.*"%>
<%@ page import="xpolog.eye.media.telsh.*"%>
<%@ page import="xpolog.eye.security.ActionsPermissionConstants"%>
<%@ page import="xpolog.eye.security.WebSecurityManager"%>
<%@ page import="xpolog.eye.site.*" %>
<%@ page import="xpolog.eye.util.DateUtil"%>
<%@ page import="xpolog.eye.util.hosts.HostsManager"%>
<%@ page import="xpolog.eye.util.hosts.UpdateHostInfoRequest"%>

<%!
	static final String BASE_DIRECTORY = "../../../";
%>

<%@ include file="../accountCloudSettingsAction.jsp"%>

<%
	if (!WebSecurityManager.getInstance().checkForPermission(request, response, ActionsPermissionConstants.DataSupportPermissions.ADDRESS_BOOK_PERMISSION, true,true)) {
		return;
	}
	
	String ERROR_OBJ = "ERROR_OBJ";
	UserContext userContext = UserEnvironment.getUserContext(request);

	String Name,Description,Url,Port,User,Pwd,Id,conType,privateKeyPath,adminEmail;
	String forwardURL = request.getParameter("forwardURL");
	
	String actionType = request.getParameter("ACTION_TYPE");
	if(actionType == null || actionType.length() == 0 ){
		actionType = "save";
	}
	String verifyBeforeSaveStr = request.getParameter("verifyBeforeSave");
	boolean verifyBeforeSave = verifyBeforeSaveStr != null && verifyBeforeSaveStr.equals("true");
	String verifyMsg = "";
	String errorMsg = "";
	String result = "";
	String isEmbededStr = request.getParameter("isEmbeded");
	boolean isEmbeded = isEmbededStr != null && isEmbededStr.equals("true");
	
	Name = request.getParameter("Name");
	Description = request.getParameter("Description");
	Url = request.getParameter("Url");
	Port = request.getParameter("Port");
	User = request.getParameter("User");
	Pwd = request.getParameter("Pwd");
	Id = request.getParameter("Id");
	conType = request.getParameter("conType");
	privateKeyPath = request.getParameter("privateKeyPath");
	if (privateKeyPath == null){
		privateKeyPath = "";
	}
	boolean isPublicKey = privateKeyPath.length() > 0;
	
	String useCert = request.getParameter("useCert");
	boolean showX509 = Configuration.getInstance().getPropertiesManager().getPropertyAsBoolean("media.ssh.ext.x509.show",false);
	adminEmail = request.getParameter("adminEmail");
	String enabledStr = request.getParameter("enabled");
	boolean enabled = enabledStr != null && enabledStr.equals("true");
	
	ErrorModel errmodel = new ErrorModel(); 
	if(Name == null || Name.equals("")){
  	errmodel.addError("Name was not supplied");
    if(isEmbeded){
    	errorMsg += "Name was not supplied<br>";
    }
  }
  if(Url == null || Url.equals("")){
   	errmodel.addError("Host address was not supplied");
  	errorMsg += "Host address was not supplied<br>";
  }
  int port = -1;
	if(Port == null || Port.trim().equals("")){
   	errmodel.addError("Port number was not supplied");
   	errorMsg += "Port number was not supplied<br>";
  }else {
  	try{
  		port = Integer.parseInt(Port);
  	}catch(NumberFormatException e){
    	errmodel.addError("Port must be a valid number");
    	errorMsg += "Port must be a valid number<br>";		
  	}
  }
	if(User == null || User.equals("")){
   	errmodel.addError("Username was not supplied");
   	errorMsg += "Username was not supplied<br>";
	}
	 if (showX509){
   	if((Pwd == null || Pwd.trim().equals("")) && (useCert == null)){
     	errmodel.addError("Please enter a Password or use a Certificate");
    }
	}else {
	 	if(!isPublicKey && (Pwd == null || Pwd.trim().equals(""))){
     	errmodel.addError("Password was not supplied");
     	errorMsg += "Password was not supplied<br>";
    }
	}
	
	//account policy
	String accountPolicyType = request.getParameter("accountPolicyType");
	boolean isDefaultAccountPolicyType = isEmbeded || (accountPolicyType != null && accountPolicyType.equals("default"));
	long sshPoolTimeoutIntervalValue = 0, sshPoolTimeoutInterval = 0, sshSessionTimeoutInterval = 0, sshPooledSessionTimeoutIntervalValue = 0, sshPooledSessionTimeoutInterval = 0 , agentForwardTimeout =  -1;
	String sshPoolTimeoutIntervalValueType = "", sshSessionTimeoutIntervalValueType = "", sshPooledSessionTimeoutIntervalValueType = "";
	int sshMaxConnections = 0, sshMaxSessionsPerConnection = 0, sshPooledSessions = 0,agentForwardPort = -1;
	String sshPoolTimeoutIntervalStr = request.getParameter("sshPoolTimeoutInterval");
	sshPoolTimeoutIntervalValueType = request.getParameter("sshPoolTimeoutIntervalValueType");
	if(sshPoolTimeoutIntervalStr != null && sshPoolTimeoutIntervalStr.length() > 0) {
		try{
			sshPoolTimeoutIntervalValue = Integer.parseInt(sshPoolTimeoutIntervalStr);
			if(sshPoolTimeoutIntervalValue == -1) {
				sshPoolTimeoutInterval = -1;
			}else {
				if(sshPoolTimeoutIntervalValueType.equals("min")) {
					sshPoolTimeoutInterval = sshPoolTimeoutIntervalValue * 1000 * 60;
				}else if(sshPoolTimeoutIntervalValueType.equals("hour")) {
					sshPoolTimeoutInterval = sshPoolTimeoutIntervalValue * 1000 * 60 * 60;
				}
			}
			if(sshPoolTimeoutInterval < 1 && sshPoolTimeoutIntervalValue != TelnetAccountPolicy.IMMEDIATE_TIMEOUT_INTERVAL) {
				errmodel.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
			}
		}catch(Exception e){
			errmodel.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
		}
	}else if(!isEmbeded && !isDefaultAccountPolicyType) {
		errmodel.addError("Wrong connection pool timeout interval entered. Value must be a positive number");
	}
	String sshSessionTimeoutIntervalStr = request.getParameter("sshSessionTimeoutInterval");
	sshSessionTimeoutIntervalValueType = request.getParameter("sshSessionTimeoutIntervalValueType");
	if(sshSessionTimeoutIntervalStr != null && sshSessionTimeoutIntervalStr.length() > 0) {
		long minimumSessionTimeoutInterval = TelShActivityManager.MINIMUM_SESSION_TIMEOUT_INTERVAL;
		try{
			sshSessionTimeoutInterval = Integer.parseInt(sshSessionTimeoutIntervalStr);
			if(sshSessionTimeoutInterval != -1) {
				if(sshSessionTimeoutIntervalValueType.equals("min")) {
					sshSessionTimeoutInterval = sshSessionTimeoutInterval * 1000 * 60;
				}else if(sshSessionTimeoutIntervalValueType.equals("hour")) {
					sshSessionTimeoutInterval = sshSessionTimeoutInterval * 1000 * 60 * 60;
				}
			}
			if(sshSessionTimeoutInterval != -1 && sshSessionTimeoutInterval < minimumSessionTimeoutInterval) {
				errmodel.addError("Wrong session timeout interval entered. Minimum value is " + DateUtil.formatTime(minimumSessionTimeoutInterval) + ", leave blank for no limit");
			}
		}catch(Exception e){
			errmodel.addError("Wrong session timeout interval entered. Minimum value is " + DateUtil.formatTime(minimumSessionTimeoutInterval) + ", leave blank for no limit");
		}
	}else {
		sshSessionTimeoutInterval = -1;
	}
	String sshMaxConnectionsStr = request.getParameter("sshMaxConnections");
	if(sshMaxConnectionsStr != null && sshMaxConnectionsStr.length() > 0) {
		try{
			sshMaxConnections = Integer.parseInt(sshMaxConnectionsStr);
			if(sshMaxConnections != -1 && sshMaxConnections < 1) {
				errmodel.addError("Wrong number of connections allowed to remote machine entered. Value must be a positive number, leave blank for no limit");
			}
		}catch(Exception e){
			errmodel.addError("Wrong number of connections allowed to remote machine entered. Value must be a positive number, leave blank for no limit");
		}
	}else {
		sshMaxConnections = -1;
	}
	String sshMaxSessionsPerConnectionStr = request.getParameter("sshMaxSessionsPerConnection");
	if(sshMaxSessionsPerConnectionStr != null && sshMaxSessionsPerConnectionStr.length() > 0) {
		try{
			sshMaxSessionsPerConnection = Integer.parseInt(sshMaxSessionsPerConnectionStr);
			if(sshMaxSessionsPerConnection < 2 || sshMaxSessionsPerConnection > 7) {
				errmodel.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
			}
		}catch(Exception e){
			errmodel.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
		}
	}else if(!isEmbeded && !isDefaultAccountPolicyType) {
		errmodel.addError("Wrong number of sessions allowed per connection entered. Value must be a number between 2 and 7");
	}
	String sshPooledSessionsStr = request.getParameter("sshPooledSessions");
	if(sshPooledSessionsStr != null && sshPooledSessionsStr.length() > 0) {
		try{
			sshPooledSessions = Integer.parseInt(sshPooledSessionsStr);
			if(sshPooledSessions != -1 && sshPooledSessions < 1) {
				errmodel.addError("Wrong number of pooled sessions allowed entered. Value must be a positive number, leave blank to disable session pooling");
			}
		}catch(Exception e){
			errmodel.addError("Wrong number of pooled sessions allowed entered. Value must be a positive number, leave blank to disable session pooling");
		}
	}else {
		sshPooledSessions = -1;
	}
	if(sshPooledSessions > 0) {
		String sshPooledSessionTimeoutIntervalStr = request.getParameter("sshPooledSessionTimeoutInterval");
		sshPooledSessionTimeoutIntervalValueType = request.getParameter("sshPooledSessionTimeoutIntervalValueType");
		if(sshPooledSessionTimeoutIntervalStr != null && sshPooledSessionTimeoutIntervalStr.length() > 0) {
			try{
				sshPooledSessionTimeoutInterval = Integer.parseInt(sshPooledSessionTimeoutIntervalStr);
				if(sshPooledSessionTimeoutInterval != -1) {
					if(sshPooledSessionTimeoutIntervalValueType.equals("min")) {
						sshPooledSessionTimeoutInterval = sshPooledSessionTimeoutInterval * 1000 * 60;
					}else if(sshPooledSessionTimeoutIntervalValueType.equals("hour")) {
						sshPooledSessionTimeoutInterval = sshPooledSessionTimeoutInterval * 1000 * 60 * 60;
					}
				}
			}catch(Exception e){
				errmodel.addError("Wrong pooled session timeout interval entered. Minimum value is 1 minute, leave blank for no limit");
			}
		}else {
			sshPooledSessionTimeoutInterval = -1;
		}
		if(sshPooledSessionTimeoutInterval < -1) {
			errmodel.addError("Wrong pooled session timeout interval entered. Minimum value is 1 minute, leave blank for no limit");
		}
	}else {
		sshPooledSessionTimeoutInterval = -1;
	}
  
	String agentForwardPortStr = request.getParameter("sshAgentForwardPort");
	if(agentForwardPortStr != null && agentForwardPortStr.length() > 0) {
		try{
			agentForwardPort = Integer.parseInt(agentForwardPortStr);
			if(agentForwardPort < 1) {
				errmodel.addError("Wrong LogAway Agent forwarding port. Value must be a positive number, leave blank to disable port forwarding");
			}
		}catch(Exception e){
			errmodel.addError("Wrong LogAway Agent forwarding port. Value must be a positive number, leave blank to disable port forwarding");
		}
	}else {
		agentForwardPort = -1;
	}
  
	String agentForwardTimeoutStr = request.getParameter("sshAgentForwardTimeout");
	if(agentForwardTimeoutStr != null && agentForwardTimeoutStr.length() > 0) {
		try{
			agentForwardTimeout = Integer.parseInt(agentForwardTimeoutStr);
			if(agentForwardTimeout < 1) {
				errmodel.addError("Wrong LogAway Agent timeout. Value must be a positive number");
			}else {
        String type = request.getParameter("sshAgentForwardTimeoutValueType");
        if (type != null){
          if (type.equals("hour")){
        	  agentForwardTimeout = agentForwardTimeout * 1000 * 60 * 60;
          }else if (type.equals("min")){
            agentForwardTimeout = agentForwardTimeout * 1000 * 60;
          } else if (type.equals("sec")){
            agentForwardTimeout = agentForwardTimeout * 1000;
          }
        }
      }
		}catch(Exception e){
			errmodel.addError("Wrong LogAway Agent timeout. Value must be a positive number");
		}
	}else if (!isEmbeded && !isDefaultAccountPolicyType){
		errmodel.addError("Wrong LogAway Agent timeout. Value must be a positive number");
	}
  
	AddressBook adbok = AddressBook.getInstance();
	if (Id == null || Id.length() == 0){
		Account acc = adbok.getAccountByName(Name);
		if (acc instanceof TelnetAccount){
			errmodel.addError("Account name " + Name + " already exists. Please enter a different account name");
			if(isEmbeded){
	    	errorMsg += "Account name " + Name + " already exists. Please enter a different account name<br>";
	    }
		}
	}
	
	String[] cloudSettings = getCloudSettings(request, errmodel);
	
 	if(errmodel.getErrorCount() != 0){
		if(!isEmbeded){
	 		request.getSession().setAttribute(ERROR_OBJ,errmodel);
	 		response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp?cancelURL=tools/addresses/addressview.jsp");
	 	}else{
			result += "error@#" + errorMsg;
			out.write(result);
			out.flush();
		}
  	return;
	}
	
	TelnetAccount ftac = null;
	if(Id != null){
		ftac = (TelnetAccount)adbok.getAccountById(Id);
	}
	if(ftac == null){
		ftac = new TelnetAccount();
	}
	
	ftac.setAccountName(Name);
	ftac.setNetAddress(Url);
	if (Pwd != null && Pwd.length()>0) {
		ftac.setPassword(Pwd);
	}else {
		ftac.setPassword("");
	}
	
	
	ftac.setPort(port);
	ftac.setUserName(User);
	ftac.setDescription(Description);
	ftac.setPrivateKeyPath(privateKeyPath);
	ftac.setPublicKey(isPublicKey);
	if(!isEmbeded) {
		TelnetAccountPolicy telnetAccountPolicy = (TelnetAccountPolicy)ftac.getAccountPolicy();
		if(!isDefaultAccountPolicyType) {
			if(telnetAccountPolicy == null) {
				telnetAccountPolicy = new TelnetAccountPolicy();
			}
			telnetAccountPolicy.setDefault(false);
			if(sshPoolTimeoutInterval != 0) {
				telnetAccountPolicy.setPoolTimeoutInterval(sshPoolTimeoutInterval);
				telnetAccountPolicy.setPoolTimeoutIntervalValueType(sshPoolTimeoutIntervalValueType);
			}
			if(sshSessionTimeoutInterval != 0) {
				telnetAccountPolicy.setSessionTimeoutInterval(sshSessionTimeoutInterval);
				telnetAccountPolicy.setSessionTimeoutIntervalValueType(sshSessionTimeoutIntervalValueType);
			}
			if(sshMaxConnections != 0) {
				telnetAccountPolicy.setMaxConnections(sshMaxConnections);
			}
			if(sshMaxSessionsPerConnection != 0) {
				telnetAccountPolicy.setMaxSessionsPerConnection(sshMaxSessionsPerConnection);
			}
			if(sshPooledSessions != 0) {
				telnetAccountPolicy.setPooledSessions(sshPooledSessions);
			}
			telnetAccountPolicy.setPooledSessionTimeoutInterval(sshPooledSessionTimeoutInterval);
			telnetAccountPolicy.setPooledSessionTimeoutIntervalValueType(sshPooledSessionTimeoutIntervalValueType);
      
			telnetAccountPolicy.setAgentForwardPort(agentForwardPort);
			telnetAccountPolicy.setAgentForwardTimeout(agentForwardTimeout);
			ftac.setAccountPolicy(telnetAccountPolicy);
		}else {
			ftac.setAccountPolicy(null);
		}
	}
	
	if(conType != null){
		ftac.setTypeOfConnecion(TelnetAccount.TYPE_SCP);
	}else if(!isEmbeded){
		ftac.setTypeOfConnecion(TelnetAccount.TYPE_SFTP);
	}
	if(useCert != null){
		ftac.setCertificate(true);
		//media to use in case of cert connection.
		ftac.setMediaClass("xpolog.eye.media.telsh.X509TelShManager");
	}else{
		ftac.setCertificate(false);
		ftac.setCertificateId("");
		ftac.setMediaClass(null);
	}
	ftac.setAdminEmail(adminEmail);
	ftac.setEnabled(enabled);
	
	if(cloudSettings != null) {
		String cloudAccountType = cloudSettings[0];
		String cloudAccountId = cloudSettings[1];
		String cloudRegion = cloudSettings[2];
		if(cloudRegion != null && cloudRegion.length() == 0) {
			cloudRegion = null;
		}
		String cloudInstanceId = cloudSettings[3];
		ftac.setCloudAccountType(cloudAccountType);
		ftac.setCloudAccountId(cloudAccountId);
		ftac.setCloudRegion(cloudRegion);
		ftac.setCloudInstanceId(cloudInstanceId);
		
	}
	
	boolean verified = false;
	if(actionType.equals("verify") || verifyBeforeSave){
		if(errorMsg.length() == 0){
			Media med = MediaManager.newInstance().getMediaByAccount(ftac);
		  if (med instanceof AbstractMedia){
		    ((AbstractMedia)med).setLogEnabled(false);
		  }
		  try {
			  verified = med.verify(ftac);
			  if (!verified){
			  	verifyMsg = "<span style=\"font-size:11;color: red;\">Verification failed. Please verify your account's info</span>";
			  }else{
			  	verifyMsg = "<span style=\"font-size:11;color: green;\">Verification OK</span>";
			  }
		  }catch(Throwable t) {
		  	verifyMsg = "An error occurred during verification: " + t.getMessage();
		  }
		}
	}
	
	if((!verifyBeforeSave || verified) && !actionType.equals("verify")){
		AccountAdministrationRequest accountAdminRequest = new AccountAdministrationRequest(ftac,userContext);
		adbok.addAccount(accountAdminRequest);
		
		if(!isEmbeded) {
			request.getSession().setAttribute("lastSelectedAccount",ftac.getId());
		}
		
		TelShMediaPoolManager.getInstance().updatePool(ftac);
		//	audit
		AuditManager.getInstance().write(AuditConstants.BASIC_AUDIT_LEVEL,
			  			userContext, AuditConstants.CHANGE, "add/edit account", AuditConstants.CONFIGURATION, "add/edit ssh account " + Name);
	}
	
	if (!adbok.validateMaxHosts()){
		errmodel.addError(AddressBook.MAX_DATA_SOURCES_WARN_MSG);
		request.getSession().setAttribute(ERROR_OBJ,errmodel);
  	response.sendRedirect(BASE_DIRECTORY + "common/errorpage.jsp");
  	return;
	}
	
	if(isEmbeded){
		response.setContentType("text/html");
		//result: action type + acc type + action result status + 
		//        error msg OR new acc name + new acc Id
		result += "ok@#";
		result += "ssh@#";
		result += actionType + "@#";
		if(actionType.equals("verify")){
			result += verifyMsg;
		}else{
			String name = ftac.getAccountName();
			if(!ftac.isEnabled()) {
				name += " (disabled)";
			}
			result += name + "@#";
			result += ftac.getId() + "@#";
			result += Id != null && Id.length() > 0 ? "edit" : "new";
			if(verifyBeforeSave) {
				result += "@#" + verified;
			}
		}
		out.write(result);
		out.flush();
	}else{
			forwardURL = request.getParameter("forwardURL");
			if (forwardURL != null && !forwardURL.startsWith("http")){
				forwardURL = BASE_DIRECTORY + forwardURL;
			}
			if (forwardURL != null){
				forwardURL += (forwardURL.indexOf("?") == -1 ? "?" : "&") + "accountId=" + ftac.getId();
				response.sendRedirect(forwardURL);
			}else{
				response.sendRedirect(BASE_DIRECTORY + "tools/addresses/addressview.jsp?addressType=ssh");
			}
	}
%>

