/*
    To add new data flow pattern color add new 'type' to types Array in DATA_FLOW_COLORS Object
    or create new color group in DATA_FLOW_COLORS Object
*/

const GREEN_COLOR = '#EBF2E4';
const GREEN_COLOR_HOVER = '#DBEACC';

const CYAN_COLOR = '#C1FFFF';
const CYAN_COLOR_HOVER = '#B6EFEF';

const BLUE_COLOR = '#D6E7F1';
const BLUE_COLOR_HOVER = '#C3D8E5';

const RED_COLOR = '#FEE9E9';
const RED_COLOR_HOVER = '#F5DCDC';

export const DATA_FLOW_COLORS_DEFAULT: {color: string, hoverColor: string} = {
    color: BLUE_COLOR,
    hoverColor: BLUE_COLOR_HOVER
};

export const DATA_FLOW_COLORS: Array<{color: string, hoverColor: string, types: Array<string>}> = [
    {
        color: GREEN_COLOR,
        hoverColor: GREEN_COLOR_HOVER,
        types: ['sourceId']
    },
    {
        color: CYAN_COLOR,
        hoverColor: CYAN_COLOR_HOVER,
        types: ['query', 'sourceQuery']
    },
    {
        color: BLUE_COLOR,
        hoverColor: BLUE_COLOR_HOVER,
        types: ['json', 'delimited', 'csv', 'format', 'filebeatceftrans', 'qradartrans', 'replace', 'rawData']
    },
    {
        color: RED_COLOR,
        hoverColor: RED_COLOR_HOVER,
        types: ['recordMask', 'columnsCustomizations']
    }
];
