<%@ page import="java.net.*" %>
<%@ page import="javax.net.ssl.*" %>
<%@ page import="java.net.http.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.security.cert.*" %>
<%@ page import="org.json.simple.*" %>
<%@ page import="java.util.regex.*" %>

<%!

SSLContext createTrustAllSSLContext() throws Exception {
   TrustManager[] trustAllCerts = new TrustManager[]{new X509ExtendedTrustManager() {
           @Override
           		public void checkClientTrusted(X509Certificate[] chain, String authType, Socket socket) throws CertificateException {

           		}

           		@Override
           		public void checkServerTrusted(X509Certificate[] chain, String authType, Socket socket) throws CertificateException {

           		}

           		@Override
           		public void checkClientTrusted(X509Certificate[] chain, String authType, SSLEngine engine) throws CertificateException {

           		}

           		@Override
           		public void checkServerTrusted(X509Certificate[] chain, String authType, SSLEngine engine) throws CertificateException {

           		}

           		@Override
           		public java.security.cert.X509Certificate[] getAcceptedIssuers() {
           			return new java.security.cert.X509Certificate[0];
           		}

           		@Override
           		public void checkClientTrusted(X509Certificate[] chain, String authType) throws CertificateException {

           		}

           		@Override
           		public void checkServerTrusted(java.security.cert.X509Certificate[] chain, String authType) throws CertificateException {
           			// empty method
           		}
       }};
       SSLContext sc = SSLContext.getInstance("SSL");
       sc.init(null, trustAllCerts, new java.security.SecureRandom());
       return sc;
}

ProxySelector createProxySelector(final Proxy proxy){
     ProxySelector selector = new ProxySelector() {

          @Override
          public List<Proxy> select(URI uri) {
              return Collections.singletonList(proxy);
          }


          @Override
          public void connectFailed(URI uri, SocketAddress sa, IOException ioe){

          }
    };
    return selector;
}

HttpClient createHttpClient()throws Exception {
    return HttpClient.newBuilder().sslContext(createTrustAllSSLContext()).build();

}

HttpClient createHttpClient(Proxy proxy)throws Exception {
    return HttpClient.newBuilder().sslContext(createTrustAllSSLContext()).proxy(createProxySelector(proxy)).build();

}

HttpClient createHttpsClient()throws Exception {
    Properties props = System.getProperties();
    props.setProperty("jdk.internal.httpclient.disableHostnameVerification", Boolean.TRUE.toString());
    return HttpClient.newBuilder().sslContext(createTrustAllSSLContext()).build();
}

HttpClient createHttpsClient(Proxy proxy)throws Exception {
    Properties props = System.getProperties();
    props.setProperty("jdk.internal.httpclient.disableHostnameVerification", Boolean.TRUE.toString());
    return HttpClient.newBuilder().sslContext(createTrustAllSSLContext()).proxy(createProxySelector(proxy)).build();
}


String buildErrorResult(String message,Exception e,int errorCode){
    JSONObject result = new JSONObject();
    JSONObject error = new JSONObject();
    error.put("errorCode",errorCode);
    String msg = message;
    if (e != null && msg != null && msg.length() > 0){
        msg = msg + ", cause: " + e.getMessage();
    }else if (e != null){
        msg = e.getMessage();
    }
    if (msg == null){
      msg = "";
    }
    error.put("errorMessage",msg);

    StringWriter sw = new StringWriter();
    if (e != null){
        PrintWriter pw = new PrintWriter(sw);
        e.printStackTrace(pw);
    }
    String stackTrace = sw.toString();
    error.put("errorTrace",stackTrace);

    result.put("error",error);

    return result.toString();
}

String buildErrorResult(String message,Exception e){
    return buildErrorResult(message,e,500);
}


void logError(String message, Exception e){
    new xpolog.eye.plugin.log.PluginLogger(this.getClass().getName()).error(message,e);
}

void logInfo(String message, Exception e){
    new xpolog.eye.plugin.log.PluginLogger(this.getClass().getName()).info(message,e);
}

void logDebug(String message, Exception e){
    new xpolog.eye.plugin.log.PluginLogger(this.getClass().getName()).debug(message,e);
}

Set<String> getCurrentNodeStrAddresses(){
    Set<String> addresses = new HashSet<>();
    try {
        Enumeration<NetworkInterface> interfaces = NetworkInterface.getNetworkInterfaces();

        while (interfaces.hasMoreElements()) {
            NetworkInterface networkInterface = interfaces.nextElement();
            if (networkInterface.isLoopback() || !networkInterface.isUp()) {
                continue;
            }

            Enumeration<InetAddress> inetAddresses = networkInterface.getInetAddresses();
            while (inetAddresses.hasMoreElements()) {
                InetAddress inetAddress = inetAddresses.nextElement();
                addresses.add(inetAddress.getHostAddress());
                addresses.add(inetAddress.getCanonicalHostName());
            }
        }
    } catch (Exception e) {
    }
    return addresses;
}

boolean checkSecurity(HttpServletRequest request){
    if (!xpolog.eye.security.WebSecurityManager.getInstance().isSecurityEnabled()){
        return true;
    }
    xpolog.eye.site.UserContext userContext = xpolog.eye.site.UserEnvironment.getUserContext(request);
    if (userContext != null && userContext.getUser() != null && userContext.getUser().isAdmin()){
        return true;
    }
    String ipAddress = request.getRemoteAddr();
    if (ipAddress != null && ("localhost".equals(ipAddress) || "127.0.0.1".equals(ipAddress) || "0:0:0:0:0:0:0:1".equals(ipAddress))){
        return true;
    }else {
        try {
            if (ipAddress != null && getCurrentNodeStrAddresses().contains(ipAddress)){
                return true;
            }

            String host = null;
            InetAddress inetAddress = xpolog.config.Configuration.getCurrentNodeAddress();
            if(inetAddress != null) {
                host = inetAddress.getHostAddress();
            }else {
                host = InetAddress.getLocalHost().getHostAddress();
            }
            if (host != null && host.equals(ipAddress)){
                return true;
            }
        }catch (Exception e1){}
        logError("Security failed for ipAddress " + ipAddress + " and user " + (userContext == null || userContext.getUser() == null || userContext.getUser().getUser() == null ? "NONE" : userContext.getUser().getUser()),null);
    }
    return false;
}

Map<String, String> createReplacementMap(JSONObject obj){
    Map<String, String> result = new HashMap<>();

    if (obj != null){
        for (Object keyObj : obj.keySet()) {
            String key = (String) keyObj;
            Object value = obj.get(key);
            result.put(key, value != null ? value.toString() : null);
        }
    }

    return result;
}

String getOrDefault(Map<String, String> map, String key, String defaultValue) {
    if (map != null) {
        String value = map.get(key);
        if (value != null && !value.isEmpty()) {
            return value;
        }
    }
    return defaultValue;
}

String encryptField(String message) {
    return encryptField(message,false,true);
}
String encryptField(String message,boolean encryptEmpty,boolean addPrefix) {
    if (message == null || (!encryptEmpty && message.isEmpty()) || message.startsWith("encrypt-")) return message;
    try {
        String result = xpolog.eye.util.crypto.CryptoUtil.encryptToHex(message);
        if (addPrefix){
            result = "encrypt-" + result;
        }
        return result;
    } catch (Exception e) {
        logError("Failed to encrypt key ",e);
    }
    return message;
}

String decryptField(String message) {
    return decryptField(message,false);
}

String decryptField(String message,boolean prefixOnly) {
    try {
        if (message == null || message.isEmpty()) return message;
        if (message.startsWith("encrypt-")){
            message = message.substring("encrypt-".length());
        }else if (prefixOnly){
            return message;
        }
        String result = xpolog.eye.util.crypto.CryptoUtil.decryptFromHex(message);
        return result;
    } catch (Exception e) {
        logError("Failed to decrypt key ",e);
    }
    return message;
}

Pattern placeHolderPattern = Pattern.compile("\\$\\{([^\\{\\}]+)\\}");

String replaceWithMapPlaceholders(String message,Map<String, String> replacementMap) {
        if (message == null) {
            return null;
        }

        if (!message.contains("${")){
            return message;
        }

        StringBuffer sb = new StringBuffer();
        Matcher m = placeHolderPattern.matcher(message);
        while (m.find()) {
            String g = m.group(1);
            String replaceTo = replacementMap == null ? null : replacementMap.get(g);
            if (replaceTo == null){
                replaceTo = System.getProperty(g);
            }
            if (replaceTo == null){
                replaceTo = "";
            }else {
                if (replaceTo.contains("\\")){
                    replaceTo = replaceTo.replaceAll("\\\\","\\\\\\\\");
                }

            }
            m.appendReplacement(sb,replaceTo);

        }
        m.appendTail(sb);
        return sb.toString();
    }

%>
