<%@ page import="java.net.*" %>
<%@ page import="javax.net.ssl.*" %>
<%@ page import="java.net.http.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.util.logging.*" %>
<%@ page import="java.security.cert.*" %>
<%@ page import="org.json.simple.*" %>
<%@ page import="java.time.*" %>
<%@ page import="java.nio.charset.*" %>

<%@ page import="org.bouncycastle.asn1.x500.X500Name" %>
<%@ page import="org.bouncycastle.cert.X509v3CertificateBuilder" %>
<%@ page import="org.bouncycastle.cert.jcajce.*" %>
<%@ page import="org.bouncycastle.jce.provider.BouncyCastleProvider" %>
<%@ page import="org.bouncycastle.operator.ContentSigner" %>
<%@ page import="org.bouncycastle.operator.jcajce.JcaContentSignerBuilder" %>
<%@ page import="org.bouncycastle.util.io.pem.*" %>

<%@ page import="java.math.*" %>
<%@ page import="java.nio.file.*" %>
<%@ page import="java.security.*" %>
<%@ page import="java.security.cert.*" %>
<%@ page import="java.security.spec.PKCS8EncodedKeySpec" %>
<%@ page import="org.w3c.dom.*" %>


<%!

class SSOCommon {

    protected Map<String, String> contextParams = new HashMap();
    protected Level logLevel = Level.WARNING;

    public SSOCommon(){}

    public SSOCommon(Map<String, String> contextParams){
        this.contextParams = contextParams;
    }

    public void setContextParams(Map<String, String> contextParams){
        this.contextParams = contextParams;
    }

    public void initialize() {
        try {
            logLevel = Level.parse(getOrDefault(contextParams,"plugin-logLevel","WARNING"));
        }catch (Exception e){
            logError("Failed to initialize saml common",e);
        }

    }

    public boolean isInfoEnabled(){
        return logLevel.intValue() <= Level.INFO.intValue();
    }

    public boolean isDebugEnabled(){
        return logLevel.intValue() <= Level.ALL.intValue();
    }

    public void ssoLogError(String message,Exception e){
        logError(message,e);
    }

    public void ssoLogInfo(String message,Exception e){
        logInfo(message,e);
    }

    public void ssoLogDebug(String message,Exception e){
        logDebug(message,e);
    }

     public void ssoLogError(String message){
        logError(message,null);
    }

    public void ssoLogInfo(String message){
        logInfo(message,null);
    }

    public void ssoLogDebug(String message){
        logDebug(message,null);
    }

    public JSONObject parseJsonFile(String path) {
         try (FileReader reader = new FileReader(path)) {
            // Parse the JSON file
            JSONObject jsonObject = (JSONObject) new JSONParser().parse(reader);

            return jsonObject;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
%>
