function getName() {
	return "aws_cloudtrail";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "aws_cloudtrail",
		"apptags": "",
		"logtypes": [{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "The cloudtrail log is pulled directrly from cloudtrail event api",
					"typetag": "aws,cloudtrail,access,audit",
					"name": "AWS CloudTrail",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,AccessKeyId#_#ftype=accesskeyid#_#name=Access Key ID;CloudTrailEvent->eventVersion#_#ftype=eventversion#_#name=Event Version;CloudTrailEvent->userIdentity->type#_#ftype=type#_#name=Type;CloudTrailEvent->userIdentity->principalId#_#ftype=principalid#_#name=Principal ID;CloudTrailEvent->userIdentity->arn#_#ftype=arn#_#name=ARN;CloudTrailEvent->userIdentity->accountId#_#ftype=accountid#_#name=Account ID;CloudTrailEvent->userIdentity->sessionContext->sessionIssuer#_#ftype=sessionissuer#_#name=SessionIssuer;CloudTrailEvent->userIdentity->sessionContext->webIdFederationData#_#ftype=webidfederationdata#_#name=Web Id Federation Data;CloudTrailEvent->userIdentity->sessionContext->attributes->mfaAuthenticated#_#ftype=mfaauthenticated#_#name=mfa Authenticated;CloudTrailEvent->userIdentity->sessionContext->attributes->creationDate#_#name=Creation Date;CloudTrailEvent->userIdentity->invokedBy#_#ftype=invokedby#_#name=Invoked By;CloudTrailEvent->eventTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm:ss#_#name=Event Time;CloudTrailEvent->eventSource#_#ftype=eventsource#_#name=Event Source;;CloudTrailEvent->eventName#_#ftype=eventname#_#name=Event Name;CloudTrailEvent->awsRegion#_#ftype=awsregion#_#name=AWS Region;CloudTrailEvent->sourceIPAddress#_#ftype=sourceip#_#name=Source IP Address;CloudTrailEvent->userAgent#_#ftype=useragent#_#name=User Agent;CloudTrailEvent->requestParameters->host#_#ftype=host#_#name=Host;CloudTrailEvent->responseElements#_#ftype=responseelements#_#name=Response Elements;CloudTrailEvent->additionalEventData->signatureVersion#_#ftype=signatureversion#_#name=Signature Version;CloudTrailEvent->additionalEventData->CipherSuite#_#ftype=ciphersuite#_#name=Cipher Suite;CloudTrailEvent->additionalEventData->AuthenticationMethod#_#ftype=authenticationmethod#_#name=Authentication Method;CloudTrailEvent->additionalEventData->vpcEndpointId#_#ftype=vpcendpointid#_#name=VPC Endpoint ID;;CloudTrailEvent->requestID#_#ftype=requestid#_#name=Request ID;EventId#_#ftype=eventid#_#name=Event ID;CloudTrailEvent->eventType#_#ftype=eventtype#_#name=Event Type;CloudTrailEvent->recipientAccountId#_#ftype=recipientaccountid#_#name=Recipient Account ID;EventTime#_#ftype=eventtime#_#name=EventTime;ReadOnly#_#ftype=readonly#_#name=Read Only;Username#_#ftype=username}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "cloudtrail_access",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "AWS cloudtrail",
		"typetag": "aws,cloudtrail",
		"name": "aws_cloudtrail",
		"description": "",
		"type": "cloud",
		"doclink": "https://docs.aws.amazon.com/awscloudtrail/latest/userguide/cloudtrail-log-file-examples.html",
		"version": "CloudTrail_20131101",
		"supportedDataSources": "cloudtrail",
		"xwikilink": "",
		"example": ""
	}
});
