<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>

<%@ include file="../../../../common/rest/restCommonServices.jsp" %>
<%

     if (!checkSecurity(request) ){
        out.println(buildErrorResult("Rest is not authorize",null,401));
        response.setStatus(401);
        return;
    }

    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }
	 
	 

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();

    JSONObject queryObject = (JSONObject)jsonObject.get("defaultParams");
	if (queryObject == null){
		queryObject = new JSONObject();
	}
	
	boolean scripttest = Boolean.TRUE.equals(jsonObject.get("scripttest"));	


    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");
	
	String clientAuth = "";
	String logType = null;
	 

    String clientReqBody = "";
	String baseUrl = "";
    try {		
		if (formObject != null){
		    logType = (String)formObject.get("logType");
			baseUrl = (String)formObject.get("baseUrl");
			
			long timeToGoBack = 300000;
			String str = (String)formObject.get("timeToGoBack");
			if (str != null){
				timeToGoBack = Long.parseLong(str);
			}
			long time = System.currentTimeMillis() - timeToGoBack;
			time = time - (time%1000);
			
			int maxNumOfRecords = 1000;
			str = (String)formObject.get("numOfEvents");
			if (str != null){
				maxNumOfRecords = Integer.parseInt(str);
			}

		   JSONObject paramsObj = new JSONObject();

		   queryObject.put("params",paramsObj);
		   if (timeToGoBack > 0) {
		     queryObject.put("startTime",String.valueOf(time));
		   }


						
           queryObject.put("maxNumOfRecords",maxNumOfRecords);
		   String username = (String)formObject.get("username");
		   String token = (String)formObject.get("apiToken");
		   
		   
		   if (username != null && token != null){
			   String encodedString = username + ":"+ token;
			   clientAuth = "Basic " + Base64.getEncoder().encodeToString(encodedString.getBytes());
		   }
		   
		}
		initObject.put("baseUrl",baseUrl);
		initObject.put("clientAuth",clientAuth);
		
		//System.out.println("clientAuth " + clientAuth);
		 

    }catch (Exception e){
       xpolog.eye.error.ErrorModel.log.error("Failed to init for " + clientReqBody,e);
	   if (scripttest){
			response.setStatus(200);
	   }else {
		  response.setStatus(500);
	   }
       String errorMessage = buildErrorResult(null,e);

       %>
         <%=errorMessage%>
       <%

       return;
    }

    initObject.put("pluginToken",pluginToken);
    initObject.put("queryInfo",queryObject);
    if (logType != null){
        initObject.put("logType",logType);
    }

    session.setAttribute(pluginToken, initObject);

  // System.out.println("init query = " + initObject);

    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "authResponse": {
        "headers" : {
            "plugin-token" : "<%=pluginToken%>"
        }
    }
	<%if(false){%>
		,"form":<%=jsonObject%>
	<%}%>
		
}
