<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.JSONArray" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ page import="java.text.*" %>
<%@ include file="../../../../common/rest/restCommonServices.jsp" %>

<%

    if (!checkSecurity(request)){
        out.println(buildErrorResult("Rest is not authorize",null,401));
        response.setStatus(401);
        return;
    }
    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null){
          pluginToken = "";
     }

      JSONObject initObject = (JSONObject)session.getAttribute(pluginToken);
       if (initObject == null){
            initObject = new JSONObject();
       }

       String logType = request.getParameter("logType");
       if (logType == null || logType.length() == 0){
            logType = (String)initObject.get("logType");
       }


     StringBuilder requestBody = new StringBuilder();
     String line;
      while ((line = request.getReader().readLine()) != null) {
        requestBody.append(line);
      }

      if (requestBody.length() == 0){
          requestBody.append("{}");
      }

       JSONParser parser = new JSONParser();
       JSONObject jsonObject =  (JSONObject)parser.parse(requestBody.toString());
	   
	   boolean scripttest = Boolean.TRUE.equals(jsonObject.get("scripttest"));

      JSONObject metaObj = (JSONObject)jsonObject.get("metaData");
      String pluginDataRef = request.getParameter("pluginDataRef");
      if (metaObj != null && pluginDataRef == null){
          pluginDataRef = (String)metaObj.get("pluginDataRef");
      }


       if (logType == null){
            logType = "jira_audit";
       }

	   boolean reverse = true;
       String startKey = "from";
       String url = "rest/api/3/auditing/record";
	   String resultKey = "records";
	   String resultTimeKey = "created";
       if (logType.equals("confluence_audit")){
            startKey = "startDate";
            url = "wiki/rest/api/audit";
			resultKey = "results";
			resultTimeKey = "creationDate";
       }


       response.setContentType("application/json");
       response.setCharacterEncoding("UTF-8");
       String clientReqBody = "";
       JSONArray array = new JSONArray();
       long lastTime = -1;
       JSONObject jsonBody = null;
       Map<String, String> params = new HashMap<>();
      try {

			String baseUrl = (String)initObject.get("baseUrl");
            JSONObject queryObj = (JSONObject)initObject.get("queryInfo");
            if (queryObj != null){
                JSONObject jsonParams = (JSONObject)queryObj.get("params");
                if (jsonParams != null){
                    for (Object entry : jsonParams.entrySet()) {
                        Map.Entry<String, Object> mapEntry = (Map.Entry<String, Object>) entry;
                        String key = mapEntry.getKey();
                        Object value = mapEntry.getValue();
                        params.put(key,value.toString());
                    }
                }

                String startTime = (String)queryObj.get("startTime");
               

                if (pluginDataRef != null && pluginDataRef.startsWith("{")){
                    JSONObject pluginRefObj = (JSONObject)parser.parse(pluginDataRef);
                    if (pluginRefObj != null){
                       Long time = (Long)pluginRefObj.get("time");
                       if (time != null){
						   startTime = String.valueOf(time.longValue());
                        }
                    }
                }
				if (startTime != null){
                     params.put(startKey,startTime);
					 if (logType.equals("jira_audit"))
					 {
						 SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
						 params.put(startKey,format.format(new Date(Long.parseLong(startTime))));
					 }
                }
            }


           String clientAuth = (String)initObject.get("clientAuth");
           if (clientAuth == null){
                clientAuth = "";
           }
          
           StringBuilder urlBuilder = new StringBuilder(baseUrl + url);
           if (!params.isEmpty()){
               urlBuilder.append("?");
               for (Map.Entry<String, String> entry : params.entrySet()) {
                   urlBuilder.append(entry.getKey()).append("=").append(entry.getValue()).append("&");
               }
           }

           System.out.println("Request url: " + urlBuilder.toString());


           HttpClient client = createHttpsClient();
		   HttpRequest.Builder builder = HttpRequest.newBuilder();
		   builder = builder.uri(URI.create(urlBuilder.toString()))
                   .header("Content-Type", "application/json")
                   .GET();
		   if (clientAuth.length() > 0){
			   builder = builder.header("Authorization", clientAuth);
		   }
		  
           HttpRequest clientReq = builder.build();

           HttpResponse<String> clientRes = client.send(clientReq, HttpResponse.BodyHandlers.ofString());

           String body = clientRes.body().trim();

           //System.out.println("Response Code: " + clientRes.statusCode());
           //System.out.println("Response Body: " + body);

           if (body.startsWith("{")){
                jsonBody =  (JSONObject)parser.parse(body);
                if (jsonBody != null){
					JSONArray events = (JSONArray) jsonBody.get(resultKey);
					if (events != null){
						int size = events.size();
						if (reverse)
						{
							for (int i = size; --i >= 0;){
								if (scripttest){
									array.add(events.get(i));
								}else {
									array.add(events.get(i).toString());
								}
							}
						}
						else
						{
							for (int i = 0; i < size;i++){
								if (scripttest){
									array.add(events.get(i));
								}else {
									array.add(events.get(i).toString());
								}
							}
						}
						if (size > 0){
							JSONObject lastEvent = (JSONObject)events.get(reverse?0:size - 1);
							Object objTime = lastEvent.get(resultTimeKey);
							Long time = null;
							if (objTime instanceof Long){
								time = (Long)objTime;
							}	
							else if (objTime instanceof String) {
							SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSZ");
							time = format.parse((String)objTime).getTime();
							}
                            if (time != null){
                                long t = time.longValue() + 1;
                                JSONObject obj = new JSONObject();
                                obj.put("time",t);
                                pluginDataRef = obj.toString();
                                 // System.out.println("last time : " + new Date(time) +  " , events size:" + size);
                                 if (time.longValue() == lastTime){
                                    array = new JSONArray();
                                 }
                            }

						}else {
							System.out.println("no events size:" + size);
						}
					}                    
                }
           }



       }catch (Exception e){
          xpolog.eye.error.ErrorModel.log.error("Failed to get next events for " + clientReqBody,e);
          if (scripttest){
			response.setStatus(200);
	   }else {
		  response.setStatus(500);
	   }
          String errorMessage = buildErrorResult(null,e);

          %>
            <%=errorMessage%>
          <%

          return;
       }


     // Thread.sleep(5000);



%>
{
	"metaData" : {
		"pluginDataRef" : "<%=(pluginDataRef != null ? JSONObject.escape(pluginDataRef) : "")%>"
	},
    <% if (false) {%>

    "body" : <%=(jsonBody == null ? "{}" : jsonBody.toString())%>,

    	<% } %>
	"dataEvents" : <%=array.toString()%>





}
