function getName() {
	return "azure_ad";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "azure_ad",
		"apptags": "",
		"logtypes": [
		    {
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "AZURE ACTIVE DIRECTORY LOG",
					"typetag": "azure,activedirectory,audit",
					"name": "Azure Active Directory Audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Json,result#_#ftype=status#_#name=Result;activityDisplayName#_#ftype=eventname#_#name=Activity Display Name;resultReason#_#ftype=reason#_#name=Result Reason;correlationId#_#ftype=correlationid#_#name=Correlation ID;loggedByService#_#ftype=loggedbyservice#_#name=Logged By Service;operationType#_#ftype=operationtype#_#name=Operation Type;id#_#ftype=id#_#name=ID;activityDateTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss.SSSSSS'Z',dateUIFormat=yyyy-MM-dd HH:mm:ss.SSSSSS#_#name=Activity Date Time;category#_#ftype=category#_#name=Category;targetResources;additionalDetails#_#ftype=additionaldetails#_#name=Additional Details;initiatedBy->app#_#ftype=app#_#name=App;initiatedBy->user->displayName#_#ftype=userdisplayname#_#name=User Display Name;initiatedBy->user->ipAddress#_#ftype=sourceip#_#name=User SourceIP;initiatedBy->user->id#_#ftype=userid#_#name=User ID;initiatedBy->user->userPrincipalName#_#ftype=username#_#name=User Principal Name;initiatedBy->user#_#ftype=initiateuser#_#name=Initiated By User}{map:User Type,ftype=usertype;refIndex=15,file:knowledge/repository/system/Azure/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=15,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/",
					"type_uid": "auditLogs/directoryAudits",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
                "log": {
                    "xdoclink": "",
                    "defaultPattern": "NONE",
                    "howto": "AZURE ACTIVE DIRECTORY LOG",
                    "typetag": "azure,activedirectory,audit",
                    "name": "Azure Active Directory SignIns",
                    "custom_parser_location": "<LINK to JS>",
                    "defaultXpoLogPattern": "{json:Json,resourceId;deviceDetail->trustType#_#name=trustType;deviceDetail->deviceId#_#name=deviceId;deviceDetail->browser#_#name=browser;deviceDetail->isCompliant#_#name=isCompliant;deviceDetail->isManaged#_#name=isManaged;deviceDetail->displayName#_#name=displayName;deviceDetail->operatingSystem#_#name=operatingSystem;appliedConditionalAccessPolicies;isInteractive;conditionalAccessStatus#_#ftype=conditionalaccess#_#name=Conditional Access;clientAppUsed;status->additionalDetails#_#name=additionalDetails;status->errorCode#_#ftype=errorcode#_#name=errorCode;status->failureReason#_#ftype=failurereason#_#name=failureReason;createdDateTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss,dateUIFormat=yyyy-MM-dd HH:mm:ss;riskLevelAggregated;appId;location->geoCoordinates#_#name=geoCoordinates;location->city#_#ftype=city#_#name=city;location->countryOrRegion#_#ftype=country#_#name=countryOrRegion;location->state;correlationId#_#ftype=correlationid#_#name=Correlation ID;id#_#ftype=requestid#_#name=Request ID;riskState;userPrincipalName#_#ftype=username;resourceDisplayName;riskEventTypes;appDisplayName#_#ftype=app#_#name=Application;riskLevelDuringSignIn;ipAddress#_#ftype=sourceip;userDisplayName#_#ftype=userdisplayname;userId#_#ftype=userid#_#name=User ID;riskDetail;riskEventTypes_v2}",
                    "parser_type": "default",
                    "xwikilink": "http://wiki.xpolog.com/",
                    "type_uid": "auditLogs/signIns",
                    "parser_specification": {
                        "defaultPattern": "NONE",
                        "parserparam": "",
                        "defaultXpoLogPattern": "{string:someStingName}",
                        "externalJS": "link or code"
                    }
                }
            },
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "AUDIT FROM OFFICE PULLS AZURE AD DATA ",
					"typetag": "office365,activedirectory,audit",
					"name": "Office 365 Audit Active Directory",
					"custom_parser_location": "<LINK to JS>",
                    "defaultXpoLogPattern": "{json:Audit Data,CreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss,dateUIFormat=yyyy-MM-dd HH:mm:ss;AzureActiveDirectoryEventType#_#ftype=eventtype;UserKey#_#ftype=userkey#_#name=User Key;ActorIpAddress#_#ftype=sourceip#_#name=Actor IP Address;Operation#_#ftype=operation;OrganizationId#_#ftype=organizationid#_#name=Organization ID;ExtendedProperties#_#ftype=extendedproperties#_#name=Extended Properties;IntraSystemId#_#ftype=intrasystemid#_#name=Intra System ID;Target#_#ftype=target;RecordType#_#ftype=recordtype#_#name=Record Type;Version#_#ftype=version;ModifiedProperties#_#ftype=modifiedproperties#_#name=Modified Properties;SupportTicketId#_#ftype=supportticketid#_#name=Support Ticket ID;Actor#_#ftype=actor;ActorContextId#_#ftype=actorcontextid#_#name=Actor Context ID;ResultStatus#_#ftype=status#_#Result Status;ObjectId#_#ftype=object#_#name=Object ID;ClientIP#_#ftype=clientip#_#name=Client IP;Workload#_#ftype=workload;UserId#_#ftype=username#_#name=User ID;TargetContextId#_#ftype=targetcontextid#_#name= Target Context ID;Id;InterSystemId#_#ftype=intersystemid#_#name=Inter System ID;ApplicationId#_#ftype=application#_#name=Application ID;UserType#_#_#name=User Type;InterSystemsId#_#ftype=intersystemsid#_#name=Inter Systems ID;ItemType#_#ftype=itemtype#_#name=Item Type;EventData#_#ftype=eventdata#_#name=Event Data;EventSource#_#ftype=eventsource#_#name=Event Source;UserAgent#_#ftype=useragent#_#name=User Agent;CorrelationId#_#ftype=correlationid#_#name=Correlation ID;TeamGuid#_#ftype=teamguid#_#name=Team Guid;TeamName#_#ftype=usergroup#_#name=Team Name;Members#_#ftype=members;Site#_#ftype=site;SiteUrl#_#ftype=siteurl;SourceRelativeUrl#_#ftype=sourcerelativeurl#_#name=Source Relative URL;WebId#_#ftype=webuid;UniqueSharingId#_#ftype=uniquesharingid#_#name=Unique Sharing ID;ListItemUniqueId#_#ftype=listitemuniqueid#_#name=List Item Unique ID;OrganizationName#_#ftype=organizationname#_#name=Organization Name;Parameters#_#ftype=parameters;ExternalAccess#_#ftype=externalaccess;OriginatingServer#_#ftype=originatingserver#_#name=Originating Server;ClientAppId#_#ftype=clientappid#_#name=Client App ID;AppId#_#ftype=appid#_#name=App ID;ApplicationDisplayName#_#ftype=applicationdisplayname#_#name=Application Display Name;AddOnGuid#_#ftype=addtoguid#_#name=Add On Guid;AddOnName#_#ftype=addonname#_#name=Add On Name;ChannelName#_#ftype=channelname#_#name=Channel Name;AddOnType#_#ftype=addontype#_#name=Add On Type;ChannelGuid#_#ftype=channelguid#_#name=Channel Guid;AdditionalData#_#ftype=additionaldata;ListId#_#ftype=listid#_#name=List ID;SourceFileName#_#ftype=sourcefilename#_#name=Source File Name;SourceFileExtension#_#ftype=sourcefileextension#_#name=Source File Extension;ListBaseType#_#ftype=listbasetype#_#name=List Base Type;ListTitle#_#ftype=listtitle#_#name=List Title;ListId#_#ftype=listid#_#name=List ID;ListBaseTemplateType#_#ftype=listbasetemplatetype#_#name-List Base Template Type;TargetUserOrGroupName#_#ftype=tragetusergroupname#_#name=Target User Or Group Name;TargetUserOrGroupType#_#ftype=targetusergrouptype#_#name=Target User Or Group Type;LogonError#_#ftype=logonerror;DestinationFileName#_#ftype=destinationfilename#_#name=Destination File Name;DestinationFileExtension#_#ftype=destinationfileextenstion#_#name=Destination File Extenstion;DestinationRelativeUrl#_#ftype=destinationrelativeurl#_#name=Destination Relative Url;Category#_#ftype=category;Description#_#ftype=description;InsightId#_#ftype=insightid#_#name=Insight ID;Severity#_#ftype=severity;Name;InsightData#_#ftype=insightdata#_#name=Insight Data;Type#_#ftype=type;Details#_#ftype=details;CustomUniqueId#_#ftype=customuniqueid#_#name=Custom Unique ID;SessionId#_#ftype=sessionid#_#name=Session ID;MailboxOwnerSid#_#ftype=mailboxownersid#_#name=Mailbox Owner SID;LogonType#_#ftype=logontype#_#name=Logon Type;MailboxGuid#_#ftype=mailboxguid#_#name=MailboxGuid;ClientIPAddress#_#ftype=clientipaddress#_#name=Client IP Address;LogonUserSid#_#ftype=logonusersid#_#name=Logon User SID;ClientInfoString#_#ftype=clientinfostring#_#name=Client Info String;MailboxOwnerUPN#_#ftype=mailboxownerupn#_#name=Mailbox Owner UPN;MailboxOwnerMasterAccountSid#_#ftype=mailboxownermasteraccountsid#_#name=Mailbox Owner Master Account Sid;InternalLogonType#_#ftype=internallogontype#_#name=Internal Logon Type;Item#_#ftype=item;DataType#_#ftype=datatype#_#name=Data Type;ImplicitShare#_#ftype=implicitshare#_#name=Implicit Share;TabType#_#ftype=tabtype#_#name=Tab Type;DeviceProperties;ErrorNumber#_#ftype=errornumber}{map:User Type,ftype=usertype;refIndex=19,file:knowledge/repository/system/Azure/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=19,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "Audit.AzureActiveDirectory",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "AUDIT EXCHANGE PULLED FROM AZURE OFFICE 365 FEED ",
					"typetag": "office365,exchange,audit",
					"name": "Office 365 Audit Exchange",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Audit Data,CreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss,dateUIFormat=yyyy-MM-dd HH:mm:ss;Id#_#ftype=id#_#name=ID;Operation#_#ftype=operation;OrganizationId#_#ftype=organizationid#_#name=Organization ID;RecordType#_#ftype=recordtype#_#name=Record Type;ResultStatus#_#ftype=status#_#Result Status;UserKey#_#ftype=userkey#_#name=User Key;UserType;Version#_#ftype=version;Workload#_#ftype=workload;ClientIP#_#ftype=sourceip#_#name=Client IP;UserId#_#ftype=username#_#name=User ID;ClientIPAddress#_#ftype=clientipaddress#_#name=Client IP Address;ClientInfoString#_#ftype=clientinfostring#_#name=Client Info String;ExternalAccess#_#ftype=externalaccess;InternalLogonType#_#ftype=internallogontype#_#name=Internal Logon Type;LogonType#_#ftype=logontype#_#name=Logon Type;MailboxGuid#_#ftype=mailboxguid#_#name=MailboxGuid;MailboxOwnerMasterAccountSid#_#ftype=mailboxownermasteraccountsid#_#name=Mailbox Owner Master Account Sid;MailboxOwnerSid#_#ftype=mailboxownersid#_#name=Mailbox Owner SID;LogonUserSid#_#ftype=logonusersid#_#name=Logon User SID;MailboxOwnerUPN#_#ftype=mailboxownerupn#_#name=Mailbox Owner UPN;OriginatingServer#_#ftype=originatingserver#_#name=Originating Server;ModifiedProperties#_#ftype=modifiedproperties#_#name=Modified Properties;SupportTicketId#_#ftype=supportticketid#_#name=Support Ticket ID;Actor#_#ftype=actor;ActorContextId#_#ftype=actorcontextid#_#name=Actor Context ID;ObjectId#_#ftype=object#_#name=Object ID;TargetContextId#_#ftype=targetcontextid#_#name= Target Context ID;InterSystemId#_#ftype=intersystemid#_#name=Inter System ID;ApplicationId#_#ftype=application#_#name=Application ID;InterSystemsId#_#ftype=intersystemsid#_#name=Inter Systems ID;ItemType#_#ftype=itemtype#_#name=Item Type;EventData#_#ftype=eventdata#_#name=Event Data;EventSource#_#ftype=eventsource#_#name=Event Source;UserAgent#_#ftype=useragent#_#name=User Agent;CorrelationId#_#ftype=correlationid#_#name=Correlation ID;TeamGuid#_#ftype=teamguid#_#name=Team Guid;TeamName#_#ftype=usergroup#_#name=Team Name;Members#_#ftype=members;Site#_#ftype=site;SiteUrl#_#ftype=siteurl;SourceRelativeUrl#_#ftype=sourcerelativeurl#_#name=Source Relative URL;WebId#_#ftype=webuid;UniqueSharingId#_#ftype=uniquesharingid#_#name=Unique Sharing ID;ListItemUniqueId#_#ftype=listitemuniqueid#_#name=List Item Unique ID;OrganizationName#_#ftype=organizationname#_#name=Organization Name;Parameters#_#ftype=parameters;ClientAppId#_#ftype=clientappid#_#name=Client App ID;AppId#_#ftype=appid#_#name=App ID;ApplicationDisplayName#_#ftype=applicationdisplayname#_#name=Application Display Name;AddOnGuid#_#ftype=addtoguid#_#name=Add On Guid;AddOnName#_#ftype=addonname#_#name=Add On Name;ChannelName#_#ftype=channelname#_#name=Channel Name;AddOnType#_#ftype=addontype#_#name=Add On Type;ChannelGuid#_#ftype=channelguid#_#name=Channel Guid;AdditionalData#_#ftype=additionaldata;ListId#_#ftype=listid#_#name=List ID;SourceFileName#_#ftype=sourcefilename#_#name=Source File Name;SourceFileExtension#_#ftype=sourcefileextension#_#name=Source File Extension;ListBaseType#_#ftype=listbasetype#_#name=List Base Type;ListTitle#_#ftype=listtitle#_#name=List Title;ListId#_#ftype=listid#_#name=List ID;ListBaseTemplateType#_#ftype=listbasetemplatetype#_#name-List Base Template Type;TargetUserOrGroupName#_#ftype=tragetusergroupname#_#name=Target User Or Group Name;TargetUserOrGroupType#_#ftype=targetusergrouptype#_#name=Target User Or Group Type;LogonError#_#ftype=logonerror;DestinationFileName#_#ftype=destinationfilename#_#name=Destination File Name;DestinationFileExtension#_#ftype=destinationfileextenstion#_#name=Destination File Extenstion;DestinationRelativeUrl#_#ftype=destinationrelativeurl#_#name=Destination Relative Url;Category#_#ftype=category;Description#_#ftype=description;InsightId#_#ftype=insightid#_#name=Insight ID;Severity#_#ftype=severity;Name;InsightData#_#ftype=insightdata#_#name=Insight Data;Type#_#ftype=type;Details#_#ftype=details;CustomUniqueId#_#ftype=customuniqueid#_#name=Custom Unique ID;SessionId#_#ftype=sessionid#_#name=Session ID;Item#_#ftype=item;DataType#_#ftype=datatype#_#name=Data Type;ImplicitShare#_#ftype=implicitshare#_#name=Implicit Share;TabType#_#ftype=tabtype#_#name=Tab Type;CrossMailboxOperation#_#ftype=crossmailboxoperation;Folder#_#ftype=folder;AffectedItems#_#ftype=affecteditems}{map:User Type,ftype=usertype;refIndex=11,file:knowledge/repository/system/Azure/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=11,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "Audit.Exchange",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "AZURE OFFICE FEED SHARE POINT ",
					"typetag": "office365,sharepoint,audit",
					"name": "Office 365 Audit Share Point",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Audit Data,CreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss,dateUIFormat=yyyy-MM-dd HH:mm:ss;Id#_#ftype=id#_#name=ID;Operation#_#ftype=operation;OrganizationId#_#ftype=organizationid#_#name=Organization ID;RecordType#_#ftype=recordtype#_#name=Record Type;ResultStatus#_#ftype=status#_#Result Status;UserKey#_#ftype=userkey#_#name=User Key;UserType;Version#_#ftype=version;Workload#_#ftype=workload;ClientIP#_#ftype=clientip#_#name=Client IP;UserId#_#ftype=username#_#name=User ID;ObjectId#_#ftype=object;ApplicationDisplayName#_#ftype=application#_#name=Application Display Name;ApplicationId#_#ftype=appid;CorrelationId#_#ftype=correlationid;EventSource#_#ftype=eventsource;ItemType#_#ftype=itemtype;Site#_#ftype=site;UserAgent#_#ftype=useragent;WebId#_#ftype=webid;EventData#_#ftype=eventdata;TargetUserOrGroupType#_#ftype=usergrouptype;UniqueSharingId#_#ftype=sharingid;SiteUrl#_#ftype=siteurl;TargetUserOrGroupName#_#ftype=usergroupname;SourceFileExtension#_#ftype=fileextentsionSourceFileName#_#ftype=filename;SourceRelativeUrl#_#ftype=relativeurl;ListId#_#ftype=listid#_#name=List ID;ListBaseType#_#ftype=listbasetype#_#name=List Base Type;ListTitle#_#ftype=listtitle#_#name=List Title;ListId#_#ftype=listid#_#name=List ID;ListBaseTemplateType#_#ftype=listbasetemplatetype#_#name-List Base Template Type;ListItemUniqueId#_#ftype=listitemuniqueid#_#name=List Item Unique ID;SourceFileName#_#ftype=sourcefilename#_#name=Source File Name;SourceFileExtension#_#ftype=sourcefileextension#_#name=Source File Extension;MachineId#_#ftype=machineid;CustomUniqueId#_#ftype=uniqueid;FileSyncBytesCommitted#_#ftype=filesyncbytes;MachineDomainInfo#_#ftype=machinedomaininfo;AppAccessContext->ClientAppId#_#ftype=clientappid#_#name=ClientAppID;AppAccessContext->ClientAppName#_#ftype=clientappname#_#name=ClientAppName;AppAccessContext->CorrelationId#_#ftype=correlationid#_#name=CorellationID;AppAccessContext->AADSessionId#_#name=AADSessionId;AppAccessContext->UniqueTokenId#_#ftype=uniquetokenid#_#name=UniqueTokenID;ImplicitShare;HighPriorityMediaProcessing;IsManagedDevice;FileSizeBytes#_#ftype=bytes;DoNotDistributeEvent;DestinationFileName#_#ftype=destinationfilename;DestinationFileExtension#_#destinationfileextension;DestinationRelativeUrl;TemplateTypeId;ItemCount;Source;ListIcon;ListColor}{map:User Type,ftype=usertype;refIndex=11,file:knowledge/repository/system/Azure/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=11,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "Audit.SharePoint",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "OFFICE FEED GENERAL AUDIT",
					"typetag": "office365,general,audit",
					"name": "Office 365 Audit General",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:Audit Data,CreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss,dateUIFormat=yyyy-MM-dd HH:mm:ss;Id#_#ftype=id#_#name=ID;Operation#_#ftype=operation;OrganizationId#_#ftype=organizationid#_#name=Organization ID;RecordType#_#ftype=recordtype#_#name=Record Type;ResultStatus#_#ftype=status#_#Result Status;UserKey#_#ftype=userkey#_#name=User Key;UserType;Version#_#ftype=version;Workload#_#ftype=workload;UserId#_#ftype=username#_#name=User ID;AddOnGuid#_#ftype=addonguid;AddOnType#_#ftype=addontype;ChannelGuid#_#ftype=channelguid;Members#_#ftype=members;TeamGuid#_#ftype=teamguid#_#name=Team Guid;AddOnName#_#ftype=addonname;ChannelName#_#ftype=channel;TeamName#_#ftype=usergroup#_#name=Team Name;SkypeForBusinessEventType;CmdletVersion#_#ftype=cmdletversion;TenantName#_#ftype=tenantname;ObjectName#_#ftype=object;ClientIPAddress#_#ftype=clientipaddress#_#name=Client IP Address;ClientInfoString#_#ftype=clientinfostring#_#name=Client Info String;ExternalAccess#_#ftype=externalaccess;InternalLogonType#_#ftype=internallogontype#_#name=Internal Logon Type;LogonType#_#ftype=logontype#_#name=Logon Type;LogonUserSid#_#ftype=logonusersid#_#name=Logon User SID;OriginatingServer#_#ftype=originatingserver#_#name=Originating Server;ModifiedProperties#_#ftype=modifiedproperties#_#name=Modified Properties;SupportTicketId#_#ftype=supportticketid#_#name=Support Ticket ID;Actor#_#ftype=actor;ActorContextId#_#ftype=actorcontextid#_#name=Actor Context ID;ObjectId#_#ftype=object#_#name=Object ID;TargetContextId#_#ftype=targetcontextid#_#name= Target Context ID;InterSystemId#_#ftype=intersystemid#_#name=Inter System ID;ApplicationId#_#ftype=application#_#name=Application ID;InterSystemsId#_#ftype=intersystemsid#_#name=Inter Systems ID;ItemType#_#ftype=itemtype#_#name=Item Type;EventData#_#ftype=eventdata#_#name=Event Data;EventSource#_#ftype=eventsource#_#name=Event Source;UserAgent#_#ftype=useragent#_#name=User Agent;CorrelationId#_#ftype=correlationid#_#name=Correlation ID;Site#_#ftype=site;SiteUrl#_#ftype=siteurl;SourceRelativeUrl#_#ftype=sourcerelativeurl#_#name=Source Relative URL;WebId#_#ftype=webuid;UniqueSharingId#_#ftype=uniquesharingid#_#name=Unique Sharing ID;ListItemUniqueId#_#ftype=listitemuniqueid#_#name=List Item Unique ID;OrganizationName#_#ftype=organizationname#_#name=Organization Name;Parameters#_#ftype=parameters;ClientAppId#_#ftype=clientappid#_#name=Client App ID;AppId#_#ftype=appid#_#name=App ID;ApplicationDisplayName#_#ftype=applicationdisplayname#_#name=Application Display Name;AddOnGuid#_#ftype=addtoguid#_#name=Add On Guid;AddOnName#_#ftype=addonname#_#name=Add On Name;ChannelName#_#ftype=channelname#_#name=Channel Name;AddOnType#_#ftype=addontype#_#name=Add On Type;ChannelGuid#_#ftype=channelguid#_#name=Channel Guid;AdditionalData#_#ftype=additionaldata;ListId#_#ftype=listid#_#name=List ID;SourceFileName#_#ftype=sourcefilename#_#name=Source File Name;SourceFileExtension#_#ftype=sourcefileextension#_#name=Source File Extension;ListBaseType#_#ftype=listbasetype#_#name=List Base Type;ListTitle#_#ftype=listtitle#_#name=List Title;ListId#_#ftype=listid#_#name=List ID;ListBaseTemplateType#_#ftype=listbasetemplatetype#_#name-List Base Template Type;TargetUserOrGroupName#_#ftype=tragetusergroupname#_#name=Target User Or Group Name;TargetUserOrGroupType#_#ftype=targetusergrouptype#_#name=Target User Or Group Type;LogonError#_#ftype=logonerror;DestinationFileName#_#ftype=destinationfilename#_#name=Destination File Name;DestinationFileExtension#_#ftype=destinationfileextenstion#_#name=Destination File Extenstion;DestinationRelativeUrl#_#ftype=destinationrelativeurl#_#name=Destination Relative Url;Category#_#ftype=category;Description#_#ftype=description;InsightId#_#ftype=insightid#_#name=Insight ID;Severity#_#ftype=severity;Name;InsightData#_#ftype=insightdata#_#name=Insight Data;Type#_#ftype=type;Details#_#ftype=details;CustomUniqueId#_#ftype=customuniqueid#_#name=Custom Unique ID;SessionId#_#ftype=sessionid#_#name=Session ID;Item#_#ftype=item;DataType#_#ftype=datatype#_#name=Data Type;ImplicitShare#_#ftype=implicitshare#_#name=Implicit Share;TabType#_#ftype=tabtype#_#name=Tab Type;Folder#_#ftype=folder;AffectedItems#_#ftype=affecteditems;SenderIp#_#ftype=senderIp;P1Sender;NetworkMessageId;DetectionMethod;Recipients;EventDeepLink;MessageTime;P2Sender;Subject;DetectionType;InternetMessageId;Verdict;ClientIP#_#ftype=sourceip;EntityPath;OperationPath}{map:User Type,ftype=usertype;refIndex=10,file:knowledge/repository/system/Azure/map/usertype.prop}{map:User Identity,ftype=useridentity;refIndex=10,file:knowledge/repository/system/useridentity.prop}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "Audit.General",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "office feed dlp all logs ",
					"typetag": "azure,dlp_all,audit",
					"name": "Office 365 DLP All",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:json,dynamic=true;,CreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss#_#name=Event Time}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/Amazon+cloudtrail",
					"type_uid": "DLP.All",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Windows Defeneder atp ",
					"typetag": "windows_defender,advanced_threat_protection",
					"name": "Microsoft Defender ATP",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:JSON, alertCreationTime#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss.SSS;severity;investigationId;comments;evidence;threatFamilyName;resolvedTime;aadTenantId;description;determination;classifiction;investigationState;title;assignedTo;machineId;computerDnsName;detectionSource;lastEventTime;id;firstEventTime;incidentId;category;status;lastUpdateTime}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/display/XPOL/",
					"type_uid": "eu",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:someStingName}",
						"externalJS": "link or code"
					}
				}
			},

		],
		"displayName": "Azure AD",
		"typetag": "azure",
		"name": "azure_ad",
		"description": "",
		"type": "cloud",
		"doclink": "FILL",
		"version": "NONE",
		"supportedDataSources": "AD",
		"xwikilink": "",
		"example": ""
	}
});
