<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ page import="java.net.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.nio.charset.*" %>
<%@ page import="javax.xml.parsers.*" %>
<%@ page import="org.w3c.dom.*" %>


<%@ include file="include.jsp" %>
<%

    //System.out.println("callback jsp");
    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

       boolean validate = checkSecurity(request);
       if (!validate){
          response.setStatus(401);
          String errorMessage = buildErrorResult("Failed to init from security reason",null,401);

          %>
            <%=errorMessage%>
          <%

          return;
       }


        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();


    String pluginRestBase = null;
    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");

    Map<String, String> contextParams = createReplacementMap(formObject);

	String idpCertificatePath = null;
    if (formObject != null){
        pluginRestBase = (String)formObject.get("pluginRestBase");
		idpCertificatePath = (String)formObject.get("saml-idpCertificatePath");
		
    }

     SamlCommon samlCommon = new SamlCommon(contextParams);
     samlCommon.initialize();

    //System.out.println("accountFormData = " + formObject);

    String content = "";
    String username = null;
    JSONObject loginDetails = null;

    JSONObject requestObject = (JSONObject)jsonObject.get("request");
    if (requestObject != null){
        Object bodyObj = requestObject.get("body");
        if (bodyObj != null){
            content = bodyObj.toString();
            if (content != null){
                content = content.trim();
            }
        }
        //System.out.println("content = " + content);
        JSONObject headersObject = (JSONObject)requestObject.get("headers");
        JSONObject parametersObject = (JSONObject)requestObject.get("parameters");
		

        String contentType = headersObject == null ? null : (String)headersObject.get("content-type");
        if (content != null && contentType != null && contentType.equals("application/x-www-form-urlencoded")){
            content = URLDecoder.decode(content.toString(), StandardCharsets.UTF_8.name());
        }

        if (samlCommon.getSSOCommon().isDebugEnabled()){
            samlCommon.getSSOCommon().ssoLogInfo("callback content " + content);
        }

		String errorMessage = null;
        if (content != null && content.startsWith("SAMLResponse=")){
            content = content.substring(content.indexOf("=") + 1);
            try {
				//System.out.println("callback content = " + content);
                Response samlResponse = samlCommon.decodeAndUnmarshall(content);
				
				if (samlResponse.getAssertions().isEmpty()) {
					errorMessage = "No assertions found in SAML response";
					//System.out.println("No assertions found in SAML response");
					samlCommon.getSSOCommon().ssoLogError(errorMessage + ", content = " + content);
				}else {
				   Assertion assertion = samlResponse.getAssertions().get(0);
				   
				   if (idpCertificatePath != null && idpCertificatePath.length() > 0){
				        idpCertificatePath = replaceWithMapPlaceholders(idpCertificatePath,contextParams);
						idpCertificatePath = new File(idpCertificatePath).getAbsolutePath();

				        //System.out.println("idpCertificatePath: " + idpCertificatePath);
					    // Load the IdP credential
						Credential idpCredential = samlCommon.loadIdPCredential(idpCertificatePath);


						// Validate the signature
						SignatureValidator.validate(assertion.getSignature(), idpCredential);
						
						//System.out.println("validate: " + validate);
				   }
				   
				   
				   
				    username = assertion.getSubject().getNameID().getValue();
					//System.out.println("username: " + username);
					
					loginDetails = samlCommon.createLoginDetails(formObject,assertion);
				   
				}


            }catch (Exception e){
                //e.printStackTrace();
                //System.out.println("content error = " + e.getMessage());
                samlCommon.getSSOCommon().ssoLogError("Failed on callback",e);
            }
        }else {
            if (content == null || content.length() == 0){
                samlCommon.getSSOCommon().ssoLogError("Login callback no context was supplied.");
            }else {
                samlCommon.getSSOCommon().ssoLogError("Login callback wrong context was supplied = " + content);
            }
        }

        //System.out.println("content = " + content);
        // System.out.println("headersObject = " + headersObject);


    }

    initObject.put("pluginToken",pluginToken);
    session.setAttribute(pluginToken, initObject);

    JSONObject clientResponse = new JSONObject();
    clientResponse.put("statusCode",301);
    clientResponse.put("content","{}");
    JSONObject responseHeaderFields = new JSONObject();
    JSONArray array = new JSONArray();
    if (loginDetails != null){
        array.add("/logeye");
    }else {
        String error = "User is not permitted to login";
        if (loginDetails == null){
            error = "Invalid user login";
        }
        error = java.net.URLEncoder.encode(error, java.nio.charset.StandardCharsets.UTF_8.toString());
        array.add("/logeye/root.jsp#/login?loginErrorMessage=" + error);
    }
    responseHeaderFields.put("Location",array);
    clientResponse.put("responseHeaderFields",responseHeaderFields);

   //System.out.println("init loginDetails = " + loginDetails);
   
   if (loginDetails == null){
		loginDetails = new JSONObject();
   }

   if (samlCommon.getSSOCommon().isInfoEnabled()){
       samlCommon.getSSOCommon().ssoLogInfo("Login details " + loginDetails);
   }
   if (samlCommon.getSSOCommon().isDebugEnabled()){
          samlCommon.getSSOCommon().ssoLogInfo("Client reponse " + clientResponse);
      }

    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "loginDetails": <%=loginDetails%>
    
     <%
      if (clientResponse != null){%>
        ,"clientResponse" : <%=clientResponse.toString()%>
    <%}%>
}
