<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>


<%@ include file="include.jsp" %>
<%!



%>

<%

    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

       boolean validate = checkSecurity(request);
       if (!validate){
          response.setStatus(401);
          String errorMessage = buildErrorResult("Failed to init from security reason",null,401);

          %>
            <%=errorMessage%>
          <%

          return;
       }


        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();


    String pluginRestBase = null;
    JSONObject clientResponse = null;
	String spSignatureDirectory = null;
	String spPrivateSignature = null;
	boolean allowSigned = false;
    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");
    Map<String, String> contextParams = createReplacementMap(formObject);
    if (formObject != null){
        pluginRestBase = (String)formObject.get("pluginRestBase");
		spSignatureDirectory = (String)formObject.get("saml-spSignatureDirectory");
		String certificateCNName = (String)formObject.get("saml-certificateCNName");
        if (certificateCNName != null && certificateCNName.length() > 0){
            allowSigned = true;
        }
    }else {
		formObject = new JSONObject();	
	}

   //System.out.println("formObject = " + formObject);



    String content = "";


	String requestBaseUrl = null;
    JSONObject requestObject = (JSONObject)jsonObject.get("request");
    if (requestObject != null){
        Object bodyObj = requestObject.get("body");
        if (bodyObj != null){
            content = bodyObj.toString();
        }
        JSONObject headersObject = (JSONObject)requestObject.get("headers");
        JSONObject parametersObject = (JSONObject)requestObject.get("parameters");
		
		if(headersObject != null){
			requestBaseUrl = (String)headersObject.get("requestBaseUrl");
			contextParams.put("requestBaseUrl",requestBaseUrl);
		}

        //System.out.println("url = " + requestObject.get("url"));
    }

    SamlCommon samlCommon = new SamlCommon(contextParams);
     samlCommon.initialize();

    String destination = (String)formObject.get("saml-destination");

    if (destination != null){
		 try {	
			 samlCommon.samlInitialize();

			 String callbackUrl = (String)formObject.get("saml-assertionConsumerServiceURL");
			 if (callbackUrl != null && requestBaseUrl != null && callbackUrl.startsWith("${requestBaseUrl}")){
				 callbackUrl = requestBaseUrl + callbackUrl.substring("${requestBaseUrl}".length());
			 }
			 
			 
			 AuthnRequest authnRequest = samlCommon.buildAuthnRequest(destination,callbackUrl ,(String)formObject.get("saml-identifier"),(String)formObject.get("saml-protocolBinding"),(String)formObject.get("saml-format"));
			 
			 if (spSignatureDirectory != null && spSignatureDirectory.length() > 0 && allowSigned){
			     spSignatureDirectory = replaceWithMapPlaceholders(spSignatureDirectory,contextParams);
				 samlCommon.signRequest(authnRequest,spSignatureDirectory,contextParams);
				 //System.out.println("signed");
			 }

			// Convert SAML Request to XML and encode
			String encodedSAMLRequest = samlCommon.encodeSAMLRequest(authnRequest);

			// Send the encoded SAML request
			// Use an HTTP library like HttpClient to send a POST request with the encoded SAML request
			//System.out.println(encodedSAMLRequest);

			encodedSAMLRequest = samlCommon.marshallAndEncode(authnRequest);
			//System.out.println(encodedSAMLRequest);
			 
				 
			clientResponse = new JSONObject();
			clientResponse.put("statusCode",200);

			StringBuilder builder = new StringBuilder();

			builder.append("<html>");
			builder.append("<body onload='document.forms[0].submit()'>");
			builder.append("<form action='" + destination + "' method='post'>");
			builder.append("<input type='hidden' name='SAMLRequest' value='" + encodedSAMLRequest + "' />");
			builder.append("<noscript>");
			builder.append("<input type='submit' value='Continue' />");
			builder.append("</noscript>");
			builder.append("</form>");
			builder.append("</body>");
			builder.append("</html>");


			clientResponse.put("content",builder.toString());
			JSONObject responseHeaderFields = new JSONObject();
			JSONArray array = new JSONArray();
			array.add("text/html");
			responseHeaderFields.put("content-type",array);
			clientResponse.put("responseHeaderFields",responseHeaderFields);
		 }catch (Exception e){
			 //e.printStackTrace();
			 samlCommon.getSSOCommon().ssoLogError("Failed on login",e);
		 }
    }else {
        samlCommon.getSSOCommon().ssoLogInfo("No destination was definied");
    }

    initObject.put("pluginToken",pluginToken);
    session.setAttribute(pluginToken, initObject);

   //System.out.println("init formObject = " + formObject);
   //System.out.println("clientResponse = " + clientResponse);




    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "authResponse": {
        "headers" : {
            "plugin-token" : "<%=pluginToken%>"
        }
    }
    <% if (clientResponse != null){%>
        ,"clientResponse" : <%=clientResponse.toString()%>
    <%}%>

}
