<%!

void fetchAuditEvents(
	String organization,
	HttpClient client,
	String clientAuth,
	JSONObject pluginRefObj,
	JSONArray array,
	Instant sinceTimeDefault,
	int numOfEvents
) {
	Instant sinceTime = sinceTimeDefault;
	String lastAuditTimeS = (String)pluginRefObj.get("orgAuditTime");;
	if (lastAuditTimeS != null) {
		sinceTime = Instant.parse(lastAuditTimeS);
	}
	List<JSONObject> auditObjects = new ArrayList<JSONObject>();
	Instant lastAuditTime = null;
	for (JSONObject auditObject :
		new GitHubJSONObjectIterable(client, clientAuth, "/orgs/" + organization + "/audit-log?include=all&order=desc&per_page=100"))
	{
		Instant thisAuditTime = auditTime(auditObject);
		if ((sinceTime != null && !thisAuditTime.isAfter(sinceTime)) ||
			array.size() >= numOfEvents) {
			break;
		}
		if (lastAuditTime == null) {
			lastAuditTime = thisAuditTime;
		}
		auditObject.put("stamped_at", thisAuditTime.toString());
		array.add(0, auditObject.toString());
	}
	if (lastAuditTime != null) {
		pluginRefObj.put("orgAuditTime", lastAuditTime.toString());
	}
}

%>
