<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>

<%@ include file="../../../../common/rest/restCommonServices.jsp" %>
<%
if (!checkSecurity(request)) {
	out.println(buildErrorResult("Rest is not authorize", null, 401));
	response.setStatus(401);
	return;
}

String pluginToken = request.getParameter("plugin-token");
if (pluginToken == null || pluginToken.length() == 0) {
	pluginToken = request.getHeader("plugin-token");
}
if (pluginToken == null || pluginToken.length() == 0) {
	pluginToken = "Bearer " + System.currentTimeMillis();
}

StringBuilder requestBody = new StringBuilder();
String line;
while ((line = request.getReader().readLine()) != null) {
	requestBody.append(line);
}
if (requestBody.length() == 0) {
	requestBody.append("{}");
}
JSONParser parser = new JSONParser();
JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

boolean scripttest = Boolean.TRUE.equals(jsonObject.get("scripttest"));

JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");
JSONObject queryObject = (JSONObject)jsonObject.get("defaultParams");
if (queryObject == null){
	queryObject = new JSONObject();
}

JSONObject initObject = new JSONObject();
String clientAuth = "";
String logType = null;
String organization = "";
long startTS = 0;

try {
	if (formObject != null) {
		long timeToGoBackMS = 0;
		String timeToGoBack = (String)formObject.get("timeToGoBack");
		if (timeToGoBack != null) {
			timeToGoBackMS = Long.parseLong(timeToGoBack);
		}
		if (timeToGoBackMS > 0) {
			startTS = (System.currentTimeMillis() - timeToGoBackMS)/1000;
		}

		String numOfEvents = (String)formObject.get("numOfEvents");
		if (numOfEvents != null) {
			queryObject.put("numOfEvents", Integer.parseInt(numOfEvents));
		}

		logType = (String)formObject.get("logType");
		organization = (String)formObject.get("organization");

		String apiToken = (String)formObject.get("apiToken");
		if (apiToken != null) {
			clientAuth = "Bearer " + apiToken;
		} else {
			out.println(buildErrorResult("Required API token wasn't passed", null, 400));
			response.setStatus(400);
			return;
		}
	}
}
catch (Exception e) {
	xpolog.eye.error.ErrorModel.log.error("Failed to init for " + formObject.toString(), e);

	if (scripttest) {
		response.setStatus(200);
	} else {
		response.setStatus(500);
	}

	out.println(buildErrorResult(null, e));
	return;
}
initObject.put("clientAuth", clientAuth);
initObject.put("organization", organization);
initObject.put("pluginToken", pluginToken);
if (logType != null) {
	initObject.put("logType", logType);
}
initObject.put("startTS", startTS);
initObject.put("queryInfo", queryObject);

session.setAttribute(pluginToken, initObject);
%>
{
	"authResponse": {
		"headers": {
			"plugin-token": "<%=pluginToken%>"
		}
	}
}
