function getName() {
	return "github";
}
xplgRegisterSystemDef({
	"xplg_system_def": {
		"uid": "github",
		"apptags": "",
		// NOTE update "dataTypes" in ../rest/dataTypes.jsp
		"logtypes": [
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Github Org Audit",
					"typetag": "github,git,audit",
					"name": "GitHub organization audit",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:JSON,dynamic=true;,isFlattenArrays=true,stamped_at#_#name=stamped at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm;repo#_#ftype=repo#_#name=repo;actor#_#ftype=username#_#name=Actor;action#_#ftype=github_action#_#name=Action;operation_type;org;created_at;invitee_email;@timestamp;org_id;actor_location->country_code;actor_id;email;user_agent;_document_id;permission;user_id;user;team;visibility;old_name;public_repo;repo_id;owner;reason;plan;branch;authorized_actor_names;required_approving_review_count;dismiss_stale_reviews_on_push;create_protected;signature_requirement_enforcement_level;strict_required_status_checks_policy;lock_branch_enforcement_level;required_review_thread_resolution_enforcement_level;enforcement_level;require_code_owner_review;required_deployments_enforcement_level;merge_queue_enforcement_level;required_status_checks_enforcement_level;ignore_approvals_from_contributors;admin_enforced;allow_force_pushes_enforcement_level;name;pull_request_reviews_enforcement_level;allow_deletions_enforcement_level;lock_allows_fetch_and_merge;require_last_push_approval;linear_history_requirement_enforcement_level;old_permission;user_programmatic_access_id;repository_selection;user_programmatic_access_name;actor_is_bot;changes->old_default_branch;changes->default_branch;pull_request_url;pull_request_id;pull_request_title;business;invitee;inviter;reviewer_type;request_category;repositories_added_names;repositories_added;integration;old_repo_base_role;old_permissions->pull;old_permissions->maintain;old_permissions->admin;old_permissions->triage;old_permissions->push;new_repo_permission;new_repo_base_role;old_repo_permission;key;business_id;external_identity_username;external_id;repository;hashed_token;programmatic_access_type;transport_protocol_name;transport_protocol;external_identity_nameid;repository_public}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/",
					"type_uid": "github_org_audit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:message}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Github Org Commits",
					"typetag": "github,git",
					"name": "GitHub organization detailed commits",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:JSON,dynamic=true;,isFlattenArrays=true,commit->push->repo->name#_#ftype=repo#_#name=repo;filename#_#ftype=filename#_#name=file path;changes#_#ftype=changes;commit->commit->author->date#_#name=committed at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm;commit->commit->author->name#_#ftype=username#_#name=author;commit->commit->message#_#ftype=message#_#name=message;commit->commit->tree->sha#_#name=Tree SHA;commit->parents->sha#_#name=Parents SHA;commit->push->created_at#_#name=pushed at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm;additions#_#ftype=additions;deletions#_#ftype=deletions;commit->committer->gists_url#_#name=Commit Gists URL;commit->committer->repos_url#_#ftype=commitrepourl#_#name=Commit Repo URL;commit->committer->following_url#_#name=Commit Following URL;commit->committer->starred_url#_#name=Started URL;commit->committer->login#_#ftype=github_username#_#name=GitHub Username;commit->committer->followers_url#_#ftype=followersurl#_#name=Commit Follower URL;commit->committer->type#_#ftype=committype#_#name=Commit Type;commit->committer->url#_#ftype=github_login_url#_#name=GitHub Login URL;commit->committer->subscriptions_url#_#name=Commit Subscription URL;commit->committer->received_events_url#_#name=Commit Received Events URL;commit->committer->avatar_url#_#ftype=avatarrequrl#_#name=Avatar URL;commit->committer->events_url#_#name=Commit Events URL;commit->committer->html_url#_#name=Commit HTML URL;commit->committer->site_admin#_#ftype=siteadmin#_#name=Commit Site Admin;commit->committer->id#_#ftype=commit_userid#_#name=GitHub Commit UserID;commit->committer->gravatar_id#_#name=Username Commit Gravatar ID;commit->committer->node_id#_#name=Commit Node ID;commit->committer->organizations_url#_#ftype=organizationurl#_#name=Commiter Organization URL;commit->stats->total#_#name=Commit Total;commit->stats->additions#_#name=Commit Additions;commit->stats->deletions#_#name=Commit Deletions;commit->author->gists_url#_#name=Commit Author Gists URL;commit->author->repos_url#_#name=Commit Author Request URL;commit->author->following_url#_#name=Commit Author Following URL;commit->author->starred_url#_#name=Commit Author Started URL;commit->author->login#_#ftype=github_username_login#_#name=GitHub Login;commit->author->followers_url#_#name=Commit Author Followers URL;commit->author->type#_#ftype=usertype#_#name=Commit Author Type;commit->author->url#_#ftype=requrl#_#name=Commit Author URL;commit->author->subscriptions_url#_#name=Commit Author Subscriptions URL;commit->author->received_events_url#_#Commit Author Received Events URL;commit->author->avatar_url#_#ftype=github_username_avatar#_#name=GitHub Username Avatar;commit->author->events_url#_#name=Commit Author Events URL;commit->author->html_url#_#name=Commit Author Html URL;commit->author->site_admin#_#ftype=commitauthorsiteadmin#_#name=Commit Author Site Admin;commit->author->id#_#ftype=github_userid#_#name=GitHub UserID;commit->author->gravatar_id#_#name=Username Gravatar ID;commit->author->node_id#_#name=Commit Author Node ID;commit->author->organizations_url#_#name=Commit Author Organizations URL;commit->html_url#_#name=Commit General Html URL;commit->commit->comment_count#_#name=Commit Comment Count;commit->commit->committer->date#_#name=Commit Date;commit->commit->committer->name#_#ftype=commitername#_#name=Commiter Name;commit->commit->committer->email;commit->commit->author->email#_#ftype=username_email;commit->commit->tree->url#_#name=Commit Tree URL;commit->commit->url#_#name=Commit General URL;commit->commit->verification->reason#_#ftype=verificationreason#_#name=Verification Reason;commit->commit->verification->signature#_#name=Verification Signature;commit->commit->verification->payload#_#name=Verification Payload;commit->commit->verification->verified#_#name=Verification IsVerified;commit->comments_url#_#name=Comments URL;commit->sha#_#name=Commit SHA;commit->url#_#name=Commit URL;commit->push->actor->display_login#_#name=Commit Display Login;commit->push->actor->avatar_url#_#name=Commit Avatar URL;commit->push->actor->id#_#name=Commit Actor ID;commit->push->actor->login#_#name=Commit Login;commit->push->actor->gravatar_id#_#name=Commit Gravatar ID;commit->push->actor->url#_#name=Commit Actor URL;commit->push->public#_#ftype=commitpublic#_#name=Commit Public;commit->push->payload->head#_#name=Commit Head;commit->push->payload->ref#_#ftype=git_branch#_#name=Git Branch;commit->push->payload->size#_#name=Commit Payload Size;commit->push->payload->before#_#name=Before;commit->push->payload->push_id#_#ftype=commitpayloadpushid#_#name=Commit Payload Push ID;commit->push->payload->distinct_size#_#name=Payload Distinct Size;commit->push->payload->repository_id#_#ftype=repoid#_#name=Repository ID;commit->push->org->avatar_url#_#ftype=organizationrequrl#_#name=Push Organization URL;commit->push->org->id#_#ftype=pushid#_#name=Push ID;commit->push->org->login#_#name=Commit Organization Login;commit->push->org->gravatar_id#_#name=Commit Organization Gravatar ID;commit->push->org->url#_#name=Commit Organization URL;commit->push->repo->id#_#name=Commit Repository ID;commit->push->repo->url#_#name=Commit Repository URL;commit->push->id#_#name=Commit Push ID;commit->push->type#_#ftype=pushtype#_#name=Commit Push Type;commit->node_id#_#name=Commit Node IT;commit->parents#_#ftype=parents#_#name=Parents;blob_url#_#ftype=blob_url;raw_url#_#ftype=raw_url;status#_#ftype=status;contents_url;previous_filename#_#ftype=prev_filename;sha#_#name=SHA}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/",
					"type_uid": "github_org_push_commit_file",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:message}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Github Org Commits",
					"typetag": "github,git",
					"name": "GitHub organization commits",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:JSON,dynamic=true;,isFlattenArrays=true,push->repo->name#_#name=repo;commit->author->date#_#name=committed at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm;commit->author->name#_#name=author;commit->message;commit->tree->sha#_#name=sha;parents->sha;push->created_at#_#name=pushed at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/",
					"type_uid": "github_org_push_commit",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:message}",
						"externalJS": "link or code"
					}
				}
			},
			{
				"log": {
					"xdoclink": "",
					"defaultPattern": "NONE",
					"howto": "Github Org Commits",
					"typetag": "github,git",
					"name": "GitHub organization push event commits",
					"custom_parser_location": "<LINK to JS>",
					"defaultXpoLogPattern": "{json:JSON,dynamic=true;,push->repo->name#_#ftype=repo#_#name=repo;author->name#_#ftype=username#_#name=author;sha;push->created_at#_#name=pushed at#_#date::dateFormat=yyyy-MM-dd'T'HH:mm:ss'Z',dateUIFormat=yyyy-MM-dd HH:mm;author->email#_#ftype=username_email;distinct;message#_#ftype=message#_#name=Message;url#_#ftype=requrl#_#name=URL;push->actor->display_login#_#ftype=github_username#_#name=GitHub Username;push->actor->avatar_url#_#ftype=github_username_avatar#_#name=GitHub Username Avatar;push->actor->id#_#ftype=github_userid#_#name=GitHub UserID;push->actor->login#_#ftype=github_username_login#_#name=GitHub Login;push->actor->gravatar_id#_#name=Username Gravatar ID;push->actor->url#_#ftype=github_login_url#_#name=GitHub Login URL;push->public#_#ftype=public#_#name=Public;push->payload->head#_#ftype=headsha#_#name=Head SHA;push->payload->ref#_#ftype=git_branch#_#name=Git Branch;push->payload->size#_#ftype=payload_size#_#name=Payload Size;push->payload->before#_#name=Before;push->payload->push_id#_#ftype=pushid#_#name=Payload ID;push->payload->distinct_size#_#name=Payload Distinct Size;push->payload->repository_id#_#ftype=payloadrepoid#_#name=Payload Repository ID;push->org->avatar_url#_#ftype=avatarrequrl#_#name=Avatar URL;push->org->id#_#name=Push Organization ID;push->org->login#_#ftype=organizationname#_#name=Push Organization Name;push->org->gravatar_id#_#name=Gravatar ID;push->org->url#_#ftype=organizationrequrl#_#name=Push Organization URL;push->repo->id#_#ftype=repoid#_#name=Repository ID;push->repo->url#_#ftype=pushurl#_#name=Push URL;push->id#_#ftype=pushid#_#name=Push ID;push->type#_#ftype=eventtype#_#name=Event Type}",
					"parser_type": "default",
					"xwikilink": "http://wiki.xpolog.com/",
					"type_uid": "github_org_push_commit_brief",
					"parser_specification": {
						"defaultPattern": "NONE",
						"parserparam": "",
						"defaultXpoLogPattern": "{string:message}",
						"externalJS": "link or code"
					}
				}
			}
		],
		"displayName": "GitHub",
		"typetag": "github",
		"name": "github",
		"description": "",
		"type": "cloud",
		"doclink": "FILL TODO",
		"version": "NONE",
		"supportedDataSources": "",
		"xwikilink": "",
		"example": ""
	}
});
