<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ page import="java.net.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.nio.charset.*" %>
<%@ page import="javax.xml.parsers.*" %>
<%@ page import="org.w3c.dom.*" %>

<%@ include file="include.jsp" %>
<%

    //System.out.println("callback jsp");
    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

       boolean validate = checkSecurity(request);
       if (!validate){
          response.setStatus(401);
          String errorMessage = buildErrorResult("Failed to init from security reason",null,401);

          %>
            <%=errorMessage%>
          <%

          return;
       }


        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();


    String pluginRestBase = null;
    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");

    Map<String, String> contextParams = createReplacementMap(formObject);

	String idpCertificatePath = null;
	String requestBaseUrl = null;
    if (formObject != null){
        pluginRestBase = (String)formObject.get("pluginRestBase");
		idpCertificatePath = (String)formObject.get("oauth-idpCertificatePath");		
		
    }

     OAuth2Common oauthCommon = new OAuth2Common(contextParams);
     oauthCommon.initialize();

    //System.out.println("accountFormData = " + formObject);

    String content = "";
    String username = null;
    JSONObject loginDetails = null;

    JSONObject requestObject = (JSONObject)jsonObject.get("request");
	//oauthCommon.getSSOCommon().updateContextWithRequest(requestObject);
    if (requestObject != null){
        
        //System.out.println("content = " + content);
        JSONObject headersObject = (JSONObject)requestObject.get("headers");
        JSONObject parametersObject = (JSONObject)requestObject.get("parameters");
		if (parametersObject != null){
			contextParams.putAll(parametersObject);
		}
		requestBaseUrl = (String)headersObject.get("requestBaseUrl");
		if (requestBaseUrl != null){
			contextParams.put("requestBaseUrl",requestBaseUrl);
		}
		

       

        if (oauthCommon.getSSOCommon().isDebugEnabled()){
            oauthCommon.getSSOCommon().ssoLogInfo("callback parametersObject " + parametersObject);
        }

		//System.out.println("callback parametersObject = " + parametersObject);
		String errorMessage = null;
        if (contextParams.containsKey("code")){            
            try {
				String authCode = contextParams.get("code");
				//System.out.println("callback authCode = " + authCode);
                JSONObject accessTokenObj = oauthCommon.getAccessToken(authCode);
				//System.out.println("callback accessToken = " + accessTokenObj);
				JSONObject jwt = oauthCommon.decodeJWTWithoutVerification((String)accessTokenObj.get("id_token"));
				
				//System.out.println("callback jwt = " + jwt);
				
				loginDetails = oauthCommon.createLoginDetailsFromJwt(formObject,jwt);

            }catch (Exception e){
                //e.printStackTrace();
                //System.out.println("content error = " + e.getMessage());
                oauthCommon.getSSOCommon().ssoLogError("Failed on callback",e);
            }
        }else {
            if (content == null || content.length() == 0){
                oauthCommon.getSSOCommon().ssoLogError("Login callback no context was supplied.");
            }else {
                oauthCommon.getSSOCommon().ssoLogError("Login callback wrong context was supplied = " + content);
            }
        }

        //System.out.println("content = " + content);
        // System.out.println("headersObject = " + headersObject);


    }

    initObject.put("pluginToken",pluginToken);
    session.setAttribute(pluginToken, initObject);

    JSONObject clientResponse = new JSONObject();
    clientResponse.put("statusCode",301);
    clientResponse.put("content","{}");
    JSONObject responseHeaderFields = new JSONObject();
    JSONArray array = new JSONArray();
    if (loginDetails != null){
        array.add("/logeye");
    }else {
        String error = "User is not permitted to login";
        if (loginDetails == null){
            error = "Invalid user login";
        }
        error = java.net.URLEncoder.encode(error, java.nio.charset.StandardCharsets.UTF_8.toString());
        array.add("/logeye/root.jsp#/login?loginErrorMessage=" + error);
    }
    responseHeaderFields.put("Location",array);
    clientResponse.put("responseHeaderFields",responseHeaderFields);

   //System.out.println("init loginDetails = " + loginDetails);
   
   if (loginDetails == null){
		loginDetails = new JSONObject();
   }

   if (oauthCommon.getSSOCommon().isInfoEnabled()){
       oauthCommon.getSSOCommon().ssoLogInfo("Login details " + loginDetails);
   }
   if (oauthCommon.getSSOCommon().isDebugEnabled()){
          oauthCommon.getSSOCommon().ssoLogInfo("Client reponse " + clientResponse);
      }

    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "loginDetails": <%=loginDetails%>
    
     <%
      if (clientResponse != null){%>
        ,"clientResponse" : <%=clientResponse.toString()%>
    <%}%>
}
