<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ page import="java.net.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.nio.charset.*" %>
<%@ page import="javax.xml.parsers.*" %>
<%@ page import="org.w3c.dom.*" %>


<%@ include file="../../../common/rest/restCommonServices.jsp" %>
<%

    //System.out.println("callback jsp");
    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

       boolean validate = checkSecurity(request);
       if (!validate){
          response.setStatus(401);
          String errorMessage = buildErrorResult("Failed to init from security reason",null,401);

          %>
            <%=errorMessage%>
          <%

          return;
       }


        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();


    String pluginRestBase = null;
    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");
    boolean loginUnknownUser = true;
    if (formObject != null){
        pluginRestBase = (String)formObject.get("pluginRestBase");
        String loginUnknownUserParam = (String)formObject.get("loginUnknownUser");
        loginUnknownUser = loginUnknownUserParam == null || !loginUnknownUserParam.equals("false");
    }

//    System.out.println("accountFormData = " + formObject);

    String content = "";
    String username = null;
    JSONObject userInfo = null;

    JSONObject requestObject = (JSONObject)jsonObject.get("request");
    if (requestObject != null){
        Object bodyObj = requestObject.get("body");
        if (bodyObj != null){
            content = bodyObj.toString();
            if (content != null){
                content = content.trim();
            }
        }
       // System.out.println("content = " + content);
        JSONObject headersObject = (JSONObject)requestObject.get("headers");
        JSONObject parametersObject = (JSONObject)requestObject.get("parameters");

        String contentType = headersObject == null ? null : (String)headersObject.get("content-type");
        if (content != null && contentType != null && contentType.equals("application/x-www-form-urlencoded")){
            content = URLDecoder.decode(content.toString(), StandardCharsets.UTF_8.name());
        }


        if (content != null && content.startsWith("SAMLResponse=")){
            content = content.substring(content.indexOf("=") + 1);
            try {
                byte[] decodedBytes = java.util.Base64.getDecoder().decode(content);
                content = new String(decodedBytes);

                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                  factory.setNamespaceAware(true); // Important to handle namespaces
                  DocumentBuilder builder = factory.newDocumentBuilder();
                  Document doc = builder.parse(new java.io.ByteArrayInputStream(content.getBytes("UTF-8")));



                  // Extract the NameID value
                  NodeList nameIDNodes = doc.getElementsByTagNameNS("urn:oasis:names:tc:SAML:2.0:assertion", "NameID");
                  if (nameIDNodes.getLength() > 0) {
                      Node nameIDNode = nameIDNodes.item(0);
                      username = nameIDNode.getTextContent();

                      userInfo = new JSONObject();
                      userInfo.put("name" , username);
                     // System.out.println("NameID: " + username);
                  }

                  if (userInfo != null){
                      NodeList attributeNodes = doc.getElementsByTagNameNS("urn:oasis:names:tc:SAML:2.0:assertion", "Attribute");
                      for (int i = 0; i < attributeNodes.getLength(); i++) {
                          Element attributeElement = (Element) attributeNodes.item(i);
                          if ("http://schemas.microsoft.com/identity/claims/displayname".equals(attributeElement.getAttribute("Name"))) {
                              NodeList attributeValues = attributeElement.getElementsByTagNameNS("urn:oasis:names:tc:SAML:2.0:assertion", "AttributeValue");
                              if (attributeValues.getLength() > 0) {
                                  String displayName = attributeValues.item(0).getTextContent();
                                  userInfo.put("displayName",displayName);
                                  //System.out.println("Display Name: " + displayName);
                              }
                          }
                      }
                  }


            }catch (Exception e){
                //e.printStackTrace();
                System.out.println("content error = " + content);
            }
        }

        //System.out.println("content = " + content);
        // System.out.println("headersObject = " + headersObject);


    }

    initObject.put("pluginToken",pluginToken);
    session.setAttribute(pluginToken, initObject);

    JSONObject clientResponse = new JSONObject();
    clientResponse.put("statusCode",301);
    clientResponse.put("content","{}");
    JSONObject responseHeaderFields = new JSONObject();
    JSONArray array = new JSONArray();
    if (loginUnknownUser && userInfo != null){
        array.add("/logeye");
    }else {
        String error = "User is not permitted to login";
        if (userInfo == null){
            error = "Invalid user login";
        }
        error = java.net.URLEncoder.encode(error, java.nio.charset.StandardCharsets.UTF_8.toString());
        array.add("/logeye/root.jsp#/login?loginErrorMessage=" + error);
    }
    responseHeaderFields.put("Location",array);
    clientResponse.put("responseHeaderFields",responseHeaderFields);

   // System.out.println("init formObject = " + formObject);

    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "loginDetails": {
        <% if (userInfo != null){%>
        "user" : <%=userInfo%>
        <%}%>
    }
     <%
      if (clientResponse != null){%>
        ,"clientResponse" : <%=clientResponse.toString()%>
    <%}%>
}
