<%@ page language="java" contentType="application/json; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="org.json.simple.JSONObject" %>
<%@ page import="org.json.simple.parser.JSONParser" %>
<%@ include file="../../../common/rest/restCommonServices.jsp" %>
<%

    String pluginToken = request.getParameter("plugin-token");
     if (pluginToken == null || pluginToken.length() == 0){
        pluginToken = request.getHeader("plugin-token");
     }
     if (pluginToken == null || pluginToken.length() == 0){
          pluginToken = "Bearer " + System.currentTimeMillis();
     }

     StringBuilder requestBody = new StringBuilder();
        String line;
        while ((line = request.getReader().readLine()) != null) {
            requestBody.append(line);
        }

        if (requestBody.length() == 0){
            requestBody.append("{}");
        }

       boolean validate = checkSecurity(request);
       if (!validate){
          response.setStatus(401);
          String errorMessage = buildErrorResult("Failed to init from security reason",null,401);

          %>
            <%=errorMessage%>
          <%

          return;
       }


        JSONParser parser = new JSONParser();

    JSONObject jsonObject = (JSONObject)parser.parse(requestBody.toString());

    JSONObject initObject = new JSONObject();


    String pluginRestBase = null;
    JSONObject clientResponse = null;
    JSONObject formObject = (JSONObject)jsonObject.get("accountFormData");
    if (formObject != null){
        pluginRestBase = (String)formObject.get("pluginRestBase");
    }

   //System.out.println("formObject = " + formObject);

    String content = "";


    JSONObject requestObject = (JSONObject)jsonObject.get("request");
    if (requestObject != null){
        Object bodyObj = requestObject.get("body");
        if (bodyObj != null){
            content = bodyObj.toString();
        }
        JSONObject headersObject = (JSONObject)requestObject.get("headers");
        JSONObject parametersObject = (JSONObject)requestObject.get("parameters");

        //System.out.println("url = " + requestObject.get("url"));
    }

    String destination = (String)formObject.get("saml-destination");

    if (false){
        if (pluginRestBase == null){
            pluginRestBase = "http://localhost:30303/logeye/plugins/rest/";
        }
        clientResponse = new JSONObject();
        clientResponse.put("statusCode",301);
        clientResponse.put("content","{}");
        JSONObject responseHeaderFields = new JSONObject();
        JSONArray array = new JSONArray();
       // System.out.println("location = " + pluginRestBase + "ldptest.jsp");
        //array.add(pluginRestBase + "ldptest.jsp");

      //   String encodedValue = java.net.URLEncoder.encode(encodedSAMLRequest, java.nio.charset.StandardCharsets.UTF_8.toString());
      //   array.add(azureADUrl + "?SAMLRequest=" + encodedValue);

       // responseHeaderFields.put("Location",array);
        clientResponse.put("responseHeaderFields",responseHeaderFields);

    }else if (destination != null){


         String xml = "<saml2p:AuthnRequest xmlns:saml2p=\"urn:oasis:names:tc:SAML:2.0:protocol\" AssertionConsumerServiceURL=\"${saml-assertionConsumerServiceURL}\" Destination=\"${saml-destination}\" ID=\"${saml-id}\" IssueInstant=\"${saml-issueInstant}\" ProtocolBinding=\"${saml-protocolBinding}\" Version=\"2.0\">\n" +
                        "\t<saml2:Issuer xmlns:saml2=\"urn:oasis:names:tc:SAML:2.0:assertion\">${saml-identifier}</saml2:Issuer>\n" +
                        "\t<saml2p:NameIDPolicy AllowCreate=\"true\" Format=\"${saml-format}\"/>\n" +
                        "</saml2p:AuthnRequest>";

        Map<String,String> formData = new HashMap<>();

        java.time.Instant now = java.time.Instant.now();
        java.time.LocalDateTime dateTime = java.time.LocalDateTime.ofInstant(now, java.time.ZoneOffset.UTC);
        java.time.format.DateTimeFormatter formatter = java.time.format.DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        String formattedDateTime = dateTime.format(formatter);

        formData.put("saml-id","_" + UUID.randomUUID());
        formData.put("saml-issueInstant",formattedDateTime);
        //formData.put("request.protocolBinding","urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST");
        //formData.put("request.format","urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified");

        if (formObject != null){
            for (Object o : formObject.keySet()) {
		        String key = o.toString();
		        String value = (String)formObject.get(key);
		        formData.put(key,value);
	        }
        }


        for (String s : formData.keySet()) {
            String value = formData.get(s);
            xml = xml.replaceAll("\\$\\{" + s + "}",value);
        }

       // System.out.println("xml = " + xml);
        String encodedSAMLRequest = Base64.getEncoder().encodeToString(xml.getBytes());

        clientResponse = new JSONObject();
        clientResponse.put("statusCode",200);

        StringBuilder builder = new StringBuilder();

        builder.append("<html>");
        builder.append("<body onload='document.forms[0].submit()'>");
        builder.append("<form action='" + destination + "' method='post'>");
        builder.append("<input type='hidden' name='SAMLRequest' value='" + encodedSAMLRequest + "' />");
        builder.append("<noscript>");
        builder.append("<input type='submit' value='Continue' />");
        builder.append("</noscript>");
        builder.append("</form>");
        builder.append("</body>");
        builder.append("</html>");


        clientResponse.put("content",builder.toString());
        JSONObject responseHeaderFields = new JSONObject();
        JSONArray array = new JSONArray();
        array.add("text/html");
        responseHeaderFields.put("content-type",array);
        clientResponse.put("responseHeaderFields",responseHeaderFields);
    }

    initObject.put("pluginToken",pluginToken);
    session.setAttribute(pluginToken, initObject);

   // System.out.println("init formObject = " + formObject);

    response.setContentType("application/json");
    response.setCharacterEncoding("UTF-8");
%>
{
    "authResponse": {
        "headers" : {
            "plugin-token" : "<%=pluginToken%>"
        }
    }
    <% if (clientResponse != null){%>
        ,"clientResponse" : <%=clientResponse.toString()%>
    <%}%>

}
