{

	"id": "tour-step",
	"displayName": "Tour step",
	"position": {
		"side": "bottom",
		"align": "start",
		"hideArrow": false
	},
	"buttons": [{
			"id": "xplg-guide-btn-close",
			"action": "d => d.end()"
		}, {
			"id": "xplg-guide-btn-back",
			"action": "d => d.prev()"
		}, {
			"id": "xplg-guide-btn-next",
			"action": "d => d.next()"
		}, {
			"id": "xplg-guide-do-not-show-again",
			"action": "d => d.toggleDoNotShowAgain()"
		}, {
			"id": "xplg-guide-hide-tips",
			"action": "d => {d.toggleDoNotShowAgain(); d.end();}"
		}
	],
	"progress": {
		"enabled": true,
		"content": "(c,t) => c +'/'+t",
		"id": "xplg-guide-progress"
	},
	"style": "theme-handler xplg-default-theme xplg-tour-step btn-close-{{hasBack}} title-{{hasTitle}} progress-{{hasProgress}} do-not-show-again-{{hasDoNotShowAgain}} btn-back-{{hasBack}} footer-{{hasFooter}} hide-tips-{{hideTips}}",
	"header": "",
	"description": "\n<button type=\"button\" class=\"btn-close xplg-btn gi-cross\" id=\"xplg-guide-btn-close\"></button>\n<div class=\"container\">\n  <div class=\"title\" id=\"xplg-guide-title\">{{title}}</div>\n  <div class=\"content\">{{content}}</div>\n  <div class=\"footer\">\n    <label id=\"xplg-guide-hide-tips\">Hide all Tips</label>\n    <div class=\"progress\" id=\"xplg-guide-progress\">1/3</div>\n    <label class=\"do-not-show-again checkbox-item\" onclick=\"event.stopPropagation()\">\n      {{doNotShowAgainTitle}}\n      <input type=\"checkbox\" id=\"xplg-guide-do-not-show-again\" />\n      <span class=\"gi gi-check-icon checkmark\"></span>\n    </label>\n    <div class=\"guide-separator\">&nbsp;</div>\n    <div class=\"buttons\">\n      <button type=\"button\" id=\"xplg-guide-btn-back\" class=\"btn btn-secondary xplg-h2\">Back</button>\n      <button type=\"button\" id=\"xplg-guide-btn-next\" class=\"btn btn-primary xplg-title-small\">\n        {{nextBtnName}}\n      </button>\n    </div>\n  </div>\n</div>",
	"onRenderEnd": "(arg) => {\n    const e = arg.elem;\n    if (arg.isFirstStep) {\n      const backBtn = e.querySelector('#xplg-guide-btn-back');\n      if(backBtn) backBtn.style.display = 'none';\n    }\n    if (arg.isLastStep) {\n      const nextBtn = e.querySelector('#xplg-guide-btn-next');\n      if(nextBtn) nextBtn.innerHTML = 'Done';\n    }\n    if (!e || !arg.isDoNotShowAgainChecked) return;\n    const input = e.querySelector('#xplg-guide-do-not-show-again');\n    if (input) input.checked = true;\n  }",
	"onHighlightEnd": "(element, step, opts) => {\n    const targetEl = element;\n    const wrapperEl = opts?.state?.popover?.wrapper;\n    const side = step?.popover?.side;\n    const align = step?.popover?.align;\n    if (targetEl && wrapperEl && align && side) {\n        const insetStyle = wrapperEl.style.inset;\n        if (insetStyle) {\n            const targetRect = targetEl.getBoundingClientRect();\n            const wrapperRect = wrapperEl.getBoundingClientRect();\n            const pageWidth = document.body.offsetWidth;\n            const pageHeight = document.body.offsetHeight;\n            const adminSectionWidth = document.getElementById('guide_me_admin_panel')?.offsetWidth || 0;\n            const spaceBetween = 10;\n            const targetPadding = 10;\n            const offset = 2;\n            const canFitTop = targetRect.top - spaceBetween - wrapperRect.height - offset >= 0;\n            const canFitRight = targetRect.left + targetRect.width + targetPadding + spaceBetween + offset + wrapperRect.width <= pageWidth;\n            const canFitBottom = targetRect.top + targetRect.height + targetPadding + spaceBetween + offset + wrapperRect.height <= pageHeight;\n            const canFitLeft = targetRect.left - targetPadding - spaceBetween - wrapperRect.width - offset >= adminSectionWidth;\n            const arrowEl = wrapperEl.querySelector('.driver-popover-arrow');\n            const arrowClass = 'driver-popover-arrow';\n            const arrowSideClassPrefix = 'driver-popover-arrow-side-';\n            const arrowAlignClassPrefix = 'driver-popover-arrow-align-';\n            let [top, right, bottom, left] = insetStyle.split(' ');\n            let adjustedSide = '';\n            let adjustedAlign = '';\n            switch (side) {\n                case 'top': {\n                    if (canFitTop) {\n                        adjustedSide = 'top';\n                    } else if (canFitBottom) {\n                        adjustedSide = 'bottom';\n                    } else {\n                        if (canFitLeft) {\n                            adjustedSide = 'left';\n                            adjustedAlign = 'center';\n                            break;\n                        } else if (canFitRight) {\n                            adjustedSide = 'right';\n                            adjustedAlign = 'center';\n                            break;\n                        }\n                    }\n                    switch (align) {\n                        case 'start': {\n                            if (targetRect.left - targetPadding + wrapperRect.width + offset <= pageWidth) {\n                                adjustedAlign = 'start';\n                            } else {\n                                adjustedAlign = 'end';\n                            }\n                            break;\n                        }\n                        case 'center': {\n                            const wrapperHalfWidth = (wrapperRect.width - targetRect.width) / 2;\n                            if (targetRect.width >= wrapperRect.width ||\n                                (targetRect.left - wrapperHalfWidth - offset >= adminSectionWidth &&\n                                targetRect.left + targetRect.width + wrapperHalfWidth + offset <= pageWidth)) {\n                                adjustedAlign = 'center';\n                            } else {\n                                if (targetRect.left - targetPadding + wrapperRect.width + offset <= pageWidth) {\n                                    adjustedAlign = 'start';\n                                } else {\n                                    adjustedAlign = 'end';\n                                }\n                            }\n                            break;\n                        }\n                        case 'end': {\n                            if (targetRect.left + targetRect.width + targetPadding - wrapperRect.width - offset >= adminSectionWidth) {\n                                adjustedAlign = 'end';\n                            } else {\n                                adjustedAlign = 'start';\n                            }\n                            break;\n                        }\n                    }\n                    break;\n                }\n                case 'right': {\n                    if (canFitRight) {\n                        adjustedSide = 'right';\n                    } else if (canFitLeft) {\n                        adjustedSide = 'left';\n                    } else if (canFitTop) {\n                        adjustedSide = 'top';\n                        adjustedAlign = 'center';\n                        break;\n                    } else if (canFitBottom) {\n                        adjustedSide = 'bottom';\n                        adjustedAlign = 'center';\n                        break;\n                    }\n                    switch (align) {\n                        case 'start': {\n                            if (targetRect.top - targetPadding + wrapperRect.height + offset <= pageHeight) {\n                                adjustedAlign = 'start';\n                            } else {\n                                adjustedAlign = 'end';\n                            }\n                            break;\n                        }\n                        case 'center': {\n                            const wrapperHalfHeight = (wrapperRect.height - targetRect.height) / 2;\n                            if (targetRect.height >= wrapperRect.height ||\n                                (targetRect.top - wrapperHalfHeight - offset >= 0 &&\n                                targetRect.top + targetRect.height + wrapperHalfHeight + offset <= pageHeight)) {\n                                adjustedAlign = 'center';\n                            } else {\n                                if (targetRect.top - targetPadding + wrapperRect.height + offset <= pageHeight) {\n                                    adjustedAlign = 'start';\n                                } else {\n                                    adjustedAlign = 'end';\n                                }\n                            }\n                            break;\n                        }\n                        case 'end': {\n                            if (targetRect.top + targetRect.height + targetPadding - wrapperRect.height - offset >= 0) {\n                                adjustedAlign = 'end';\n                            } else {\n                                adjustedAlign = 'start';\n                            }\n                            break;\n                        }\n                    }\n                    break;\n                }\n                case 'bottom': {\n                    if (canFitBottom) {\n                        adjustedSide = 'bottom';\n                    } else if (canFitTop) {\n                        adjustedSide = 'top';\n                    } else if (canFitLeft) {\n                        adjustedSide = 'left';\n                        adjustedAlign = 'center';\n                        break;\n                    } else if (canFitRight) {\n                        adjustedSide = 'right';\n                        adjustedAlign = 'center';\n                        break;\n                    }\n                    switch (align) {\n                        case 'start': {\n                            if (targetRect.left - targetPadding + wrapperRect.width + offset <= pageWidth) {\n                                adjustedAlign = 'start';\n                            } else {\n                                adjustedAlign = 'end';\n                            }\n                            break;\n                        }\n                        case 'center': {\n                            const wrapperHalfWidth = (wrapperRect.width - targetRect.width) / 2;\n                            if (targetRect.width >= wrapperRect.width ||\n                                (targetRect.left - wrapperHalfWidth - offset >= adminSectionWidth &&\n                                targetRect.left + targetRect.width + wrapperHalfWidth + offset <= pageWidth)) {\n                                adjustedAlign = 'center';\n                            } else {\n                                if (targetRect.left - targetPadding + wrapperRect.width + offset <= pageWidth) {\n                                    adjustedAlign = 'start';\n                                } else {\n                                    adjustedAlign = 'end';\n                                }\n                            }\n                            break;\n                        }\n                        case 'end': {\n                            if (targetRect.left + targetRect.width + targetPadding - wrapperRect.width - offset >= adminSectionWidth) {\n                                adjustedAlign = 'end';\n                            } else {\n                                adjustedAlign = 'start';\n                            }\n                            break;\n                        }\n                    }\n                    break;\n                }\n                case 'left': {\n                    if (canFitLeft) {\n                        adjustedSide = 'left';\n                    } else if (canFitRight) {\n                        adjustedSide = 'right';\n                    } else if (canFitTop) {\n                        adjustedSide = 'top';\n                        adjustedAlign = 'center';\n                        break;\n                    } else if (canFitBottom) {\n                        adjustedSide = 'bottom';\n                        adjustedAlign = 'center';\n                        break;\n                    }\n                    switch (align) {\n                        case 'start': {\n                            if (targetRect.top - targetPadding + wrapperRect.height + offset <= pageHeight) {\n                                adjustedAlign = 'start';\n                            } else {\n                                adjustedAlign = 'end';\n                            }\n                            break;\n                        }\n                        case 'center': {\n                            const wrapperHalfHeight = (wrapperRect.height - targetRect.height) / 2;\n                            if (targetRect.height >= wrapperRect.height ||\n                                (targetRect.top - wrapperHalfHeight - offset >= 0 &&\n                                targetRect.top + targetRect.height + wrapperHalfHeight + offset <= pageHeight)) {\n                                adjustedAlign = 'center';\n                            } else {\n                                if (targetRect.top - targetPadding + wrapperRect.height + offset <= pageHeight) {\n                                    adjustedAlign = 'start';\n                                } else {\n                                    adjustedAlign = 'end';\n                                }\n                            }\n                            break;\n                        }\n                        case 'end': {\n                            if (targetRect.top + targetRect.height + targetPadding - wrapperRect.height - offset >= 0) {\n                                adjustedAlign = 'end';\n                            } else {\n                                adjustedAlign = 'start';\n                            }\n                            break;\n                        }\n                    }\n                    break;\n                }\n            }\n\n            if (adjustedSide) {\n                switch (adjustedSide) {\n                    case 'top': {\n                        top = (targetRect.top - targetPadding - spaceBetween - wrapperRect.height) + 'px';\n                        break;\n                    }\n                    case 'right': {\n                        left = (targetRect.left + targetRect.width + targetPadding + spaceBetween) + 'px';\n                        break;\n                    }\n                    case 'bottom': {\n                        top = (targetRect.top + targetRect.height + targetPadding + spaceBetween) + 'px';\n                        break;\n                    }\n                    case 'left': {\n                        left = (targetRect.left - targetPadding - spaceBetween - wrapperRect.width) + 'px';\n                        break;\n                    }\n                }\n            }\n\n            if (adjustedAlign) {\n                switch (adjustedAlign) {\n                    case 'start': {\n                        if (adjustedSide === 'top' || adjustedSide === 'bottom') {\n                            left = (targetRect.left - targetPadding) + 'px';\n                        } else if (adjustedSide === 'right' || adjustedSide === 'left') {\n                            top = (targetRect.top - targetPadding) + 'px';\n                        }\n                        break;\n                    }\n                    case 'center': {\n                        if (adjustedSide === 'top' || adjustedSide === 'bottom') {\n                            if (wrapperRect.width > targetRect.width) {\n                                const wrapperHalfWidth = (wrapperRect.width - targetRect.width) / 2;\n                                left = (targetRect.left - wrapperHalfWidth) + 'px';\n                            } else if (wrapperRect.width < targetRect.width) {\n                                left = (targetRect.left + (targetRect.width - wrapperRect.width) / 2) + 'px';\n                            } else {\n                                left = targetRect.left + 'px';\n                            }\n                        } else if (adjustedSide === 'right' || adjustedSide === 'left') {\n                            if (wrapperRect.height > targetRect.height) {\n                                const wrapperHalfHeight = (wrapperRect.height - targetRect.height) / 2;\n                                top = (targetRect.top - wrapperHalfHeight) + 'px';\n                            } else if (wrapperRect.height < targetRect.height) {\n                                top = (targetRect.top + (targetRect.height - wrapperRect.height) / 2) + 'px';\n                            } else {\n                                top = targetRect.height + 'px';\n                            }\n                        }\n                        break;\n                    }\n                    case 'end': {\n                        if (adjustedSide === 'top' || adjustedSide === 'bottom') {\n                            left = (targetRect.left + targetRect.width + targetPadding - wrapperRect.width) + 'px';\n                        } else if (adjustedSide === 'right' || adjustedSide === 'left') {\n                            top = (targetRect.top + targetRect.height + targetPadding - wrapperRect.height) + 'px';\n                        }\n                        break;\n                    }\n                }\n            }\n\n            if (adjustedSide || adjustedAlign) {\n                wrapperEl.style.inset = [top, 'auto', 'auto', left].join(' ');\n                if (arrowEl) {\n                    arrowEl.className = arrowClass + ' ' + arrowSideClassPrefix + adjustedSide + ' ' + arrowAlignClassPrefix + adjustedAlign;\n                }\n            }\n        }\n    }\n    var stepTargetClickListenerFn = function(event) {\n        if (!event || !event.target?.closest('#driver-popover-content')) {\n            if (this.step?.popover?.onCloseClick) {\n                this.step.popover.onCloseClick(this.element, this.step, this.opts);\n            }\n        } \n    };\n    window.stepTargetClickListenerRef = stepTargetClickListenerFn.bind({element, step, opts});\n    document.body.addEventListener('click', window.stepTargetClickListenerRef);\n    if (wrapperEl) {\n        wrapperEl.classList.add('xplg-tour-step__visible');\n    }\n}",
	"onDeselected": "(element, step, opts) => {\n  if (window.stepTargetClickListenerRef) {\n    document.body.removeEventListener('click', window.stepTargetClickListenerRef);\n    window.stepTargetClickListenerRef = null;\n  }\n}",
	"variables": {
		"nextBtnName": "Next",
		"doNotShowAgainTitle": "Stop all guides",
		"title": "Title",
		"content": "Content",
		"hasBack": true,
		"hasTitle": true,
		"hasProgress": true,
		"hasDoNotShowAgain": true,
		"hasFooter": true,
		"hideTips": false
	}
}
